﻿package com 
{
	import br.com.stimuli.loading.BulkLoader;
	import br.com.stimuli.loading.BulkProgressEvent;
	import com.scenes.SceneContact;
	import com.scenes.SceneEmpty;
	import com.scenes.SceneExternal;
	import com.scenes.SceneGallery;
	import com.scenes.SceneHtml;
	import com.scenes.SceneMenu;
	import com.scenes.SceneNews;
	import com.ui.Bg;
	import com.ui.Footer;
	import com.ui.Header;
	import com.ui.Menu;
	import com.utkudemir.Rect;
	import com.utkudemir.utils.Scene;
	import com.utkudemir.utils.SceneManager;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import gs.TweenLite;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class Main extends MovieClip
	{
		
		public function Main() 
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, addedHandler);
			
			if (Properties.BL == null)
			{
				// create the preloader
				Properties.BL					= new BulkLoader("itemLoader");
				Properties.BL.add("data/main.xml", { id:"data" } ).addEventListener(Event.COMPLETE, xmlLoadedHandler);
				Properties.BL.start(1);
			}
			else
			{
				itemsLoadedHandler();
			}
			
		}
		
		private function xmlLoadedHandler(e:Event):void 
		{
			// store xml data
			Properties.DATA					= Properties.BL.getXML("data");
			
			// add items to preloader
			Properties.BL.add(String(Properties.DATA.config.@logo_source), { id:"logo" } );
			Properties.BL.add(String(Properties.DATA.config.@main_page_bg_source), { id:String(Properties.DATA.config.@main_page_bg_source)} );
			if(Properties.DATA.config.@sound_source != undefined) Properties.BL.add(String(Properties.DATA.config.@sound_source), { id:"music"} );
			Properties.BL.addEventListener(BulkProgressEvent.COMPLETE, itemsLoadedHandler);
		}
		
		private function itemsLoadedHandler(e:Event = null):void 
		{
			Properties.BL.removeEventListener(BulkProgressEvent.COMPLETE, itemsLoadedHandler);
			
			// set stage scale and alignment adjustments
			stage.scaleMode					= "noScale";
			stage.align						= "TL";
			stage.addEventListener(Event.RESIZE, stageResizeHandler);
			stageResizeHandler();
			
			// create the background class
			var bg:Bg						= new Bg();
			addChild(bg);
			
			// create the header
			var header:Header				= new Header();
			addChild(header);
			
			// create the menu
			var menu:Menu					= new Menu();
			addChild(menu);
			
			// create the footer
			var footer:Footer				= new Footer();
			addChild(footer);
			
			menu.open(1);
			footer.open(1);
			
			// create scenes
			var sceneEmpty:Scene			= Scene(new SceneEmpty());
			sceneEmpty.id					= "empty";
			addChild(sceneEmpty);
			
			var sceneExternal:Scene			= Scene(new SceneExternal());
			sceneExternal.id				= "external";
			addChild(sceneExternal);
			
			var sceneNews:Scene				= Scene(new SceneNews());
			sceneNews.id					= "news";
			addChild(sceneNews);
			
			var sceneHtml:Scene				= Scene(new SceneHtml());
			sceneHtml.id					= "html";
			addChild(sceneHtml);
			
			var sceneGallery:Scene			= Scene(new SceneGallery());
			sceneGallery.id					= "gallery";
			addChild(sceneGallery);
			
			var sceneContact:Scene			= Scene(new SceneContact());
			sceneContact.id					= "contact";
			addChild(sceneContact);
			
			var sceneMenu:Scene				= Scene(new SceneMenu());
			sceneMenu.id					= "menu";
			addChild(sceneMenu);
			
			var nOpen:int					= -1;
			for (var i:int = 0; i < Properties.DATA.content.item.length(); i++) 
			{
				if (Properties.DATA.content.item[i].@main == true)  nOpen = i;
			}
			
			Properties.nMainPage			= nOpen;
			
			if (nOpen != -1)
			{
				TweenLite.delayedCall(1, Menu.instance.openItem, [nOpen]);
				if (Properties.DATA.content.item[nOpen].@bg_image != undefined)
				{
					Bg.instance.openImage(Properties.DATA.content.item[nOpen].@bg_image);
				}
				else
				{
					Bg.instance.openImage(Properties.DATA.config.@main_page_bg_source);
				}
			}
			else
			{
				SceneManager.instance.openScene("empty");
			}
			
			// create a top level sprite as container for gallery
			var mTop:Sprite					= new Sprite();
			addChild(mTop);
			
			Properties.MTOP					= mTop;
		}
		
		private function stageResizeHandler(e:Event = null):void
		{
			// set stage dimentions
			Properties.WI					= Math.max(1000, stage.stageWidth);
			Properties.HE					= Math.max(600, stage.stageHeight);
			
			// declare the stage is resized
			dispatchEvent(new Event("stageResized"));
		}
		
	}

}