package com 
{
	import br.com.stimuli.loading.BulkLoader;
	import br.com.stimuli.loading.BulkProgressEvent;
	import com.utkudemir.Rect;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.system.Capabilities;
	import gs.easing.Expo;
	import gs.TweenLite;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class MainLoader extends Sprite
	{
		private var mBar					:Rect;
		private var mBarContainer			:Rect;
		
		private var mBgContainer			:Sprite;
		private var mBg						:Bitmap;
		private var nOrgWi					:int;
		private var nOrgHe					:int;
		
		private var nCurrent				:int			= 0;
		private var nBytes					:int			= 0;
		private var bLoaded					:Boolean		= false;;
		
		public function MainLoader() 
		{
			// set stage properties
			stage.scaleMode					= "noScale";
			stage.align						= "TL";
			stage.addEventListener(Event.RESIZE, stageResizeHandler);
			
			// create a solid background
			addChild(new Rect(Capabilities.screenResolutionX, Capabilities.screenResolutionY, 0x111111));
			
			// crate the background container.
			mBgContainer					= new Sprite();
			addChild(mBgContainer);
			
			// create the preloader bar and it's container.
			mBarContainer					= new Rect(100, 1, 0, 0, 0, 0);
			addChild(mBarContainer);
			
			mBar							= new Rect(100, 1, 0xFFFFFF);
			mBar.width						= 0;
			mBarContainer.addChild(mBar);
			
			// create the loader
			Properties.BL						= new BulkLoader("firstLoader");
			Properties.BL.add("data/main.xml", { id:"data" } ).addEventListener(Event.COMPLETE, xmlLoadedHandler);
			Properties.BL.start(1);
			
			// place everything
			stageResizeHandler();
		}
		
		private function xmlLoadedHandler(e:Event):void 
		{
			// store xml data.
			Properties.DATA						= Properties.BL.getXML("data");
			
			// set preloader bar's color
			TweenLite.to(mBar, 0, { tint:Properties.DATA.config.@themeColor } );
			
			// add assets to the loader
			nBytes								= 1820;
			Properties.BL.add(String(Properties.DATA.config.@logo_source), { id:"logo", weight:150 } );
			Properties.BL.add(String(Properties.DATA.config.@main_page_bg_source), { id:String(Properties.DATA.config.@main_page_bg_source), weight:200 } );
			if(Properties.DATA.config.@sound_source != undefined) Properties.BL.add(String(Properties.DATA.config.@sound_source), { id:"music", weight:1350 } );
			Properties.BL.add("main.swf", { id:"main", weight:120 } );
			
			var itemXml:XML;
			var sSource:String;
			for (var i:int = 0; i < Properties.DATA.content.item.length(); i++) 
			{
				itemXml							= XML(Properties.DATA.content.item[i]);
				if (itemXml.@main == true)
				{
					if (itemXml.@bg_image != undefined)
					{
						sSource					= itemXml.@bg_image;
						Properties.BL.add(sSource, { id:sSource, weight:200 } );
					}
				}
			}
			
			Properties.BL.addEventListener(BulkProgressEvent.COMPLETE, itemsLoadedHandler);
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}
		
		private function itemsLoadedHandler(e:BulkProgressEvent):void 
		{
			// set the loading is done and clear the event listener of the loader.
			bLoaded						= true;
			Properties.BL.removeEventListener(BulkProgressEvent.COMPLETE, itemsLoadedHandler);
		}
		
		private function enterFrameHandler(e:Event):void 
		{
			// handle loading
			if (bLoaded && nCurrent == 100)
			{
				removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
				TweenLite.to(mBar, .5, { x:100, width:0, ease:Expo.easeInOut, onComplete:function()
				{
					addChild(Properties.BL.getMovieClip("main"));
				} } );
			}
			else
			{
				var nLoaded:int				= bLoaded ? 100 : (Properties.BL.bytesLoaded / (nBytes * 1024)) * 100;
				nLoaded						= Math.min(nLoaded, 100);
				
				if (nLoaded > nCurrent)
				{
					nCurrent += 1;
					mBar.width			= nCurrent;
				}
			}
		}
		
		private function stageResizeHandler(e:Event = null):void
		{
			// set stage sizes
			Properties.WI						= Math.max(1000, stage.stageWidth);
			Properties.HE						= Math.max(600, stage.stageHeight);
			
			// declare that stage resized to everything
			dispatchEvent(new Event("stageResized"));
			
			// place items
			mBarContainer.width					= Properties.WI;
			mBarContainer.y						= int(Properties.HE / 2);
			
			if (mBgContainer)
			{
				mBgContainer.x					= int(Properties.WI / 2);
				mBgContainer.y					= int(Properties.HE / 2);
				
				var nPercent:Number				= Math.min(nOrgWi / Properties.WI, nOrgHe / Properties.HE);
				
				mBgContainer.width				= nOrgWi / nPercent;
				mBgContainer.height				= nOrgHe / nPercent;
			}
		}
		
	}

}