package com.cuisine 
{
	import br.com.stimuli.loading.BulkLoader;
	import com.Global;
	import com.utkudemir.Rect;
	import com.utkudemir.Text;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	import gs.easing.Expo;
	import gs.TweenLite;
	import com.mcs.mcCloseBtn;
	
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class Cuisine extends Sprite
	{
		public var he				:int;
		public var orgY				:int;
		
		private var nItemsHe		:int;
		
		private var mBtnItems		:Sprite;
		private var closeBtn		:MovieClip;
		
		private var mSubItems		:Sprite;
		private var mMask			:Rect;
		private var mMasked			:Sprite;
		
		public function Cuisine(xml:XML, bl:BulkLoader, wi:int, $orgY:int) 
		{
			y						=
			orgY					= $orgY;
			
			mBtnItems				= new Sprite();
			addChild(mBtnItems);
			
			var image:Sprite		= new Sprite(); 
			mBtnItems.addChild(image);
			
			var imageBmd:BitmapData	= bl.getBitmapData(xml.@image);
			image.graphics.beginBitmapFill(imageBmd);
			image.graphics.drawRect(0, 0, imageBmd.width, imageBmd.height);
			image.graphics.endFill();
			
			var title:Text			= new Text(xml.@title, { color:0xFFFFFF, size:50, font:1 } );
			var nScale:Number		= 1;
			if (xml.@title_scale != undefined) nScale = Number(xml.@title_scale);
			title.scaleX = title.scaleY = nScale;
			title.x					= int(image.width - title.wi * nScale) - 10;
			title.y					= int(image.height - title.tf.getLineMetrics(0).ascent * nScale) - 10;
			title.filters			= [new GlowFilter(0x000000, .5, 6, 6, 20, 2)];
			mBtnItems.addChild(title);
			
			mBtnItems.mouseChildren	= false;
			
			closeBtn				= MovieClip(new mcCloseBtn());
			closeBtn.x				= 480;
			closeBtn.y				= 50;
			closeBtn.scaleX	= -1;
			addChild(closeBtn);
			
			closeBtn.mouseChildren			= false;
			Global.addButtonFunctions(true, closeBtn, [closeOverHandler, closeOutHandler, closeClickHandler]);
			
			he						+= image.height + 10;
			
			mSubItems				= new Sprite();
			mSubItems.y				= he + 20;
			mSubItems.visible		= false;
			addChild(mSubItems);
			
			mMask					= new Rect(wi, 100);
			mMask.height			= 0;
			mSubItems.addChild(mMask);
			
			mMasked					= new Sprite();
			mMasked.mask			= mMask;
			mSubItems.addChild(mMasked);
			
			var item:CuisineItem;
			var nY:int				= 0;
			for (var i:int = 0; i < xml.item.length(); i++) 
			{
				item				= new CuisineItem(XML(xml.item[i]), bl, wi);
				item.y				= nY;
				mMasked.addChild(item);
				
				nY					+= item.he;
			}
			
			nItemsHe				= nY;
		}
		
		private function closeClickHandler(e:MouseEvent):void
		{
			dispatchEvent(new Event("closeClicked"));
		}
		
		private function closeOverHandler(e:MouseEvent):void
		{
			TweenLite.to(e.target.mcBtn, .3, { alpha:1 } );
		}
		
		private function closeOutHandler(e:MouseEvent):void
		{
			TweenLite.to(e.target.mcBtn, .3, { alpha:.5 } );
		}
		
		public function set Enable(b:Boolean):void
		{
			mBtnItems.buttonMode	= b;
			
			Global.addButtonFunctions(b, mBtnItems, [overHandler, outHandler, clickHandler]);
		}
		
		private function clickHandler(e:MouseEvent = null):void
		{
			he						= mSubItems.y + nItemsHe;
			dispatchEvent(new Event("clicked"));
		}
		
		private function overHandler(e:MouseEvent = null):void
		{
			dispatchEvent(new Event("over"));
		}
		
		private function outHandler(e:MouseEvent = null):void
		{
			dispatchEvent(new Event("out"));
		}
		
		public function open(nDelay:Number = 0):void
		{
			Enable					= false;
			TweenLite.to(closeBtn.mcBtn, .6, { delay:nDelay, x:0, ease:Expo.easeInOut } );
			mSubItems.visible		= true;
			TweenLite.to(mMask, .6, { delay:nDelay + .6, height:mMasked.height + 50, ease:Expo.easeInOut } );
		}
		
		public function close():void
		{
			mouseChildren			= false;
			TweenLite.to(mBtnItems, .3, { autoAlpha:0 } );
		}
		
		public function idle():void
		{
			Enable					= true;
			mouseChildren			= true;
			
			he						= mSubItems.y - 20;
			
			TweenLite.to(closeBtn.mcBtn, .3, { x:-85, ease:Expo.easeIn } );
			TweenLite.to(mBtnItems, .3, { delay:.9, autoAlpha:1 } );
			TweenLite.to(mMask, .3, { height:0, ease:Expo.easeInOut, onComplete:function()
			{
				mSubItems.visible	= false;
			} } );
			TweenLite.to(this, .6, { delay:.3, y:orgY, ease:Expo.easeInOut } );
		}
	}

}