﻿package com.formEelements 
{
	import com.utkudemir.Text;
	import com.utkudemir.Rect;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	/**
	* ...
	* @author Utku Demir || utku@csdlab.com
	*/
	public class FCheckbox extends Sprite
	{
		// variables
		public var value				:String;
		public var he					:int = 48;
		public var warnable				:Boolean = false;
		
		private var themeColor			:Number;
		private var selectedBtn			:Rect;
		private var dot					:Rect;
		private var firstSelected		:Rect;
		
		private var bCheckbox			:Boolean;
		
		
		public function FCheckbox(xml:XML, _width:int, _themeColor:Number, _bCheckbox:Boolean = false)
		{
			// set variables
			bCheckbox					= _bCheckbox;
			themeColor 					= _themeColor;
			
			// create the text on the left
			var tTitle:Text 			= new Text(xml.@title, { color:0x000000, font:1, width:100, size:14 } );
			tTitle.y					= 7;
			addChild(tTitle);
			
			// create variables
			var i:int 					= 0;
			var nX:int 					= 105;
			var border:FBorder;
			var title:Text;
			var button:Rect;
			
			// create the check/radio button dot
			dot 						= new Rect(5, 5, 0xFFFFFF);
			dot.mouseChildren			= false;
			dot.mouseEnabled			= false;
			dot.visible					= false;
			dot.y = 14;
			
			if (bCheckbox)
			{
				dot.graphics.clear();
				dot.graphics.beginFill(0xFFFFFF);
				dot.graphics.moveTo(-4, 0);
				dot.graphics.lineTo(1, 5);
				dot.graphics.lineTo(10, -3);
				dot.graphics.lineTo(1, 8);
				dot.graphics.lineTo(-4, 0);
				dot.graphics.endFill();
				dot.y = 13;
			}
			
			// create the checbox/radio button items
			for each(var xmlNode:XML in xml.children())
			{
				border = new FBorder(14, 14);
				border.y = 9;
				border.x = nX;
				addChild(border);
				
				nX += border.width + 5;
				
				title = new Text(xmlNode.@title, {color:0xffffff, font:1, size:14});
				title.x = nX;
				title.y = 8;
				addChild(title);
				
				nX += title.wi + 15;
				
				
				button = new Rect(14, 20, themeColor, 0, 0, 0);
				button.name = xmlNode.@fValue;
				button.x = border.x;
				button.y = border.y;
				addChild(button);
				button.buttonMode = true;
				button.addEventListener(MouseEvent.CLICK, changeSelected);
				if (xmlNode.@fSelected == true)
				{
					changeSelected(null, button);
					firstSelected = button;
				}
			}
			
			addChild(dot);
		}
		
		private function changeSelected(e:MouseEvent = null, btn:Rect = null)
		{
			var targetBtn:Rect = ((e != null) ? Rect(e.target) : btn);
			
			if (selectedBtn != null) selectedBtn.visible = true;
			
			if (targetBtn != null)
			{
				if ((selectedBtn != targetBtn) || !bCheckbox)
				{
					selectedBtn 			= targetBtn;
					if(!bCheckbox) selectedBtn.visible = false;
					dot.x 					= selectedBtn.x + 5;
					dot.visible				= true;
					value = selectedBtn.name;
				}
				else
				{
					selectedBtn			= null;
					value				= "false";
					dot.visible			= false;
					
					if (bCheckbox && firstSelected != null && e == null)
					{
						selectedBtn		= firstSelected;
						selectedBtn.visible	= true;
						dot.x 					= selectedBtn.x + 5;
						dot.visible				= true;
					}
				}
			}
			else
			{				
				selectedBtn			= null;
				value				= "false";
				dot.visible			= false;
			}
			
			if (bCheckbox) value		= dot.visible ? "true" : "false";
		}
		public function clear()
		{
			changeSelected(null, firstSelected);
		}
	}
	
}