﻿package com.formEelements 
{
	import com.Properties;
	import com.utkudemir.Input;
	import com.utkudemir.Text;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.text.AntiAliasType;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import com.utkudemir.Rect;
	import gs.TweenLite;
	import gs.TweenMax;
	
	/**
	* ...
	* @author Utku Demir || utku@csdlab.com
	*/
	public class FDate extends Sprite
	{
		// variables
		public var value			:String 	= "";
		public var he				:int 		= 48;
		public var warnable			:Boolean 	= true;
		
		private var mDds			:Sprite;
		private var aItems			:Array;
		private var fDay			:FDropdownItem;
		private var fMonth			:FDropdownItem;
		private var fYear			:FDropdownItem;
		private var inputText		:Input;
		private var border			:FBorder;
		private var themeColor		:Number;
		private var required		:Boolean;
		
		private var mWarn			:Sprite;
		
		
		public function FDate(xml:XML, _width:int, _themeColor:Number, sReq:String) 
		{			
			// set variables
			themeColor 					= _themeColor;
			required 					= (xml.@fRequired == "true");
			_width 						-= 130;
			
			// create the text on the left
			var tTitle:Text 			= new Text(xml.@title, { color:0xffffff, font:1, width:100, size:14 } );
			tTitle.y					= 7;
			addChild(tTitle);
			
			var date:Date				= new Date();
			
			var dayXml:XML				= <formElement></formElement>;
			dayXml.@select				= "";
			dayXml.@fMaxLine			= "5";
			var dayItemXml:XML;
			for (var i:int = 0; i < 31; i++) 
			{
				dayItemXml				= <dropdownItem />;
				dayItemXml.@title		= String(i + 1);
				dayItemXml.@fValue		= String(i + 1);
				
				if (i + 1 == date.getDate()) dayItemXml.@selected = "true";
				dayXml.appendChild(dayItemXml);
			}
			
			var monthXml:XML			= <formElement></formElement>;
			monthXml.@select			= "";
			monthXml.@fMaxLine			= "5";
			var monthItemXml:XML;
			for (i = 0; i < 12; i++) 
			{
				monthItemXml			= <dropdownItem />;
				monthItemXml.@title		= String(i + 1);
				monthItemXml.@fValue	= String(i + 1);
				if (i == date.getMonth()) monthItemXml.@selected = "true";
				monthXml.appendChild(monthItemXml);
			}
			
			var yearXml:XML				= <formElement></formElement>;
			yearXml.@select				= "";
			yearXml.@fMaxLine			= "5";
			var yearItemXml:XML;
			for (i = 0; i < 2; i++) 
			{
				yearItemXml				= <dropdownItem />;
				yearItemXml.@title		= String(date.getFullYear() + i);
				yearItemXml.@fValue		= String(date.getFullYear() + i);
				if (i == 0) yearItemXml.@selected = "true";
				yearXml.appendChild(yearItemXml);
			}
			
			// create the warning items' container
			mWarn					= new Sprite();
			mWarn.alpha				= 0;
			mWarn.x					= _width + 105;
			mWarn.y					= 31;
			addChild(mWarn);
			
			// create the warning items' background rectangle
			var warnBg:Rect			= new Rect(100, 11, themeColor, -100);
			mWarn.addChild(warnBg);
			
			// create the warning text
			var warnText:Text		= new Text(sReq, { size:10, width:300, font:2, color:0x000000, align:"right" } );
			warnText.x				= -300;
			warnText.y				= -6;
			mWarn.addChild(warnText);
			
			warnBg.width			= warnText.wi + 10;
			
			mDds					= new Sprite();
			addChild(mDds);
			
			aItems					= new Array();
			
			fDay					= new FDropdownItem(dayXml, 40, Properties.DATA.config.@themeColor, 0, false, true);
			fDay.x 					= 105;
			fDay.addEventListener("activated", itemActivatedHandler);
			fDay.addEventListener("changed", itemChangedHandler);
			mDds.addChild(fDay);
			aItems.push(fDay);
			
			fMonth					= new FDropdownItem(monthXml, 40, Properties.DATA.config.@themeColor, 1, false, true);
			fMonth.x 				= 144;
			fMonth.addEventListener("activated", itemActivatedHandler);
			mDds.addChild(fMonth);
			aItems.push(fMonth);
			
			fYear					= new FDropdownItem(yearXml, 60, Properties.DATA.config.@themeColor, 2, false, true);
			fYear.x 				= 183;
			fYear.addEventListener("activated", itemActivatedHandler);
			mDds.addChild(fYear);
			aItems.push(fYear);
			
			
			// create the item's border
			border 					= new FBorder(60, 31);
			TweenMax.to(border.bg, 0, {glowFilter:{color:0xFF0000, alpha:1, blurX:10, blurY:10, strength:0} } ); 
			border.x 				= 260;
			addChild(border);
			
			
			// create the item's input field
			inputText				= new Input(60, 250, 2, "0-9:", required, "str", false, 1, 14, 0xFFFFFF, "center");
			inputText.x				= 260;
			inputText.y				= 8;
			inputText.text			= xml.@fDefaultTime;
			addChild(inputText);
			
		}
		
		private function itemChangedHandler(e:Event):void 
		{
			value					= fDay.value + "." + fMonth.value + "." + fYear.value + " " + inputText.value;
		}
		
		private function itemActivatedHandler(e:Event):void 
		{
			mDds.swapChildren(mDds.getChildAt(mDds.numChildren - 1), aItems[e.target.no]);
			dispatchEvent(new Event("activated"));
		}
		
		public function get ok():Boolean
		{
			return true;
		}
		
		public function set warn(b:Boolean)
		{
			if (b)
			{
				TweenLite.to(mWarn, .3, { alpha:1 } );
			}
			else
			{
				TweenLite.to(mWarn, .3, { alpha:0 } );
			}
		}
		
		public function clear()
		{
			value 						= "";
			warn 						= false;
			fDay.clear();
			fMonth.clear();
			fYear.clear();
			inputText.reset();
		}
	}
	
}