﻿package com.formEelements 
{
	import com.utkudemir.Text;
	import flash.display.Sprite;
	import flash.events.Event;
	import com.utkudemir.Rect;
	import gs.TweenLite;
	
	/**
	* ...
	* @author Utku Demir || utku@csdlab.com
	*/
	public class FDropdown extends Sprite
	{
		// variables
		public var he			:int = 48;
		public var value		:String = "";
		public var warnable		:Boolean = true;
		
		private var themeColor	:Number;
		private var required	:Boolean;
		private var items		:Sprite;
		private var itemsMask	:Sprite;
		
		private var ddItem		:FDropdownItem;
		
		private var mWarn		:Sprite;
		
		
		public function FDropdown(xml:XML, _width:int, _themeColor:Number, sReq:String)
		{
			// set variables
			themeColor 				= _themeColor;
			required 				= (xml.@fRequired == "true");
			
			// create the text on the left
			var tTitle:Text 		= new Text(xml.@title, { color:0xffffff, font:1, width:100, size:16 } );
			tTitle.y				= 6;
			addChild(tTitle);
			
			_width -= 130;
			
			// create the warning container sprite
			mWarn					= new Sprite();
			mWarn.alpha				= 0;
			mWarn.x					= _width + 105;
			mWarn.y					= 33;
			addChild(mWarn);
			
			// create the dropdown item
			ddItem 					= new FDropdownItem(xml, _width, _themeColor);
			ddItem.addEventListener("selected", ddChanged);
			ddItem.addEventListener("activated", function() 
			{
				dispatchEvent(new Event("activated"));
			} );
			ddItem.x 				= 105;
			addChild(ddItem);
			
			// create the warning objects
			var warnBg:Rect			= new Rect(100, 11, themeColor, -100);
			mWarn.addChild(warnBg);
			
			var warnText:Text		= new Text(sReq, { size:10, width:300, font:2, color:0x000000, align:"right" } );
			warnText.x				= -300;
			warnText.y				= -6;
			mWarn.addChild(warnText);
			
			warnBg.width			= warnText.wi + 10;
		}
		private function ddChanged(e:Event)
		{
			value = ddItem.value;
			ok;
		}
		public function get ok():Boolean
		{
			if (required && value == "")
			{
				warn = true;
				return false;
			}
			else
			{
				warn = false;
				return true;
			}
		}
		public function set warn(b:Boolean)
		{
			ddItem.warn = b;
			
			
			if (b)
			{
				TweenLite.to(mWarn, .3, { alpha:1 } );
			}
			else
			{
				TweenLite.to(mWarn, .3, { alpha:0 } );
			}
		}
		public function clear()
		{
			value = "";
			ddItem.clear();
		}
	}
	
}