﻿package com.formEelements 
{
	import com.utkudemir.Text;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.AntiAliasType;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import com.utkudemir.Rect;
	import gs.TweenLite;
	import gs.TweenMax;
	
	/**
	* ...
	* @author Utku Demir || utku@csdlab.com
	*/
	public class FDropdownItem extends Sprite
	{
		// variables
		public var value			:String;
		public var no				:int;
		private var themeColor		:Number;
		private var border			:FBorder;
		private var btn				:Rect;
		private var menu			:FDropdownMenu;
		private var titleText		:Text;
		private var selecttext		:String;
		private var selectedValue	:String				= "";
		
		public function FDropdownItem(xml:XML, _width:int, _themeColor:Number, _no:int = 0, bArrow:Boolean =true, bCenter:Boolean = false) 
		{
			// set variables
			no 						= _no;
			themeColor 				= _themeColor;
			
			// create item's border
			border 					= new FBorder(_width, 31);
			addChild(border);
			
			selecttext 				= xml.@select;
			
			// create the selected item's caption text
			titleText 				= new Text(selecttext, { color:0xFFFFFF, font:1, width:_width - 10, size:14, align:bCenter ? "center" : "left" } );
			titleText.x				= 5;
			titleText.y				= 8;
			addChild(titleText);
			
			// create the dropdown item objects
			var fArrow:FDropdownArrow = new FDropdownArrow();
			fArrow.mouseEnabled 	= false;
			fArrow.x 				= _width - 40;
			fArrow.y 				= 11;
			if(bArrow) addChild(fArrow);
			
			btn 					= new Rect(_width, 31, 0xFf0000, 0, 0, 0);
			
			// create the dropdown menu
			menu 					= new FDropdownMenu();
			menu.addEventListener("changed", menuChanged);
			menu.init(xml, _width, themeColor);
			
			for (var i:int = 0; i < xml.dropdownItem.length(); i++) 
			{
				if (xml.dropdownItem[i].@selected == true) 
				{
					selecttext		= xml.dropdownItem[i].@title;
					selectedValue 	= xml.dropdownItem[i].@fValue;
				}
			}
			
			TweenMax.to(menu, 0, {glowFilter:{color:0xCCCCCC, alpha:.6, blurX:3, blurY:3, strength:0} } ); 
			menu.visible 			= false;
			addChild(menu);
			addChild(btn);
			
			Enable 					= true;
		}
		
		private function menuChanged(e:Event)
		{
			titleText.text 			= menu.selectedText;
			value 					= menu.value;
			closeMenu();
			dispatchEvent(new Event("selected"));
		}
		public function set Enable(value:Boolean) 
		{
			btn.buttonMode 			= value;
			
			if (value) {
				btn.addEventListener(MouseEvent.CLICK, openMenu);
			} else {
				btn.removeEventListener(MouseEvent.CLICK, openMenu);
			}
		}
		
		private function openMenu(e:MouseEvent)
		{
			TweenMax.to(menu, .3, { glowFilter:{strength:1} } );
			dispatchEvent(new Event("activated"));
			btn.visible 			= false;
			menu.visible 			= true;
			menu.Enable 			= true;
			addEventListener(Event.ENTER_FRAME, hitCheck);
		}
		private function closeMenu()
		{
			removeEventListener(Event.ENTER_FRAME, hitCheck);
			menu.visible 			= false;
			menu.Enable 			= false;
			btn.visible 			= true;
			TweenMax.to(menu, .3, { glowFilter:{strength:0} } );
		}
		
		private function hitCheck(e:Event)
		{
			if (mouseX < 0 || mouseX > menu.width || mouseY < 0 || mouseY > menu.he)
			{
				closeMenu();
			}
		}
		
		public function set warn(b:Boolean)
		{
			if (b)
			{
				TweenLite.to(border.border, .3, { tint:themeColor } );
			}
			else
			{
				TweenLite.to(border.border, .3, {tint:null } );
			}
		}
		
		public function clear()
		{
			value 					= selectedValue;
			titleText.text 			= selecttext;
			warn 					= false;
		}
	}
	
}