﻿package com.formEelements 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import com.utkudemir.Rect;
	
	/**
	* ...
	* @author Utku Demir || utku@csdlab.com
	*/
	public class FDropdownMenu extends Sprite
	{
		// variables
		public var he					:int;
		public var value				:String;
		public var selectedText			:String;
		private var themeColor			:Number;
		private var sItems				:Sprite;
		private var sMask				:Rect;
		private var itemCount			:int;
		private var maskHeight			:int;
		private var maxItemCount		:int;
		
		public function FDropdownMenu():void
		{}
		
		public function init(xml:XML, width:int, _themeColor:Number) 
		{
			// set variables
			themeColor 					= _themeColor;
			maxItemCount 				= xml.@fMaxLine;
			itemCount 					= xml.dropdownItem.length();
			maskHeight 					= (itemCount <= maxItemCount) ? itemCount * 24:maxItemCount * 24;
			he 							= maskHeight;
			
			// create the item's border
			addChild(new FBorder(width, maskHeight));
			
			// create the main container sprite
			sItems 						= new Sprite();
			sMask 						= new Rect(width, maskHeight, 0xFF0000, 0, 0, .2);
			
			sItems.mask 				= sMask;
			
			addChild(sItems);
			addChild(sMask);
			
			// create the dropdown items
			var i:int 					= 0;
			var item:FDropdownMenuItem;
			for each(var xmlNode:XML in xml.dropdownItem)
			{
				item 					= new FDropdownMenuItem(xmlNode.@title, xmlNode.@fValue, width);
				item.onClick 			= clickHandler;
				item.y 					= i * 24;
				
				if (xmlNode.@selected == "true")
				{
					selectedText		= xmlNode.@title;
					value				= xmlNode.@fValue;
					dispatchEvent(new Event("changed"));
				}
				sItems.addChild(item);
				
				i++;
			}
		}
		
		public function set Enable(b:Boolean)
		{
			if (b)
			{
				if(itemCount > maxItemCount) addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			}
			else
			{
				if(hasEventListener(Event.ENTER_FRAME)) removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			}
		}
		private function enterFrameHandler(e:Event)
		{
			var minY:int 				= -1 * (sItems.height - maxItemCount * 24);
			var refY:int 				= maxItemCount * 24;
			var targetY:Number 			= (mouseY - 12) * minY / (refY - 24);
			if (targetY > 0) targetY 	= 0;
			if (targetY < minY) targetY = minY;
			sItems.y 					= targetY;
		}
		private function clickHandler(item:FDropdownMenuItem)
		{
			value 						= item.value;
			selectedText 				= item.selectedText;
			dispatchEvent(new Event("changed"));
		}
	}
	
}