﻿package com.formEelements 
{
	import com.utkudemir.Text;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import com.utkudemir.Rect;
	import gs.TweenLite;
	
	/**
	* ...
	* @author Utku Demir || utku@csdlab.com
	*/
	public class FDropdownMenuItem extends Sprite
	{
		// variables
		public var onClick			:Function;
		public var value			:String;
		public var selectedText		:String;
		
		
		public function FDropdownMenuItem(_text:String, _value:String, _width:Number) 
		{
			// set variables
			value 					= _value;
			selectedText 			= _text;
			
			var title:Text 			= new Text(_text, {color:0xFFFFFF, font:1, width:_width - 10, size:14});
			title.x 				= 10;
			title.y 				= 3;
			addChild(title);
			
			// create a background rectangle
			addChild(new Rect(_width, 20, 0xFF0000, 0, 0, 0));
			
			// enable it
			mouseChildren 			= false;
			Enable 					= true;
		}
		public function set Enable(b:Boolean)
		{
			buttonMode = b;
			
			if (b)
			{
				addEventListener(MouseEvent.ROLL_OVER, rollOverHandler);
				addEventListener(MouseEvent.ROLL_OUT, rollOutHandler);
				addEventListener(MouseEvent.CLICK, clickHandler);
			}
			else
			{
				removeEventListener(MouseEvent.ROLL_OVER, rollOverHandler);
				removeEventListener(MouseEvent.ROLL_OUT, rollOutHandler);
				removeEventListener(MouseEvent.CLICK, clickHandler);
			}
		}
		
		private function rollOverHandler(e:MouseEvent)
		{
			TweenLite.to(this, .3, {alpha:.6 } );
		}
		private function rollOutHandler(e:MouseEvent)
		{
			TweenLite.to(this, .3, {alpha:1 } );
		}
		private function clickHandler(e:MouseEvent)
		{
			if (onClick != null) onClick(this);
		}
	}
	
}