﻿package com.formEelements 
{
	import com.utkudemir.Input;
	import com.utkudemir.Text;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.text.AntiAliasType;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import com.utkudemir.Rect;
	import gs.TweenLite;
	import gs.TweenMax;
	
	/**
	* ...
	* @author Utku Demir || utku@csdlab.com
	*/
	public class FString extends Sprite
	{
		// variables
		public var value			:String 	= "";
		public var he				:int 		= 48;
		public var warnable			:Boolean 	= true;
		
		private var inputText		:Input;
		private var border			:FBorder;
		private var themeColor		:Number;
		private var required		:Boolean;
		
		private var mWarn			:Sprite;
		
		
		public function FString(xml:XML, _width:int, _themeColor:Number, sReq:String) 
		{			
			// set variables
			themeColor 				= _themeColor;
			required 				= (xml.@fRequired == "true");
			_width 					-= 130;
			
			// create the text on the left
			var tTitle:Text 		= new Text(xml.@title, { color:0xffffff, font:1, width:100, size:14 } );
			tTitle.y				= 7;
			addChild(tTitle);
			
			// create the item's border
			border 					= new FBorder(_width, 31);
			TweenMax.to(border.bg, 0, {glowFilter:{color:0xFF0000, alpha:1, blurX:10, blurY:10, strength:0} } ); 
			border.x 				= 105;
			addChild(border);
			
			// create the item's input field
			inputText				= new Input(_width, 250, 1, xml.@fRestrict == undefined ? "":String(xml.@fRestrict), required, "str", false, 1, 14, 0xFFFFFF);
			inputText.x				= 110;
			inputText.y				= 8;
			addChild(inputText);
			
			// create the warning items' container
			mWarn					= new Sprite();
			mWarn.alpha				= 0;
			mWarn.x					= _width + 105;
			mWarn.y					= 31;
			addChild(mWarn);
			
			// create the warning items' background rectangle
			var warnBg:Rect			= new Rect(100, 11, themeColor, -100);
			mWarn.addChild(warnBg);
			
			// create the warning text
			var warnText:Text		= new Text(sReq, { size:10, width:300, font:2, color:0x000000, align:"right" } );
			warnText.x				= -300;
			warnText.y				= -6;
			mWarn.addChild(warnText);
			
			warnBg.width			= warnText.wi + 10;
			
			// enable it
			Enable = true;
			
		}
		
		public function set Enable(value:Boolean)
		{	
			if (value) 
			{
				inputText.addEventListener("focusedIn", focusInHandler);
				inputText.addEventListener("focusedOut", focusOutHandler);
			} 
			else 
			{
				inputText.removeEventListener("focusedIn", focusInHandler);
				inputText.removeEventListener("focusedOut", focusOutHandler);
				inputText.text = "";
			}
		}

		private function focusInHandler(e:Event)
		{
			TweenLite.to(mWarn, .3, { alpha:0 } );
			dispatchEvent(new Event("activated"));
			TweenLite.to(border.border, .3, {tint:0x666666 } );
			TweenLite.to(border.bg, .3, {tint:0x111111 } );
		}
		
		private function focusOutHandler(e:Event)
		{
			value = inputText.value;
			TweenLite.to(border.border, .3, {tint:null } );
			TweenLite.to(border.bg, .3, {tint:null } );
			ok;
		}
		
		public function get ok():Boolean
		{
			if (!inputText.check)
			{
				warn 					= true;
				return false;
			}
			else
			{
				warn 					= false;
				return true;
			}
		}
		
		public function set warn(b:Boolean)
		{
			if (b)
			{
				TweenLite.to(border.border, .3, { tint:themeColor } );
				TweenLite.to(mWarn, .3, { alpha:1 } );
			}
			else
			{
				TweenLite.to(border.border, .3, {tint:null } );
				TweenLite.to(mWarn, .3, { alpha:0 } );
			}
		}
		public function clear()
		{
			value 						= "";
			inputText.reset();
			warn 						= false;
		}
	}
	
}