package com.gallery 
{
	import com.utkudemir.Rect;
	import com.utkudemir.Text;
	import com.Properties;
	import com.ui.Menu;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.TextEvent;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class Gallery extends Sprite
	{
		// variables
		private static var _instance	:Gallery;
		
		public var activeItem			:GalleryItem;
		public var nTotal				:int;
		private var xml					:XML;
		private var wi					:int;
		
		private var aItems				:Array;
		private var mMasked				:Sprite;
		
		private var info				:Object;
		
		public function Gallery($nCol:int, $nColSpace:int, $nRowSpace:int, $nThumbWi:int, $nThumbHe:int, $nOffset:int, $wi:int) 
		{
			// set instance
			_instance					= this;
			wi							= $wi;
			
			// get values of properties
			info						= { nCol:$nCol, nColSpace:$nColSpace, nRowSpace:$nRowSpace, nThumbWi:$nThumbWi, nThumbHe:$nThumbHe, nOffset:$nOffset };
			
			// create mask
			mMasked						= new Sprite();
			addChild(mMasked);
			
			// create the main container array
			aItems						= new Array();
		}
		
		public function init($xml:XML):void
		{
			// set xml
			xml							= $xml;
			
			// set variables
			var item					:GalleryItem;
			var tHeader					:Text;
			var mLine					:Rect;
			var nX:int					= 0;
			var nY:int					= 0;
			var nOnRow:int				= 0;
			var bEndOfLine:Boolean		= false;
			nTotal						= 0;
			
			// create thumbnail items
			for (var i:int = 0; i < xml.children().length(); i++) 
			{
				if (xml.children()[i].localName() == "header")
				{
					if (i > 0 && !bEndOfLine)  
					{
						nY		+= info.nThumbHe + info.nRowSpace + info.nOffset + 40;
					}
					
					tHeader				= new Text("", { size:10, font:2, color:0xFFFFFF, width:wi, leading:-2, linkcolor:Properties.DATA.config.@linkColor, overcolor:Properties.DATA.config.@linkOverColor } );
					tHeader.y			= nY;
					mMasked.addChild(tHeader);
					
					tHeader.tf.addEventListener(TextEvent.LINK, linkHandler);
					
					tHeader.text		= xml.children()[i].text();
					
					mLine				= new Rect(wi, 1, 0x333333);
					mLine.y				= nY + tHeader.he + 10;
					mMasked.addChild(mLine);
					
					nX					= 0;
					nY 					+= tHeader.he + 20;
					nOnRow				= 0;
				}
				else
				{
					item					= new GalleryItem(nTotal, XML(xml.children()[i]), info);
					item.x					= nX;
					item.y					= nY;
					item.addEventListener("clicked", itemClickHandler);
					mMasked.addChild(item);
					
					aItems[nTotal]				= item;
					
					nX						+= info.nThumbWi + info.nColSpace + info.nOffset;
					nOnRow					++;
					nTotal					++;
					bEndOfLine				= false;
					
					if (nOnRow == info.nCol)
					{
						nX					= 0;
						nY					+= info.nThumbHe + info.nRowSpace + info.nOffset + 30;
						nOnRow				= 0;
						bEndOfLine			= true;
					}
				}
			}
			
			// setMaxSizes
			if (xml.@maxImageWidth != undefined || xml.@maxImageHeight != undefined)
			{
				var nMaxImageWidth:int	= xml.@maxImageWidth != undefined ? xml.@maxImageWidth: -1;
				var nMaxImageHeight:int	= xml.@maxImageHeight != undefined ? xml.@maxImageHeight: -1;
				
				for (i = 0; i < aItems.length; i++) 
				{
					if (aItems[i].xml.@maxImageWidth == undefined) aItems[i].xml.@maxImageWidth = nMaxImageWidth;
					if (aItems[i].xml.@maxImageHeight == undefined) aItems[i].xml.@maxImageHeight = nMaxImageHeight;
				}
			}
		}
		
		private function linkHandler(e:TextEvent):void
		{
			//Menu.instance.linkClick(e.text);
		}
		
		public function np(n:int):void
		{
			// next-previous buttons' click
			var nNext:int					= activeItem.no + n;
			
			if (nNext == nTotal) nNext		= 0;
			if (nNext == -1) nNext			= nTotal - 1;
			
			// set the active item
			activeItem						= aItems[nNext];
			
			// declare some thumbnail's clicked
			dispatchEvent(new Event("clicked"));
		}
		
		private function itemClickHandler(e:Event):void 
		{
			// change the active item
			activeItem						= GalleryItem(e.target);
			
			// declare some thumbnail's clicked
			dispatchEvent(new Event("clicked"));
		}
		
		public function clear():void
		{
			// remove all the thumbnails
			while (mMasked.numChildren > 0) mMasked.removeChildAt(0);
			aItems						= new Array();
		}
		
		static public function get instance():Gallery { return _instance; }
	}

}