package com.gallery 
{
	import br.com.stimuli.loading.loadingtypes.LoadingItem;
	import com.Global;
	import com.utkudemir.Border;
	import com.utkudemir.GradRect;
	import com.utkudemir.MaskedObject;
	import com.utkudemir.PreloaderBall;
	import com.utkudemir.Rect;
	import com.utkudemir.Text;
	import com.Properties;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import gs.easing.Expo;
	import gs.TweenLite;
	import gs.TweenMax;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class GalleryItem extends Sprite
	{
		// variables
		public var xml					:XML;
		public var no					:int;
		private var mOver				:Rect;
		private var mBorder				:Border;
		private var info				:Object;
		private var mPreloader			:PreloaderBall;
		
		private var mImage				:Sprite;
		private var mImageMask			:Rect;
		private var tTitle				:Text;
		
		private var sThumbSource		:String;
		private var nThemeColor			:int;
		
		
		public function GalleryItem($no:int, $xml:XML, $info:Object) 
		{
			// set the variables
			no							= $no;
			xml							= $xml;
			info						= $info;
			
			// get the theme color
			nThemeColor					= xml.@overColor != undefined ? xml.@overColor : Properties.DATA.config.@themeColor;
			
			// create the background rectangle
			addChild(new Rect(info.nThumbWi, info.nThumbHe + 20, 0x000000));
			
			// create the over rectangle
			mOver						= new Rect(info.nThumbWi, 20, nThemeColor);
			mOver.alpha					= .6;
			mOver.y						= info.nThumbHe;
			mOver.height				= 0;
			addChild(mOver);
			
			var gradOver:GradRect		= new GradRect(info.nThumbWi, 20, [0x000000, 0x000000], 1, [0, .3]);
			gradOver.y					= info.nThumbHe;
			addChild(gradOver);
			
			// add button functions
			mouseChildren				= false;
			Global.addButtonFunctions(true, this, [overHandler, outHandler, clickHandler]);
			
			// create the caption textfield
			tTitle						= new Text(xml.@title, { size:10, color:0xFFFFFF, font:2 } );
			tTitle.x					= 5;
			tTitle.y					= info.nThumbHe + 2;
			addChild(tTitle);
			
			// create the mask
			mImageMask					= new Rect(info.nThumbWi, info.nThumbHe, 0, -1 * info.nThumbWi / 2, -1 * info.nThumbHe / 2);
			mImageMask.x				= info.nThumbWi / 2;
			mImageMask.y				= info.nThumbHe / 2;
			mImageMask.width			= info.nThumbWi - 10;
			mImageMask.height			= info.nThumbHe - 10;
			addChild(mImageMask);
			
			// create the preloader
			mPreloader					= new PreloaderBall();
			mPreloader.x				= int(info.nThumbWi / 2);
			mPreloader.y				= int(info.nThumbHe / 2);
			mPreloader.turn				= true;
			addChild(mPreloader);
			
			// create the image container sprite
			mImage						= new Sprite();
			mImage.mask					= mImageMask;
			mImage.alpha				= 0;
			addChild(mImage);
			
			// set the thumbnails saturation
			//TweenMax.to(mImage, 0, {colorMatrixFilter:{saturation:0}});
			
			// create the border
			mBorder						= new Border(info.nThumbWi, info.nThumbHe, 0x333333);
			mBorder.alpha				= .6;
			addChild(mBorder);
			
			// create the image loader
			sThumbSource				= xml.@thumbnail;
			var imageItem:LoadingItem;
			if (Properties.BL.get(sThumbSource) == null)
			{
				imageItem				= Properties.BL.add(sThumbSource, { id:sThumbSource } );
				imageItem.addEventListener(Event.COMPLETE, itemLoadedHandler);
			}
			else
			{
				imageItem				= Properties.BL.get(sThumbSource);
				imageItem.addEventListener(Event.COMPLETE, itemLoadedHandler);
				
				if (imageItem.isLoaded) imageItem.dispatchEvent(new Event(Event.COMPLETE));				
			}
			
			if (!Properties.BL.isRunning) Properties.BL.start(1);
		}
		
		private function itemLoadedHandler(e:Event):void 
		{
			var imageItem:LoadingItem	= Properties.BL.get(sThumbSource);
			var bmp:Bitmap				= Properties.BL.getBitmap(sThumbSource);
			var bmd:BitmapData			= new BitmapData(bmp.width, bmp.height);
			bmd.draw(bmp);
			
			mImage.graphics.beginBitmapFill(bmd);
			mImage.graphics.drawRect(0, 0, bmp.width, bmp.height);
			mImage.graphics.endFill();
			
			mPreloader.turn				= false;
			TweenLite.to(mPreloader, .3, { scaleX:2, scaleY:2, alpha:0 } );
			TweenLite.to(mImage, 1, { delay:.3, alpha:1 } );
		}
		
		public function overHandler(e:MouseEvent = null):void
		{
			TweenLite.to(mOver, .5, { height:20, ease:Expo.easeOut } );
			TweenLite.to(mBorder, .5, { tint:nThemeColor, ease:Expo.easeOut } );
			TweenLite.to(tTitle, .5, { tint:nThemeColor, ease:Expo.easeOut } );
			TweenLite.to(mImageMask, .5, { width:info.nThumbWi - 4, height:info.nThumbHe - 4, ease:Expo.easeOut } );
			//TweenMax.to(mImage, .5, {colorMatrixFilter:{saturation:1}});
		}
		
		public function outHandler(e:MouseEvent = null):void
		{
			TweenLite.to(mOver, .3, { height:0, ease:Expo.easeInOut } );
			TweenLite.to(mBorder, .5, { tint:null, ease:Expo.easeInOut } );
			TweenLite.to(tTitle, .5, { tint:null, ease:Expo.easeInOut } );
			TweenLite.to(mImageMask, .5, { width:info.nThumbWi - 10, height:info.nThumbHe - 10, ease:Expo.easeOut } );
			//TweenMax.to(mImage, .3, {colorMatrixFilter:{saturation:0}});
		}
		
		public function clickHandler(e:MouseEvent = null):void
		{
			dispatchEvent(new Event("clicked"));
		}
	}

}