package com.gallery 
{
	import com.Global;
	import com.ui.Footer;
	import com.utkudemir.GradRect;
	import com.utkudemir.MaskedObject;
	import com.utkudemir.Rect;
	import com.utkudemir.Text;
	import com.mcs.mcNextPrev;
	import com.mcs.mcCloseBtn;
	import com.mcs.mcPauseBtn;
	import com.Properties;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.NetStatusEvent;
	import flash.events.ProgressEvent;
	import flash.media.Video;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.net.URLRequest;
	import flash.system.Capabilities;
	import flash.ui.Mouse;
	import gs.easing.Expo;
	import gs.TweenLite;
	import com.bmds.bmdFilter;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class TopItems extends Sprite
	{
		// variables
		private var mBg					:Rect;
		private var mImage				:MaskedObject;
		private var mBase				:Sprite;
		private var mFilter				:Sprite;
		
		private var mButtons			:Sprite;
		private var mPrev				:MovieClip;
		private var mNext				:MovieClip;
		private var mClose				:MovieClip;
		private var mPause				:MovieClip;
		
		private var mVideo				:Sprite;
		private var video				:Video;
		private var ns					:NetStream;
		private var nc					:NetConnection;
		private var obj					:Object;
		private var nDuration			:int;
		private var nTime				:int;
		private var nTimePlus			:int;
		private var bPlaying			:Boolean;
		
		private var mBar				:Rect;
		private var mBarLoaded			:Rect;
		private var mBarContainer		:Rect;
		
		private var gallery				:Gallery;
		
		public var nWi					:int				= 400;
		public var nHe					:int				= 300;
		
		private var loader				:Loader;
		private var bLoaded				:Boolean;
		private var nLoaded				:int;
		private var nCurrent			:int;
		
		private var nOrgWi				:int;
		private var nOrgHe				:int;
		
		private var nTargetWi			:int;
		private var nTargetHe			:int;
		
		private var bStopped			:Boolean;
		private var bDown				:Boolean			= false;
		
		private var bManualSize			:Boolean			= false;
		private var nMaxWidth			:int;
		private var nMaxHeight			:int;
		
		public function TopItems() 
		{
			// set the first situation
			visible						= false;
			
			// create a fake backgroud rectangle
			mBg							= new Rect(100, 100, 0, 0, 0, .8);
			mBg.alpha					= 0;
			addChild(mBg);
			
			// create a masked object as a countainer
			mImage						= new MaskedObject();
			addChild(mImage);
			
			// create the main container sprite
			mBase						= new Sprite();
			mImage.mMasked.addChild(mBase);
			
			// create the buttons' container
			mButtons					= new Sprite();
			addChild(mButtons);
			
			// create the next-previous buttons' container
			mPrev						= MovieClip(new mcNextPrev());
			mPrev.no					= -1;
			mButtons.addChild(mPrev);
			
			mPrev.mouseChildren			= false;
			Global.addButtonFunctions(true, mPrev, [overHandler, outHandler, npClickHandler]);
			
			// create the next-previous buttons
			mNext						= MovieClip(new mcNextPrev());
			mNext.scaleX				= -1;
			mNext.no					= 1;
			mButtons.addChild(mNext);
			
			mNext.mouseChildren			= false;
			Global.addButtonFunctions(true, mNext, [overHandler, outHandler, npClickHandler]);
			
			// create the close button
			mClose						= MovieClip(new mcCloseBtn());
			mClose.scaleX				= -1;
			mButtons.addChild(mClose);
			
			mClose.mouseChildren			= false;
			Global.addButtonFunctions(true, mClose, [overHandler, outHandler, closeClickHandler]);
			
			// create the play-pause button
			mPause						= MovieClip(new mcPauseBtn());
			mPause.alpha				= 0;
			mPause.mcBtn.gotoAndStop(1);
			mButtons.addChild(mPause);
			
			mPause.mouseChildren			= false;
			Global.addButtonFunctions(true, mPause, [overHandler, outHandler, pauseClickHandler]);
			
			// create the video objects
			video						= new Video(640, 360);
			
			nc							= new NetConnection();
			nc.connect(null);
			
			obj							= new Object();
			obj.onMetaData				= metaDataHandler;
			
			ns							= new NetStream(nc);
			ns.client					= obj;
			ns.addEventListener(NetStatusEvent.NET_STATUS, netStatusHandler);
			
			video.attachNetStream(ns);
			
			// create the loader bar and it's container
			mBarContainer				= new Rect(100, 5, 0, 0, -5, 0);
			addChild(mBarContainer);
			
			mBarLoaded					= new Rect(100, 5, 0xFFFFFF, 0, -5);
			mBarLoaded.width			= 0;
			mBarContainer.addChild(mBarLoaded);
			
			mBar						= new Rect(100, 5, Properties.DATA.config.@themeColor, 0, -5);
			mBar.width					= 0;
			mBarContainer.addChild(mBar);
		}
		
		private function metaDataHandler(o:Object):void
		{
			nDuration					= int(o.duration);
		}
		
		private function overHandler(e:MouseEvent):void
		{
			TweenLite.to(e.target.mcBtn, .3, { alpha:1 } );
		}
		
		private function outHandler(e:MouseEvent):void
		{
			TweenLite.to(e.target.mcBtn, .3, { alpha:.5 } );
		}
		
		private function npClickHandler(e:MouseEvent):void
		{
			mouseChildren				= false;
			
			TweenLite.to(this, 1, { onComplete:function()
			{
				mouseChildren			= true;
			} } );
			
			TweenLite.to(mBarContainer, .3, { height:5 } );
			TweenLite.to(mBarLoaded, .3, { width:0 } );
			
			removeEventListener(Event.ENTER_FRAME, videoEnterFrameHandler);
			removeEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
			mBarContainer.removeEventListener(MouseEvent.MOUSE_DOWN, downHandler);
				
			Mouse.show();
			nTime						= 0;
			TweenLite.killTweensOf(mButtons);
			TweenLite.to(mButtons, .3, { alpha:1 } );
			
			ns.pause();
			ns.close();
			gallery.np(e.target.no);
		}
		
		private function loadImage():void
		{
			Footer.instance.soundOn();
			mBar.width					= 0;
			mBar.x						= 0;
			
			bLoaded						= false;
			nLoaded						= 0;
			nCurrent					= 0;
			
			loader						= new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, imageLoadedHandler);
			loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, imageLoadingHandler);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
			loader.load(new URLRequest(gallery.activeItem.xml.@image));
			
			if (!hasEventListener(Event.ENTER_FRAME)) addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}
		
		private function ioErrorHandler(e:IOErrorEvent):void
		{}
		
		private function imageLoadingHandler(e:ProgressEvent):void 
		{
			nLoaded						= e.bytesLoaded / e.bytesTotal * 100;
		}
		
		private function imageLoadedHandler(e:Event):void 
		{
			bLoaded						= true;
		}
		
		private function enterFrameHandler(e:Event):void 
		{
			if (bLoaded && nCurrent == 100)
			{
				removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
				TweenLite.to(mBar, .3, { width:0, x:100, ease:Expo.easeInOut } );
				
				mImage.addEventListener("closed", imageMaskClosed);
				mImage.close();
				
			}
			else
			{
				if (nCurrent < nLoaded)
				{
					nCurrent			+= Math.min(nLoaded - nCurrent, 10);
					mBar.width			= nCurrent;
				}
			}
		}
		
		private function imageMaskClosed(e:Event):void 
		{			
			video.clear();
			ns.close();
			
			mImage.removeEventListener("closed", imageMaskClosed);
			
			var bmp:Bitmap			= Bitmap(loader.content);
			var bmd:BitmapData		= new BitmapData(bmp.width, bmp.height);
			bmd.draw(bmp, null, null, null, null, true);
			
			nOrgWi					= bmp.width;
			nOrgHe					= bmp.height;
			
			if (gallery.activeItem.xml.@maxImageWidth != undefined || gallery.activeItem.xml.@maxImageHeight != undefined)
			{
				bManualSize			= true;
				nMaxWidth			= int(gallery.activeItem.xml.@maxImageWidth);
				nMaxHeight			= int(gallery.activeItem.xml.@maxImageHeight);
			}
			else
			{
				bManualSize			= false;
			}
			
			while (mBase.numChildren > 0) mBase.removeChildAt(0);
			mBase.graphics.clear();
			mBase.graphics.beginBitmapFill(bmd, null, false, true);
			mBase.graphics.drawRect(0, 0, bmp.width, bmp.height);
			mBase.graphics.endFill();
			
			updatePlacement();
			
			mImage.addEventListener("opened", imageOpenHandler);
			mImage.open();
		}
		
		private function loadVideo():void
		{
			Footer.instance.soundOff();
			mImage.addEventListener("closed", videoMaskClosed);
			mImage.close();
		}
		
		private function videoMaskClosed(e:Event):void 
		{
			video.clear();
			ns.close();
			
			mImage.removeEventListener("closed", videoMaskClosed);
			mBase.graphics.clear();
			
			if(!video.stage) mBase.addChild(video);
			
			nOrgWi						= 640;
			nOrgHe						= 360;
			
			if (gallery.activeItem.xml.@maxImageWidth != undefined || gallery.activeItem.xml.@maxImageHeight != undefined)
			{
				bManualSize			= true;
				nMaxWidth			= int(gallery.activeItem.xml.@maxImageWidth);
				nMaxHeight			= int(gallery.activeItem.xml.@maxImageHeight);
			
				nOrgWi				= nMaxWidth;
				nOrgHe				= nMaxHeight;
				video.width			= nOrgWi;
				video.height		= nOrgHe;
				
				if (gallery.activeItem.xml.@maxImageWidth == -1 && gallery.activeItem.xml.@maxImageHeight == -1)
				{
					bManualSize			= false;
					nOrgWi				= 640;
					nOrgHe				= 360;
					video.width			= 640;
					video.height		= 360;
				}
			}
			else
			{
				bManualSize			= false;
				video.width			= 640;
				video.height		= 360;
			}
			
			ns.play(String(gallery.activeItem.xml.@video));
			
			nTimePlus					= 1;
			nTime						= 0;
			mPause.visible				= true;
			bPlaying					= true;
			mBar.x						= 0;
			
			TweenLite.to(mBarContainer, .3, { height:15 } );
			
			mPause.mcBtn.gotoAndStop(1);
			TweenLite.to(mPause, .5, { alpha:1 } );
			
			addEventListener(Event.ENTER_FRAME, videoEnterFrameHandler);
			addEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
			
			mBarContainer.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
			
			updatePlacement();
			mImage.addEventListener("opened", imageOpenHandler);
			mImage.open();
			
			bStopped					= false;
		}
		
		private function downHandler(e:MouseEvent):void 
		{
			bDown						= true;
			stage.addEventListener(MouseEvent.MOUSE_UP, upHandler);
			
			ns.pause();
			ns.seek(nDuration * mouseX / Properties.WI);
		}
		
		private function upHandler(e:MouseEvent):void 
		{
			bDown						= false;
			stage.removeEventListener(MouseEvent.MOUSE_UP, upHandler);
			bStopped					= ns.time == nDuration;
			if (bPlaying) ns.resume();
		}
		
		private function moveHandler(e:MouseEvent):void 
		{
			if (bDown) ns.seek(nDuration * mouseX / Properties.WI);
			
			Mouse.show();
			nTime						= 0;
			if(mButtons.alpha < 1) TweenLite.to(mButtons, .3, { alpha:1 } );
		}
		
		private function videoEnterFrameHandler(e:Event):void 
		{
			nTime						+= nTimePlus;
			mBarLoaded.width			= ns.bytesLoaded / ns.bytesTotal * 100;
			mBar.width					= ns.time / nDuration * 100;
			
			if (nTime == 60)
			{
				Mouse.hide();
				TweenLite.to(mButtons, .3, { alpha:0 } );
			}
		}
		
		private function pauseClickHandler(e:MouseEvent):void
		{
			if (bPlaying)
			{
				bPlaying				= false;
				ns.pause();
				nTimePlus				= 0;
				mPause.mcBtn.gotoAndStop(2);
			}
			else
			{
				bPlaying				= true;
				
				if (bStopped) 
				{
					bStopped			= false;
					ns.seek(0);
				}
				
				ns.resume();
				nTimePlus				= 1;
				mPause.mcBtn.gotoAndStop(1);
			}
		}
		
		private function imageOpenHandler(e:Event):void 
		{
			mImage.removeEventListener("opened", imageOpenHandler);
			
			TweenLite.to(mNext.mcBtn, .3, { x:0, ease:Expo.easeOut } );
			TweenLite.to(mPrev.mcBtn, .3, { x:0, ease:Expo.easeOut } );
			TweenLite.to(mClose.mcBtn, .3, { x:0, ease:Expo.easeOut } );
		}
		
		private function netStatusHandler(e:NetStatusEvent):void 
		{
			switch(String(e.info.code))
			{
				case "NetStream.Play.Stop":
				bPlaying				= false;
				mPause.mcBtn.gotoAndStop(2);
				TweenLite.to(mButtons, .3, { alpha:1 } );
				bStopped				= true;
				Mouse.show();
				break;
				
				case "NetStream.Play.Start":
				break;
			}
		}
		
		public function open($gallery:Gallery):void
		{
			
			if (!visible)
			{
				gallery						= $gallery;
				
				nWi							= 400;
				nHe							= 300;
				updatePlacement();
				
				visible						= true;
				TweenLite.to(mBg, 1, { alpha:1, onComplete:function()
				{
					mouseChildren			= true;
					if (gallery.activeItem.xml.@image != undefined)
					{
						mPause.visible		= false;
						loadImage();
					}
					else
					{
						loadVideo();
					}
				} } );
			}
			else
			{				
				if (gallery.activeItem.xml.@image != undefined)
				{
					mPause.visible			= false;
					loadImage();
				}
				else
				{
					mPause.visible			= true;
					loadVideo();
				}
			}
		}
		
		private function closeClickHandler(e:MouseEvent):void
		{
			close();
		}
		
		public function close():void
		{
			if (visible)
			{
				ns.pause();
				ns.close();
				mouseChildren					= false;
				
				TweenLite.to(mBarContainer, .3, { height:5 } );
				TweenLite.to(mBar, .3, { width:0 } );
				TweenLite.to(mBarLoaded, .3, { width:0 } );
				TweenLite.to(mPause, .3, { alpha:0 } );
				
				mImage.removeEventListener("opened", imageOpenHandler);
				mImage.removeEventListener("closed", imageMaskClosed);
				mImage.removeEventListener("closed", videoMaskClosed);
				removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
				
				Footer.instance.soundOn();
				removeEventListener(Event.ENTER_FRAME, videoEnterFrameHandler);
				removeEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
				mBarContainer.removeEventListener(MouseEvent.MOUSE_DOWN, downHandler);
				
				Mouse.show();
				nTime						= 0;
				TweenLite.killTweensOf(mButtons);
				TweenLite.to(mButtons, .3, { alpha:1 } );
				
				TweenLite.to(mNext.mcBtn, .3, { x:-80, ease:Expo.easeIn } );
				TweenLite.to(mPrev.mcBtn, .3, { x:-80, ease:Expo.easeIn } );
				TweenLite.to(mClose.mcBtn, .3, { x:-80, ease:Expo.easeIn } );
				
				
				mImage.addEventListener("closed", imageLastClosed);
				mImage.close();
			}
			else
			{
				dispatchEvent(new Event("closed"));
			}
		}
		
		private function imageLastClosed(e:Event):void 
		{
			mImage.removeEventListener("closed", imageLastClosed);
			TweenLite.to(mBg, 1, { alpha:0, onComplete:function()
			{
				visible					= false;
				dispatchEvent(new Event("closed"));
			} } );
			
		}
		
		public function updatePlacement():void
		{
			var nPercent:Number			= Math.max(Properties.WI / nOrgWi, Properties.HE / nOrgHe);
			
			if (bManualSize)
			{
				if (nMaxWidth == -1 && nMaxHeight == -1) 
				{
					nPercent			= Math.max(Properties.WI / nOrgWi, Properties.HE / nOrgHe);
				}
				else
				{
					nPercent 			= Math.min((nMaxWidth != -1 ? nMaxWidth : Properties.WI) / nOrgWi, (nMaxHeight != -1 ? nMaxHeight : Properties.HE) / nOrgHe);
				}
			}
			
			nWi							= nOrgWi * nPercent;
			nHe							= nOrgHe * nPercent;
			
			mImage.setSize(Properties.WI, Properties.HE);
			mBase.width					= nWi;
			mBase.height				= nHe;
			mImage.mMasked.x			= -1 * int((nWi - Properties.WI) / 2);
			mImage.mMasked.y			= -1 * int((nHe - Properties.HE) / 2);
			
			mButtons.y					= int(Properties.HE / 2);
			mClose.x					= Properties.WI;
			mClose.y					= -1 * int(Properties.HE / 2) + 60;
			mNext.x						= Properties.WI;
			mPause.x					= int(Properties.WI / 2);
			
			mBg.width					= Properties.WI;
			mBg.height					= Properties.HE;
			
			mBarContainer.y				= Properties.HE;
			mBarContainer.width			= Properties.WI;
		}
	}

}