package com.news
{
	import br.com.stimuli.loading.BulkLoader;
	import br.com.stimuli.loading.loadingtypes.LoadingItem;
	import com.Properties;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import gs.easing.Linear;
	import gs.TweenLite;
	
	import com.home.mcs.mcProcess;
	
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class ItemSwf extends Sprite
	{
		public var nHeOffset		:int			= 0;
		private var _wi				:Number;
		private var _he				:Number;
		
		private var bl				:BulkLoader;
		private var loadingItem		:LoadingItem;
		private var mAll			:Sprite;
		private var mBase			:Sprite;
		
		private var nRotateTime		:Number;
		private var mProcess		:MovieClip;
		
		public function init($bl:BulkLoader, $xml:XML):void
		{
			bl						= $bl;
			nRotateTime				= $xml.@rotateTime != undefined ? $xml.@rotateTime : -1;
			
			wi						= $xml.@width;
			he						= $xml.@height;
			
			mAll					= new Sprite();
			mAll.alpha				= 0;
			addChild(mAll);
			
			mBase					= new Sprite();
			mAll.addChild(mBase);
			
			
			if (nRotateTime != -1)
			{
				mProcess			= MovieClip(new mcProcess());
				mAll.addChild(mProcess);
			}
			
			loadingItem				= $bl.get(String($xml.@target));
			loadingItem.addEventListener(Event.COMPLETE, itemLoadedHandler);
			
			if (loadingItem.isLoaded)
			{
				loadingItem.dispatchEvent(new Event(Event.COMPLETE));
			}
			else
			{
				bl.loadNow(String($xml.@target));
			}
		}
		
		private function itemLoadedHandler(e:Event):void 
		{
			loadingItem.removeEventListener(Event.COMPLETE, itemLoadedHandler);
			
			var mc:MovieClip		= bl.getMovieClip(e.target.id);
			
			if (mProcess)
			{
				mProcess.x			= wi - 30;
				mProcess.y			= he - 30;
				TweenLite.to(mProcess.mcBar, 0, { tint:Properties.COLORSCHEME.@videoPlayedBarColor } );
			}
			
			mBase.addChild(mc);
			
			dispatchEvent(new Event("ready"));
		}
		
		public function open(nDelay:Number = 0, nTime:Number = 1):void
		{
			TweenLite.to(mAll, nTime, { delay:nDelay, alpha:1, onComplete:function()
			{
				if (nRotateTime == -1) return;
				TweenLite.to(mProcess.mcBar, nRotateTime, { rotation:360, ease:Linear.easeNone, onComplete:function()
				{
					dispatchEvent(new Event("finished"));
				} } );
			} } );
		}
		
		public function stopEverything():void
		{
			TweenLite.killTweensOf(mAll);
			TweenLite.killTweensOf(mProcess.mcBar);
		}
		
		public function close():void
		{
			TweenLite.killTweensOf(mProcess.mcBar);
			TweenLite.to(mAll, .5, { alpha:0, onComplete:function()
			{
				while (mBase.numChildren > 0) mBase.removeChildAt(0);
				dispatchEvent(new Event("closed"));
			} } );
		}
		
		public function get wi():Number { return _wi; }
		
		public function set wi(n:Number):void 
		{
			_wi = n;
		}
		
		public function get he():Number { return _he; }
		
		public function set he(n:Number):void 
		{
			_he = n;
		}
	}

}