package com.news
{
	import br.com.stimuli.loading.BulkLoader;
	import com.Properties;
	import com.ui.Footer;
	import com.utkudemir.Rect;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.NetStatusEvent;
	import flash.events.TimerEvent;
	import flash.media.SoundTransform;
	import flash.media.Video;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.utils.Timer;
	import gs.TweenLite;
	
	import com.mcs.mcVolIcon;
	import com.mcs.mcPlayPause;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class ItemVideo extends Sprite
	{
		public var nHeOffset		:int			= 10;
		
		private var _wi				:Number;
		private var _he				:Number;
		
		private var xml				:XML;
		private var bLoop			:Boolean;
		private var bPlaying		:Boolean;
		private var bHd				:Boolean;
		private var bRotate			:Boolean;
		private var bRun			:Boolean;
		private var bSeeking		:Boolean;
		
		private var mAll			:Sprite;
		private var video			:Video;
		private var ns				:NetStream;
		private var nc				:NetConnection;
		private var obj				:Object;
		
		private var nBarWi			:int;
		private var mBgBar			:Rect;
		private var mLoadedBar		:Rect;
		private var mPlayedBar		:Rect;
		private var mSeekBar		:Rect;
		
		private var mVolIcon		:Sprite;
		private var mVol			:Sprite;
		private var nVolBarWi		:int;
		private var mBgVol			:Rect;
		private var mValueVol		:Rect;
		private var mSeekVol		:Rect;
		private var bVolSeek		:Boolean;
		private var nVol			:Number;
		
		private var timer			:Timer;
		
		private var nDuration		:int;
		private var mPlayPause		:MovieClip;
		
		private var bOver			:Boolean		= false;
		private var nState			:int;
		
		public function init():void
		{
			
			nDuration				= -1;
			bPlaying				= true;
			bRun					= false;
			bSeeking				= false;
			
			video					= new Video(490, 250);
			addChild(video);
			
			nc						= new NetConnection();
			nc.connect(null);
			
			obj						= new Object();
			obj.onMetaData			= metaDataHandler;
			
			ns						= new NetStream(nc);
			ns.client				= obj;
			
			video.attachNetStream(ns);
			
			mBgBar					= new Rect(100, 5, 0x222222);
			mBgBar.x				= 20;
			addChild(mBgBar);
			
			mLoadedBar				= new Rect(100, 5, 0x222222);
			mLoadedBar.x			= 20;
			addChild(mLoadedBar);
			
			mPlayedBar				= new Rect(2, 5, 0xFFFFFF);
			mPlayedBar.x			= 20;
			addChild(mPlayedBar);
			
			mSeekBar				= new Rect(100, 10, 0, 0, 0, 0);
			mSeekBar.x				= 20;
			mSeekBar.buttonMode		= true;
			addChild(mSeekBar);
			
			
			mVol					= new Sprite();
			addChild(mVol);
			
			mVolIcon				= Sprite(new mcVolIcon());
			addChild(mVolIcon);
			
			TweenLite.to(mVolIcon, 0, { tint:0xFFFFFF } );
			
			mBgVol					= new Rect(100, 5, 0x222222);
			mVol.addChild(mBgVol);
			
			mValueVol				= new Rect(2, 5, 0xFFFFFF);
			mValueVol.x				= nVolBarWi * Properties.VIDEOVOLUME;
			mVol.addChild(mValueVol);
			
			mSeekVol				= new Rect(100, 10, 0xFF0000, 0, 0, 0);
			mSeekVol.buttonMode		= true;
			mVol.addChild(mSeekVol);
			
			
			timer					= new Timer(100);
			
			mPlayPause				= MovieClip(new mcPlayPause());
			mPlayPause.x			= 7;
			mPlayPause.gotoAndStop(1);
			addChild(mPlayPause);
			
			mPlayPause.buttonMode	= true;
			
			mSeekBar.addEventListener(MouseEvent.MOUSE_DOWN, seekStartHandler);
			mSeekVol.addEventListener(MouseEvent.MOUSE_DOWN, seekVolStartHandler);
			mPlayPause.addEventListener(MouseEvent.CLICK, ppClickHandler);
			
			timer.addEventListener(TimerEvent.TIMER, timerHandler);
			ns.addEventListener(NetStatusEvent.NET_STATUS, netStatusHandler);
		}
		
		private function ppClickHandler(e:MouseEvent):void
		{
			if (bPlaying)
			{
				Footer.instance.soundOn();
				mPlayPause.gotoAndStop(1);
				ns.pause();
			}
			else
			{
				Footer.instance.soundOff();
				mPlayPause.gotoAndStop(2);
				ns.resume();
			}
			
			bPlaying				= !bPlaying;
		}
		
		private function seekVolStartHandler(e:MouseEvent):void 
		{
			setVolume();
			stage.addEventListener(MouseEvent.MOUSE_MOVE, seekVolMoveHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, seekVolStopHandler);
		}
		
		private function seekVolMoveHandler(e:MouseEvent):void 
		{
			setVolume();
		}
		
		private function setVolume(nValue:Number = -1):void
		{
			var nPercent:Number		= nValue == -1 ? (mouseX - mVol.x) / nVolBarWi : nValue;
			nPercent				= Math.min(nPercent, 1);
			nPercent				= Math.max(nPercent, 0);
			
			nVol					= nPercent;
			mValueVol.x				= int(nPercent * (nVolBarWi - 2));
			
			ns.soundTransform		= new SoundTransform(nVol);
			Properties.VIDEOVOLUME	= nPercent;
		}
		
		private function seekVolStopHandler(e:MouseEvent):void 
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, seekVolMoveHandler);
			stage.removeEventListener(MouseEvent.MOUSE_UP, seekVolStopHandler);
		}
		
		private function seekStartHandler(e:MouseEvent):void 
		{
			bSeeking				= true;
			
			timer.stop();
			ns.pause();
			stage.addEventListener(MouseEvent.MOUSE_MOVE, seekMoveHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, seekStopHandler);
			
			seekVideo();
		}
		
		private function seekMoveHandler(e:MouseEvent):void 
		{
			seekVideo();
		}
		
		private function seekVideo():void
		{
			var nPercent:Number		= Math.min((mouseX - 20) / nBarWi, mLoadedBar.width / wi);
			nPercent				= Math.min(nPercent, 1);
			nPercent				= Math.max(nPercent, 0);
			
			mPlayedBar.x			= 20 + int(nPercent * (nBarWi - 2));
			ns.seek(Math.floor(nPercent * nDuration));
		}
		
		private function seekStopHandler(e:MouseEvent):void 
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, seekMoveHandler);
			stage.removeEventListener(MouseEvent.MOUSE_UP, seekStopHandler);
			
			ns.seek(mPlayedBar.x / (nBarWi - 2) * nDuration);
			if (bPlaying) ns.resume();
			timer.start();
			
			bSeeking				= false;
		}
		
		private function metaDataHandler(o:Object):void
		{
			nDuration					= int(o.duration);
			trace("DURATION: " + nDuration);
		}
		
		private function timerHandler(e:TimerEvent):void
		{
			mPlayedBar.x			= 20 + (nBarWi - 2) * ns.time / nDuration;
			mLoadedBar.width		= nBarWi * ns.bytesLoaded / ns.bytesTotal;
		}
		
		private function netStatusHandler(e:NetStatusEvent):void 
		{
			switch(String(e.info.code))
			{
				case "NetStream.Play.Stop":
				nState					= 0;
				if (bLoop)
				{
					ns.seek(0);
				}
				else
				{
					Footer.instance.soundOn();
					mPlayPause.gotoAndStop(1);
					bPlaying			= false;
					if(bRotate) dispatchEvent(new Event("finished"));
				}
				break;
				
				case "NetStream.Play.Start":
				nState					= 1;
				mPlayPause.gotoAndStop(2);
				Footer.instance.soundOff();
				break;
			}
		}
		
		public function playVideo($xml:XML):void
		{
			xml						= $xml;
			bLoop					= xml.@loop == true;
			bRotate					= xml.@rotateWhenFinished == true;
			
			wi						= 490;
			he						= int(xml.@height) + 15;
			
			video.width				= wi;
			video.height			= he - 15;
			nBarWi					= wi - 100;	
			mBgBar.width			= nBarWi;
			mBgBar.y				= he - 5;
			mLoadedBar.width		= nBarWi
			mLoadedBar.y			= he - 5;
			mLoadedBar.width		= 0;
			mPlayedBar.y			= he - 5;
			mSeekBar.width			= nBarWi;
			mSeekBar.y				= he - 10;
			nVolBarWi				= 60;
			mVol.x					= wi - nVolBarWi;
			mVol.y					= he - 5;
			mVolIcon.x				= wi - nVolBarWi - 8;
			mVolIcon.y				= he - 4;
			mBgVol.width			= nVolBarWi;
			mSeekVol.width			= nVolBarWi;
			mSeekVol.y				= -5;
			mPlayPause.y			= he - 8;
			
			setVolume(Properties.VIDEOVOLUME);
			ns.play(String(xml.@source));
			timer.start();
		}
		
		public function dispose():void
		{
			Footer.instance.soundOn();
			ns.pause();
			timer.stop();
			bOver					= false;
		}
		
		public function clear():void
		{
			ns.close();
		}
		
		public function get wi():Number { return _wi; }
		
		public function set wi(n:Number):void 
		{
			_wi = n;
		}
		
		public function get he():Number { return _he; }
		
		public function set he(n:Number):void 
		{
			_he = n;
		}
		
	}

}