package com.news
{
	import br.com.stimuli.loading.BulkLoader;
	import com.Properties;
	import com.ui.Footer;
	import com.utkudemir.Rect;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.net.URLRequest;
	import flash.system.Security;
	import flash.utils.Timer;
	import gs.TweenLite;
	
	import com.mcs.mcVolIcon;
	import com.mcs.mcPlayPause;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class ItemYouTube extends Sprite
	{
		public var nHeOffset		:int			= 10;
		private var _wi				:Number;
		private var _he				:Number;
		
		private var xml				:XML;
		private var bLoop			:Boolean;
		private var bPlaying		:Boolean;
		private var bHd				:Boolean;
		private var bRotate			:Boolean;
		
		private var player			:Object;
		
		private var nBarWi			:int;
		private var mBgBar			:Rect;
		private var mPlayedBar		:Rect;
		private var mSeekBar		:Rect;
		
		private var mVolIcon		:Sprite;
		private var mVol			:Sprite;
		private var nVolBarWi		:int;
		private var mBgVol			:Rect;
		private var mValueVol		:Rect;
		private var mSeekVol		:Rect;
		private var bVolSeek		:Boolean;
		private var nVol			:Number;
		
		private var timer			:Timer;
		
		private var nDuration		:int;
		private var mPlayPause		:MovieClip;
		private var mPlayPauseAll	:Rect;
		private var aQualities		:Array;
		
		private var bOver			:Boolean		= false;
		private var nState			:int;
		
		public function init($player:Object):void
		{
			bPlaying				= true;
			nDuration				= -1;
			
			player					= $player;
			player.addEventListener("onStateChange", onStateChangeHandler);
			addChild(player as DisplayObject);
			
			mBgBar					= new Rect(100, 5, 0x222222);
			mBgBar.x				= 20;
			addChild(mBgBar);
			
			mPlayedBar				= new Rect(2, 5, 0xFFFFFF);
			mPlayedBar.x			= 20;
			addChild(mPlayedBar);
			
			mSeekBar				= new Rect(100, 10, 0, 0, 0, 0);
			mSeekBar.x				= 20;
			mSeekBar.buttonMode		= true;
			addChild(mSeekBar);
			
			
			
			mVol					= new Sprite();
			addChild(mVol);
			
			mVolIcon				= Sprite(new mcVolIcon());
			addChild(mVolIcon);
			
			TweenLite.to(mVolIcon, 0, { tint:0xFFFFFF } );
			
			mBgVol					= new Rect(100, 5, 0x222222);
			mVol.addChild(mBgVol);
			
			mValueVol				= new Rect(2, 5, 0xFFFFFF);
			mVol.addChild(mValueVol);
			
			mSeekVol				= new Rect(100, 10, 0xFFFFFF, 0, 0, 0);
			mSeekVol.buttonMode		= true;
			mVol.addChild(mSeekVol);
			
			
			timer					= new Timer(100);
			timer.addEventListener(TimerEvent.TIMER, timerHandler);
			
			mPlayPause				= MovieClip(new mcPlayPause());
			mPlayPause.x			= 7;
			mPlayPause.gotoAndStop(1);
			addChild(mPlayPause);
			
			mPlayPause.buttonMode	= true;
			
			mSeekBar.addEventListener(MouseEvent.MOUSE_DOWN, seekStartHandler);
			mSeekVol.addEventListener(MouseEvent.MOUSE_DOWN, seekVolStartHandler);
			mPlayPause.addEventListener(MouseEvent.CLICK, ppClickHandler);
		}
		
		private function ppClickHandler(e:MouseEvent):void
		{
			if (bPlaying)
			{
				Footer.instance.soundOn();
				mPlayPause.gotoAndStop(1);
				player.pauseVideo();
				timer.stop();
				bPlaying					= false;
			}
			else
			{
				Footer.instance.soundOff();
				mPlayPause.gotoAndStop(2);
				player.playVideo();
				if (!timer.running) timer.start();
			}
		}
		
		private function seekVolStartHandler(e:MouseEvent):void 
		{
			setVolume();
			stage.addEventListener(MouseEvent.MOUSE_MOVE, seekVolMoveHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, seekVolStopHandler);
		}
		
		private function seekVolMoveHandler(e:MouseEvent):void 
		{
			setVolume();
		}
		
		private function setVolume(nValue:Number = -1):void
		{
			var nPercent:Number		= nValue == -1 ? (mouseX - mVol.x) / nVolBarWi : nValue;
			nPercent				= Math.min(nPercent, 1);
			nPercent				= Math.max(nPercent, 0);
			
			nVol					= nPercent;
			mValueVol.x				= int(nPercent * (nVolBarWi - 2));
			
			player.setVolume(nVol * 100);
			Properties.VIDEOVOLUME	= nPercent;
		}
		
		private function seekVolStopHandler(e:MouseEvent):void 
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, seekVolMoveHandler);
			stage.removeEventListener(MouseEvent.MOUSE_UP, seekVolStopHandler);
		}
		
		private function seekStartHandler(e:MouseEvent):void 
		{
			timer.stop();
			player.pauseVideo();
			stage.addEventListener(MouseEvent.MOUSE_MOVE, seekMoveHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, seekStopHandler);
			seekMoveHandler();
		}
		
		private function seekMoveHandler(e:MouseEvent = null):void 
		{
			var nPercent:Number		= (mouseX - 20) / nBarWi;
			nPercent				= Math.min(nPercent, 1);
			nPercent				= Math.max(nPercent, 0);
			
			mPlayedBar.x			= 20 + int(nPercent * (nBarWi - 2));
			player.seekTo(nPercent * nDuration, false);
		}
		
		private function seekStopHandler(e:MouseEvent):void 
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, seekMoveHandler);
			stage.removeEventListener(MouseEvent.MOUSE_UP, seekStopHandler);
			
			player.seekTo(mPlayedBar.x / (nBarWi - 2) * nDuration, true);
			if (bPlaying) player.playVideo();
			timer.start();
		}
		
		public function playVideo(xml:XML):void
		{
			wi						= 490;
			he						= xml.@height;
			
			nVolBarWi				= 60;
			nBarWi					= wi - 100;	
			mBgBar.width			= nBarWi;
			mBgBar.y				= he - 5;
			mPlayedBar.y			= he - 5;
			mSeekBar.width			= nBarWi;
			mSeekBar.y				= he - 10;
			mVol.x					= wi - nVolBarWi;
			mVol.y					= he - 5;
			mVolIcon.x				= wi - nVolBarWi - 8;
			mVolIcon.y				= he - 4;
			mBgVol.width			= nVolBarWi;
			mValueVol.x				= nVolBarWi * Properties.VIDEOVOLUME;
			mSeekVol.width			= nVolBarWi;
			mSeekVol.y				= -5;
			mPlayPause.y			= he - 8;
			
			bLoop					= xml.@loop == true;
			bRotate					= xml.@rotateWhenFinished == true;
			bHd						= xml.@hd == true;
			
			player.setSize(wi, he - 10);
			player.loadVideoById(String(xml.@source));
			
			timer.start();
		}
		
		private function timerHandler(e:TimerEvent):void
		{
			mPlayedBar.x			= 20 + (nBarWi - 2) * player.getCurrentTime() / nDuration;
			if (nState == 1) 
			{
				bPlaying = true;
			}
			else
			{
				bPlaying = false;
			}
		}
		
		private function onStateChangeHandler(e:Event):void 
		{
			nState					= int(Object(e).data);
			switch (Object(e).data) {
				case 0: //ENDED
				if (bLoop)
				{
					player.seekTo(0);
				}
				else
				{
					Footer.instance.soundOn();
					mPlayPause.gotoAndStop(1);
					bPlaying			= false;
					if(bRotate) dispatchEvent(new Event("finished"));
				}
				break;
				
				case 1: //PLAYING
				bPlaying						= true;
				mPlayPause.gotoAndStop(2);
				if (nDuration == -1)
				{
					Footer.instance.soundOff();
					nDuration			= player.getDuration();
					setVolume(Properties.VIDEOVOLUME);
					aQualities			= player.getAvailableQualityLevels();
					if(bHd) player.setPlaybackQuality(aQualities[0]);
				}
				break;
				
				case 2:	//PAUSED
				break;
				
				case 5:	//CUED
				break;
			}
		}
		
		public function dispose():void
		{
			Footer.instance.soundOn();
			player.stopVideo();
			timer.stop();
			nDuration				= -1;
			bOver					= false;
		}
		
		public function clear():void
		{
			
		}
		
		public function get wi():Number { return _wi; }
		
		public function set wi(n:Number):void 
		{
			_wi = n;
		}
		
		public function get he():Number { return _he; }
		
		public function set he(n:Number):void 
		{
			_he = n;
		}
		
	}

}