﻿package com.scenes
{
	import br.com.stimuli.loading.BulkLoader;
	import br.com.stimuli.loading.loadingtypes.LoadingItem;
	import com.formEelements.FButton;
	import com.Properties;
	import com.ui.Bg;
	import com.ui.Header;
	import com.ui.Menu;
	import com.utkudemir.Form;
	import com.utkudemir.Rect;
	import com.utkudemir.ScrollBar;
	import com.utkudemir.Text;
	import com.utkudemir.utils.Scene;
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import flash.events.Event;
	import gs.easing.Expo;
	import gs.TweenLite;
	/**
	* ...
	* @author Utku DEMİR || utku@csdlab.com
	*/
	public class SceneContact extends Scene
	{
		// variables
		private var bPrepared			:Boolean	= false;
		
		private var bl					:BulkLoader;
		private var xml					:XML;
		
		private var mMainLoaderBar		:Rect;
		private var nLoaded				:int;
		private var nCurrent			:int;
		private var bLoaded				:Boolean;
		
		private var mItems				:Sprite;
		private var mItemsMask			:Rect;
		
		private var mFake				:Rect;
		
		private var mMask				:Rect;
		private var mMasked				:Sprite;
		private var mBg					:Rect;
		private var tText				:Text;
		private var scrollbar			:ScrollBar;
		
		private var mFormItems			:Sprite;
		private var form				:Form;
		private var sendBtn				:FButton;
		private var cleanBtn			:FButton;
		private var tSending			:Text;
		private var tSent				:Text;
		private var tError				:Text;
		
		private var bResize				:Boolean;
		public function SceneContact()
		{
			visible 					= false;
			mouseChildren 				= false;
		}
		
		private function prepare():void
		{
			// declare it's prepared
			bPrepared 					= true;
			
			// create the loader
			bl							= new BulkLoader("contactLoader");
			
			// create scene items
			mFake						= new Rect(1, 100, 0, 0, 0, 0);
			
			mItems						= new Sprite();
			mItems.x					= 420;
			
			mItemsMask					= new Rect(550, 100);
			mItemsMask.height			= 0;
			mItemsMask.x				= mItems.x;
			addChild(mItemsMask);
			
			mItems.mask					= mItemsMask;
			
			mBg							= new Rect(510, 100, 0x000000, 0, 0, .9);
			mBg.scaleX					= 0;
			addChild(mBg);
			addChild(mItems);
			
			mMainLoaderBar				= new Rect(100, 3, 0xFFFFFF);
			mMainLoaderBar.width		= 0;
			mMainLoaderBar.x			= 420;
			addChild(mMainLoaderBar);
			
			mMask						= new Rect(550, 100, 0xFF0000);
			mItems.addChild(mMask);
			
			mMasked						= new Sprite();
			mMasked.mask				= mMask;
			mMasked.x					= 10;
			mItems.addChild(mMasked);
			
			tText						= new Text("", { size:10, color:0xffffff, font:2, width:910 - mItems.x, linkcolor:Properties.DATA.config.@linkColor, overcolor:Properties.DATA.config.@linkOverColor } );
			tText.y						= 20;
			mMasked.addChild(tText);
			
			tSending					= new Text("", { size:10, color:0xffffff, font:2 } );
			tSending.alpha				= 0;
			mMasked.addChild(tSending);
			
			tSent						= new Text("", { size:10, color:0xffffff, font:2 } );
			tSent.alpha					= 0;
			mMasked.addChild(tSent);
			
			tError						= new Text("", { size:10, color:0xffffff, font:2 } );
			tError.alpha				= 0;
			mMasked.addChild(tError);
			
			mFormItems					= new Sprite();
			mMasked.addChild(mFormItems);
			
			scrollbar					= new ScrollBar();
			scrollbar.x					= 512;
			mItems.addChild(scrollbar);
			
			TweenLite.to(scrollbar, 0, { tint:0xFFFFFF } );
			
			scrollbar.init(mMask, mMasked, 0, 50, 0, mFake);
			
			stage.addEventListener("stageResized", stageResizedHandler, true);
			stageResizedHandler();
		}
		
		private function setContent():void
		{
			mMainLoaderBar.width		= 0;
			mMainLoaderBar.x			= mItems.x;
			
			mMasked.y					= 0;
			mBg.x						= 0;
			stageResizedHandler();
			
			TweenLite.to(mBg, .5, { x:mItems.x, scaleX:1, ease:Expo.easeInOut, onComplete:loadXml } );
		}
		
		private function loadXml():void
		{
			nLoaded						= 0;
			nCurrent					= 0;
			bLoaded						= false;
			
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			
			var sXml:String				= Properties.CONTENTXML.@xml;
			
			var xmlItem:LoadingItem;
			if (bl.get(sXml) == null)
			{
				xmlItem					= bl.add(sXml, { id:sXml } );
			}
			else
			{
				xmlItem					= bl.get(sXml);
			}
			
			xmlItem.addEventListener(Event.COMPLETE, xmlLoadedHandler);
			
			if (xmlItem.isLoaded) xmlItem.dispatchEvent(new Event(Event.COMPLETE));
			
			if (!bl.isRunning) bl.start(1);
		}
		
		private function xmlLoadedHandler(e:Event):void 
		{
			xml							= bl.getXML(e.target.id);
			nLoaded						= 100;
			bLoaded						= true;
		}
		
		private function enterFrameHandler(e:Event):void 
		{
			if (nCurrent == 100 && bLoaded)
			{
				removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
				TweenLite.to(mMainLoaderBar, .3, { width:0, x:mItems.x + mMainLoaderBar.width, ease:Expo.easeInOut } );
				openScene();
			}
			else
			{
				if (nCurrent < nLoaded) nCurrent = Math.min(nLoaded, nCurrent + 5);
				mMainLoaderBar.width	= 510 * nCurrent / 100;
			}
		}
		
		private function openScene():void
		{
			mMasked.y					= 0;
			scrollbar.reset();
			var sText:String			= xml.form_description.text();
			tText.text					= sText;
			
			form 						= new Form(XML(xml.form), 920 - mItems.x, xml.@themeColor != undefined ? xml.@themeColor : Properties.DATA.config.@themeColor);
			form.onSend					= formSendHandler;
			form.onSending				= formSendingHandler;
			form.onError				= formErrorHandler;
			form.y						= tText.height + 40;
			mFormItems.addChild(form);
			
			tSending.y					= form.y + 10;
			tSent.y						= form.y + 10;
			tError.y					= form.y + 10;
			
			sendBtn						= new FButton(xml.form.@fSend);
			sendBtn.x					= 105;
			sendBtn.y					= int(form.y + form.he);
			sendBtn.Enable				= true;
			sendBtn.addEventListener("clicked", sendClickHandler);
			mFormItems.addChild(sendBtn);
			
			cleanBtn					= new FButton(xml.form.@fClean);
			cleanBtn.x					= sendBtn.x + sendBtn.wi + 10;
			cleanBtn.y					= sendBtn.y;
			cleanBtn.Enable 			= true;
			cleanBtn.addEventListener("clicked", cleanClickHandler);
			mFormItems.addChild(cleanBtn);
			
			tSending.text				= xml.form.@fSendingMessage;
			tSent.text					= xml.form.@fCompleteMessage;
			tError.text					= xml.form.@fErrorMessage;
			
			mFake.height				= form.y + form.he + 50;
			stageResizedHandler();

			TweenLite.to(mItemsMask, .6, { height:Properties.HE, ease:Expo.easeInOut, onComplete:function()
			{
				bResize					= true;
				scrollbar.enable		= true;
				stageResizedHandler();
				mouseChildren 			= true;
				onOpen();
				Menu.instance.enable();
				
				if (Properties.CONTENTXML.@bg_image != undefined) 
				{
					Bg.instance.openImage(Properties.CONTENTXML.@bg_image);
				}
				else
				{
					Bg.instance.openImage(Properties.DATA.config.@main_page_bg_source);
				}
			} } );
		}
		
		private function cleanClickHandler(e:Event):void 
		{
			form.clearForm();
		}
		
		private function sendClickHandler(e:Event):void 
		{
			form.sendForm();
		}
		
		private function formErrorHandler():void
		{
			TweenLite.killTweensOf(mFormItems);
			TweenLite.to(mFormItems, .3, { autoAlpha:0, ease:Expo.easeIn} );
			TweenLite.killTweensOf(tSending);
			TweenLite.to(tSending, .3, { autoAlpha:0, ease:Expo.easeIn} );
			
			TweenLite.killTweensOf(tError);
			TweenLite.to(tError, .3, { autoAlpha:1, onComplete:function()
			{
				TweenLite.to(this, 2, { onComplete:function()
				{
					TweenLite.to(tError, .3, { autoAlpha:0, ease:Expo.easeInOut } );
					TweenLite.to(mFormItems, .3, { autoAlpha:1, ease:Expo.easeInOut} );
				} } );
			} } );
		}
		
		private function formSendingHandler():void
		{
			TweenLite.killTweensOf(mFormItems);
			TweenLite.to(mFormItems, .3, { autoAlpha:0, ease:Expo.easeIn} );
			
			TweenLite.killTweensOf(tSending);
			TweenLite.to(tSending, .3, { autoAlpha:1, ease:Expo.easeIn} );
		}
		
		private function formSendHandler():void
		{
			TweenLite.killTweensOf(mFormItems);
			TweenLite.to(mFormItems, .3, { autoAlpha:0, ease:Expo.easeIn} );
			TweenLite.killTweensOf(tSending);
			TweenLite.to(tSending, .3, { autoAlpha:0, ease:Expo.easeIn} );
			
			TweenLite.killTweensOf(tSent);
			TweenLite.to(tSent, .3, { autoAlpha:1, onComplete:function()
			{
				TweenLite.to(this, 2, { onComplete:function()
				{
					TweenLite.to(tSent, .3, { autoAlpha:0, ease:Expo.easeInOut } );
					TweenLite.to(mFormItems, .3, { autoAlpha:1, ease:Expo.easeInOut } );
				} } );
			} } );
		}
		
		public function open():void
		{
			bResize						= false;
			
			if(!bPrepared) prepare();
			setContent();
			
			visible 					= true;
		}
		
		public function close():void
		{
			scrollbar.enable			= false;
			bResize						= false;
			TweenLite.to(mItemsMask, .3, { height:0, ease:Expo.easeInOut, onComplete:function()
			{
				TweenLite.to(mBg, .5, { x:Properties.WI, scaleX:0, ease:Expo.easeInOut, onComplete:function() 
				{
					while (mFormItems.numChildren > 0) mFormItems.removeChildAt(0);
					visible 					= false;
					onClose();
				}} );
			}});
			mouseChildren 				= false;
		}
		
		private function stageResizedHandler(e:Event = null):void
		{
			mBg.height					= 
			mMask.height				= Properties.HE;
			
			if (bResize)
			{
				mItemsMask.height		= Properties.HE;
			}
			
			scrollbar.resize();
		}
	}
	
}