package com.scenes
{
	import br.com.stimuli.loading.BulkLoader;
	import br.com.stimuli.loading.BulkProgressEvent;
	import br.com.stimuli.loading.loadingtypes.LoadingItem;
	import com.Properties;
	import com.ui.Bg;
	import com.ui.Header;
	import com.ui.Menu;
	import com.utkudemir.Rect;
	import com.utkudemir.ScrollBar;
	import com.utkudemir.utils.Scene;
	import flash.display.Sprite;
	import flash.events.Event;
	import gs.easing.Expo;
	import gs.TweenLite;
	/**
	* ...
	* @author Utku DEMİR || utku@csdlab.com
	*/
	public class SceneExternal extends Scene
	{
		// variables
		private var bl					:BulkLoader;
		private var bPrepared			:Boolean	= false;
		
		private var xml					:XML;
		private var nImageCount			:int;
		
		private var mFakeForScroll		:Rect;
		private var mItems				:Sprite;
		private var mItemsMask			:Rect;
		
		private var mMainLoaderBar		:Rect;
		private var nLoaded				:int;
		private var nCurrent			:int;
		private var bLoaded				:Boolean;
		
		private var mMask				:Rect;
		private var mMasked				:Sprite;
		private var mBg					:Rect;
		private var mBase				:Sprite;
		private var mScrollbarMask		:Rect;
		private var scrollbar			:ScrollBar;
		
		private var bResize				:Boolean;
		
		public function SceneExternal()
		{
			visible 					= false;
			mouseChildren 				= false;
		}
		
		private function prepare():void
		{
			// declare it's prepared
			bPrepared 					= true;
			
			// create the loader
			bl							= new BulkLoader("externalLoader");
			
			// create scene items
			mItems						= new Sprite();
			mItems.x					= 420;
			
			mItemsMask					= new Rect(550, 100);
			mItemsMask.height			= 0;
			mItemsMask.x				= mItems.x;
			addChild(mItemsMask);
			
			mItems.mask					= mItemsMask;
			
			mBg							= new Rect(510, 100, 0x000000, 0, 0, .9);
			mBg.scaleX					= 0;
			addChild(mBg);
			addChild(mItems);
			
			mMainLoaderBar				= new Rect(100, 3, 0xFFFFFF);
			mMainLoaderBar.width		= 0;
			mMainLoaderBar.x			= 420;
			addChild(mMainLoaderBar);
			
			mMask						= new Rect(550, 100, 0xFF0000);
			mItems.addChild(mMask);
			
			mMasked						= new Sprite();
			mMasked.mask				= mMask;
			mItems.addChild(mMasked);
			
			mBase						= new Sprite();
			mBase.x						= 10;
			mMasked.addChild(mBase);
			
			mFakeForScroll				= new Rect(1, 100, 0, 0, 0, 0);
			
			scrollbar					= new ScrollBar();
			scrollbar.x					= 512;
			mItems.addChild(scrollbar);
			
			TweenLite.to(scrollbar, 0, { tint:0xFFFFFF } );
			
			scrollbar.init(mMask, mMasked, 0, 50, 0, mFakeForScroll);
			
			stage.addEventListener("stageResized", stageResizedHandler, true);
			stageResizedHandler();
		}
		
		private function setContent():void
		{
			mMainLoaderBar.width		= 0;
			mMainLoaderBar.x			= mItems.x;
			
			mMasked.y					= 0;
			mBg.x						= 0;
			stageResizedHandler();
			
			TweenLite.to(mBg, .5, { x:mItems.x, scaleX:1, ease:Expo.easeInOut, onComplete:loadExternal } );
		}
		
		private function enterFrameHandler(e:Event):void 
		{
			if (nCurrent >= 100 && bLoaded)
			{
				removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
				TweenLite.to(mMainLoaderBar, .3, { width:0, x:mItems.x + mMainLoaderBar.width, ease:Expo.easeInOut } );
				openScene();
			}
			else
			{
				if (nCurrent < nLoaded) nCurrent = Math.min(nLoaded, nCurrent + 5);
				nCurrent = Math.min(nCurrent, 100);
				mMainLoaderBar.width	= 510 * nCurrent / 100;
			}
		}
		
		private function loadExternal():void 
		{
			nLoaded						= 0;
			nCurrent					= 0;
			bLoaded						= false;
			
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			
			var externalItem:LoadingItem;
			var sExternal:String		= Properties.CONTENTXML.@source
			
			if (bl.get(sExternal) == null)
			{
				externalItem			= bl.add(sExternal, { id:sExternal } );
			}
			else
			{
				externalItem			= bl.get(sExternal);
			}
			
			if (!bl.isRunning) bl.start(1);
			
			bl.addEventListener(BulkProgressEvent.COMPLETE, loadingCompleteHandler);
			if (bl.isFinished) bl.dispatchEvent(new BulkProgressEvent(BulkProgressEvent.COMPLETE));
		}
		
		private function loadingCompleteHandler(e:BulkProgressEvent):void
		{
			nLoaded						= 100;
			bl.removeEventListener(BulkProgressEvent.COMPLETE, loadingCompleteHandler);
			bLoaded						= true;
		}
		
		private function openScene():void
		{
			mBase.addChild(bl.getMovieClip(String(Properties.CONTENTXML.@source)));
			
			scrollbar.reset();
			stageResizedHandler();
			
			TweenLite.to(mItemsMask, .3, { height:Properties.HE, ease:Expo.easeInOut, onComplete:function()
			{
				bResize				= true;
				scrollbar.enable	= true;
				stageResizedHandler();
				mouseChildren 				= true;
				onOpen();
				
				Menu.instance.enable(); 
				
				if (Properties.CONTENTXML.@bg_image != undefined) 
				{
					Bg.instance.openImage(Properties.CONTENTXML.@bg_image);
				}
				else
				{
					Bg.instance.openImage(Properties.DATA.config.@main_page_bg_source);
				}
			} } );
		}
		
		public function open():void
		{
			if(!bPrepared) prepare();
			setContent();
			
			visible 					= true;
			mouseChildren 				= true;
			onOpen();
		}
		
		public function close():void
		{
			scrollbar.enable			= false;
			bResize						= false;
			TweenLite.to(mItemsMask, .3, { height:0, ease:Expo.easeInOut, onComplete:function()
			{
				TweenLite.to(mBg, .5, { x:Properties.WI, scaleX:0, ease:Expo.easeInOut, onComplete:function() 
				{
					visible 					= false;
					onClose();
					while (mBase.numChildren > 0) mBase.removeChildAt(0);
				}} );
			}});
			mouseChildren 				= false;
		}
		
		private function stageResizedHandler(e:Event = null):void
		{
			mBg.height					= 
			mMask.height				= Properties.HE;
			
			if (bResize)
			{
				mItemsMask.height		= Properties.HE;
			}
			
			scrollbar.resize();
		}
	}
	
}