﻿package com.scenes
{
	import br.com.stimuli.loading.BulkLoader;
	import br.com.stimuli.loading.loadingtypes.LoadingItem;
	import com.gallery.Gallery;
	import com.gallery.TopItems;
	import com.Properties;
	import com.ui.Bg;
	import com.ui.Header;
	import com.ui.Menu;
	import com.utkudemir.MaskedObject;
	import com.utkudemir.Rect;
	import com.utkudemir.ScrollBar;
	import com.utkudemir.utils.Scene;
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import flash.events.Event;
	import gs.easing.Expo;
	import gs.TweenLite;
	/**
	* ...
	* @author Utku DEMİR || utku@csdlab.com
	*/
	public class SceneGallery extends Scene
	{
		// variables
		private var bPrepared			:Boolean	= false;
		
		private var bl					:BulkLoader;
		private var xml					:XML;
		
		private var mMainLoaderBar		:Rect;
		private var nLoaded				:int;
		private var nCurrent			:int;
		private var bLoaded				:Boolean;
		
		private var mItems				:Sprite;
		private var mItemsMask			:Rect;
		
		private var mMask				:Rect;
		private var mMasked				:Sprite;
		private var mBg					:Rect;
		
		private var gallery				:Gallery;
		private var scrollbar			:ScrollBar;
		
		private var mTopItems			:TopItems;
		private var bTopOpen			:Boolean;
		private var bClosing			:Boolean;
		
		
		private var bResize				:Boolean;
		
		public function SceneGallery()
		{
			// set the first situation
			visible 					= false;
			mouseChildren 				= false;
		}
		
		private function prepare():void
		{
			// declare it's prepared
			bPrepared 					= true;
			
			// create the loader
			bl							= new BulkLoader("galleryLoader");
			
			// create the scene items
			mItems						= new Sprite();
			mItems.x					= 420;
			
			mItemsMask					= new Rect(550, 100);
			mItemsMask.height			= 0;
			mItemsMask.x				= mItems.x;
			addChild(mItemsMask);
			
			mItems.mask					= mItemsMask;
			
			mBg							= new Rect(510, 100, 0x000000, 0, 0, .9);
			mBg.scaleX					= 0;
			addChild(mBg);
			addChild(mItems);
			
			mMainLoaderBar				= new Rect(100, 3, 0xFFFFFF);
			mMainLoaderBar.width		= 0;
			mMainLoaderBar.x			= 420;
			addChild(mMainLoaderBar);
			
			mMask						= new Rect(550, 100, 0xFF0000);
			mItems.addChild(mMask);
			
			mMasked						= new Sprite();
			mMasked.mask				= mMask;
			mItems.addChild(mMasked);
			
			// create scene items
			
			var nThumbWi:int			= int(Properties.CONTENTXML.@thumbnail_width);
			var nThumbHe:int			= int(Properties.CONTENTXML.@thumbnail_height);
			var nItemCount:int			= Math.floor((910 - mItems.x) / (nThumbWi + 5));
			var nSpace:int				= (490 % nThumbWi) / (nItemCount - 1);
			
			gallery						= new Gallery(nItemCount, nSpace, 12, nThumbWi, nThumbHe, 0, 910 - mItems.x);
			gallery.x					= 10;
			gallery.y					= 20;
			gallery.addEventListener("clicked", galleryClickHandler);
			mMasked.addChild(gallery);
			
			
			scrollbar					= new ScrollBar();
			scrollbar.x					= 512;
			mItems.addChild(scrollbar);
			
			TweenLite.to(scrollbar, 0, { tint:0xFFFFFF } );
			
			scrollbar.init(mMask, mMasked, 0, 50);
			
			mTopItems					= new TopItems();
			mTopItems.addEventListener("closed", topItemsClosed);
			Properties.MTOP.addChild(mTopItems);
			
			
			stage.addEventListener("stageResized", stageResizedHandler, true);
			stageResizedHandler();
		}
		
		private function setContent():void
		{
			mMainLoaderBar.width		= 0;
			mMainLoaderBar.x			= mItems.x;
			
			mMasked.y					= 0;
			mBg.x						= 0;
			stageResizedHandler();
			
			TweenLite.to(mBg, .5, { x:mItems.x, scaleX:1, ease:Expo.easeInOut, onComplete:loadXml } );
		}
		
		private function loadXml():void
		{
			nLoaded						= 0;
			nCurrent					= 0;
			bLoaded						= false;
			
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			
			var sXml:String				= Properties.CONTENTXML.@xml;
			
			var xmlItem:LoadingItem;
			if (bl.get(sXml) == null)
			{
				xmlItem					= bl.add(sXml, { id:sXml } );
			}
			else
			{
				xmlItem					= bl.get(sXml);
			}
			
			xmlItem.addEventListener(Event.COMPLETE, xmlLoadedHandler);
			
			if (xmlItem.isLoaded) xmlItem.dispatchEvent(new Event(Event.COMPLETE));
			
			if (!bl.isRunning) bl.start(1);
		}
		
		private function xmlLoadedHandler(e:Event):void 
		{
			xml							= bl.getXML(e.target.id);
			nLoaded						= 100;
			bLoaded						= true;
		}
		
		private function enterFrameHandler(e:Event):void 
		{
			if (nCurrent == 100 && bLoaded)
			{
				removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
				TweenLite.to(mMainLoaderBar, .3, { width:0, x:mItems.x + mMainLoaderBar.width, ease:Expo.easeInOut } );
				openScene();
			}
			else
			{
				if (nCurrent < nLoaded) nCurrent = Math.min(nLoaded, nCurrent + 5);
				mMainLoaderBar.width	= 510 * nCurrent / 100;
			}
		}
		
		private function galleryClickHandler(e:Event):void 
		{
			bClosing					= false;
			bTopOpen					= true;
			mTopItems.open(gallery);
		}
		
		private function openScene():void
		{
			mMasked.y					= 0;
			scrollbar.reset();
			bTopOpen					= false;
			
			gallery.init(xml);
			scrollbar.resize();
			
			stageResizedHandler();
			
			TweenLite.to(mItemsMask, .3, { height:Properties.HE, ease:Expo.easeInOut, onComplete:function()
			{
				bResize				= true;
				scrollbar.enable	= true;
				stageResizedHandler();
				mouseChildren 				= true;
				onOpen();
				Menu.instance.enable();
				
				if (Properties.CONTENTXML.@bg_image != undefined) 
				{
					Bg.instance.openImage(Properties.CONTENTXML.@bg_image);
				}
				else
				{
					Bg.instance.openImage(Properties.DATA.config.@main_page_bg_source);
				}
			} } );
		}
		
		public function open(sLeft:String = ""):void
		{
			if(!bPrepared) prepare();
			setContent();
			
			visible 					= true;
		}
		public function close():void
		{
			mouseChildren 				= false;
			scrollbar.enable			= false;
			bClosing					= true;
			
			if (bTopOpen)
			{
				mTopItems.close();
			}
			else
			{
				topItemsClosed();
			}
		}
		
		private function topItemsClosed(e:Event = null):void 
		{
			bTopOpen					= false;
			if (bClosing)
			{
				gallery.clear();
				scrollbar.enable			= false;
				bResize						= false;
				TweenLite.to(mItemsMask, .3, { height:0, ease:Expo.easeInOut, onComplete:function()
				{
					TweenLite.to(mBg, .5, { x:Properties.WI, scaleX:0, ease:Expo.easeInOut, onComplete:function() 
					{
						visible 					= false;
						onClose();
					}} );
				}});
				
				mouseChildren 				= false;
			}
		}
		
		
		private function stageResizedHandler(e:Event = null):void
		{
			mBg.height					= 
			mMask.height				= Properties.HE;
			
			if (bResize)
			{
				mItemsMask.height		= Properties.HE;
			}
			
			scrollbar.resize();
			
			mTopItems.updatePlacement();
		}
	}
	
}