﻿package com.scenes
{
	import br.com.stimuli.loading.BulkLoader;
	import br.com.stimuli.loading.BulkProgressEvent;
	import br.com.stimuli.loading.loadingtypes.LoadingItem;
	import com.cuisine.Cuisine;
	import com.Properties;
	import com.ui.Bg;
	import com.ui.Header;
	import com.ui.Menu;
	import com.utkudemir.Rect;
	import com.utkudemir.ScrollBar;
	import com.utkudemir.Text;
	import com.utkudemir.utils.Scene;
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import flash.events.Event;
	import gs.easing.Expo;
	import gs.TweenLite;
	/**
	* ...
	* @author Utku DEMİR || utku@csdlab.com
	*/
	public class SceneMenu extends Scene
	{
		// variables
		private var bl					:BulkLoader;
		private var bPrepared			:Boolean	= false;
		
		private var xml					:XML;
		private var nImageCount			:int;
		
		private var mFakeForScroll		:Rect;
		private var mItems				:Sprite;
		private var mItemsMask			:Rect;
		
		private var mMainLoaderBar		:Rect;
		private var nLoaded				:int;
		private var nCurrent			:int;
		private var bLoaded				:Boolean;
		
		private var mMask				:Rect;
		private var mMasked				:Sprite;
		private var mBg					:Rect;
		private var mBase				:Sprite;
		private var mScrollbarMask		:Rect;
		private var scrollbar			:ScrollBar;
		
		private var bResize				:Boolean;
		private var aMenuItems			:Array;
		
		public function SceneMenu()
		{
			visible 					= false;
			mouseChildren 				= false;
		}
		
		private function prepare():void
		{
			// declare it's prepared
			bPrepared 					= true;
			
			// create the loader
			bl							= new BulkLoader("menuLoader");
			
			// create scene items
			mItems						= new Sprite();
			mItems.x					= 420;
			
			mItemsMask					= new Rect(550, 100);
			mItemsMask.height			= 0;
			mItemsMask.x				= mItems.x;
			addChild(mItemsMask);
			
			mItems.mask					= mItemsMask;
			
			mBg							= new Rect(510, 100, 0x000000, 0, 0, .9);
			mBg.scaleX					= 0;
			addChild(mBg);
			addChild(mItems);
			
			mMainLoaderBar				= new Rect(100, 3, 0xFFFFFF);
			mMainLoaderBar.width		= 0;
			mMainLoaderBar.x			= 420;
			addChild(mMainLoaderBar);
			
			mMask						= new Rect(550, 100, 0xFF0000);
			mItems.addChild(mMask);
			
			mMasked						= new Sprite();
			mMasked.mask				= mMask;
			mItems.addChild(mMasked);
			
			mBase						= new Sprite();
			mBase.x						= 10;
			mMasked.addChild(mBase);
			
			mFakeForScroll				= new Rect(1, 100, 0, 0, 0, 0);
			
			scrollbar					= new ScrollBar();
			scrollbar.x					= 512;
			mItems.addChild(scrollbar);
			
			TweenLite.to(scrollbar, 0, { tint:0xFFFFFF } );
			
			scrollbar.init(mMask, mMasked, 0, 50, 0, mFakeForScroll);
			
			stage.addEventListener("stageResized", stageResizedHandler, true);
			stageResizedHandler();
		}
		
		private function setContent():void
		{
			mMainLoaderBar.width		= 0;
			mMainLoaderBar.x			= mItems.x;
			
			mMasked.y					= 0;
			mBg.x						= 0;
			stageResizedHandler();
			
			TweenLite.to(mBg, .5, { x:mItems.x, scaleX:1, ease:Expo.easeInOut, onComplete:loadXml } );
		}
		
		private function loadXml():void
		{
			nLoaded						= 0;
			nCurrent					= 0;
			bLoaded						= false;
			
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			
			var sXml:String				= Properties.CONTENTXML.@xml;
			
			var xmlItem:LoadingItem;
			if (bl.get(sXml) == null)
			{
				xmlItem					= bl.add(sXml, { id:sXml } );
			}
			else
			{
				xmlItem					= bl.get(sXml);
			}
			
			xmlItem.addEventListener(Event.COMPLETE, xmlLoadedHandler);
			
			if (xmlItem.isLoaded) xmlItem.dispatchEvent(new Event(Event.COMPLETE));
			
			if (!bl.isRunning) bl.start(1);
		}
		
		private function enterFrameHandler(e:Event):void 
		{
			if (nCurrent >= 100 && bLoaded)
			{
				removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
				TweenLite.to(mMainLoaderBar, .3, { width:0, x:mItems.x + mMainLoaderBar.width, ease:Expo.easeInOut } );
				openScene();
			}
			else
			{
				if (nCurrent < nLoaded) nCurrent = Math.min(nLoaded, nCurrent + 5);
				nCurrent = Math.min(nCurrent, 100);
				mMainLoaderBar.width	= 510 * nCurrent / 100;
			}
		}
		
		private function xmlLoadedHandler(e:Event):void 
		{
			xml							= bl.getXML(e.target.id);
			nLoaded						= 20;
			
			var aImages:Array			= new Array();
			var sImage:String;
			var imageItem:LoadingItem;
			for (var i:int = 0; i < xml.cuisine.length(); i++) 
			{
				sImage					= xml.cuisine[i].@image;
				if(aImages.indexOf(sImage) == -1) aImages.push(sImage);
				
				for (var j:int = 0; j < xml.cuisine[i].item.length(); j++) 
				{
					sImage				= xml.cuisine[i].item[j].@image;
					if(aImages.indexOf(sImage) == -1) aImages.push(sImage);
				}
			}
			
			nImageCount					= aImages.length - 1;
			
			for (i = 0; i < aImages.length; i++) 
			{
				sImage					= aImages[i];
				
				if (bl.get(sImage) == null)
				{
					imageItem			= bl.add(sImage, { id:sImage } );
				}
				else
				{
					imageItem			= bl.get(sImage);
				}
				
				imageItem.addEventListener(Event.COMPLETE, imageLoadedHandler);
				
				if (imageItem.isLoaded) imageItem.dispatchEvent(new Event(Event.COMPLETE));
			}
			
			bl.addEventListener(BulkProgressEvent.COMPLETE, loadingCompleteHandler);
			if (bl.isFinished) bl.dispatchEvent(new BulkProgressEvent(BulkProgressEvent.COMPLETE));
		}
		
		private function imageLoadedHandler(e:Event):void 
		{
			nLoaded						+= 80 / nImageCount;
		}
		
		private function loadingCompleteHandler(e:BulkProgressEvent):void
		{
			bl.removeEventListener(BulkProgressEvent.COMPLETE, loadingCompleteHandler);
			bLoaded						= true;
		}
		
		private function openScene():void
		{
			aMenuItems				= new Array();
			
			var cuisine:Cuisine;
			var nY:int				= 0;
			for (var i:int = 0; i < xml.cuisine.length(); i++) 
			{
				cuisine				= new Cuisine(XML(xml.cuisine[i]), bl, 520, nY);
				cuisine.addEventListener("over", itemOverHandler);
				cuisine.addEventListener("out", itemOutHandler);
				cuisine.addEventListener("clicked", itemClickHandler);
				cuisine.addEventListener("closeClicked", itemCloseClickHandler);
				cuisine.Enable		= true;
				mBase.addChild(cuisine);
				aMenuItems.push(cuisine);
				
				nY					+= cuisine.he;
			}
			
			mFakeForScroll.height	= nY;
			
			scrollbar.reset();
			stageResizedHandler();
			
			TweenLite.to(mItemsMask, .3, { height:Properties.HE, ease:Expo.easeInOut, onComplete:function()
			{
				bResize				= true;
				scrollbar.enable	= true;
				stageResizedHandler();
				mouseChildren 				= true;
				onOpen();
				Menu.instance.enable(); 
				
				if (Properties.CONTENTXML.@bg_image != undefined) 
				{
					Bg.instance.openImage(Properties.CONTENTXML.@bg_image);
				}
				else
				{
					Bg.instance.openImage(Properties.DATA.config.@main_page_bg_source);
				}
			} } );
		}
		
		private function itemCloseClickHandler(e:Event):void 
		{
			var item:Cuisine;
			for (var i:int = 0; i < aMenuItems.length; i++) 
			{
				item						= Cuisine(aMenuItems[i]);
				item.idle();
			}
			
			TweenLite.to(mMasked, .3, { delay:.6, y:0, ease:Expo.easeInOut } );
			mFakeForScroll.height			= aMenuItems[aMenuItems.length - 1].orgY + aMenuItems[aMenuItems.length - 1].he;
			scrollbar.reset();
			scrollbar.resize();
		}
		
		private function itemClickHandler(e:Event):void 
		{
			var item:Cuisine;
			for (var i:int = 0; i < aMenuItems.length; i++) 
			{
				item						= Cuisine(aMenuItems[i]);
				if (Cuisine(e.target) == item)
				{
					item.open(.3);
					TweenLite.to(item, .3, { delay:.3, y:0, ease:Expo.easeInOut } );
					
					mFakeForScroll.height	= item.he;
				}
				else
				{
					item.close();
				}
			}
			TweenLite.to(mMasked, .3, { y:0, ease:Expo.easeInOut } );
			scrollbar.reset();
			scrollbar.resize();
		}
		
		private function itemOverHandler(e:Event):void 
		{
			for (var i:int = 0; i < aMenuItems.length; i++) 
			{
				TweenLite.to(aMenuItems[i], .3, { alpha:Cuisine(e.target) == aMenuItems[i] ? 1 : .6, ease:Expo.easeOut } );
			}
		}
		
		private function itemOutHandler(e:Event):void 
		{
			for (var i:int = 0; i < aMenuItems.length; i++) 
			{
				TweenLite.to(aMenuItems[i], .3, { alpha:1, ease:Expo.easeOut } );
			}
		}
		
		public function open():void
		{
			bResize						= false;
			
			if(!bPrepared) prepare();
			setContent();
			
			visible 					= true;
		}
		
		public function close():void
		{
			scrollbar.enable			= false;
			bResize						= false;
			TweenLite.to(mItemsMask, .3, { height:0, ease:Expo.easeInOut, onComplete:function()
			{
				TweenLite.to(mBg, .5, { x:Properties.WI, scaleX:0, ease:Expo.easeInOut, onComplete:function() 
				{
					visible 					= false;
					onClose();
					while (mBase.numChildren > 0) mBase.removeChildAt(0);
				}} );
			}});
			mouseChildren 				= false;
		}
		
		private function stageResizedHandler(e:Event = null):void
		{
			mBg.height					= 
			mMask.height				= Properties.HE;
			
			if (bResize)
			{
				mItemsMask.height		= Properties.HE;
			}
			
			scrollbar.resize();
		}
	}
	
}