package com.scenes
{
	import br.com.stimuli.loading.BulkLoader;
	import br.com.stimuli.loading.BulkProgressEvent;
	import br.com.stimuli.loading.loadingtypes.LoadingItem;
	import com.news.ItemImage;
	import com.news.ItemVideo;
	import com.news.ItemYouTube;
	import com.Properties;
	import com.ui.Bg;
	import com.ui.Menu;
	import com.utkudemir.Rect;
	import com.utkudemir.ScrollBar;
	import com.utkudemir.Text;
	import com.utkudemir.utils.Scene;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.system.Security;
	import gs.easing.Expo;
	import gs.TweenLite;
	
	import com.mcs.mcText;
	/**
	* ...
	* @author Utku DEMİR || utku@csdlab.com
	*/
	public class SceneNews extends Scene
	{
		// variables
		private var bl					:BulkLoader;
		private var bPrepared			:Boolean	= false;
		
		private var xml					:XML;
		private var nImageCount			:int;
		
		private var mFakeForScroll		:Rect;
		private var mItems				:Sprite;
		private var mItemsMask			:Rect;
		
		private var mMainLoaderBar		:Rect;
		private var nLoaded				:int;
		private var nCurrent			:int;
		private var bLoaded				:Boolean;
		private var bOpened				:Boolean;
		
		private var mMask				:Rect;
		private var mMasked				:Sprite;
		private var mBg					:Rect;
		private var mBase				:Sprite;
		private var mScrollbarMask		:Rect;
		private var scrollbar			:ScrollBar;
		
		private var bResize				:Boolean;
		private var sYoutubePlayer		:String			= "http://www.youtube.com/apiplayer?version=3";
		private var bYoutubeLoaded		:Boolean		= false;
		
		private var nCurrentItem		:int;
		private var loader				:Loader;
		
		private var mTypeBg				:Rect;
		private var mTypeContainer		:Sprite;
		private var mTypeMask			:Rect;
		private var typeYoutube			:ItemYouTube;
		private var typeVideo			:ItemVideo;
		private var typeImage			:ItemImage;
		private var currentType			:*;
		private var aBtns				:Array;
		private var mBtnContainer		:Sprite;
		private var contentxml			:XML;
		private var bNow				:Boolean;
		
		private var sHeaderFont			:String;
		private var tText				:Text;
		
		public function SceneNews()
		{
			visible 					= false;
			mouseChildren 				= false;
		}
		
		private function prepare():void
		{
			// declare it's prepared
			bPrepared 					= true;
			
			// create the loader
			bl							= new BulkLoader("newsLoader");
			
			// create scene items
			mItems						= new Sprite();
			mItems.x					= 420;
			
			mItemsMask					= new Rect(550, 100);
			mItemsMask.height			= 0;
			mItemsMask.x				= mItems.x;
			addChild(mItemsMask);
			
			mItems.mask					= mItemsMask;
			
			mBg							= new Rect(510, 100, 0x000000, 0, 0, .9);
			mBg.scaleX					= 0;
			addChild(mBg);
			addChild(mItems);
			
			mMainLoaderBar				= new Rect(100, 3, 0xFFFFFF);
			mMainLoaderBar.width		= 0;
			mMainLoaderBar.x			= 420;
			addChild(mMainLoaderBar);
			
			mMask						= new Rect(550, 100, 0xFF0000);
			mItems.addChild(mMask);
			
			mMasked						= new Sprite();
			mMasked.mask				= mMask;
			mItems.addChild(mMasked);
			
			mTypeMask					= new Rect(510, 100);
			mTypeMask.height			= 0;
			mMasked.addChild(mTypeMask);
			
			mBase						= new Sprite();
			mBase.x						= 10;
			mBase.y						= Properties.DATA.config.@menu_y;
			mBase.mask					= mTypeMask;
			mMasked.addChild(mBase);
			
			mFakeForScroll				= new Rect(490, 100, 0xff0000, 0, 0, 0);
			mBase.addChild(mFakeForScroll);
			
			tText						= new Text("", { size:10, color:0xFFFFFF, font:2, width:490 } );
			mBase.addChild(tText);
			
			mTypeBg						= new Rect(490, 2, 0, 0, 0, .9);
			mBase.addChild(mTypeBg);
			
			typeYoutube					= new ItemYouTube();
			typeYoutube.addEventListener("finished", itemFinishedHandler);
			typeYoutube.visible			= false;
			mBase.addChild(typeYoutube);
			
			typeVideo					= new ItemVideo();
			typeVideo.addEventListener("finished", itemFinishedHandler);
			typeVideo.visible			= false;
			mBase.addChild(typeVideo);
			
			typeVideo.init();
			
			typeImage					= new ItemImage(bl);
			typeImage.addEventListener("finished", itemFinishedHandler);
			typeImage.visible			= false;
			mBase.addChild(typeImage);
			
			aBtns						= new Array();
			mBtnContainer				= new Sprite();
			mBtnContainer.x				= 480;
			mBtnContainer.y				= mBase.y - 2;
			mMasked.addChild(mBtnContainer);
			
			scrollbar					= new ScrollBar();
			scrollbar.x					= 512;
			mItems.addChild(scrollbar);
			
			TweenLite.to(scrollbar, 0, { tint:0xFFFFFF } );
			
			
			stage.addEventListener("stageResized", stageResizedHandler, true);
			stageResizedHandler();
			
			sHeaderFont					= MovieClip(new mcText())["tText1"].defaultTextFormat.font;
			trace("FONT: " + sHeaderFont);
		}
		
		private function setContent():void
		{
			nCurrentItem				= 0;
			
			mMainLoaderBar.width		= 0;
			mMainLoaderBar.x			= mItems.x;
			
			mMasked.y					= 0;
			mBg.x						= 0;
			stageResizedHandler();
			
			
			TweenLite.to(mBg, .5, { x:mItems.x, scaleX:1, ease:Expo.easeInOut, onComplete:loadXml } );
		}
		
		private function loadXml():void
		{
			nLoaded						= 0;
			nCurrent					= 0;
			bLoaded						= false;
			
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			
			var sXml:String				= Properties.CONTENTXML.@xml;
			
			var xmlItem:LoadingItem;
			if (bl.get(sXml) == null)
			{
				xmlItem					= bl.add(sXml, { id:sXml } );
			}
			else
			{
				xmlItem					= bl.get(sXml);
			}
			
			xmlItem.addEventListener(Event.COMPLETE, xmlLoadedHandler);
			
			if (xmlItem.isLoaded) xmlItem.dispatchEvent(new Event(Event.COMPLETE));
			
			if (!bl.isRunning) bl.start(1);
		}
		
		private function xmlLoadedHandler(e:Event):void 
		{
			xml							= bl.getXML(e.target.id);
			nLoaded						= 10;
			
			var bLoadYoutube:Boolean	= !bYoutubeLoaded;
			bYoutubeLoaded				= true;
			if (xml.newsItem.(@type == "youtube").length() == 0) bLoadYoutube = false;
			
			if (bLoadYoutube)
			{
				loadYoutube();
			}
			else
			{
				nLoaded					= 20;
				loadImages();
			}
		}
		
		private function loadYoutube():void
		{
			Security.allowDomain("www.youtube.com");
			Security.allowDomain("youtube.com");
			Security.allowDomain("s.ytimg.com");
			Security.allowDomain("i.ytimg.com");
			
			loader					= new Loader();
			loader.contentLoaderInfo.addEventListener(Event.INIT, onLoaderInit);
			loader.load(new URLRequest(sYoutubePlayer));
		}
		
		private function onLoaderInit(e:Event):void
		{
			typeYoutube.init(loader.content);
			loader.content.addEventListener("onReady", onReadyHandler);
		}
		
		private function onReadyHandler(e:Event):void 
		{
			nLoaded					= 20;
			loadImages();
		}
		
		private function enterFrameHandler(e:Event):void 
		{
			if (nCurrent >= 100 && bLoaded)
			{
				removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
				TweenLite.to(mMainLoaderBar, .3, { width:0, x:mItems.x + mMainLoaderBar.width, ease:Expo.easeInOut } );
				openScene();
			}
			else
			{
				if (nCurrent < nLoaded) nCurrent = Math.min(nLoaded, nCurrent + 5);
				nCurrent = Math.min(nCurrent, 100);
				mMainLoaderBar.width	= (510) * nCurrent / 100;
			}
		}
		
		private function loadImages():void 
		{
			var aImages:Array			= new Array();
			var sImage:String;
			var imageItem:LoadingItem;
			var nLoadedItemCount:int	= 0;
			for (var i:int = 0; i < xml.newsItem.length(); i++) 
			{
				if (xml.newsItem[i].@type == "image") 
				{
					aImages.push(xml.newsItem[i].@source);
				}
			}
			
			nImageCount					= aImages.length;
			
			for (i = 0; i < aImages.length; i++) 
			{
				sImage					= aImages[i];
				
				if (bl.get(sImage) == null)
				{
					imageItem			= bl.add(sImage, { id:sImage } );
				}
				else
				{
					imageItem			= bl.get(sImage);
				}
				
				imageItem.addEventListener(Event.COMPLETE, imageLoadedHandler);
				
				if (imageItem.isLoaded)
				{
					nLoadedItemCount++;
					imageItem.dispatchEvent(new Event(Event.COMPLETE));
				}
			}
			
			bl.addEventListener(BulkProgressEvent.COMPLETE, loadingCompleteHandler);
			
			if (nLoadedItemCount == nImageCount) 
			{
				nLoaded					= 100;
				bl.dispatchEvent(new BulkProgressEvent(BulkProgressEvent.COMPLETE));
			}
		}
		
		private function imageLoadedHandler(e:Event):void 
		{
			nLoaded						+= Math.ceil(80 / nImageCount);
		}
		
		private function loadingCompleteHandler(e:BulkProgressEvent):void
		{
			nLoaded						= 100;
			bl.removeEventListener(BulkProgressEvent.COMPLETE, loadingCompleteHandler);
			bLoaded						= true;
		}
		
		private function openScene():void
		{
			aBtns						= new Array();
			
			var btn:MovieClip;
			var nBtnCount:int			= xml.newsItem.length();
			for (var i:int = 0; i < nBtnCount; i++) 
			{
				btn						= new MovieClip();
				btn.no					= i;
				btn.addChild(new Rect(20, 5, 0xFFFFFF, 0, -5));
				btn.addChild(new Rect(20, 10, 0, 0, -10, 0));
				btn.mouseChildren		= false;
				btn.x					= -1 * (nBtnCount - i) * 22;
				if (i != 0)
				{
					btn.buttonMode		= true;
					btn.addEventListener(MouseEvent.ROLL_OVER, btnOverHandler);
					btn.addEventListener(MouseEvent.ROLL_OUT, btnOutHandler);
					btn.addEventListener(MouseEvent.CLICK, btnClickHandler);
				}
				mBtnContainer.addChild(btn);
				aBtns.push(btn);
			}
			
			mTypeMask.height			= Properties.HE;
			changeContent(0);
			
			scrollbar.reset();
			stageResizedHandler();
			
			TweenLite.to(mItemsMask, .3, { height:Properties.HE, ease:Expo.easeInOut, onComplete:function()
			{
				bResize				= true;
				scrollbar.enable	= true;
				stageResizedHandler();
				mouseChildren 				= true;
				onOpen();
				
				Menu.instance.enable(); 
				
				if (Properties.CONTENTXML.@bg_image != undefined) 
				{
					Bg.instance.openImage(Properties.CONTENTXML.@bg_image);
				}
				else
				{
					Bg.instance.openImage(Properties.DATA.config.@main_page_bg_source);
				}
			} } );
		}
		
		private function btnOverHandler(e:MouseEvent = null, m:MovieClip = null):void 
		{
			var btn:MovieClip				= e != null ? MovieClip(e.target) : m;
			TweenLite.to(btn.getChildAt(0), .3, { height:10, ease:Expo.easeOut } );
		}
		
		private function btnOutHandler(e:MouseEvent = null, m:MovieClip = null):void 
		{
			var btn:MovieClip				= e != null ? MovieClip(e.target) : m;
			TweenLite.to(btn.getChildAt(0), .3, { height:5, ease:Expo.easeOut } );
		}
		
		private function btnClickHandler(e:MouseEvent):void 
		{
			var btn:MovieClip	= aBtns[nCurrentItem];
			btn.buttonMode		= true;
			btn.addEventListener(MouseEvent.ROLL_OVER, btnOverHandler);
			btn.addEventListener(MouseEvent.ROLL_OUT, btnOutHandler);
			btn.addEventListener(MouseEvent.CLICK, btnClickHandler);
			
			btnOutHandler(null, btn);
			
			nCurrentItem		= e.target.no;
			changeContent(nCurrentItem);
		}
		
		
		private function itemFinishedHandler(e:Event):void 
		{
			var btn:MovieClip	= aBtns[nCurrentItem];
			btn.buttonMode		= true;
			btn.addEventListener(MouseEvent.ROLL_OVER, btnOverHandler);
			btn.addEventListener(MouseEvent.ROLL_OUT, btnOutHandler);
			btn.addEventListener(MouseEvent.CLICK, btnClickHandler);
			
			btnOutHandler(null, btn);
			
			nCurrentItem++;
			if (nCurrentItem == xml.newsItem.length()) nCurrentItem = 0;
			
			aBtns[nCurrentItem].dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
		
		
		private function changeContent(n:int):void
		{
			mouseChildren		= false;
			var btn:MovieClip	= aBtns[n];
			btn.buttonMode		= false;
			btn.removeEventListener(MouseEvent.ROLL_OVER, btnOverHandler);
			btn.removeEventListener(MouseEvent.ROLL_OUT, btnOutHandler);
			btn.removeEventListener(MouseEvent.CLICK, btnClickHandler);
			
			btnOverHandler(null, btn);
			
			contentxml			= XML(xml.newsItem[n]);
			if (currentType != null) currentType.dispose();
			bNow				= currentType == null;
			scrollbar.visible	= false;
			TweenLite.to(mTypeMask, bNow ? 0 : .5, { height:mBase.y, ease:Expo.easeOut, onComplete:function()
			{
				
				tText.text		= "<font face=\"Code Bold\" size=\"" + int(contentxml.header.@size) + "\">" + contentxml.header.text() + "</font><br/>" + contentxml.body.text();
				
				if (currentType != null) 
				{
					currentType.clear();
					currentType.visible = false;
				}
				var nOffset:int				= 0;
				switch(String(contentxml.@type))
				{
					case "youtube":
					currentType				= typeYoutube;
					currentType.playVideo(contentxml);
					break;
					
					case "video":
					currentType				= typeVideo;
					currentType.playVideo(contentxml);
					break;
					
					case "image":
					currentType				= typeImage;
					currentType.setImage(contentxml);
					nOffset					= 10;
					break;
				}
				
				tText.y						= currentType.he + 20;
				
				mTypeBg.height				= currentType.he + 10 - nOffset;
				
				currentType.visible			= true;
				TweenLite.to(mTypeMask, bNow ? 0 : .5, { height:Properties.HE, ease:Expo.easeIn, onComplete:function()
				{
					mFakeForScroll.height	= Properties.HE - mBase.y - tText.y;
					mFakeForScroll.y		= tText.y;
					scrollbar.reset();
					scrollbar.init(mFakeForScroll, tText, tText.y, 50, mFakeForScroll.height - Properties.HE);
					scrollbar.resize();
					mouseChildren			= true;
					if (!bOpened)
					{
						bOpened				= true;
						onOpen();
					}
				} } );
			} } );
		}
		
		public function open():void
		{
			bOpened						= false;
			
			if(!bPrepared) prepare();
			setContent();
			
			visible 					= true;
		}
		
		public function close():void
		{
			var btn:MovieClip	= aBtns[nCurrentItem];
			btn.buttonMode		= true;
			btn.addEventListener(MouseEvent.ROLL_OVER, btnOverHandler);
			btn.addEventListener(MouseEvent.ROLL_OUT, btnOutHandler);
			btn.addEventListener(MouseEvent.CLICK, btnClickHandler);
			btnOutHandler(null, btn);
			
			TweenLite.killTweensOf(mTypeMask);
			
			currentType.dispose();
			currentType.visible			= false;
			currentType					= null;
			
			scrollbar.enable			= false;
			bResize						= false;
			TweenLite.to(mItemsMask, .3, { height:0, ease:Expo.easeInOut, onComplete:function()
			{
				TweenLite.to(mBg, .5, { x:Properties.WI, scaleX:0, ease:Expo.easeInOut, onComplete:function() 
				{
					for (var i:int = 0; i < aBtns.length; i++) 
					{
						aBtns[i].removeEventListener(MouseEvent.ROLL_OVER, btnOverHandler);
						aBtns[i].removeEventListener(MouseEvent.ROLL_OUT, btnOutHandler);
						aBtns[i].removeEventListener(MouseEvent.CLICK, btnClickHandler);
					}
					while (mBtnContainer.numChildren > 0) mBtnContainer.removeChildAt(0);
					visible 					= false;
					onClose();
				}} );
			}});
			mouseChildren 				= false;
		}
		
		private function stageResizedHandler(e:Event = null):void
		{
			mBg.height					= 
			mMask.height				= Properties.HE;
			
			if (bResize)
			{
				mTypeMask.height		= Properties.HE;
				mItemsMask.height		= Properties.HE;
			}
			
			try
			{
				mFakeForScroll.height	= Properties.HE - mBase.y - (currentType.he + 20);
				mFakeForScroll.y		= currentType.he + 20;
				scrollbar.init(mFakeForScroll, tText, (currentType.he + 20), 50, mFakeForScroll.height - Properties.HE);
				scrollbar.resize();
			}
			catch(e:*){}
		}
	}
	
}