﻿package com.ui 
{
	import br.com.stimuli.loading.loadingtypes.LoadingItem;
	import com.Properties;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.system.Capabilities;
	import gs.TweenLite;
	
	import com.bmds.bmdFilter;
	
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class Bg extends Sprite
	{
		private static var _instance	:Bg;
		
		private var mImages				:Sprite;
		private var mFake				:Sprite;
		private var mBase				:Sprite;
		private var mFilter				:Sprite;
		
		private var nOrgWi				:int;
		private var nOrgHe				:int;
		
		private var sSource				:String;
		private var bmd:BitmapData;
		private var bmp:Bitmap;
		
		public function Bg() 
		{
			_instance					= this;
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
			
			mFake						= new Sprite();
			addChild(mFake);
			
			mImages						= new Sprite();
			addChild(mImages);
			
			mBase						= new Sprite();
			mImages.addChild(mBase);
			
			mFilter						= new Sprite();
			mFilter.alpha				= .1;
			addChild(mFilter);
			
			var bFilter:BitmapData		= BitmapData(new bmdFilter(4, 4));
			mFilter.graphics.beginBitmapFill(bFilter);
			mFilter.graphics.drawRect(0, 0, Capabilities.screenResolutionX, Capabilities.screenResolutionY);
			mFilter.graphics.endFill();
			
			trace("FILL");
		}
		
		private function addedHandler(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, addedHandler);
			
			stage.addEventListener("stageResized", stageResizeHandler, true);
			stageResizeHandler();
		}
		
		public function openImage($sSource:String):void
		{
			sSource						= $sSource;
			
			var item:LoadingItem;
			if (Properties.BL.get(sSource) != null)
			{
				item					= Properties.BL.get(sSource);
			}
			else
			{
				item					= Properties.BL.add(sSource, { id:sSource } );
			}
			
			item.addEventListener(Event.COMPLETE, itemLoadedHandler);
			if (item.isLoaded) item.dispatchEvent(new Event(Event.COMPLETE));
		}
		
		private function itemLoadedHandler(e:Event):void 
		{
			bmd							= Properties.BL.getBitmapData(sSource);
			
			nOrgWi						= bmd.width;
			nOrgHe						= bmd.height;
			
			try
			{
				var bmdFake:BitmapData;
				bmdFake						= new BitmapData(Properties.WI, Properties.HE, false, 0x000000);
				bmdFake.draw(mImages);
				
				mFake.graphics.clear();
				mFake.graphics.beginBitmapFill(bmdFake, null, false, true);
				mFake.graphics.drawRect(0, 0, Properties.WI, Properties.HE);
				mFake.graphics.endFill();
			}
			catch(e:*)
			{
			}
			
			mBase.graphics.clear();
			mBase.graphics.beginBitmapFill(bmd, null, false, true);
			mBase.graphics.drawRect(0, 0, nOrgWi, nOrgHe);
			mBase.graphics.endFill();
			
			mBase.alpha				= 0;
			
			stageResizeHandler();
			
			TweenLite.to(mBase, 1, { alpha:1 } );
		}
		
		private function stageResizeHandler(e:Event = null):void 
		{
			var nPercent:Number			= Math.max(Properties.WI / nOrgWi, Properties.HE / nOrgHe);
			
			var nWi:int					= nOrgWi * nPercent;
			var nHe:int					= nOrgHe * nPercent;
			
			mBase.width					= nWi;
			mBase.height				= nHe;
			mBase.x						= -1 * int((nWi - Properties.WI) / 2);
			mBase.y						= -1 * int((nHe - Properties.HE) / 2);
		}
		
		static public function get instance():Bg { return _instance; }
		
	}

}