package com.ui 
{
	import com.Properties;
	import com.utkudemir.Music;
	import com.utkudemir.Rect;
	import com.utkudemir.Text;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.StageDisplayState;
	import flash.events.Event;
	import com.mcs.mcSoundLines;
	import com.mcs.mcFullscreen;
	import flash.events.MouseEvent;
	import gs.easing.Back;
	import gs.easing.Expo;
	import gs.TweenLite;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class Footer extends Sprite
	{
		private static var _instance		:Footer;
		private var mContainer			:Sprite;
		private var mBg					:Rect;
		
		private var mLines				:MovieClip;
		private var bSoundOpen			:Boolean		= true;
		private var mSound				:Music;
		private var tSound				:Text;
		
		private var mFullscreen			:MovieClip;
		private var bFull				:Boolean		= false;
		
		private var social				:Social;
		private var bSubItems			:Boolean		= false;
		public function Footer() 
		{
			_instance					= this;
			
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
			
			mContainer					= new Sprite();
			addChild(mContainer);
			
			mBg							= new Rect(100, 30, 0x000000, 0, 0, .8);
			mBg.x						= 10;
			mContainer.addChild(mBg);
			
			var nT:int					= 0;
			if (Properties.BL.get("music") != null)
			{
				bSubItems					= true;
				
				mLines						= MovieClip(new mcSoundLines());
				mLines.x					= 20;
				mLines.y					= 25;
				
				mLines.addEventListener(MouseEvent.CLICK, soundClickHandler);
				mLines.addEventListener(MouseEvent.ROLL_OVER, btnOverHandler);
				mLines.addEventListener(MouseEvent.ROLL_OUT, btnOutHandler);
				mLines.buttonMode			= true;
				mLines.mouseChildren		= false;
			
				mSound						= new Music(Properties.BL.getSound("music"));
				mSound.fadeIn();
				
				tSound						= new Text("", { size:24, font:0 } );
				tSound.x					= 21;
				tSound.y					= -22;
				mLines.addChild(tSound);
				
				tSound.text					= Properties.DATA.config.@soundOnCaption;
				var nTwi2:int				= tSound.wi;
				
				tSound.text					= Properties.DATA.config.@soundOffCaption;
				var nTwi:int				= tSound.wi;
				
				nT						= 70 + Math.max(nTwi, nTwi2);
			}
			else
			{
				nT						= 20;
			}
			
			if (Properties.DATA.config.@fullscreenCaption != undefined)
			{
				bSubItems					= true;
				
				mFullscreen					= MovieClip(new mcFullscreen());
				mFullscreen.x				= nT;
				mFullscreen.y				= 25;
				
				mFullscreen.addEventListener(MouseEvent.CLICK, fullscreenClickHandler);
				mFullscreen.addEventListener(MouseEvent.ROLL_OVER, btnOverHandler);
				mFullscreen.addEventListener(MouseEvent.ROLL_OUT, btnOutHandler);
				mFullscreen.buttonMode		= true;
				mFullscreen.mouseChildren	= false;
				
				var tFullscreen:Text		= new Text(Properties.DATA.config.@fullscreenCaption, { size:24, font:0 } );
				tFullscreen.x				= 21;
				tFullscreen.y				= -22;
				mFullscreen.addChild(tFullscreen);
				
				mBg.width					= mFullscreen.x + tFullscreen.wi + 20;
			}
			
			if(!bSubItems) mContainer.removeChild(mBg);
			
			if (mLines)
			{
				mContainer.addChild(mLines);
				TweenLite.to(mLines, 0, { tint:0xffffff } );
			}
			
			if (mFullscreen)
			{
				mContainer.addChild(mFullscreen);
				TweenLite.to(mFullscreen, 0, { tint:0xffffff } );
			}
			
			if (Properties.DATA.social != undefined)
			{
				if (Properties.DATA.social.children().length() == 0) return;
				social						= new Social();
				social.x					= 10;
				social.y					= 10;
				addChild(social);
			}
		}
		
		public function soundOn():void
		{
			if (mSound != null)
			{
				if (bSoundOpen) mSound.fadeIn();
				mLines.addEventListener(MouseEvent.CLICK, soundClickHandler);
				tSound.text				= Properties.DATA.config.@soundOffCaption;
				mLines.gotoAndStop(1);
			}
		}
		
		public function soundOff():void
		{
			if (mSound != null)
			{
				mSound.fadeOut();
				mLines.removeEventListener(MouseEvent.CLICK, soundClickHandler);
				tSound.text				= Properties.DATA.config.@soundOnCaption;
				mLines.gotoAndStop(2);
			}
		}
		
		private function fullscreenClickHandler(e:MouseEvent):void
		{
			if (bFull)
			{
				stage.displayState		= StageDisplayState.NORMAL;
			}
			else
			{
				stage.displayState		= StageDisplayState.FULL_SCREEN;
			}
			
			bFull						= !bFull;
		}
		
		private function soundClickHandler(e:MouseEvent):void
		{
			bSoundOpen					= !bSoundOpen;
			mLines.gotoAndStop(bSoundOpen ? 1:2);
			
			if (bSoundOpen)
			{
				tSound.text				= Properties.DATA.config.@soundOffCaption;
				mSound.fadeIn();
			}
			else
			{
				tSound.text				= Properties.DATA.config.@soundOnCaption;
				mSound.fadeOut();
			}
		}
		
		private function btnOverHandler(e:MouseEvent):void 
		{
			TweenLite.to(e.target, .3, { alpha:.6 } );
		}
		
		private function btnOutHandler(e:MouseEvent):void 
		{
			TweenLite.to(e.target, .3, { alpha:1 } );
		}
		
		public function open(nDelay:Number = 0):void
		{
			TweenLite.to(mContainer, .5, { delay:nDelay, y: -30, ease:Expo.easeOut } );
			if(social) TweenLite.to(social, .5, { delay:nDelay + .1, y:bSubItems ? -65 : -35, ease:Expo.easeOut } );
		}
		
		private function addedHandler(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, addedHandler);
			
			stage.addEventListener("stageResized", stageResizeHandler, true);
			stageResizeHandler();
		}
		
		private function stageResizeHandler(e:Event = null):void
		{
			y						= Properties.HE;
		}
		
		static public function get instance():Footer { return _instance; }
		
	}

}