﻿package com.ui 
{
	import com.Properties;
	import com.utkudemir.utils.SceneManager;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import gs.easing.Expo;
	import gs.TweenLite;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class Menu extends Sprite
	{
		private static var _instance	:Menu;
		
		public var wi					:int			= 0;
		
		private var mBase				:Sprite;
		private var activeItem			:MenuItem;
		private var aItems				:Array;
		
		public function Menu() 
		{
			_instance					= this;
			
			mBase						= new Sprite();
			addChild(mBase);
			
			y							= Properties.DATA.config.@menu_y;
			
			scaleX						=
			scaleY						= Properties.DATA.config.@menu_scale;
			
			aItems						= new Array();
			
			var item:MenuItem;
			var i:int					= 0;
			var nY:int					= 0;
			for each(var xmlNode:XML in Properties.DATA.content.item)
			{
				item					= new MenuItem(i, xmlNode);
				item.Enable				= true;
				item.addEventListener("clicked", itemClickHandler);
				item.y					= nY;
				mBase.addChild(item);
				
				aItems[i]				= item;
				
				wi						= Math.max(wi, item.width);
				nY						+= item.he;
				i++;
			}
			
			for (i = 0; i < aItems.length; i++) 
			{
				aItems[i].x				= -1 * wi;
			}
			
			wi							*= Properties.DATA.config.@menu_scale;
		}
		
		public function openItem(n:int):void
		{
			aItems[n].dispatchEvent(new Event("clicked"));
		}
		
		public function clear():void
		{
			if (activeItem != null) 
			{
				activeItem.Enable		= true;
				activeItem				= null;
			}
		}
		
		public function open(nDelay:Number = 0):void
		{
			for (var i:int = 0; i < aItems.length; i++) 
			{
				TweenLite.to(aItems[i], .5, { delay:nDelay + i * .1, x:0, ease:Expo.easeOut } );
			}
		}
		
		public function close(nDelay:Number = 0):void
		{
			for (var i:int = 0; i < aItems.length; i++) 
			{
				TweenLite.to(aItems[i], .5, { delay:nDelay + i * .1, x:-1 * wi, ease:Expo.easeOut } );
			}
		}
		
		private function itemClickHandler(e:Event):void 
		{
			if (e.target.no != Properties.nMainPage) Properties.bActivateLogo = true;
			
			if (MenuItem(e.target).xml.@type == "link")
			{
				var sUrl:String			= MenuItem(e.target).xml.@url;
				var sTarget:String		= MenuItem(e.target).xml.@url_target != undefined ? MenuItem(e.target).xml.@url_target : "_self";
				
				navigateToURL(new URLRequest(sUrl), sTarget);
				return;
			}
			
			mouseChildren				= false;
			
			if (activeItem != null) activeItem.Enable	= true;
			activeItem					= MenuItem(e.target);
			activeItem.Enable			= false;
			
			Properties.CONTENTXML		= activeItem.xml;
			SceneManager.instance.openScene(Properties.CONTENTXML.@type);
		}
		
		public function enable():void
		{
			mouseChildren				= true;
		}
		
		static public function get instance():Menu { return _instance; }
		
	}

}