﻿package com.ui 
{
	import com.Global;
	import com.Properties;
	import com.utkudemir.Rect;
	import com.utkudemir.Text;
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import gs.easing.Expo;
	import gs.TweenLite;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir
	$(CBI)*/
	public class MenuItem extends Sprite
	{
		public var no					:int;
		public var xml					:XML;
		public var he					:int;
		
		private var mItems				:Sprite;
		private var mOver				:Rect;
		private var tText				:Text;
		private var mBtn				:Rect;
		
		public function MenuItem($no:int, $xml:XML) 
		{
			no							= $no;
			xml							= $xml;
			
			mItems						= new Sprite();
			mItems.scaleX				=
			mItems.scaleY				= xml.@item_scale != undefined ? xml.@item_scale:1;
			mItems.x					= Properties.DATA.config.@menu_x;
			if (xml.@item_scale != undefined) mItems.x += (1 - xml.@item_scale) * mItems.x;
			addChild(mItems);
			
			var nHe:int					= 70;
			var nPlus:int				= 8;
			var nOffset:int				= 2;
			
			tText						= new Text(xml.@title, { size:nHe, color:0xDDDDDD } );
			nHe							= tText.tf.getLineMetrics(0).ascent + nPlus;
			
			//mItems.y					= (nHe + 2) * no;
			mOver						= new Rect(200, nHe, 0x000000, -100);
			mOver.alpha					= .6;
			mOver.width					= (tText.wi + mItems.x + 5) * 2;
			mOver.x						= -1 * Properties.DATA.config.@menu_x;
			mOver.y						= nOffset;
			if (xml.@item_scale != undefined) mOver.y += (1 - xml.@item_scale) * mOver.y;
			mItems.addChild(mOver);
			
			mOver						= new Rect(200, nHe, 0x000000, -100);
			mOver.alpha					= 1;
			mOver.x						= -1 * Properties.DATA.config.@menu_x;
			mOver.blendMode				= BlendMode.OVERLAY;
			mOver.y						= nOffset;
			if (xml.@item_scale != undefined) mOver.y += (1 - xml.@item_scale) * mOver.y;
			mItems.addChild(mOver);
			mItems.addChild(tText);
			
			mOver.width					= 0;
			
			mBtn						= new Rect(100, nHe, 0xFF0000, 0, 0, 0);
			mItems.addChild(mBtn);
			
			mBtn.width					= tText.wi + mItems.x + 5;
			he							= int(mOver.height * mItems.scaleX + 2);
		}
		
		public function set Enable(b:Boolean):void
		{
			Global.addButtonFunctions(b, mBtn, [overHandler, outHandler, clickHandler]);
			
			if (b)
			{
				outHandler();
			}
			else
			{
				overHandler();
			}
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			dispatchEvent(new Event("clicked"));
		}
		
		private function overHandler(e:MouseEvent = null):void
		{
			TweenLite.to(mOver, .6, { width:(tText.wi + mItems.x + 5) * 2, ease:Expo.easeOut } );
		}
		
		private function outHandler(e:MouseEvent = null):void
		{
			TweenLite.to(mOver, .6, { width:0, ease:Expo.easeInOut } );
		}
	}

}