﻿package com.utkudemir 
{
	import com.formEelements.FDate;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	import com.formEelements.FCheckbox;
	import com.formEelements.FDropdown;
	import com.formEelements.FEmail;
	import com.formEelements.FHidden;
	import com.formEelements.FMultiline;
	import com.formEelements.FString;
	import flash.net.navigateToURL;
	import gs.TweenLite;
	/**
	* ...
	* @author Utku Demir || utku@csdlab.com
	*/
	public class Form extends Sprite
	{
		// variables
		public var onSend					:Function;
		public var onSending				:Function;
		public var onError					:Function;
		
		private var sFormItems				:Sprite;
		private var aFormItems				:Array 		= new Array();
		
		private var sSendAddress			:String;
		private var sSendingMessage			:String;
		private var sRequiredMessage		:String;
		private var sErrorMessage			:String;
		private var sCompleteMessage		:String;
		
		private var loader					:URLLoader;
		private var req						:URLRequest;
		private var variables				:URLVariables;
		
		private var wi						:uint;
		public var he						:uint		= 0;
		
		
		public function Form(xml:XML, _width:int, themeColor:Number) 
		{
			// create an opaque rectangle to calculate the size correctly
			addChild(new Rect(39, 30, 0xFF0000, 0, 0, 0));
			
			// set width
			wi								= _width;
			
			// create the main container sprite
			sFormItems 						= new Sprite();
			
			sSendAddress 					= xml.@fSendAddress;
			sSendingMessage 				= xml.@fSendingMessage;
			sRequiredMessage 				= xml.@fRequiredMessage;
			sErrorMessage 					= xml.@fErrorMessage;
			sCompleteMessage 				= xml.@fCompleteMessage;
			
			// set loader objects
			loader 							= new URLLoader();
			loader.addEventListener(Event.COMPLETE, sendingComplete);
			loader.addEventListener(IOErrorEvent.IO_ERROR, sendingError);
			req 							= new URLRequest(sSendAddress);
			variables 						= new URLVariables();
			
			// create some variables
			var item:*;
			var i:int 						= 0;
			
			// create some other variables
			var widthPerCol:int 			= (_width - 20);
			var nY:int 						= 0;
			
			// create and add form items to the container
			for each(var xmlNode:XML in xml.formElement)
			{
				switch(String(xmlNode.@fType))
				{
					case "string": item = new FString(xmlNode, (xmlNode.@fCol != 0 ? widthPerCol:_width), themeColor, sRequiredMessage); break;
					case "dropdown": item = new FDropdown(xmlNode, (xmlNode.@fCol != 0 ? widthPerCol:_width), themeColor, sRequiredMessage); break;
					case "checkbox": item = new FCheckbox(xmlNode, (xmlNode.@fCol != 0 ? widthPerCol:_width), themeColor, true); break;
					case "radio": item = new FCheckbox(xmlNode, (xmlNode.@fCol != 0 ? widthPerCol:_width), themeColor); break;
					case "multiline": item = new FMultiline(xmlNode, (xmlNode.@fCol != 0 ? widthPerCol:_width), themeColor, true, sRequiredMessage); break;
					case "email": item = new FEmail(xmlNode, (xmlNode.@fCol != 0 ? widthPerCol:_width), themeColor, sRequiredMessage); break;
					case "date": item = new FDate(xmlNode, (xmlNode.@fCol != 0 ? widthPerCol:_width), themeColor, sRequiredMessage); break;
					case "hidden": item = new FHidden(xmlNode); break;
					default: item = new FString(xmlNode, (xmlNode.@fCol != 0 ? widthPerCol:_width - 20), themeColor, sRequiredMessage); break;
					
				}
				
				item.name 					= xmlNode.@fName;
				item.addEventListener("activated", itemActivated);

				item.y = nY;
				he += item.he;
				
				if (item.y + item.he > nY) nY = item.y + item.he;
				
				aFormItems.push(item);
				sFormItems.addChild(item);
				
				i++;
			}
			
			addChild(sFormItems);
		}
		
		private function itemActivated(e:Event)
		{
			var item:* 						= e.target;
			if (sFormItems.getChildAt(sFormItems.numChildren - 1) != item)
			{
				sFormItems.swapChildren(sFormItems.getChildAt(sFormItems.numChildren - 1), item);
			}
		}
		public function clearForm()
		{
			for (var i:int = 0; i < aFormItems.length; i++) Object(aFormItems[i]).clear();
		}
		public function sendForm()
		{
			// sending form stuff
			var allOk:Boolean 				= true;
			var item:*;
			var notReady:int;
			
			// check if all the requested fields are ok
			for (var i:int = 0; i < aFormItems.length; i++)
			{
				item = aFormItems[i];
				if (item.warnable)
				{
					if (allOk) allOk = item.ok;
					if (!allOk && !item.ok) notReady = i;
					if (item.ok)
					{
						item.warn = false;
					}
					else
					{
						item.warn = true;
					}
				}
			}
			
			// start to send if all the requested fields are ok
			if (allOk)
			{
				startSending();
				//onSending();
				//TweenLite.delayedCall(2, sendingComplete);
			}
		}
		
		// variables
		private var bExtra:Boolean = false;
		private var sExtraName:String;
		private var sExtraValue:String;
		
		private function startSending()
		{
			// start to send
			onSending();
			
			for (var i:int = 0; i < aFormItems.length; i++)
			{
				variables[Object(aFormItems[i]).name] = Object(aFormItems[i]).value;
			}
			
			req.method 				= URLRequestMethod.POST;
			req.data 				= variables;
			
			loader.dataFormat 		= URLLoaderDataFormat.TEXT;
			loader.load(req);
		}
		
		private function sendingComplete(e:Event = null)
		{
			// declare the sending is complete
			onSend();
			clearForm();
		}
		
		private function sendingError(e:IOErrorEvent)
		{
			onError();
		}
	}
	
}