﻿package com.utkudemir 
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.text.AntiAliasType;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import com.mcs.mcText;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir  ||  utku@csdlab.com
	$(CBI)*/
	public class Input extends Sprite
	{
		// variables
		public var onType				:Function;
		public var onFocusOut			:Function;
		private var required			:Boolean;
		public var checkType			:String;
		private var minChar				:int;
		public var tf					:TextField;
		private var tFormat				:TextFormat;
		private var _value				:String = "";
		private var _firstValue			:String = "";
		private var password			:Boolean;
		private var EMAIL_REGEX			:RegExp = /^[A-Z0-9._%+-]+@(?:[A-Z0-9-]+\.)+[A-Z]{2,4}$/i;
		private var bFocused			:Boolean;
		
		public function Input(_width:int, _charLimit:int = 0, _minChar:int = -1, _restrict:String = "", _required:Boolean = false, _checkType:String = "str", _password:Boolean = false, nFont:int = 0, nFontSize:int = 24, nColor:Number = 0xFFFFFF, sAlign:String = "left"  ) 
		{
			// create the input field
			var mText:MovieClip 		= MovieClip(new mcText());
			var tFormatTemp:TextFormat 	= mText["tText" + nFont].defaultTextFormat;
			
			// create it's textformat
			tFormat 					= new TextFormat(tFormatTemp.font, nFontSize, nColor, tFormatTemp.bold, tFormatTemp.italic);
			tFormat.align 				= sAlign;
			tFormat.leading 			= tFormatTemp.leading;
			
			// set it's properties
			required 					= _required;
			checkType 					= _checkType;
			minChar 					= _minChar;
			password 					= _password;
			if (minChar == -1) minChar 	= 0;
			
			tf 							= new TextField();
			tf.type 					= TextFieldType.INPUT;
			tf.maxChars 				= _charLimit;
			if(_restrict != "") tf.restrict = _restrict;
			tf.multiline 				= false;
			tf.width 					= _width;
			tf.height 					= 25;
			tf.embedFonts 				= true;
			tf.antiAliasType 			= AntiAliasType.ADVANCED;
			tf.displayAsPassword 		= password;
			tf.defaultTextFormat 		= tFormat;
			addChild(tf);
			
			tf.addEventListener(FocusEvent.FOCUS_IN, focusInHandler);
			tf.addEventListener(FocusEvent.FOCUS_OUT, focusOutHandler);
		}
		
		public function set text(v:String)
		{
			// change the text of the input field
			_firstValue 				= v;
			tf.text 					= v;
		}
		private function focusInHandler(e:FocusEvent)
		{
			if (tf.text == _firstValue) tf.text = "";
			bFocused 					= true;
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			dispatchEvent(new Event("focusedIn"));
		}
		
		private function keyDownHandler(e:KeyboardEvent):void 
		{
			if (onType != null) onType();
		}
		private function focusOutHandler(e:FocusEvent)
		{
			if (tf.text == "")
			{
				tf.text 				= _firstValue;
				_value 					= tf.text;
			}
			
			bFocused 					= false;
			stage.removeEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			dispatchEvent(new Event("focusedOut"));
		}
		
		public function set focus(b:Boolean)
		{
			stage.focus 				= tf;
		}
		
		public function get value():String
		{
			_value 						= tf.text;
			return tf.text;
		}
		
		public function reset():void
		{
			_value = "";
			tf.text = "";
		}
		
		public function get check() 
		{
			_value = tf.text;
			var nValueLength:int = _value.length;
			if (bFocused) nValueLength++;
			var bValid:Boolean = true;
			if (required)
			{
				switch(checkType)
				{
					case "str":
					if (nValueLength < minChar || _value == _firstValue) bValid = false;
					break;
					
					case "email":
					if (!EMAIL_REGEX.test(_value) || _value == _firstValue) bValid = false;
					break;
				}
			}
			return bValid;
		}
	}
	
}