﻿package com.utkudemir
{
	import flash.display.Sprite;
	import flash.events.ContextMenuEvent;
	import flash.events.Event;
	import gs.easing.Circ;
	import gs.TweenLite;
	
	/**
	* ...
	* @author Utku Demir || utku@csdlab.com
	*/
	public class MaskedObject extends Sprite
	{
		// variables
		public var mMask				:Sprite;
		public var mMasked				:Sprite;
		
		private var targetX				:int;
		private var wi					:int = -1;
		private var he					:int = -1;
		
		
		public function MaskedObject() 
		{
			// set the first situation
			visible						= false;
			
			// create mask and masked sprites
			mMask						= new Sprite();
			addChild(mMask);
			
			mMasked						= new Sprite();
			mMasked.mask 				= mMask;
			addChild(mMasked);
			
			mMask.x 					= -200;
			mMask.graphics.clear();
			mMask.graphics.beginFill(0x00FF00, .2);
			mMask.graphics.lineTo( 200, 0);
			mMask.graphics.lineTo( 100, 100);
			mMask.graphics.lineTo( 0, 100);
			mMask.graphics.lineTo(0, 0);
			mMask.graphics.endFill();
			
			tabEnabled 					= false;
		}
		
		public function setSize(_wi:int = -1, _he:int = -1):void
		{
			// set the mask's size manually
			wi 							= _wi;
			he 							= _he;
			
			mMask.width 				= w * 2;
			mMask.height 				= h;
			mMask.x 					= visible ? 0 : -2 * w;
		}
		
		private function get w():int
		{
			// return the masked sprite's width if it's not set manually
			if (wi != -1) return wi;
			return mMasked.width;
		}
		private function get h():int
		{
			// return the masked sprite's height if it's not set manually
			if (he != -1) return he;
			return mMasked.height;
		}
		
		public function open(_delay:Number = 0):void
		{
			// opening stuff
			if (!visible)
			{
				mMask.x 				= 
				targetX 				= -2 * w;
				mMask.width 			= w * 2;
				mMask.height 			= h;
			}
			
			visible 					= true;
			
			TweenLite.killTweensOf(mMask);
			TweenLite.to(mMask, .6, { x:0, delay:_delay, ease:Circ.easeOut, onComplete:function()
			{
				dispatchEvent(new Event("opened"));
			} } );
		}
		
		public function closeNow()
		{
			mMask.x 					= 0;
			visible 					= false;
		}
		
		public function close(_delay:Number = 0):void
		{
			TweenLite.killTweensOf(mMask);
			TweenLite.to(mMask, .6, { x:targetX, delay:_delay, ease:Circ.easeIn, onComplete:function()
			{
				visible 				= false;
				dispatchEvent(new Event("closed"));
			} } );
		}
		
		public function redraw()
		{
			mMask.width 				= w * 2;
			mMask.height 				= h;
			targetX 					= -2 * w;
		}
	}
	
}