﻿package com.utkudemir
{
	import com.Properties;
	import fl.motion.easing.Linear;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import gs.TweenMax;
	
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir  ||  utku@csdlab.com
	$(CBI)*/
	public class Music extends EventDispatcher
	{
		// variables
		private var snd				:Sound;
		
		private var channel			:SoundChannel;
		private var transform		:SoundTransform;
		private var nVolume			:Number;
		
		private var bFadingOut		:Boolean;
		
		public function Music($snd:Sound) 
		{
			// create the sound object
			snd						= $snd;
			
			// create the soundtransform object
			transform 				= new SoundTransform(1);
			
			// set volume
			nVolume 				= 0;
		}
		public function ply()
		{
			// start playing
			transform 				= new SoundTransform(0);
			
			if(channel != null) stop();
			channel 				= snd.play();
			channel.soundTransform 	= transform;
			channel.addEventListener(Event.SOUND_COMPLETE, soundCompleteHandler);
		}
		
		private function soundCompleteHandler(e:Event):void 
		{
			trace("complete");
			// replay when it's complete
			if (!bFadingOut) 
			{
				channel = snd.play();
				channel.soundTransform 	= transform;
				channel.addEventListener(Event.SOUND_COMPLETE, soundCompleteHandler);
			}
			
			dispatchEvent(new Event("soundComplete"));
		}
		
		public function stop()
		{
			// stop the sound
			channel.stop();
			channel = null;
		}
		
		public function set volume(nValue:Number)
		{
			// set volume
			if (channel == null) ply(); 
			nVolume 				= nValue;
			transform.volume 		= nValue;
			channel.soundTransform 	= transform;
		}
		
		public function get volume():Number { return nVolume; }
		
		public function fadeIn(nTime:Number = 1)
		{
			bFadingOut				= false;
			TweenMax.killTweensOf(this);
			TweenMax.to(this, nTime, { volume:Properties.nSoundVolume, ease:Linear.easeNone} );
		}
		
		private var bStopWhenFadeOut:Boolean;
		public function fadeOut(nTime:Number = 1, _bStopWhenFadeOut:Boolean = false )
		{
			bFadingOut				= true;
			bStopWhenFadeOut = _bStopWhenFadeOut;
			TweenMax.killTweensOf(this);
			TweenMax.to(this, nTime, { volume:0, ease:Linear.easeNone, onComplete:function()
			{
				bFadingOut			= false;
				if (bStopWhenFadeOut) stop();
			} } );
		}
		
		public function setSound():void
		{
			if (channel != null)
			{
				nVolume 				= Properties.nSoundVolume;
				transform.volume 		= Properties.nSoundVolume;
				channel.soundTransform 	= transform;
			}
		}
	}
	
}