﻿package com.utkudemir 
{
	import com.Properties;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BlurFilter;
	import flash.filters.GlowFilter;
	import flash.geom.Rectangle;
	import com.mcs.mcScrollBar;
	import gs.TweenLite;
	/**
	$(CBI)* ...
	$(CBI)* @author Utku DEMİR || utku@csdlab.com
	$(CBI)*/
	public class ScrollBar extends Sprite
	{
		// variables
		private var mScrollBar	:MovieClip;
		private var mBtn		:Rect;
		
		private var sRef		:DisplayObject;
		private var sTarget		:DisplayObject;
		private var sTargetFake	:DisplayObject;
		
		private var orgY		:int;
		private var offset		:int;
		private var diff		:int;
		private var minY		:Number;
		
		private var rect		:Rectangle;
		private var nBlurLevel	:Number;
		
		public function ScrollBar() 
		{
			// add scrollbar object from library
			mScrollBar = MovieClip(new mcScrollBar());
			mScrollBar.scaleX			= .2;
			addChild(mScrollBar);
			
			//mScrollBar.filters			= [new GlowFilter(0xff0000, 1, 5, 5, 100, 2)];
			
			// create scrollbar button
			mBtn						= new Rect(10, 100, 0xFF0000, 0, 0, 0);
			mBtn.buttonMode = true;
			mBtn.addEventListener(MouseEvent.ROLL_OVER, overHandler);
			mBtn.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
			addChild(mBtn);
			
			rect 						= new Rectangle(0, 0, 0, 100);
			
			nBlurLevel					= Number(Properties.DATA.settings.@blurLevel);
		}
		
		private function overHandler(e:MouseEvent):void 
		{
			TweenLite.to(mScrollBar, .3, { scaleX:1 } );
			mBtn.addEventListener(MouseEvent.ROLL_OUT, outHandler);
		}
		
		private function outHandler(e:MouseEvent = null):void 
		{
			TweenLite.to(mScrollBar, .3, { scaleX:.2 } );
			mBtn.removeEventListener(MouseEvent.ROLL_OUT, outHandler);
		}
		
		public function init($sRef:DisplayObject, $sTarget:DisplayObject, $orgY:int = 0, $offset:int = 0, $diff:int = 0, $sTargetFake:DisplayObject = null):void
		{
			// set variables
			sRef 						= $sRef;
			sTarget 					= $sTarget;
			orgY 						= $orgY;
			offset 						= $offset;
			diff 						= $diff;
			
			sTargetFake					= $sTargetFake;
		}
		
		public function set enable(b:Boolean):void
		{
			if (b)
			{
				stage.addEventListener(MouseEvent.MOUSE_WHEEL, wheelHandler);
			}
			else
			{
				stage.removeEventListener(MouseEvent.MOUSE_WHEEL, wheelHandler);
			}
		}
		
		private function wheelHandler(e:MouseEvent):void 
		{
			// mouse wheel handler
			if (visible)
			{
				if (sRef.mouseX+sRef.x > sRef.x && sRef.mouseX + sRef.x < sRef.x + sRef.width)
				{
					mBtn.y -= e.delta * 5;
					mScrollBar.y					= mBtn.y;
					if (mScrollBar.y < 0) 
					{
						mBtn.y						=
						mScrollBar.y 				= 0;
					}
					if (mScrollBar.y > rect.height) 
					{
						mBtn.y						=
						mScrollBar.y 				= rect.height;
					}
					moveHandler();
				}
			}
		}
		public function reset():void
		{
			mBtn.y				=
			mScrollBar.y 		= 0;
		}
		
		public function resize():void
		{
			// set the size of the scrollbar
			if ((sTargetFake == null ? sTarget.height : sTargetFake.height) > sRef.height - (orgY - sRef.y))
			{
				visible = true;
				var nPercent:Number		= ((sTargetFake == null ? sTarget.height : sTargetFake.height) + offset) / sRef.height;
				size = (sRef.height - diff) / nPercent;
				rect.height = sRef.height - diff - mScrollBar.height;
				minY = -1 * ((sTargetFake == null ? sTarget.height : sTargetFake.height) - sRef.height) - offset;
				
				if (mScrollBar.y > rect.height)
				{
					mBtn.y				=
					mScrollBar.y 		= rect.height;
					moveHandler();
				}
			}
			else
			{
				visible = false;
				mBtn.y					=
				mScrollBar.y 			= 0;
				moveHandler();
			}
		}
		
		private var nSize				:Number;
		private function set size(n:Number):void
		{
			if (n < 37) n = 37;
			nSize = n;
			mScrollBar.mcBottom.y 		= nSize - 10;
			mScrollBar.mcInner.height 	= nSize - 20;
			mBtn.height 				= nSize;
		}
		
		private function get size():Number
		{
			return nSize;
		}
		
		private function downHandler(e:MouseEvent):void 
		{
			mBtn.removeEventListener(MouseEvent.ROLL_OVER, overHandler);
			mBtn.removeEventListener(MouseEvent.ROLL_OUT, outHandler);
			mBtn.startDrag(false, rect);
			stage.addEventListener(MouseEvent.MOUSE_UP, upHandler);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
		}
		
		private function moveHandler(e:MouseEvent = null):void 
		{
			mScrollBar.y				= mBtn.y;
			if (!hasEventListener(Event.ENTER_FRAME)) addEventListener(Event.ENTER_FRAME, move);
		}
		
		private function upHandler(e:MouseEvent):void 
		{
			TweenLite.to(this, .01, { onComplete:function()
			{
				if (mouseX <= 0 || mouseX >= 10) 
				{
					outHandler();
				}
				else
				{
					mBtn.addEventListener(MouseEvent.ROLL_OUT, outHandler);
				}
			} } );
			mBtn.addEventListener(MouseEvent.ROLL_OVER, overHandler);
			mBtn.stopDrag();
			stage.removeEventListener(MouseEvent.MOUSE_UP, upHandler);
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
		}
		
		private function move(e:Event = null):void
		{
			var nPercent:Number 		=  mScrollBar.y / rect.height;
			var targetY:Number 			=  (sTargetFake == null ? sTarget.height : sTargetFake.height) > sRef.height - (orgY - sRef.y) ? minY * nPercent : 0;
			var nDiff:Number 			= targetY - sTarget.y + orgY;
			
			if (Math.abs(nDiff) < .5)
			{
				sTarget.y 				= targetY + orgY;
				removeEventListener(Event.ENTER_FRAME, move);
			}
			else
			{
				sTarget.y 				+= nDiff * .2;
			}
			
			if (Properties.DATA.settings.@blurWhenScroll == "true")
			{
				sTarget.filters 		= [new BlurFilter(0, Math.abs(nDiff) * nBlurLevel, 2)];
			}
		}
		
	}
	
}