﻿package com.utkudemir
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	import flash.text.AntiAliasType;
	import flash.text.StyleSheet;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import com.mcs.mcText;
	/**
	* ...
	* @author Utku Demir  ||  utku@csdlab.com
	*/
	public class Text extends Sprite
	{
		public 	var wi			:int;
		public 	var he			:int;
		public 	var tf			:TextField;
		public 	var tFormat		:TextFormat;
		
		private var _nLeading		:int;
		private var _nLetterSpacing	:int;
		private var _size			:Number;
		public function Text(sText:String,  $vars:Object) 
		{
				_size					= $vars.size != undefined ? $vars.size : 11;
			var _color		:Number 	= $vars.color != undefined ? $vars.color : 0x000000;
			var _linkcolor	:Number 	= $vars.linkcolor != undefined ? $vars.linkcolor : _color;
			var _overcolor	:Number 	= $vars.overcolor != undefined ? $vars.overcolor : _color;
			var _align		:String 	= $vars.align != undefined ? $vars.align : "left";
			var _width		:int 		= $vars.width != undefined ? $vars.width : 0;
			var _height		:int 		= $vars.height != undefined ? $vars.height : -1;
			var _font		:int 		= $vars.font != undefined ? $vars.font : 0;
			var _selectable	:Boolean 	= $vars.selectable != undefined ? $vars.selectable : false;
				_nLeading				= $vars.leading != undefined ? $vars.leading : 2;
				_nLetterSpacing			= $vars.spacing != undefined ? $vars.spacing : 0;
			var mText:MovieClip = MovieClip(new mcText());
			var tFormatTemp:TextFormat = mText["tText" + _font].defaultTextFormat;
			
			tFormat = new TextFormat(tFormatTemp.font, _size, _color, tFormatTemp.bold, tFormatTemp.italic);
			tFormat.align 				= _align;
			
			tFormat.leading 			= $vars.leading != undefined ? _nLeading : tFormatTemp.leading;
			tFormat.letterSpacing		= $vars.spacing != undefined ? _nLetterSpacing : tFormatTemp.letterSpacing;
			tf 							= new TextField();
			tf.width 					= _width;
			
			if (_height != -1) 
			{
				tf.height 				= _height;
				tf.multiline 			= true;
				tf.wordWrap 			= true;
			}
			else
			{
				if (_width != 0)
				{
					tf.autoSize 		= _align;
					tf.multiline 		= true;
					tf.wordWrap 		= true;
				}
				else
				{
					tf.autoSize 		= "left";
				}
			}
			tf.selectable 				= _selectable;
			tf.mouseWheelEnabled 		= false;
			
			//tf.border 				= true;
			//tf.borderColor 			= 0xFF0000;
			
			tf.embedFonts 				= true;
			tf.antiAliasType 			= mText["tText" + _font].antiAliasType;
			tf.defaultTextFormat 		= tFormat;
			tf.htmlText 				= sText;
			addChild(tf);
			
			var sOverColor:String		= _overcolor.toString(16)
			while (sOverColor.length < 6) 
			{
				sOverColor 				= "0" + sOverColor;
			}
			sOverColor					= "#" + sOverColor;
			
			var sLinkColor:String		= _linkcolor.toString(16)
			while (sLinkColor.length < 6) 
			{
				sLinkColor 				= "0" + sLinkColor;
			}
			sLinkColor					= "#" + sLinkColor;
				
			var over:Object = new Object();
			over.color = sOverColor;
			var link:Object = new Object();
			link.color = sLinkColor;
			
			var style:StyleSheet = new StyleSheet();
			style.setStyle("a:link", link);
			style.setStyle("a:hover", over);
			tf.styleSheet				= style;
			
			wi = tf.textWidth;
			he = tf.textHeight;
		}
		
		
		public function set leading(n:Number):void
		{
			tFormat.leading = n;
			tf.defaultTextFormat = tFormat;
			tf.text = tf.text;
		}
		
		public function set size(n:Number):void
		{
			_size 					= n;
			tFormat.size 			= n;
			tf.defaultTextFormat 	= tFormat;
			tf.text 				= tf.text;
			
			wi = tf.textWidth;
			he = tf.textHeight;
		}
		
		public function get size():Number
		{
			return _size;
		}
		
		public function set text(s:String)
		{
			tf.htmlText = s;
			wi = tf.textWidth;
			he = tf.textHeight;
		}
		
		public function set textNonHtml(s:String)
		{
			tf.text = s;
			wi = tf.textWidth;
			he = tf.textHeight;
		}
		
		public function get text():String
		{
			return tf.text;
		}
		
		public function set _wi(value:int)
		{
			tf.width = value;
			wi = tf.textWidth;
			he = tf.textHeight;
		}
		
		public function makeStatic():void
		{
			var bmd:BitmapData = new BitmapData(width, height+10, true, 0x00000000);
			bmd.draw(this, null, null, null, null, true);
			var bmp:Bitmap = new Bitmap(bmd, "auto", true);
			
			while (numChildren > 0) removeChildAt(0);
			
			addChild(bmp);
		}
		
		
	}
	
}