﻿package com.utkudemir.utils
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.utils.getDefinitionByName;

	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir || utku@csdlab.com
	$(CBI)*/
	public class SceneAddress
	{
		private static var _instance	:SceneAddress;
		
		public var currentScene			:String;
		public var menu					:*;
		
		private var aScenes				:Array;
		private var nCurrentScene		:int = -1;
		private var nWillBeScene		:int = -1;
		
		private var sLeft				:String;
		
		public function SceneAddress() 
		{
			aScenes 				= new Array();
		}
		
		public function addScene($obj:Scene, $name:String):void
		{
			$obj.onOpen 			= sceneOpened;
			$obj.onClose 			= sceneClosed;
			aScenes.push([$obj, $name]);
		}
		
		public function openAddress(sAddress:String):void
		{
			SWFAddress.setValue(sAddress);
		}
		
		private function openScene($name:String = null):void
		{
			if($name != null) currentScene			= $name;
			
			var _obj:Scene;
			
			if (nCurrentScene != -1)
			{
				nWillBeScene 		= find(aScenes, 1, $name);
				_obj 				= aScenes[nCurrentScene][0];
				_obj.close();
			}
			else
			{
				var _no:int;
				if ($name == null)
				{
					_no 			= nWillBeScene;
				}
				else
				{
					_no = find(aScenes, 1, $name);
				}
				nWillBeScene = -1;
				nCurrentScene = _no;
				_obj = aScenes[_no][0];
				_obj.open(sLeft);
			}
		}
		
		public function init():void
		{
			SWFAddress.addEventListener(SWFAddressEvent.CHANGE, addressChangedHandler);
		}
		
		private function addressChangedHandler(e:SWFAddressEvent):void 
		{
			var sValue:String			= SWFAddress.getValue().substr(1);
			var nSlashIndex:int			= sValue.indexOf("/");
			
			if (nSlashIndex == -1) 
			{
				nSlashIndex = sValue.length;
			}
			
			var sFirst:String			= sValue.substr(0, nSlashIndex);
			
			if (findScene(sFirst) == null)
			{
				sValue					= "main";
				sFirst					= "main";
			}
			
			if (menu != null)
			{
				menu.update(sValue);
			}
			
			if (sValue == "")
			{
				sValue					= "main";
			}
			
			sLeft						= sValue.substr(nSlashIndex + 1);
			openScene(sFirst);
			
		}
		
		public function findScene($name:String):Scene
		{
			try
			{
				return Scene(aScenes[find(aScenes, 1, $name)][0]);
			}
			catch (e:*)
			{
				
			}
			return null;
		}
		
		private function sceneOpened():void
		{
			if (nWillBeScene != -1) openScene();
		}
		
		private function sceneClosed():void
		{
			nCurrentScene = -1;
			if (nWillBeScene != -1) openScene();
		}
		
		static public function get instance():SceneAddress 
		{
			if (_instance == null) _instance = new SceneAddress();
			
			return _instance;
		}
		
		private function find($array:Array, $no:int, $find:String):int
		{
			var _no:int = -1;
			for (var i:int = 0; i < $array.length; i++) 
			{
				if ($array[i][$no] == $find) 
				{
					_no = i;
					break;
				}
			}
			
			return _no;
		}
	}
	
}