﻿package com.utkudemir.utils 
{
	import com.Properties;
	import com.ui.Header;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	
	/**
	$(CBI)* ...
	$(CBI)* @author Utku Demir || utku@csdlab.com
	$(CBI)*/
	public class SceneManager
	{
		private static var _instance	:SceneManager;
		
		public var currentScene			:String;
		
		private var aScenes				:Array;
		private var nCurrentScene		:int = -1;
		private var nWillBeScene		:int = -1;
		
		public function SceneManager() 
		{
			aScenes 				= new Array();
		}
		
		public function addScene($obj:Scene, $name:String):void
		{
			$obj.onOpen 			= sceneOpened;
			$obj.onClose 			= sceneClosed;
			aScenes.push([$obj, $name]);
		}
		
		public function openScene($name:String = null):void
		{
			Header.instance.deactivateLogo();
			if (Properties.CONTENTXML.@main == true)
			{
				Header.instance.deactivateLogo();
			}
			if($name != null) currentScene			= $name;
			
			var _obj:Scene;
			
			if (nCurrentScene != -1)
			{
				nWillBeScene 		= find(aScenes, 1, $name);
				_obj 				= aScenes[nCurrentScene][0];
				_obj.close();
			}
			else
			{
				var _no:int;
				if ($name == null)
				{
					_no 			= nWillBeScene;
				}
				else
				{
					_no = find(aScenes, 1, $name);
				}
				nWillBeScene = -1;
				nCurrentScene = _no;
				_obj = aScenes[_no][0];
				_obj.open();
			}
		}
		
		public function findScene($name:String):Scene
		{
			return Scene(aScenes[find(aScenes, 1, $name)][0]);
		}
		
		private function sceneOpened():void
		{
			if (nWillBeScene != -1) 
			{
				openScene();
			}
			else
			{
				if (Properties.bActivateLogo) 
				{
					Properties.bActivateLogo = false;
					Header.instance.activateLogo();
				}
			}
		}
		
		private function sceneClosed():void
		{
			nCurrentScene = -1;
			if (nWillBeScene != -1) openScene();
		}
		
		static public function get instance():SceneManager 
		{
			if (_instance == null) _instance = new SceneManager();
			
			return _instance;
		}
		
		private function find($array:Array, $no:int, $find:String):int
		{
			var _no:int = -1;
			for (var i:int = 0; i < $array.length; i++) 
			{
				if ($array[i][$no] == $find) 
				{
					_no = i;
					break;
				}
			}
			
			return _no;
		}
	}
	
}