<?php
/*
Plugin Name: Unique layout options
Plugin URI: http://wordpress.org
Description: Easy changing and configure: colors, types, backgrounds and promos
Author: Catalin Nita
Author URI: 
*/


add_action('admin_menu', 'unique_menu');

function unique_menu() {
  add_menu_page('Unique plugin', 'Unique plugin', 'administrator', 'UHE', 'Unique_help');
  add_submenu_page('UHE', 'Unique colors 1', 'UNIQUE colors 1', 'administrator', 'UA', 'Unique_color_config');
  add_submenu_page('UHE','Unique colors 2', 'UNIQUE colors 2', 'administrator', 'UE', 'Unique_color_elements_config');
  add_submenu_page('UHE','Unique settings', 'UNIQUE settings', 'administrator', 'USE', 'Unique_settings_config');
  add_submenu_page('UHE','Unique types', 'UNIQUE types', 'administrator', 'UT', 'Unique_type_config');
  // this features is disabled in this theme for the moment
  //add_submenu_page('UHE','Unique backgrounds', 'UNIQUE backgrounds', 'administrator', 'UB', 'Unique_background_config');
  add_submenu_page('UHE','Unique sections', 'UNIQUE sections', 'administrator', 'US', 'Unique_sections_config');
  add_submenu_page('UHE','Unique header', 'UNIQUE header', 'administrator', 'UH', 'Unique_header_config');
  add_submenu_page('UHE','Unique footer', 'UNIQUE footer', 'administrator', 'UF', 'Unique_footer_config');
  add_submenu_page('UHE','Unique menu', 'UNIQUE menu', 'administrator', 'UM', 'Unique_menu_config');
  add_submenu_page('UHE','Unique homepage', 'UNIQUE homepage', 'administrator', 'UHO', 'Unique_homepage_config');
  add_submenu_page('UHE','Unique pictures', 'UNIQUE pictures', 'administrator', 'UPI', 'Unique_pictures_config');
  add_submenu_page('UHE','Unique promos', 'UNIQUE promos', 'administrator', 'UP', 'Unique_promos_config');
}

function get_absolute_url($xml_url) {
	$axml_url = getcwd();
	
	$axml_url = explode('/wp-admin', $axml_url);
	$abs_xml_url = $axml_url[0];
	
	$pxml_url = explode('wp-content',$xml_url);
	$test_xml = explode(":\\", $axml_url[0]);
	if (count($test_xml) > 1) {
		
	$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	$abs_xml_url = str_replace('\wp-admin', '', $abs_xml_url);
	$abs_xml_url = $abs_xml_url.$p_xml_url;

	}
	else {
	$abs_xml_url = $abs_xml_url.'/wp-content'.$pxml_url[1];
	}
	
	return $abs_xml_url;

}

function update_color_xml($color1, $color2, $color3, $color4, $color5, $xml_url) {
	
	$oldvalues = array();
	$oldvalue = array();
	$colors = array();
	$vars = array();
	$abs_xml_url = get_absolute_url($xml_url);
	$handle = fopen($abs_xml_url, "r");
	$contents = '';
	
	while (!feof($handle)) {
	  $contents .= fread($handle, 8192);
	}
	fclose($handle);
		
	
	$colors = xml2array($abs_xml_url, 0, 'tag');		
	$colors = $colors['colors'];
	$new_contents = $contents;
	
	foreach($colors as $variable) {

			${'old_'.$variable['varname']} = "'".$variable['value']."'";
			$new_contents = str_replace(
			'<value id="'.$variable['varname'].'">'.$variable['value'].'</value>', 
			'<value id="'.$variable['varname'].'">'.${$variable['varname']}.'</value>',
			$new_contents);
			
	
	}	
	
	$handle = fopen($abs_xml_url, "w");
	fwrite($handle, $new_contents);
	fclose($handle);	
}

function jscolor() {
	?>
<script language="javascript">

/**
 * jscolor, JavaScript Color Picker
 *
 * @version 1.3.1
 * @license GNU Lesser General Public License, http://www.gnu.org/copyleft/lesser.html
 * @author  Jan Odvarko, http://odvarko.cz
 * @created 2008-06-15
 * @updated 2010-01-23
 * @link    http://jscolor.com
 */

var jscolor = {


	dir : '', // location of jscolor directory (leave empty to autodetect)
	bindClass : 'color', // class name
	binding : true, // automatic binding via <input class="...">
	preloading : true, // use image preloading?


	install : function() {
		jscolor.addEvent(window, 'load', jscolor.init);
	},


	init : function() {
		if(jscolor.binding) {
			jscolor.bind();
		}
		if(jscolor.preloading) {
			jscolor.preload();
		}
	},


	getDir : function() {
		if(!jscolor.dir) {
			var detected = jscolor.detectDir();
			jscolor.dir = detected!==false ? detected : '../wp-content/themes/unique/images/jscolor/';
		}
		return jscolor.dir;
	},


	detectDir : function() {
		var base = location.href;

		var e = document.getElementsByTagName('base');
		for(var i=0; i<e.length; i+=1) {
			if(e[i].href) { base = e[i].href; }
		}

		var e = document.getElementsByTagName('script');
		for(var i=0; i<e.length; i+=1) {
			if(e[i].src && /(^|\/)jscolor\.js([?#].*)?$/i.test(e[i].src)) {
				var src = new jscolor.URI(e[i].src);
				var srcAbs = src.toAbsolute(base);
				srcAbs.path = srcAbs.path.replace(/[^\/]+$/, ''); // remove filename
				srcAbs.query = null;
				srcAbs.fragment = null;
				return srcAbs.toString();
			}
		}
		return false;
	},


	bind : function() {
		var matchClass = new RegExp('(^|\\s)('+jscolor.bindClass+')\\s*(\\{[^}]*\\})?', 'i');
		var e = document.getElementsByTagName('input');
		for(var i=0; i<e.length; i+=1) {
			var m;
			if(!e[i].color && e[i].className && (m = e[i].className.match(matchClass))) {
				var prop = {};
				if(m[3]) {
					try {
						eval('prop='+m[3]);
					} catch(eInvalidProp) {}
				}
				e[i].color = new jscolor.color(e[i], prop);
			}
		}
	},


	preload : function() {
		for(var fn in jscolor.imgRequire) {
			if(jscolor.imgRequire.hasOwnProperty(fn)) {
				jscolor.loadImage(fn);
			}
		}
	},


	images : {
		pad : [ 181, 101 ],
		sld : [ 16, 101 ],
		cross : [ 15, 15 ],
		arrow : [ 7, 11 ]
	},


	imgRequire : {},
	imgLoaded : {},


	requireImage : function(filename) {
		jscolor.imgRequire[filename] = true;
	},


	loadImage : function(filename) {
		if(!jscolor.imgLoaded[filename]) {
			jscolor.imgLoaded[filename] = new Image();
			jscolor.imgLoaded[filename].src = jscolor.getDir()+filename;
		}
	},


	fetchElement : function(mixed) {
		return typeof mixed === 'string' ? document.getElementById(mixed) : mixed;
	},


	addEvent : function(el, evnt, func) {
		if(el.addEventListener) {
			el.addEventListener(evnt, func, false);
		} else if(el.attachEvent) {
			el.attachEvent('on'+evnt, func);
		}
	},


	fireEvent : function(el, evnt) {
		if(!el) {
			return;
		}
		if(document.createEventObject) {
			var ev = document.createEventObject();
			el.fireEvent('on'+evnt, ev);
		} else if(document.createEvent) {
			var ev = document.createEvent('HTMLEvents');
			ev.initEvent(evnt, true, true);
			el.dispatchEvent(ev);
		} else if(el['on'+evnt]) { // alternatively use the traditional event model (IE5)
			el['on'+evnt]();
		}
	},


	getElementPos : function(e) {
		var e1=e, e2=e;
		var x=0, y=0;
		if(e1.offsetParent) {
			do {
				x += e1.offsetLeft;
				y += e1.offsetTop;
			} while(e1 = e1.offsetParent);
		}
		while((e2 = e2.parentNode) && e2.nodeName.toUpperCase() !== 'BODY') {
			x -= e2.scrollLeft;
			y -= e2.scrollTop;
		}
		return [x, y];
	},


	getElementSize : function(e) {
		return [e.offsetWidth, e.offsetHeight];
	},


	getMousePos : function(e) {
		if(!e) { e = window.event; }
		if(typeof e.pageX === 'number') {
			return [e.pageX, e.pageY];
		} else if(typeof e.clientX === 'number') {
			return [
				e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft,
				e.clientY + document.body.scrollTop + document.documentElement.scrollTop
			];
		}
	},


	getViewPos : function() {
		if(typeof window.pageYOffset === 'number') {
			return [window.pageXOffset, window.pageYOffset];
		} else if(document.body && (document.body.scrollLeft || document.body.scrollTop)) {
			return [document.body.scrollLeft, document.body.scrollTop];
		} else if(document.documentElement && (document.documentElement.scrollLeft || document.documentElement.scrollTop)) {
			return [document.documentElement.scrollLeft, document.documentElement.scrollTop];
		} else {
			return [0, 0];
		}
	},


	getViewSize : function() {
		if(typeof window.innerWidth === 'number') {
			return [window.innerWidth, window.innerHeight];
		} else if(document.body && (document.body.clientWidth || document.body.clientHeight)) {
			return [document.body.clientWidth, document.body.clientHeight];
		} else if(document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight)) {
			return [document.documentElement.clientWidth, document.documentElement.clientHeight];
		} else {
			return [0, 0];
		}
	},


	URI : function(uri) { // See RFC3986

		this.scheme = null;
		this.authority = null;
		this.path = '';
		this.query = null;
		this.fragment = null;

		this.parse = function(uri) {
			var m = uri.match(/^(([A-Za-z][0-9A-Za-z+.-]*)(:))?((\/\/)([^\/?#]*))?([^?#]*)((\?)([^#]*))?((#)(.*))?/);
			this.scheme = m[3] ? m[2] : null;
			this.authority = m[5] ? m[6] : null;
			this.path = m[7];
			this.query = m[9] ? m[10] : null;
			this.fragment = m[12] ? m[13] : null;
			return this;
		};

		this.toString = function() {
			var result = '';
			if(this.scheme !== null) { result = result + this.scheme + ':'; }
			if(this.authority !== null) { result = result + '//' + this.authority; }
			if(this.path !== null) { result = result + this.path; }
			if(this.query !== null) { result = result + '?' + this.query; }
			if(this.fragment !== null) { result = result + '#' + this.fragment; }
			return result;
		};

		this.toAbsolute = function(base) {
			var base = new jscolor.URI(base);
			var r = this;
			var t = new jscolor.URI;

			if(base.scheme === null) { return false; }

			if(r.scheme !== null && r.scheme.toLowerCase() === base.scheme.toLowerCase()) {
				r.scheme = null;
			}

			if(r.scheme !== null) {
				t.scheme = r.scheme;
				t.authority = r.authority;
				t.path = removeDotSegments(r.path);
				t.query = r.query;
			} else {
				if(r.authority !== null) {
					t.authority = r.authority;
					t.path = removeDotSegments(r.path);
					t.query = r.query;
				} else {
					if(r.path === '') { // TODO: == or === ?
						t.path = base.path;
						if(r.query !== null) {
							t.query = r.query;
						} else {
							t.query = base.query;
						}
					} else {
						if(r.path.substr(0,1) === '/') {
							t.path = removeDotSegments(r.path);
						} else {
							if(base.authority !== null && base.path === '') { // TODO: == or === ?
								t.path = '/'+r.path;
							} else {
								t.path = base.path.replace(/[^\/]+$/,'')+r.path;
							}
							t.path = removeDotSegments(t.path);
						}
						t.query = r.query;
					}
					t.authority = base.authority;
				}
				t.scheme = base.scheme;
			}
			t.fragment = r.fragment;

			return t;
		};

		function removeDotSegments(path) {
			var out = '';
			while(path) {
				if(path.substr(0,3)==='../' || path.substr(0,2)==='./') {
					path = path.replace(/^\.+/,'').substr(1);
				} else if(path.substr(0,3)==='/./' || path==='/.') {
					path = '/'+path.substr(3);
				} else if(path.substr(0,4)==='/../' || path==='/..') {
					path = '/'+path.substr(4);
					out = out.replace(/\/?[^\/]*$/, '');
				} else if(path==='.' || path==='..') {
					path = '';
				} else {
					var rm = path.match(/^\/?[^\/]*/)[0];
					path = path.substr(rm.length);
					out = out + rm;
				}
			}
			return out;
		}

		if(uri) {
			this.parse(uri);
		}

	},


	/*
	 * Usage example:
	 * var myColor = new jscolor.color(myInputElement)
	 */

	color : function(target, prop) {


		this.required = true; // refuse empty values?
		this.adjust = true; // adjust value to uniform notation?
		this.hash = false; // prefix color with # symbol?
		this.caps = true; // uppercase?
		this.valueElement = target; // value holder
		this.styleElement = target; // where to reflect current color
		this.hsv = [0, 0, 1]; // read-only  0-6, 0-1, 0-1
		this.rgb = [1, 1, 1]; // read-only  0-1, 0-1, 0-1

		this.pickerOnfocus = true; // display picker on focus?
		this.pickerMode = 'HSV'; // HSV | HVS
		this.pickerPosition = 'bottom'; // left | right | top | bottom
		this.pickerFace = 10; // px
		this.pickerFaceColor = 'ThreeDFace'; // CSS color
		this.pickerBorder = 1; // px
		this.pickerBorderColor = 'ThreeDHighlight ThreeDShadow ThreeDShadow ThreeDHighlight'; // CSS color
		this.pickerInset = 1; // px
		this.pickerInsetColor = 'ThreeDShadow ThreeDHighlight ThreeDHighlight ThreeDShadow'; // CSS color
		this.pickerZIndex = 10000;


		for(var p in prop) {
			if(prop.hasOwnProperty(p)) {
				this[p] = prop[p];
			}
		}


		this.hidePicker = function() {
			if(isPickerOwner()) {
				removePicker();
			}
		};


		this.showPicker = function() {
			if(!isPickerOwner()) {
				var tp = jscolor.getElementPos(target); // target pos
				var ts = jscolor.getElementSize(target); // target size
				var vp = jscolor.getViewPos(); // view pos
				var vs = jscolor.getViewSize(); // view size
				var ps = [ // picker size
					2*this.pickerBorder + 4*this.pickerInset + 2*this.pickerFace + jscolor.images.pad[0] + 2*jscolor.images.arrow[0] + jscolor.images.sld[0],
					2*this.pickerBorder + 2*this.pickerInset + 2*this.pickerFace + jscolor.images.pad[1]
				];
				var a, b, c;
				switch(this.pickerPosition.toLowerCase()) {
					case 'left': a=1; b=0; c=-1; break;
					case 'right':a=1; b=0; c=1; break;
					case 'top':  a=0; b=1; c=-1; break;
					default:     a=0; b=1; c=1; break;
				}
				var l = (ts[b]+ps[b])/2;
				var pp = [ // picker pos
					-vp[a]+tp[a]+ps[a] > vs[a] ?
						(-vp[a]+tp[a]+ts[a]/2 > vs[a]/2 && tp[a]+ts[a]-ps[a] >= 0 ? tp[a]+ts[a]-ps[a] : tp[a]) :
						tp[a],
					-vp[b]+tp[b]+ts[b]+ps[b]-l+l*c > vs[b] ?
						(-vp[b]+tp[b]+ts[b]/2 > vs[b]/2 && tp[b]+ts[b]-l-l*c >= 0 ? tp[b]+ts[b]-l-l*c : tp[b]+ts[b]-l+l*c) :
						(tp[b]+ts[b]-l+l*c >= 0 ? tp[b]+ts[b]-l+l*c : tp[b]+ts[b]-l-l*c)
				];
				drawPicker(pp[a], pp[b]);
			}
		};


		this.importColor = function() {
			if(!valueElement) {
				this.exportColor();
			} else {
				if(!this.adjust) {
					if(!this.fromString(valueElement.value, leaveValue)) {
						styleElement.style.backgroundColor = styleElement.jscStyle.backgroundColor;
						styleElement.style.color = styleElement.jscStyle.color;
						this.exportColor(leaveValue | leaveStyle);
					}
				} else if(!this.required && /^\s*$/.test(valueElement.value)) {
					valueElement.value = '';
					styleElement.style.backgroundColor = styleElement.jscStyle.backgroundColor;
					styleElement.style.color = styleElement.jscStyle.color;
					this.exportColor(leaveValue | leaveStyle);

				} else if(this.fromString(valueElement.value)) {
					// OK
				} else {
					this.exportColor();
				}
			}
		};


		this.exportColor = function(flags) {
			if(!(flags & leaveValue) && valueElement) {
				var value = this.toString();
				if(this.caps) { value = value.toUpperCase(); }
				if(this.hash) { value = '#'+value; }
				valueElement.value = value;
			}
			if(!(flags & leaveStyle) && styleElement) {
				styleElement.style.backgroundColor =
					'#'+this.toString();
				styleElement.style.color =
					0.213 * this.rgb[0] +
					0.715 * this.rgb[1] +
					0.072 * this.rgb[2]
					< 0.5 ? '#FFF' : '#000';
			}
			if(!(flags & leavePad) && isPickerOwner()) {
				redrawPad();
			}
			if(!(flags & leaveSld) && isPickerOwner()) {
				redrawSld();
			}
		};


		this.fromHSV = function(h, s, v, flags) { // null = don't change
			h<0 && (h=0) || h>6 && (h=6);
			s<0 && (s=0) || s>1 && (s=1);
			v<0 && (v=0) || v>1 && (v=1);
			this.rgb = HSV_RGB(
				h===null ? this.hsv[0] : (this.hsv[0]=h),
				s===null ? this.hsv[1] : (this.hsv[1]=s),
				v===null ? this.hsv[2] : (this.hsv[2]=v)
			);
			this.exportColor(flags);
		};


		this.fromRGB = function(r, g, b, flags) { // null = don't change
			r<0 && (r=0) || r>1 && (r=1);
			g<0 && (g=0) || g>1 && (g=1);
			b<0 && (b=0) || b>1 && (b=1);
			var hsv = RGB_HSV(
				r===null ? this.rgb[0] : (this.rgb[0]=r),
				g===null ? this.rgb[1] : (this.rgb[1]=g),
				b===null ? this.rgb[2] : (this.rgb[2]=b)
			);
			if(hsv[0] !== null) {
				this.hsv[0] = hsv[0];
			}
			if(hsv[2] !== 0) {
				this.hsv[1] = hsv[1];
			}
			this.hsv[2] = hsv[2];
			this.exportColor(flags);
		};


		this.fromString = function(hex, flags) {
			var m = hex.match(/^\W*([0-9A-F]{3}([0-9A-F]{3})?)\W*$/i);
			if(!m) {
				return false;
			} else {
				if(m[1].length === 6) { // 6-char notation
					this.fromRGB(
						parseInt(m[1].substr(0,2),16) / 255,
						parseInt(m[1].substr(2,2),16) / 255,
						parseInt(m[1].substr(4,2),16) / 255,
						flags
					);
				} else { // 3-char notation
					this.fromRGB(
						parseInt(m[1].charAt(0)+m[1].charAt(0),16) / 255,
						parseInt(m[1].charAt(1)+m[1].charAt(1),16) / 255,
						parseInt(m[1].charAt(2)+m[1].charAt(2),16) / 255,
						flags
					);
				}
				return true;
			}
		};


		this.toString = function() {
			return (
				(0x100 | Math.round(255*this.rgb[0])).toString(16).substr(1) +
				(0x100 | Math.round(255*this.rgb[1])).toString(16).substr(1) +
				(0x100 | Math.round(255*this.rgb[2])).toString(16).substr(1)
			);
		};


		function RGB_HSV(r, g, b) {
			var n = Math.min(Math.min(r,g),b);
			var v = Math.max(Math.max(r,g),b);
			var m = v - n;
			if(m === 0) { return [ null, 0, v ]; }
			var h = r===n ? 3+(b-g)/m : (g===n ? 5+(r-b)/m : 1+(g-r)/m);
			return [ h===6?0:h, m/v, v ];
		}


		function HSV_RGB(h, s, v) {
			if(h === null) { return [ v, v, v ]; }
			var i = Math.floor(h);
			var f = i%2 ? h-i : 1-(h-i);
			var m = v * (1 - s);
			var n = v * (1 - s*f);
			switch(i) {
				case 6:
				case 0: return [v,n,m];
				case 1: return [n,v,m];
				case 2: return [m,v,n];
				case 3: return [m,n,v];
				case 4: return [n,m,v];
				case 5: return [v,m,n];
			}
		}


		function removePicker() {
			delete jscolor.picker.owner;
			document.getElementsByTagName('body')[0].removeChild(jscolor.picker.boxB);
		}


		function drawPicker(x, y) {
			if(!jscolor.picker) {
				jscolor.picker = {
					box : document.createElement('div'),
					boxB : document.createElement('div'),
					pad : document.createElement('div'),
					padB : document.createElement('div'),
					padM : document.createElement('div'),
					sld : document.createElement('div'),
					sldB : document.createElement('div'),
					sldM : document.createElement('div')
				};
				for(var i=0,segSize=4; i<jscolor.images.sld[1]; i+=segSize) {
					var seg = document.createElement('div');
					seg.style.height = segSize+'px';
					seg.style.fontSize = '1px';
					seg.style.lineHeight = '0';
					jscolor.picker.sld.appendChild(seg);
				}
				jscolor.picker.sldB.appendChild(jscolor.picker.sld);
				jscolor.picker.box.appendChild(jscolor.picker.sldB);
				jscolor.picker.box.appendChild(jscolor.picker.sldM);
				jscolor.picker.padB.appendChild(jscolor.picker.pad);
				jscolor.picker.box.appendChild(jscolor.picker.padB);
				jscolor.picker.box.appendChild(jscolor.picker.padM);
				jscolor.picker.boxB.appendChild(jscolor.picker.box);
			}

			var p = jscolor.picker;

			// recompute controls positions
			posPad = [
				x+THIS.pickerBorder+THIS.pickerFace+THIS.pickerInset,
				y+THIS.pickerBorder+THIS.pickerFace+THIS.pickerInset ];
			posSld = [
				null,
				y+THIS.pickerBorder+THIS.pickerFace+THIS.pickerInset ];

			// controls interaction
			p.box.onmouseup =
			p.box.onmouseout = function() { target.focus(); };
			p.box.onmousedown = function() { abortBlur=true; };
			p.box.onmousemove = function(e) { holdPad && setPad(e); holdSld && setSld(e); };
			p.padM.onmouseup =
			p.padM.onmouseout = function() { if(holdPad) { holdPad=false; jscolor.fireEvent(valueElement,'change'); } };
			p.padM.onmousedown = function(e) { holdPad=true; setPad(e); };
			p.sldM.onmouseup =
			p.sldM.onmouseout = function() { if(holdSld) { holdSld=false; jscolor.fireEvent(valueElement,'change'); } };
			p.sldM.onmousedown = function(e) { holdSld=true; setSld(e); };

			// picker
			p.box.style.width = 4*THIS.pickerInset + 2*THIS.pickerFace + jscolor.images.pad[0] + 2*jscolor.images.arrow[0] + jscolor.images.sld[0] + 'px';
			p.box.style.height = 2*THIS.pickerInset + 2*THIS.pickerFace + jscolor.images.pad[1] + 'px';

			// picker border
			p.boxB.style.position = 'absolute';
			p.boxB.style.clear = 'both';
			p.boxB.style.left = x+'px';
			p.boxB.style.top = y+'px';
			p.boxB.style.zIndex = THIS.pickerZIndex;
			p.boxB.style.border = THIS.pickerBorder+'px solid';
			p.boxB.style.borderColor = THIS.pickerBorderColor;
			p.boxB.style.background = THIS.pickerFaceColor;

			// pad image
			p.pad.style.width = jscolor.images.pad[0]+'px';
			p.pad.style.height = jscolor.images.pad[1]+'px';

			// pad border
			p.padB.style.position = 'absolute';
			p.padB.style.left = THIS.pickerFace+'px';
			p.padB.style.top = THIS.pickerFace+'px';
			p.padB.style.border = THIS.pickerInset+'px solid';
			p.padB.style.borderColor = THIS.pickerInsetColor;

			// pad mouse area
			p.padM.style.position = 'absolute';
			p.padM.style.left = '0';
			p.padM.style.top = '0';
			p.padM.style.width = THIS.pickerFace + 2*THIS.pickerInset + jscolor.images.pad[0] + jscolor.images.arrow[0] + 'px';
			p.padM.style.height = p.box.style.height;
			p.padM.style.cursor = 'crosshair';

			// slider image
			p.sld.style.overflow = 'hidden';
			p.sld.style.width = jscolor.images.sld[0]+'px';
			p.sld.style.height = jscolor.images.sld[1]+'px';

			// slider border
			p.sldB.style.position = 'absolute';
			p.sldB.style.right = THIS.pickerFace+'px';
			p.sldB.style.top = THIS.pickerFace+'px';
			p.sldB.style.border = THIS.pickerInset+'px solid';
			p.sldB.style.borderColor = THIS.pickerInsetColor;

			// slider mouse area
			p.sldM.style.position = 'absolute';
			p.sldM.style.right = '0';
			p.sldM.style.top = '0';
			p.sldM.style.width = jscolor.images.sld[0] + jscolor.images.arrow[0] + THIS.pickerFace + 2*THIS.pickerInset + 'px';
			p.sldM.style.height = p.box.style.height;
			try {
				p.sldM.style.cursor = 'pointer';
			} catch(eOldIE) {
				p.sldM.style.cursor = 'hand';
			}

			// load images in optimal order
			switch(modeID) {
				case 0: var padImg = 'hs.png'; break;
				case 1: var padImg = 'hv.png'; break;
			}
			p.padM.style.background = "url('"+jscolor.getDir()+"cross.gif') no-repeat";
			p.sldM.style.background = "url('"+jscolor.getDir()+"arrow.gif') no-repeat";
			p.pad.style.background = "url('"+jscolor.getDir()+padImg+"') 0 0 no-repeat";

			// place pointers
			redrawPad();
			redrawSld();

			jscolor.picker.owner = THIS;
			document.getElementsByTagName('body')[0].appendChild(p.boxB);
		}


		function redrawPad() {
			// redraw the pad pointer
			switch(modeID) {
				case 0: var yComponent = 1; break;
				case 1: var yComponent = 2; break;
			}
			var x = Math.round((THIS.hsv[0]/6) * (jscolor.images.pad[0]-1));
			var y = Math.round((1-THIS.hsv[yComponent]) * (jscolor.images.pad[1]-1));
			jscolor.picker.padM.style.backgroundPosition =
				(THIS.pickerFace+THIS.pickerInset+x - Math.floor(jscolor.images.cross[0]/2)) + 'px ' +
				(THIS.pickerFace+THIS.pickerInset+y - Math.floor(jscolor.images.cross[1]/2)) + 'px';

			// redraw the slider image
			var seg = jscolor.picker.sld.childNodes;

			switch(modeID) {
				case 0:
					var rgb = HSV_RGB(THIS.hsv[0], THIS.hsv[1], 1);
					for(var i=0; i<seg.length; i+=1) {
						seg[i].style.backgroundColor = 'rgb('+
							(rgb[0]*(1-i/seg.length)*100)+'%,'+
							(rgb[1]*(1-i/seg.length)*100)+'%,'+
							(rgb[2]*(1-i/seg.length)*100)+'%)';
					}
					break;
				case 1:
					var rgb, s, c = [ THIS.hsv[2], 0, 0 ];
					var i = Math.floor(THIS.hsv[0]);
					var f = i%2 ? THIS.hsv[0]-i : 1-(THIS.hsv[0]-i);
					switch(i) {
						case 6:
						case 0: rgb=[0,1,2]; break;
						case 1: rgb=[1,0,2]; break;
						case 2: rgb=[2,0,1]; break;
						case 3: rgb=[2,1,0]; break;
						case 4: rgb=[1,2,0]; break;
						case 5: rgb=[0,2,1]; break;
					}
					for(var i=0; i<seg.length; i+=1) {
						s = 1 - 1/(seg.length-1)*i;
						c[1] = c[0] * (1 - s*f);
						c[2] = c[0] * (1 - s);
						seg[i].style.backgroundColor = 'rgb('+
							(c[rgb[0]]*100)+'%,'+
							(c[rgb[1]]*100)+'%,'+
							(c[rgb[2]]*100)+'%)';
					}
					break;
			}
		}


		function redrawSld() {
			// redraw the slider pointer
			switch(modeID) {
				case 0: var yComponent = 2; break;
				case 1: var yComponent = 1; break;
			}
			var y = Math.round((1-THIS.hsv[yComponent]) * (jscolor.images.sld[1]-1));
			jscolor.picker.sldM.style.backgroundPosition =
				'0 ' + (THIS.pickerFace+THIS.pickerInset+y - Math.floor(jscolor.images.arrow[1]/2)) + 'px';
		}


		function isPickerOwner() {
			return jscolor.picker && jscolor.picker.owner === THIS;
		}


		function blurTarget() {
			if(valueElement === target) {
				THIS.importColor();
			}
			if(THIS.pickerOnfocus) {
				THIS.hidePicker();
			}
		}


		function blurValue() {
			if(valueElement !== target) {
				THIS.importColor();
			}
		}


		function setPad(e) {
			var posM = jscolor.getMousePos(e);
			var x = posM[0]-posPad[0];
			var y = posM[1]-posPad[1];
			switch(modeID) {
				case 0: THIS.fromHSV(x*(6/(jscolor.images.pad[0]-1)), 1 - y/(jscolor.images.pad[1]-1), null, leaveSld); break;
				case 1: THIS.fromHSV(x*(6/(jscolor.images.pad[0]-1)), null, 1 - y/(jscolor.images.pad[1]-1), leaveSld); break;
			}
		}


		function setSld(e) {
			var posM = jscolor.getMousePos(e);
			var y = posM[1]-posPad[1];
			switch(modeID) {
				case 0: THIS.fromHSV(null, null, 1 - y/(jscolor.images.sld[1]-1), leavePad); break;
				case 1: THIS.fromHSV(null, 1 - y/(jscolor.images.sld[1]-1), null, leavePad); break;
			}
		}


		var THIS = this;
		var modeID = this.pickerMode.toLowerCase()==='hvs' ? 1 : 0;
		var abortBlur = false;
		var
			valueElement = jscolor.fetchElement(this.valueElement),
			styleElement = jscolor.fetchElement(this.styleElement);
		var
			holdPad = false,
			holdSld = false;
		var
			posPad,
			posSld;
		var
			leaveValue = 1<<0,
			leaveStyle = 1<<1,
			leavePad = 1<<2,
			leaveSld = 1<<3;

		// target
		jscolor.addEvent(target, 'focus', function() {
			if(THIS.pickerOnfocus) { THIS.showPicker(); }
		});
		jscolor.addEvent(target, 'blur', function() {
			if(!abortBlur) {
				window.setTimeout(function(){ abortBlur || blurTarget(); abortBlur=false; }, 0);
			} else {
				abortBlur = false;
			}
		});

		// valueElement
		if(valueElement) {
			var updateField = function() {
				THIS.fromString(valueElement.value, leaveValue);
			};
			jscolor.addEvent(valueElement, 'keyup', updateField);
			jscolor.addEvent(valueElement, 'input', updateField);
			jscolor.addEvent(valueElement, 'blur', blurValue);
			valueElement.setAttribute('autocomplete', 'off');
		}

		// styleElement
		if(styleElement) {
			styleElement.jscStyle = {
				backgroundColor : styleElement.style.backgroundColor,
				color : styleElement.style.color
			};
		}

		// require images
		switch(modeID) {
			case 0: jscolor.requireImage('hs.png'); break;
			case 1: jscolor.requireImage('hv.png'); break;
		}
		jscolor.requireImage('cross.gif');
		jscolor.requireImage('arrow.gif');

		this.importColor();
	}

};


jscolor.install();

</script>
<?php
}

function Unique_color_config() {

	$xml_url = get_bloginfo('stylesheet_directory').'/styles/xml/colors.xml';
	
	if ($_POST['tc1']) {
		update_color_xml($_POST['tc1'], $_POST['tc2'], $_POST['tc3'], $_POST['tc4'], $_POST['tc5'], $xml_url);
	}
	else {
		if ($_POST['color1']) {
			update_color_xml($_POST['color1'], $_POST['color2'], $_POST['color3'], $_POST['color4'], $_POST['color5'], $xml_url);
		}
	}
	
	jscolor();

	$abs_xml_url = get_absolute_url($xml_url);

	$colors = array();
	$colors = xml2array($abs_xml_url, 0, 'tag');		
	$content = '<br/><br/><div style="padding: 15px 10px; float: right; width: 300px; ">
	<b>How to use UNIQUE COLOR 1 tool</b><br/><br/>
	<div style="font-size: 11px;">
	This is the main feature of Unique theme. Using this tool you can change the color theme of your website without writing any line of code.<br/><br/>
	Using the color picker you can create a 5 colors theme, or if you want to choose the easiest way, you can choose one theme already created.<br/><br/>
	A very important note is that <font style="background: yellow;"><b>the intesity of each color must be kept when you will change the colors</b></font>, otherwise some dark text will apear on a dark background, or a light one on a light background, creating problems in reading information.<br/><br/>
	<b>Loading a theme</b><br/>
	You can easily load an existing theme by clicking on the LOAD button. After the theme is loaded, you can see the new look on the live website. If you consider that one ore more colors must be a little different, then you must read the next chapter.<br/><br/>
	<b>Changing a theme</b><br/>
	For changing a color you cand click on the field where the hexazecimal code apears. A color picker will apear and you can play with it as long as you want till you will find the perfect color for your website.<br/>
	When all color are exactly how you want click the APPLY COLOR THEME button and the colors are appyed to your website.<br/><br/>
	<b>Changing color for one element</b><br/>
	If you want to change the color for just one element, for example H1 heading. Then you must go to UNIQUE colors 2 tool, where you will find the exact indication of using it.
	</div>
	</div>';
	$content .= '<div style="padding: 10px;">';
	$content .= '<form name=colors method=POST action="admin.php?page=UA">';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';
	$content .= '<td style="padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;" colspan=5>Actual color theme</td>';
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td height=5></td>';
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td style="padding: 3px; border: 1px solid #CCCCCC;">';			
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';			
	$content .= '<td style="background:#'.$colors['colors']['color1']['value'].';" height=100 width=100></td>';
	$content .= '<td style="background:#'.$colors['colors']['color2']['value'].';" height=100 width=100></td>';
	$content .= '<td style="background:#'.$colors['colors']['color3']['value'].';" height=100 width=100></td>';
	$content .= '<td style="background:#'.$colors['colors']['color4']['value'].';" height=100 width=100></td>';
	$content .= '<td style="background:#'.$colors['colors']['color5']['value'].';" height=100 width=100></td>';
	$content .= '</tr>';		
	$content .= '<tr>';
	$content .= '<td align=center>'.$colors['colors']['color1']['varname'].'</td>';
	$content .= '<td align=center>'.$colors['colors']['color2']['varname'].'</td>';
	$content .= '<td align=center>'.$colors['colors']['color3']['varname'].'</td>';
	$content .= '<td align=center>'.$colors['colors']['color4']['varname'].'</td>';
	$content .= '<td align=center>'.$colors['colors']['color5']['varname'].'</td>';
	$content .= '</tr>';
	
	$content .= '<tr>';
	$content .= '<td><input style="text-align:center;" class=color type=text name='.$colors['colors']['color1']['varname'].' value='.$colors['colors']['color1']['value'].'></td>';
	$content .= '<td><input style="text-align:center;" class=color type=text name='.$colors['colors']['color2']['varname'].' value='.$colors['colors']['color2']['value'].'></td>';
	$content .= '<td><input style="text-align:center;" class=color type=text name='.$colors['colors']['color3']['varname'].' value='.$colors['colors']['color3']['value'].'></td>';
	$content .= '<td><input style="text-align:center;" class=color type=text name='.$colors['colors']['color4']['varname'].' value='.$colors['colors']['color4']['value'].'></td>';
	$content .= '<td><input style="text-align:center;" class=color type=text name='.$colors['colors']['color5']['varname'].' value='.$colors['colors']['color5']['value'].'></td>';
	$content .= '</tr>';
	

	
	$content .= '<tr>';
	$content .= '<td style="font-size: 11px; padding: 5px;" align=center>'.$colors['colors']['color1']['name'].'</td>';
	$content .= '<td style="font-size: 11px; padding: 5px;" align=center>'.$colors['colors']['color2']['name'].'</td>';
	$content .= '<td style="font-size: 11px; padding: 5px;" align=center>'.$colors['colors']['color3']['name'].'</td>';
	$content .= '<td style="font-size: 11px; padding: 5px;" align=center>'.$colors['colors']['color4']['name'].'</td>';
	$content .= '<td style="font-size: 11px; padding: 5px;" align=center>'.$colors['colors']['color5']['name'].'</td>';
	$content .= '</tr>';
	
	$content .= '<tr>';
	$content .= '<td valign=top style="padding: 5px; font-size: 10px;">'.$colors['colors']['color1']['description'].'</td>';
	$content .= '<td valign=top style="padding: 5px; font-size: 10px; text-align:justify;">'.$colors['colors']['color2']['description'].'</td>';
	$content .= '<td valign=top style="padding: 5px; font-size: 10px; text-align:justify;">'.$colors['colors']['color3']['description'].'</td>';
	$content .= '<td valign=top style="padding: 5px; font-size: 10px; text-align:justify;">'.$colors['colors']['color4']['description'].'</td>';
	$content .= '<td valign=top style="padding: 5px; font-size: 10px; text-align:justify;">'.$colors['colors']['color5']['description'].'</td>';
	$content .= '</tr>';	
	$content .= '</table>';	
	$content .= '</td>';	
	$content .= '</tr>';
	
	$content .= '<tr>';
	$content .= '<td height=5></td>';
	$content .= '</tr>';
	$content .= '</table>';	
	$content .= '<input type=submit value="apply color theme">';	
	$content .= '';	
	$content .= '</div>';	
	
	echo $content;
	
	$xml_url = get_bloginfo('stylesheet_directory').'/styles/xml/colors_library.xml';

	$themes = array();
	$theme = array();
	$themecolors = array();
	
	$abs_xml_url = get_absolute_url($xml_url);
	$themes = xml2array($abs_xml_url, 0, 'tag');	
	
	$theme = $themes['colors']['theme'];
	

	$content = '<div style="padding: 10px;">';
	$content .= '';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<input type=hidden name="tc1" value="">';
	$content .= '<input type=hidden name="tc2" value="">';
	$content .= '<input type=hidden name="tc3" value="">';
	$content .= '<input type=hidden name="tc4" value="">';
	$content .= '<input type=hidden name="tc5" value="">';			

	$content .= '<tr>';
	$content .= '<td style="padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;" colspan=4>Saved color themes</td>';	
	$content .= '</tr>';	
	$content .= '<tr>';
	$content .= '<td height=5></td>';
	$content .= '</tr>';	
	
	//print_r($theme);
	
	foreach($theme as $colors) {
		
	

	$content .= '<tr>';
	$content .= '<td style="font-size: 11px; padding: 5px;">'.$colors['name'].'</td>';	
	$content .= '<td style="padding: 3px; border: 1px solid #CCCCCC;">';			
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';		
	$content .= '<td height=27 style="background:#'.$colors['color1'].';">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>';
	$content .= '<td style="background:#'.$colors['color2'].';">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>';
	$content .= '<td style="background:#'.$colors['color3'].';">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>';
	$content .= '<td style="background:#'.$colors['color4'].';">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>';
	$content .= '<td style="background:#'.$colors['color5'].';">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>';
	$content .= '</tr>';		
	$content .= '</table>';		
	$content .= '</td>';		
	$content .= '<td style="padding: 5px;"><input style="font-size: 10px;" onclick="
	document.colors.tc1.value=\''.$colors['color1'].'\';
	document.colors.tc2.value=\''.$colors['color2'].'\';
	document.colors.tc3.value=\''.$colors['color3'].'\';
	document.colors.tc4.value=\''.$colors['color4'].'\';
	document.colors.tc5.value=\''.$colors['color5'].'\';
	" type=submit value="load"></td>';
	$content .= '<td style="font-size: 10px; padding: 5px;">'.$colors['description'].'</td>';
	$content .= '</tr>';	
	
	}
	
	$content .= '</table>';	
	$content .= '</form>';	
	$content .= '</div>';	
	
	echo $content;	
		
	

	
 
}

function get_types_options($value) {
	$types_options = array('Museo', 'Junction', 'Myndraine', 'Jura', 'Nevis', 'Diavlo', 'Calluna', 'Perspective sans', 'Arial', 'Times', 'Georgia', 'Verdana', 'Tahoma');
	
	foreach($types_options as $type) {
	
	if ($type == $value) {
		$content .= '<option selected="selected">'.$type.'</option>';
	}
	else {
		$content .= '<option>'.$type.'</option>';		
	}
	
	}
	return $content;
}

function update_types_xml($xml_url){
	$abs_xml_url = get_absolute_url($xml_url);
	$oldvalues = array();
	$oldvalue = array();
	$types = array();
	$categories = array();
	$vars = array();
	
	$handle = fopen($abs_xml_url, "r");
	$contents = '';
	
	while (!feof($handle)) {
	  $contents .= fread($handle, 8192);
	}
	fclose($handle);
		
	
	$types = xml2array($abs_xml_url, 0, 'tag');		
	$categories = array_keys($types['types']);
	$new_contents = $contents;
	
	foreach($categories as $category) {
		$vars = ($types['types'][$category]);
		foreach ($vars as $variable) {
			${'old_'.$variable['varname']} = "'".$variable['value']."'";
			$new_contents = str_replace(
			'<value id="'.$variable['varname'].'">'.$variable['value'].'</value>', 
			'<value id="'.$variable['varname'].'">'.$_POST[$variable['varname']].'</value>',
			$new_contents);
			
		}
	}	
	
	//echo $new_contents;
		
	
	$axml_url = getcwd();
	$axml_url = explode('/wp-admin', $axml_url);
	$abs_xml_url = $axml_url[0];
	
	$pxml_url = explode('wp-content',$xml_url);
	//$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	
	
	$test_xml = explode(":\\", $axml_url[0]);
	if (count($test_xml) > 1) {
		
	$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	$abs_xml_url = str_replace('\wp-admin', '', $abs_xml_url);
	$abs_xml_url = $abs_xml_url.$p_xml_url;
	//chmod($xml_url, 777); 
	}
	else {
	$abs_xml_url = $abs_xml_url.'/wp-content'.$pxml_url[1];
	}
	
	
	//chmod($xml_url, 777); 
	$handle = fopen($abs_xml_url, "w");
	fwrite($handle, $new_contents);
	fclose($handle);		
	
}

function Unique_type_config() {

	$xml_url = get_bloginfo('stylesheet_directory').'/styles/xml/types.xml';
	$abs_xml_url = get_absolute_url($xml_url);
	
//	if ($_POST['color1']) {
//		update_color_xml($_POST['color1'], $_POST['color2'], $_POST['color3'], $_POST['color4'], $_POST['color5'], $xml_url);
//	}

	if ($_POST['MainMenuSections']) {
		update_types_xml($xml_url);		
	}

	$categories = array();
	$vars = array();
	$types = array();
	
	$types = xml2array($abs_xml_url, 0, 'tag');		
		
	$categories = array_keys($types['types']);
	
	$content = '
	<style>
		@import url('.get_bloginfo('stylesheet_directory').'/styles/fonts.php);
	</style>
	
	';
	
	$content .= '<br/><br/><div style="padding: 15px 10px; float: right; width: 300px; ">
	<b>How to use UNIQUE types tool</b><br/><br/>
	<div style="font-size: 11px;">
  This tool helps you to change the type of any text element from your theme, even the ones from widgets boxes. You can modify heading, main text, promo text or buttons text.<br/><br/>
  The color of each element can be changed from UNIQUE COLOR 2 section, and by now you can cange just the type using the most common system fonts. But in the future this feature will include another types and the size of each element.<br/><br/>
  The type is important because can apply a modern or clasic impresion to the whole theme.
	</div>
	</div>';
	$content .= '<div style="padding: 10px;">';
	$content .= '<form name=colors method=POST action="admin.php?page=UT">';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	
	foreach($categories as $category) {
		$vars = ($types['types'][$category]);
		
		
		$content .= '<tr>';
		$content .= '<td style="padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;" colspan=4><input type=submit value="apply all changes" style="float: right; font-size: 10px;"><b>'.$category.'</b></td>';
		$content .= '</tr>';		
		$content .= '<tr><td height=3></td></tr>';					
		foreach ($vars as $variable) {
			${$variable['varname']} = "'".$variable['value']."'";
		
			$content .= '<tr>';
			$content .= '<td style="padding: 5px; font-size: 11px;">'.$variable['name'].'</td>';
			$content .= '<td style="padding: 3px;">';
			$content .= '<select id="sel'.$variable['varname'].'" name='.$variable['varname'].' 
			onChange="document.getElementById(\'id'.$variable['varname'].'\').style.fontFamily=this.value">';
			$content .= get_types_options($variable['value']);
			$content .= '</select>';
			$content .= '</td>';
			$content .= '<td style="padding: 3px; border: 1px solid #CCCCCC;">';			
			$content .= '<table border=0 cellspacing=0 cellpadding=0>';
			$content .= '<tr>';			
			$content .= '<td style="padding: 5px;">';
			$content .= '<span id="id'.$variable['varname'].'" style="font-family:\''.$variable['value'].'\'; font-size: 18px;" >This is the type for '.$variable['name'].'</font>';
			$content .= '</td>';
			$content .= '</tr>';
			$content .= '</table>';
			$content .= '</td>';
			$content .= '<td style="padding: 5px; font-size: 11px;">'.$variable['description'].'</td>';
			$content .= '</tr>';					
			$content .= '<tr><td height=3></td></tr>';					
		
		}
	}	
	$content .= '</table>';	
	$content .= '<input type=submit value="apply all changes">';	
	$content .= '</form>';	
	$content .= '</div>';		
	echo $content;
}

function update_backgrounds_xml($xml_url) {

	$oldvalues = array();
	$oldvalue = array();
	$background = array();
	$categories = array();
	$vars = array();
	$abs_xml_url = get_absolute_url($xml_url);
	$handle = fopen($abs_xml_url, "r");
	$contents = '';
	
	while (!feof($handle)) {
	  $contents .= fread($handle, 8192);
	}
	fclose($handle);
	
	$backgrounds = xml2array($abs_xml_url, 0, 'tag');		
	$background = $backgrounds['background'];
	
	$new_contents = str_replace($background['value'], $_POST['backgroundvalue'], $contents);

	//echo $new_contents;
	
	
	$axml_url = getcwd();
	$axml_url = explode('\wp-admin', $axml_url);
	$abs_xml_url = $axml_url[0];
	
	$pxml_url = explode('wp-content',$xml_url);
	$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	
	$test_xml = explode(":\\", $axml_url[0]);
	if (count($test_xml) > 1) {
		
	$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	$abs_xml_url = str_replace('\wp-admin', '', $abs_xml_url);
	$abs_xml_url = $abs_xml_url.$p_xml_url;
	//chmod($xml_url, 777); 
	}
	else {
	$abs_xml_url = $abs_xml_url.'/wp-content'.$pxml_url[1];
	}
	
	
	//chmod($xml_url, 777); 
	$handle = fopen($abs_xml_url, "w");
	fwrite($handle, $new_contents);
	fclose($handle);		
	
}

function Unique_background_config() {

	$xml_url = get_bloginfo('stylesheet_directory').'/styles/xml/backgrounds.xml';
	
//	if ($_POST['color1']) {
//		update_color_xml($_POST['color1'], $_POST['color2'], $_POST['color3'], $_POST['color4'], $_POST['color5'], $xml_url);
//	}

	if ($_POST['backgroundvalue']) {
		update_backgrounds_xml($xml_url);		
	}
	
	$vars = array();
	$variable = array();
	$backgrounds = array();
	$abs_xml_url = get_absolute_url($xml_url);
	$vars = xml2array($abs_xml_url, 0, 'tag');
	$backgrounds = $vars['background'];

	$content = '<br/><br/><div style="padding: 15px 10px; float: right; width: 300px; ">
	<b>How to use UNIQUE backgrounds tool</b><br/><br/>
	<div style="font-size: 11px;">
	For the moment this tool can be used to choose one background from the list below. Some backgrounds are white with a 80 to 20 percent transparency. So theese ones will keep the base color of your background. But some are already colored with or without transparency and can be applyed to any color theme depending of your colors taste.<br/><br/>
	<font style="background-color: yellow;"><b>This tool is important because cand change the all image of your website, and is recommended to choose a background depending of you domain activity, and the information that you want to post.</b></font><br/><br/>
	Just click the load button and your website will look different.
	</div>
	</div>';
		
	$content .= '<div style="padding: 10px;">';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';

	$content .= '<tr>';
	$content .= '<td style="padding: 5px; border: 1px solid #CCCCCC; background-color: #FFFFFF;"><div style="padding-bottom: 5px;"><b>Actual background - '.$backgrounds['name'].'</b></div><div style="background-color: #000; overflow: hidden; height: 100px;"><img src="'.get_bloginfo('stylesheet_directory').'/images/backgrounds/'.$backgrounds['value'].'" width=680>
	</div>
	<div style="font-size: 10px; padding: 5px;">'.$backgrounds['description'].'</div>
	</td>';

	$content .= '</tr>';					

	$content .= '</table>';	
	$content .= '</div>';		
	echo $content;
	
// generate backgrounds library list

	$xml_url = get_bloginfo('stylesheet_directory').'/styles/xml/backgrounds_library.xml';

	$vars = xml2array($abs_xml_url, 0, 'tag');		
		
	$backgrounds = $vars['backgrounds']['background'];

	

	$content = '<div style="padding: 10px;">';
	$content .= '<form name=backgroundsconfig method=POST action="admin.php?page=UB">';
	$content .= '<input type=hidden name="backgroundvalue" value="">';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	
	foreach($backgrounds as $variable) {
		
			$content .= '<tr>';
			$content .= '<td style="padding: 5px; border: 1px solid #CCCCCC; background-color: #FFFFFF;"><div style="padding-bottom: 5px;"><b>'.$variable['name'].'</b></div><div style="background-color: #000; overflow: hidden; height: 100px;"><img src="'.get_bloginfo('stylesheet_directory').'/images/backgrounds/'.$variable['value'].'" width=680></div>
			<div style="font-size: 10px; padding: 5px;">'.$variable['description'].'</div></td>';
			$content .= '<td style="padding: 5px;"><input onclick="document.backgroundsconfig.backgroundvalue.value=\''.$variable['value'].'\';" type=submit value="load"></td>';
			$content .= '</tr>';					
			$content .= '<tr>';	
			$content .= '<td height=3></td>';	
			$content .= '</tr>';	
			

	}	
	$content .= '</table>';	
	$content .= '</form>';	
	$content .= '</div>';		
	
	echo $content;


	
}
$sections = array();
$new_sections = array();

function get_all_sections($parent) {
	global $sections;
	
	//echo $parent.'<br/>';
	$nsections = get_pages('hierarchical=0&parent='.$parent);
  
  $i=0;
  foreach ($nsections as $section) {	
  	$sections[$parent][$i] = 'a'.$section->ID;
  	get_all_sections($section->ID);
  $i++;
  }
  
  $ncategories = get_categories('parent='.$parent);
  foreach ($ncategories as $section) {	
  	$sections[$parent][$i] = 'c'.$section->term_id;
  	get_all_sections($section->term_id);
  $i++;
  }  
  
  $nposts = get_posts('numberposts=-1');
  foreach ($nposts as $section) {	
  	$cat = get_the_category($section->ID);
  	if ($cat[0]->term_id == $parent) {
		//echo '$sections['.$parent.']['.$i.'] = p'.$section->ID.'<br/>';
  	$sections[$parent][$i] = 'p'.$section->ID;
  	}
  	//get_all_sections($section->ID);
  $i++;
  }    
  
  //return $sections;

}
//$depth = 0;
function show_all_sections($parent, $depth) {
	global $new_sections;
	//global $depth;
	
	
	//print_r($new_sections);
	$or = 1;
	if (count($new_sections[$parent]) > 0) {
	ksort($new_sections[$parent]);
	foreach($new_sections[$parent] as $key=>$section) {
		$section_type = substr($section, 0, 1);
		$section_id = substr($section, 1);
		
		if ($section_type == 'a') {
			$infos = get_page($section_id);
			$info_id = $infos->ID;
			$info_name = $infos->post_title;
			$info_type = 'page';
			$color = 'red';
			$mykey_values = get_post_custom_values('article_type', $info_id);
			$homepage = get_post_custom_values('homepage', $info_id);
		}
		if ($section_type == 'c') {
			$infos = get_category($section_id);
			$info_id = $infos->cat_ID;
			$info_name = $infos->cat_name;
			$info_type = 'category';
			$color = 'blue';
			$mykey_values = '';
			$homepage = '';
		}
		if ($section_type == 'p') {
			$infos = get_post($section_id);
			$info_id = $infos->ID;
			$info_name = $infos->post_title;
			$info_type = 'post';
			$color = 'green';
			
 	    $mykey_values = get_post_custom_values('article_type', $info_id);
 	    $homepage = get_post_custom_values('homepage', $info_id);
			
		}		


		echo '<tr>
						';
		
		
		$fontsize = 13;
		$fontsize = $fontsize-$depth;
		$colspan = 5;
		$colspan = $colspan-$depth;
		for ($i = 0 ; $i < $depth ; $i++) {
			echo '<td width=36 align=center valign=top>&nbsp;</td>';
		}
		echo '<td colspan='.$colspan.' style="padding: 3px; background-color: #FFFFFF;';
		if ($depth == 0) {
			echo 'font-weight: bold; ';
		}
		echo ' border-width: 1px 0px 2px 1px; border-style: solid; border-color: #CCCCCC; font-size: '.$fontsize.'px;">';
		

		echo '<input name="'.$section.'-'.$parent.'" type="text" size=1 value="'.$key.'" style="text-align: center; font-size:10px;">&nbsp;'.$info_name.$info_c.'</td>
					<td style="font-size: 9px; padding: 5px; background-color: #FFFFFF; text-align: center; border-width: 1px 0px 2px 0px; border-style: solid; border-color: #CCCCCC; color: '.$color.';">['.$info_type.']</td>';
		if ($section_type == 'p') {					
		echo '<td style="background-color: #FFFFFF; text-align: center; border-width: 1px 0px 2px 0px; border-style: solid; border-color: #CCCCCC;"><input type=button value="edit" style="font-size: 10px;" onclick="window.location=\'post.php?action=edit&post='.$info_id.'\';"></td>';
		}
		if ($section_type == 'c') {					
		echo '<td style="background-color: #FFFFFF; text-align: center; border-width: 1px 0px 2px 0px; border-style: solid; border-color: #CCCCCC;"><input type=button value="edit" style="font-size: 10px;" onclick="window.location=\'categories.php?action=edit&cat_ID='.$info_id.'\';"></td>';
		}		
		if ($section_type == 'a') {					
		echo '<td style="background-color: #FFFFFF; text-align: center; border-width: 1px 0px 2px 0px; border-style: solid; border-color: #CCCCCC;"><input type=button value="edit" style="font-size: 10px;" onclick="window.location=\'page.php?action=edit&post='.$info_id.'\';"></td>';
		}

		if ($depth == 0) {
		echo '<td style="font-size: 9px; padding: 5px; background-color: #FFFFFF; text-align: center; border-width: 1px 2px 2px 0px; border-style: solid; border-color: #CCCCCC;">';
		}
		else {
		echo '<td style="font-size: 9px; padding: 5px; background-color: #FFFFFF; text-align: center; border-width: 1px 0px 2px 0px; border-style: solid; border-color: #CCCCCC;">';			
		}
		echo '&nbsp;';
		$is_excluded = 0;
		if (count($mykey_values) > 0 && $mykey_values != '') {
		foreach($mykey_values as $customfield) {
			echo '['.$customfield.']';
			if ($customfield == 'footerlinks' || $customfield == 'footertext') {
				$is_excluded = 1;
			}
			
		}
		
		}
		if ($homepage[0] == 'yes') {
			echo '[homepage]';
		}
		
		echo '</td>';
		for ($i = 0 ; $i < $depth ; $i++) {
			if ($i == $depth-1) {
			echo '<td style="background-color: #FFFFFF; text-align: center; border-width: 1px 2px 2px 0px; border-style: solid; border-color: #CCCCCC;" width=36 align=center valign=top>&nbsp;</td>';
			}
			else {
			echo '<td style="background-color: #FFFFFF; text-align: center; border-width: 1px 0px 2px 0px; border-style: solid; border-color: #CCCCCC;" width=36 align=center valign=top>&nbsp;</td>';	
			}


		}		

			if ($is_excluded == 1) {
				echo '<td colspan=5 style="width: 200px; font-size: 9px; color: #999999; padding: 0px 0px 0px 5px;">this page apears just in the website footer (is not visible in sections areas)</td>';
			}		
			else {
				for ($i = 0 ; $i < 5-$depth ; $i++) {
					echo '<td>&nbsp;</td>';
				}
			}
		echo '</tr>
					<tr>
						<td height=3></td>
					</tr>';
		if ($section_type != 'p') {
			show_all_sections($section_id, $depth+1);
		}
		
	$or++;
	
	}

	}
	
}

function find_next_pos($parent, $pos) {
	global $new_sections;
	 //print_r($new_sections[$parent]);
	 $max_value = 0;
	 foreach($new_sections[$parent] as $key=>$section) {
		 	if ($key > $max_value) {
		 		$max_value = $key;
		 	}
	}
	
	$max_value = $max_value+1;
	return $max_value;	
}
	
function reorder_section($ordered_sections, $parent) {
	global $sections, $new_sections;

	if ($sections[$parent]) {
	foreach($sections[$parent] as $key=>$value) {
		$section_type = substr($value, 0, 1);
		$section_id = substr($value, 1);
		
		$pos = intval($ordered_sections[$value]);
		
		if(!$pos) {
			if (!$new_sections[$parent]) {
				$pos = 888;
			}
			else {
			$pos = find_next_pos($parent, 888);

		}
		}
		$new_sections[$parent][$pos] = $value;
		//echo $section_id.'-----$new_sections['.$parent.']['.$pos.'] = '.$value.'<br/>';
		
		if ($section_type != 'p') {
			reorder_section($ordered_sections, $section_id);
		}
		//$pos = 0;
		
	}
	}
}	
	
function reorder_all_sections() {
	global $sections;
	
	get_all_sections(0);
	
	$xml_url = get_bloginfo('stylesheet_directory').'/sections.xml';
	$abs_xml_url = get_absolute_url($xml_url);
	$vars = xml2array($abs_xml_url, 0, 'tag');		
	
	$ordered_sections = $vars['sections'];
	
	//print_r($ordered_sections);
	//print_r($sections);
	
	reorder_section($ordered_sections, 0);
	
}	
	
function update_sections_order() {
	global $sections, $new_sections;
	$temp_sections = array();
	$temp_sections = $_POST;	
	
	$xml_url = get_bloginfo('stylesheet_directory').'/sections.xml';
	
	$content = '<?xml version="1.0" encoding="ISO-8859-1"?>
';
	$content .= '<sections>
';


	asort($temp_sections);
	//print_r($_POST);
	
	foreach($temp_sections as $key=>$var) {
		if ($key != 'neworder') {
	$key = explode("-", $key);
	
	$value = $key[0];
	$parent = $key[1];
	
	$pos = $var;
	
	while ($new_sections[$parent][$pos]) {
		$pos = $pos+1;
	}
	
	$content .= '<'.$value.'>'.$pos.'</'.$value.'>
';
	$new_sections[$parent][$pos] = $value;
	
	}
	}

	$content .= '</sections>';
	
	//echo $content;
	
	$axml_url = getcwd();
	$axml_url = explode('/wp-admin', $axml_url);
	$abs_xml_url = $axml_url[0];
	
	$pxml_url = explode('wp-content',$xml_url);
	//$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	
		$test_xml = explode(":\\", $axml_url[0]);
	if (count($test_xml) > 1) {
		
	$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	$abs_xml_url = str_replace('\wp-admin', '', $abs_xml_url);
	$abs_xml_url = $abs_xml_url.$p_xml_url;
	//chmod($xml_url, 777); 
	}
	else {
	$abs_xml_url = $abs_xml_url.'/wp-content'.$pxml_url[1];
	}
	
	
	//chmod($xml_url, 777); 
	$handle = fopen($abs_xml_url, "w");
	fwrite($handle, $content);
	fclose($handle);	
	
}

function Unique_sections_config() {
	global $sections, $new_sections;

  if ($_POST['neworder'] == 1) {
  	update_sections_order();
  }
  
	reorder_all_sections();
	
	//print_r($new_sections);
	
	//print_r($sections);
	//show_all_sections(0, 0);

	$content = '<br/><br/><div style="padding: 15px 10px; float: right; width: 300px; ">
	<b>How to use UNIQUE sections tool</b><br/><br/>
	<div style="font-size: 11px;">
  This tool was created because a general sortorder id is missing in the basic wordpress features. Using this tool you can arange all pages, posts and categories allready posted.<br/><br/>
  <b>Where applies?</b><br/>
  This order will apply to menus (the main one, dropdowns and the one included in sidebar), it is also used when the posts are displyed in their categories. <font style="background-color: yellow;"><b>This is very usefull because you can order the products or portfolio items.</b></font><br/><br/>
  <b>Where it does\'n applies?</b><br/>
  This order id is not used in the widgets menus, search results, or date ordered archives.<br/><br/>
  <b>How it works?</b><br/>
  The system is very simple, you must add a number in the field associated to every section. A smaller number will display the section higher.<br/>
  <font style="background-color: yellow;"><b>If you will submit the same number for two sections in the same level of parenting, the tool will put arbitrary a section below the other one so is strongly recommended to use different numbers for sections in the same level.</b></font><br/><br/>
  This tool can be also used as an overview of your information. You cand click on EDIT button associated to every section, and you will be redirected to edit page of wordpress.
	</div>
	</div>';
  
	$content .= '<div style="padding: 10px;">';
	$content .= '<form name=sectionsconfig method=POST action="admin.php?page=US">';
	$content .= '<input type="hidden" name="neworder" value="1">';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
  
  echo $content;
  
	show_all_sections(0, 0);
	
	$content = '</table>';	
	$content .= '<input type="submit" value="update structure">';	
	$content .= '</form>';	
	$content .= '</div>';			

	echo $content;
	
	if ($_POST['neworder'] != 1) {
  echo '	
  	<script>
  		document.sectionsconfig.submit();
  	</script>';
  }
	
}

function update_header($xml_url) {

	$content = '<?xml version="1.0" encoding="UTF-8"?>
';
	$content .= '<header>
';

	
	foreach($_POST as $key=>$var) {
	if ($key != 'updateheader' && $key != 'logo' && $key != 'smalllogo') {
		
	$content .= '<'.$key.'>'.$var.'</'.$key.'>
';
	
	}
	}
	
	$abs_uploads_dir = get_absolute_url(get_bloginfo('stylesheet_directory').'/images/logos/');


	foreach ($_FILES as $lkey => $error) {
		
  if ($_FILES[$lkey]['error'] == 0) {
  	$tmp_name = $_FILES[$lkey]["tmp_name"];
    $name = $_FILES[$lkey]["name"];
    //echo $name;
    //echo $uploads_dir;
    //echo $abs_uploads_dir;
    move_uploaded_file($tmp_name, $abs_uploads_dir.$name);
    
    $content .= '<'.$lkey.'>'.$name.'</'.$lkey.'>
 ';
 
   }
    else {
    


	}		
	
	
	}

			if ($_FILES['logo']['error'] == 4) {
					$content .= '<logo>'.$_POST['logo'].'</logo>
';
				}
				if ($_FILES['smalllogo']['error'] == 4) {
					$content .= '<smalllogo>'.$_POST['smalllogo'].'</smalllogo>
';    	
    }		

	$content .= '</header>';
	
	//echo $content;
	
	$axml_url = getcwd();
	$axml_url = explode('/wp-admin', $axml_url);
	$abs_xml_url = $axml_url[0];
	
	$pxml_url = explode('wp-content',$xml_url);
	//$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	
	$test_xml = explode(":\\", $axml_url[0]);
	if (count($test_xml) > 1) {
		
	$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	$abs_xml_url = str_replace('\wp-admin', '', $abs_xml_url);
	$abs_xml_url = $abs_xml_url.$p_xml_url;
	//chmod($xml_url, 777); 
	}
	else {
	$abs_xml_url = $abs_xml_url.'/wp-content'.$pxml_url[1];
	}
	
	
	//chmod($xml_url, 777); 
	$handle = fopen($abs_xml_url, "w");
	fwrite($handle, $content);
	fclose($handle);			
	
}

function Unique_header_config() {
	
	$xml_url = get_bloginfo('stylesheet_directory').'/header.xml';

	if ($_POST['updateheader'] == 1) {
		update_header($xml_url);
	}
	$abs_xml_url = get_absolute_url($xml_url);
	$vars = xml2array($abs_xml_url, 0, 'tag');		
	$header = $vars['header'];

	$content = '<br/><br/><div style="padding: 15px 10px; float: right; width: 300px; ">
	<b>How to use UNIQUE header tool</b><br/><br/>
	<div style="font-size: 11px;">
		This tool helps you to edit some custom data of this theme, like the header text (motto), the links and the links text to your twitter and facebook pages, and the most important the website logo.<br/><br/>
		<font style="background-color: yellow;">The logos will be uploaded at the original size.</font>
	</div>
	</div>';

	$content .= '<div style="padding: 10px;">';
	$content .= '<form name=headerconfig enctype="multipart/form-data" method=POST action="admin.php?page=UH">';
	$content .= '<input type="hidden" name="updateheader" value="1">';
	
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	
	$content .= '<td style="padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;" colspan=4>Customize header information</b></td>';
	//print_r($header);
	
	$content .= '<tr>';
	$content .= '<td height=5></td>';
	$content .= '</tr>';
	
	foreach($header as $key=>$var) {
		
		
		
		$content .= '<tr>';
		$content .= '<td style="font-size: 11px; padding: 5px;">'.str_replace('_', ' ', $key).'</td>';
		if ($key != 'logo' && $key != 'smalllogo' ) {
		
		$content .= '<td colspan=2 style="padding: 5px;"><input type="text" name="'.$key.'" value="';
		if ($var) {
		$content .=$var;
		}
		$content .='" style="width:400px;"></td>';
		}
		else {
		$content .= '<input type="hidden" name="'.$key.'" value="'.$var.'">';
		$content .= '<td style="padding: 5px;"><input type="file" name="'.$key.'" value="'.$var.'"></td>';			
		$content .= '<td style="padding: 5px;"><img src="'.get_bloginfo('stylesheet_directory').'/images/logos/'.$var.'" border=0></td>';			
		}
		$content .= '<td style="font-size: 9px; padding: 5px;">desc</td>';
		$content .= '</tr>';
		
	}
		
	$content .= '</table>';	
	$content .= '<input type="submit" value="save">';	
	$content .= '</form>';	
	$content .= '</div>';				
	
	echo $content;
	
}

function update_color_elements() {
	
	$xml_url = get_bloginfo('stylesheet_directory').'/styles/xml/colors.xml';

	$colors = array();
	$abs_xml_url = get_absolute_url($xml_url);
	$colors = xml2array($abs_xml_url, 0, 'tag');
	
	$color1 = $colors['colors']['color1']['value']; // base color
	$color2 = $colors['colors']['color2']['value']; // darkest color
	$color3 = $colors['colors']['color3']['value']; // lightest color
	$color4 = $colors['colors']['color4']['value']; // lighter than the base color
	$color5 = $colors['colors']['color5']['value']; // color for highlights - the brightest one	
	
	$xml_url = get_bloginfo('stylesheet_directory').'/styles/xml/colorelements.xml';
	$abs_xml_url = get_absolute_url($xml_url);
	$oldvalues = array();
	$oldvalue = array();
	$colors = array();
	$categories = array();
	$vars = array();
	
	$handle = fopen($abs_xml_url, "r");
	$contents = '';
	
	while (!feof($handle)) {
	  $contents .= fread($handle, 8192);
	}
	fclose($handle);
		
	
	$colors = xml2array($abs_xml_url, 0, 'tag');		
	$categories = array_keys($colors['colors']);
	$new_contents = $contents;
	
	foreach($categories as $category) {
		$vars = ($colors['colors'][$category]);
		foreach ($vars as $variable) {
			$new_value = '';
			//echo $variable['value'].'---'.$_POST[$variable['varname']].' == '.$color1.'<br/>';
			if ($_POST[$variable['varname']] == $color1) { $new_value = '!color1'; }
			if ($_POST[$variable['varname']] == $color2) { $new_value = '!color2'; }
			if ($_POST[$variable['varname']] == $color3) { $new_value = '!color3'; }
			if ($_POST[$variable['varname']] == $color4) { $new_value = '!color4'; }
			if ($_POST[$variable['varname']] == $color5) { $new_value = '!color5'; }
			if (!$new_value) { $new_value = $_POST[$variable['varname']]; }
			
			//echo $new_value.'**<br/><br/>';
			
			//${'old_'.$variable['varname']} = "'".$variable['value']."'";
			$new_contents = str_replace(
			'<value id="'.$variable['varname'].'">'.$variable['value'].'</value>', 
			'<value id="'.$variable['varname'].'">'.$new_value.'</value>',
			$new_contents);
			
			
			
		}
	}	
	
	//echo $new_contents;
		
	
	$axml_url = getcwd();
	$axml_url = explode('/wp-admin', $axml_url);
	$abs_xml_url = $axml_url[0];
	
	$pxml_url = explode('wp-content',$xml_url);
	//$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	
		
	$test_xml = explode(":\\", $axml_url[0]);
	
	if (count($test_xml) > 1) {
		
	$p_xml_url = str_replace("/", "\\", '\wp-content'.$pxml_url[1]);
	$abs_xml_url = str_replace('\wp-admin', '', $abs_xml_url);
	$abs_xml_url = $abs_xml_url.$p_xml_url;
	//chmod($xml_url, 777); 
	}
	else {
	$abs_xml_url = $abs_xml_url.'/wp-content'.$pxml_url[1];
	}
	
	
	//chmod($xml_url, 777); 
	$handle = fopen($abs_xml_url, "w");
	fwrite($handle, $new_contents);
	fclose($handle);			
	
}

function Unique_color_elements_config() {

	if ($_POST["WebSiteBg"]) {
		update_color_elements();
	}
	
	jscolor();

	$xml_url = get_bloginfo('stylesheet_directory').'/styles/xml/colors.xml';
	$abs_xml_url = get_absolute_url($xml_url);
	$colors = array();
	$colors = xml2array($abs_xml_url, 0, 'tag');
	
	$color1 = $colors['colors']['color1']['value']; // base color
	$color2 = $colors['colors']['color2']['value']; // darkest color
	$color3 = $colors['colors']['color3']['value']; // lightest color
	$color4 = $colors['colors']['color4']['value']; // lighter than the base color
	$color5 = $colors['colors']['color5']['value']; // color for highlights - the brightest one

	$xml_url1 = get_bloginfo('stylesheet_directory').'/styles/xml/colorelements.xml';
	$abs_xml_url1 = get_absolute_url($xml_url1);
	
//	if ($_POST['color1']) {
//		update_color_xml($_POST['color1'], $_POST['color2'], $_POST['color3'], $_POST['color4'], $_POST['color5'], $xml_url);
//	}

	if ($_POST['MainMenuSections']) {
		update_colorelements_xml($xml_url);		
	}

	$categories = array();
	$vars = array();
	$colors = array();
	$colors = xml2array($abs_xml_url1, 0, 'tag');		
		
	$categories = array_keys($colors['colors']);

	$content = '<br/><br/><div style="padding: 15px 10px; float: right; width: 300px; ">
	<b>How to use UNIQUE COLOR 2 tool</b><br/><br/>
	<div style="font-size: 11px;">
	This tool is created to leave you the posibility to change the color or background color for any element of your wordpress theme.<br/><br/>
	You can use one color from you 5 colors theme, you can use white or black, in case that you want to change the text color witch in the most cases in black, or you want to apply white for a text that apears on a colored background, like the main menu sections.<br/><br/>
	If you want to apply a custom color to one element you cand use the color picker by clicking on the hexazecimal code.<br/><br/>
	For backgrounds you can choose the \'none\' option, and a transparent background will be applyed to the element. For text color \'none\' option will remove the actual color and will apply the default one.<br/><br/>
	<b>Website background</b><br/>
	One of the most important element is the website background. By default is the same as the lightest color from your 5 colors theme, but probably you will change it. If you want to set a dark color to the website background, then you must change the backgrounds images and probably some text colors.<br/><br/>	
	</div>
	</div>';

	$content .= '<div style="padding: 10px;">';
	$content .= '<form name=colorselements method=POST action="admin.php?page=UE">';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	
	foreach($categories as $category) {
		$vars = ($colors['colors'][$category]);
				
		$content .= '<tr>';
		$content .= '<td style="padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;" colspan=4><input type=submit value="apply all changes" style="float: right; font-size: 10px;"><b>'.str_replace("_", " ", $category).' colors</b></td>';
		$content .= '</tr>';		
		$content .= '<tr><td height=5></td></tr>';		
		
		foreach ($vars as $variable) {
			${$variable['varname']} = "'".$variable['value']."'";
		
			
			$color_value = explode('!', $variable['value']);
			if (count($color_value) == 2) {
				$color_value = ${$color_value[1]};				
			}
			else {
				$color_value = $variable['value'];				
			}
		
			$content .= '<tr>';
			$content .= '<td style="padding: 5px; font-size: 11px;">'.$variable['name'].'</td>';
			$content .= '<td style="padding: 2px 5px 2px 5px;">';
			$content .= '<input style="font-size: 9px; width: 35px; height: 35px; background: #'.$color_value.'; color: #'.$color_value.';" type=text id="'.$variable['varname'].'" name="'.$variable['varname'].'" value="'.$color_value.'">';
			$content .= '</td>';
			$content .= '<td style="padding: 3px; border: 1px solid #CCCCCC;">';			
			$content .= '<table border=0 cellspacing=0 cellpadding=0>';
			$content .= '<tr>';			
			$content .= '<td style="font-size: 10px;">Change color&nbsp;</td>';
			for ($i = 1 ; $i <= 5 ; $i++) {
			$content .= '<td style="cursor: crosshair; background-color: #'.${'color'.$i}.';" onclick="
				document.getElementById(\''.$variable['varname'].'\').value=\''.${'color'.$i}.'\';
				document.getElementById(\''.$variable['varname'].'\').style.background=\'#'.${'color'.$i}.'\';
				document.getElementById(\''.$variable['varname'].'\').style.color=\'#'.${'color'.$i}.'\';
				">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>';			
			}
			$content .= '<td>&nbsp;&nbsp;</td>';
			$content .= '<td style="cursor: crosshair; border: 1px solid #CCCCCC; background-color: white;" onclick="
				document.getElementById(\''.$variable['varname'].'\').value=\'FFFFFF\';
				document.getElementById(\''.$variable['varname'].'\').style.background=\'#FFFFFF\';
				document.getElementById(\''.$variable['varname'].'\').style.color=\'#FFFFFF\';
				">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>';
			$content .= '<td style="cursor: crosshair; background-color: black;" onclick="
				document.getElementById(\''.$variable['varname'].'\').value=\'000000\';
				document.getElementById(\''.$variable['varname'].'\').style.background=\'#000000\';
				document.getElementById(\''.$variable['varname'].'\').style.color=\'#000000\';
				">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>';
			$content .= '<td>&nbsp;&nbsp;</td>';
			$content .= '<td style="font-size: 10px; cursor: crosshair; border: 1px solid #CCCCCC;" onclick="
				document.getElementById(\''.$variable['varname'].'\').value=\'none\';
				document.getElementById(\''.$variable['varname'].'\').style.background=\'none\';
				document.getElementById(\''.$variable['varname'].'\').style.color=\'#000000\';
				">&nbsp;none&nbsp;</td>';
			$content .= '<td>&nbsp;&nbsp;</td>';			
			$content .= '<td><input size=5 class=color type=text value="" onchange="
				document.getElementById(\''.$variable['varname'].'\').value=this.value;
				document.getElementById(\''.$variable['varname'].'\').style.background=\'#\'+this.value;			
				document.getElementById(\''.$variable['varname'].'\').style.color=\'#\'+this.value;			
			"></td>';				
			$content .= '</tr>';			
			$content .= '</table>';			
			$content .= '</td>';			
			$content .= '<td style="padding: 5px; font-size: 11px;">'.$variable['description'].'</td>';
			$content .= '</tr>';					
			$content .= '<tr><td height=3></td></tr>';	
		
		}
	}	
	$content .= '</table>';	
	$content .= '<input type=submit value="apply changes">';	
	$content .= '</form>';	
	$content .= '</div>';		
	echo $content;	
	
	
}

function Unique_help() {
	
	
	$content = '<br/><br/><div style="font-size: 20px; margin-right: 30px; float: right; padding: 15px 10px; width: 500px; ">
	<b>UNIQUE PLUGIN</b><br/><br/>
	<div style="font-size: 13px;">
	Unique plugin is made to offers you the posibility to change the look of your wordpress theme in any way you want with just some clicks:
	<br/><br/>
	Unique plugin includes a two level color customization, types, main background customization and some usefull tools for ordering the sections (pages, posts, categories) and customizing header information including website logo.
	<br/><br/>
	</div>
	<div style="font-size: 11px;">
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Unique colors 1</div><br/>	
	This is the main feature of Unique theme. Using this tool you can change the color theme of your website without writing any line of code.<br/>
	Using the color picker you can create a 5 colors theme, or if you want to choose the easiest way, you can choose one theme already created.
	<br/><br/>
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Unique colors 2</div><br/>	
	This tool is created to leave you the posibility to change the color or background color for any element of your wordpress theme.
	You can use one color from you 5 colors theme, you can use white or black, in case that you want to change the text color witch in the most cases in black, or you want to apply white for a text that apears on a colored background, like the main menu sections.	
	<br/><br/>
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Unique types</div><br/>	
	This tool helps you to change the type of any text element from your theme, even the ones from widgets boxes. You can modify heading, main text, promo text or buttons text.	
	<br/><br/>
	<!--<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Unique backgrounds</div><br/>	
	For the moment this tool can be used to choose one background from the list below. Some backgrounds are white with a 80 to 20 percent transparency. So theese ones will keep the base color of your background. But some are already colored with or without transparency and can be applyed to any color theme depending of your colors taste.	
	<br/><br/>-->
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Unique sections</div><br/>	
	This tool was created because a general sortorder id is missing in the basic wordpress features. Using this tool you can arange all pages, posts and categories allready posted.	
	<br/><br/>
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Unique header</div><br/>	
	This tool helps you to edit some custom data of this theme, like the header text (motto), the links and the links text to your twitter and facebook pages, and the most important the website logo.	
	<br/><br/>					
	</div>
	</div>';	
	
	$content .= '<div style="font-size: 20px; padding: 15px 10px; width: 500px; ">
	<b>UNIQUE HELP</b><br/><br/>
	<div style="font-size: 13px;">
	Unique theme was created to be used especially by the ones who don\'t want to write any line of code and who don\'t want to hire anybody to customize their themes. If you are one of theese will be very happy to use UNIQUE theme, if you don\'t be happy you will find some tehnical features that will wake up your interest.<br/><br/>
	So let\'s go to work. First of all you have to set up one more thing:<br/><br/>
	</div>
	<div style="font-size: 11px;">
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FCFFD6;">Setting up the image sizes</div><br/>
	It\'s very simple to do that. Go to <b>Setting > Media menu</b> and set up the sizes:<br/><br/>
	- Thumbnail size: width: <b>143px</b> and height: <b>98px</b><br/>
	- Medium size: width: <b>196px</b> and height: <b>133px</b><br/>
	- Large size: width: <b>272px</b> and height: <b>182px</b><br/><br/>
	<font style="background-color: yellow;">Note that the original size of the images that you will upload will be used for lightbox view so please don\'t upload huge image, just large ones, if is posible with a maximum of 1000px width.</font><br/><br/>
	
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">How to add images</div><br/>
	<b>The images can be uploaded using the wordpress built-in feature</b>. So add pictures in pages or posts galery. The first image from gallery will be the thumbnail and the others will be displayed in photo galery on the bottom of each article.<br/><br/>
	For the articles that you want to apear as promos you must add at least 3 images. If there will be more that 3 pictures, will be displayed in the promo just the first three.
	<br/><br/>
	
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">How to add an article on the first page</div><br/>
	After you added an article (page or post) you must scroll down to Custom fields box. There all you have to do is to <b>add a custom field named: "homepage". The value for this custom field will be "yes"</b> if you want to show the article on the first page.<br/><br/>
		
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">How to add a promo item</div><br/>
	You can choose any article (page or post) to be a promo on the homepage. For this go again to he custom fields section and <b>create a custom field named "article_type", for being a promo you must assign "promo" value</b> to this custom field.<br/><br/>
	
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">How to add a link in footer</div><br/>
	If you want to add a link in your website footer you must use the same custom field. So <b>add a custom field named "article type" and the value "footer_link"</b>
	<br/><br/>
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">How to edit the footer text</div><br/>
	If you want to add a link in your website footer you must use the same custom field. So <b>add a custom field named "article type" and the value "footer_text"</b>. In this case the the title of the article is not important because will not be shown.
	<br/><br/>	
	<font style="background-color: yellow;">Both footer links and footer text articles will be excluded from all articles lists, menus, listings, except the search results page.</font>
	<br/><br/>	
	<font style="background-color: yellow;">Homepage and article_types will be excluded from the custom fields list, so theese two will not apear in the portfolio or products pages.</font>
	<br/><br/>		
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">How to create the portfolio section</div><br/>
	Portfolio, blog and products sections can be created using shortcodes. For adding a portfolio section, <b>add in the category description the shortcode [portfolio]</b> after the text that you want to write in the description field (this description will apear on the website). If you want to have no description then just add the shortcode.<br/><br/>
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">How to create the blog section</div><br/>
	The blog section works identically like the portfolio category. <b>Add in the category description the shortcode [blog]</b><br/><br/>	
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">How to create the products section</div><br/>
	Same for products section just <b>add in the category description the shortcode [products]</b>.
	<br/><br/>
	<font style="background-color: yellow;">For portfolio and product sections you can add custom fields for the description of the item, can be add any custom field you like.<br/>
	In the products section the custom fields will be listed as tehnical description, as a table.<br/>
	For products section you have 2 special custom fields that will be displayed in a special way:<br/>
	- <b>Price</b>: the products actual price - highlighted<br/>
	- <b>Old price</b>: if you have discounts then you can use it - the price will apear with a strikeout.</font>
	<br/><br/>
	<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Pages</div><br/>
	All posts will be desplayed on pages. The number of items per page can be configured in the wordpress confing: <b>Settings > Reading</b>. There you can edit <b>Blog pages show at most</b> option. If you don\'t want to show your articles on pages just set up this field with <b>-1</b> value. This feature does not apply to search results page.
	
	</div>
	</div>';
	

	
	echo $content;
}



// Function name:
//  - xml2array 
// Description:
//  - Used for transforming xml files in arrays
// Parameters:
// 	- url: url of the xml file
//  - get_atttributes: set 0 if you don't want to get the attributes of the xml elements
//  - priority: method of parsing
// Returns:
//  - the array variable containing the xml file information

function xml2array($url, $get_attributes = 1, $priority = 'tag')
{
    $contents = "";
    if (!function_exists('xml_parser_create'))
    {
        return array ();
    }
    $parser = xml_parser_create('');
    if (!($fp = @ fopen($url, 'rb')))
    {
        return array ();
    }
    while (!feof($fp))
    {
        $contents .= fread($fp, 8192);
    }
    fclose($fp);
    xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8");
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
    xml_parse_into_struct($parser, trim($contents), $xml_values);
    xml_parser_free($parser);
    if (!$xml_values)
        return; //Hmm...
    $xml_array = array ();
    $parents = array ();
    $opened_tags = array ();
    $arr = array ();
    $current = & $xml_array;
    $repeated_tag_index = array ();
    foreach ($xml_values as $data)
    {
        unset ($attributes, $value);
        extract($data);
        $result = array ();
        $attributes_data = array ();
        if (isset ($value))
        {
            if ($priority == 'tag')
                $result = $value;
            else
                $result['value'] = $value;
        }
        if (isset ($attributes) and $get_attributes)
        {
            foreach ($attributes as $attr => $val)
            {
                if ($priority == 'tag')
                    $attributes_data[$attr] = $val;
                else
                    $result['attr'][$attr] = $val; //Set all the attributes in a array called 'attr'
            }
        }
        if ($type == "open")
        {
            $parent[$level -1] = & $current;
            if (!is_array($current) or (!in_array($tag, array_keys($current))))
            {
                $current[$tag] = $result;
                if ($attributes_data)
                    $current[$tag . '_attr'] = $attributes_data;
                $repeated_tag_index[$tag . '_' . $level] = 1;
                $current = & $current[$tag];
            }
            else
            {
                if (isset ($current[$tag][0]))
                {
                    $current[$tag][$repeated_tag_index[$tag . '_' . $level]] = $result;
                    $repeated_tag_index[$tag . '_' . $level]++;
                }
                else
                {
                    $current[$tag] = array (
                        $current[$tag],
                        $result
                    );
                    $repeated_tag_index[$tag . '_' . $level] = 2;
                    if (isset ($current[$tag . '_attr']))
                    {
                        $current[$tag]['0_attr'] = $current[$tag . '_attr'];
                        unset ($current[$tag . '_attr']);
                    }
                }
                $last_item_index = $repeated_tag_index[$tag . '_' . $level] - 1;
                $current = & $current[$tag][$last_item_index];
            }
        }
        elseif ($type == "complete")
        {
            if (!isset ($current[$tag]))
            {
                $current[$tag] = $result;
                $repeated_tag_index[$tag . '_' . $level] = 1;
                if ($priority == 'tag' and $attributes_data)
                    $current[$tag . '_attr'] = $attributes_data;
            }
            else
            {
                if (isset ($current[$tag][0]) and is_array($current[$tag]))
                {
                    $current[$tag][$repeated_tag_index[$tag . '_' . $level]] = $result;
                    if ($priority == 'tag' and $get_attributes and $attributes_data)
                    {
                        $current[$tag][$repeated_tag_index[$tag . '_' . $level] . '_attr'] = $attributes_data;
                    }
                    $repeated_tag_index[$tag . '_' . $level]++;
                }
                else
                {
                    $current[$tag] = array (
                        $current[$tag],
                        $result
                    );
                    $repeated_tag_index[$tag . '_' . $level] = 1;
                    if ($priority == 'tag' and $get_attributes)
                    {
                        if (isset ($current[$tag . '_attr']))
                        {
                            $current[$tag]['0_attr'] = $current[$tag . '_attr'];
                            unset ($current[$tag . '_attr']);
                        }
                        if ($attributes_data)
                        {
                            $current[$tag][$repeated_tag_index[$tag . '_' . $level] . '_attr'] = $attributes_data;
                        }
                    }
                    $repeated_tag_index[$tag . '_' . $level]++; //0 and 1 index is already taken
                }
            }
        }
        elseif ($type == 'close')
        {
            $current = & $parent[$level -1];
        }
    }
    return ($xml_array);
}

function update_menu_config() {
	global $_POST;
	
	if ($_POST['expages']) {
		$expagesupdate = $_POST['expages'];
	}
	else {
		$expagesupdate = '0';
	}

	if ($_POST['excategories']) {
		$excategoriesupdate = $_POST['excategories'];
	}
	else {
		$excategoriesupdate = '0';
	}	
	
	$new_contents = '<?php 
// enter the ids coma separated ex. $exclude_page_ids = array(1, 7, 5);
$exclude_page_ids = array('.$expagesupdate.');
$exclude_category_ids = array('.$excategoriesupdate.');
?>';
	
	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/mainmenu_exclude.php');
	
	$handle = fopen($abs_xml_url, "w");
	ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);	
	
	
}

function add_customlink() {
	global $_POST;
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/mainmenu_customlinks.php'));
	
	$new_links_name = '$links_name = array(';
	$new_links_link = '$links_link = array(';
	$new_links_target = '$links_target = array(';		

	foreach($links_name as $key=>$value) {
		
		$new_links_name .= "'".$value."',";
		$new_links_link .= "'".$links_link[$key]."',";
		$new_links_target .= "'".$links_target[$key]."',";

	}
	
	$new_links_name .= "'".$_POST['linkname']."');";
	$new_links_link .= "'".$_POST['link']."');";
	$new_links_target .= "'".$_POST['linktarget']."');";

	$new_contents = '<?php
'.$new_links_name.'
'.$new_links_link.'
'. $new_links_target.'
?>
';

	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/mainmenu_customlinks.php');
	
	$handle = fopen($abs_xml_url, "w");
	ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);		
	
	
}

function update_customlink($customlinkid=-1) {
	global $_POST;
	
	$update_links = $_POST;
	
	$new_links_name = '$links_name = array(';
	$new_links_link = '$links_link = array(';
	$new_links_target = '$links_target = array(';			
	
	foreach($update_links as $key=>$value) {
		
	$varname = explode('_', $key);
	
		if ($varname[2] != $customlinkid) {
		
			if ($varname[1] == 'name') {
				$new_links_name .= "'".$value."', ";
			}	
			if ($varname[1] == 'link') {
				$new_links_link .= "'".$value."', ";
			}	
			if ($varname[1] == 'target') {
				$new_links_target .= "'".$value."', ";
			}			
		
		}
	
	}
	
	if ($new_links_name != '$links_name = array(') {
	
	$new_links_name = substr($new_links_name, 0, -2);
	$new_links_link = substr($new_links_link, 0, -2);
	$new_links_target = substr($new_links_target, 0, -2);
	}
	
	$new_links_name .= ");";
	$new_links_link .= ");";
	$new_links_target .= ");";	

	$new_contents = '<?php
'.$new_links_name.'
'.$new_links_link.'
'. $new_links_target.'
?>
';	

	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/mainmenu_customlinks.php');
	
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);		

	//print_r($_POST);
	
}


function Unique_menu_config() {
	
	if ($_POST['updatecustomlink'] == 'update') {
		update_customlink();		
	}
	
	if ($_POST['updatecustomlink'] == 'delete') {
		update_customlink($_POST['customlinkid']);		
	}	
	
	if ($_POST['addcustomlink'] == 1 ) {
		add_customlink();
	}
	
	if ($_POST['excludepost'] == 1 ) {
		update_menu_config();
	}
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/mainmenu_exclude.php'));
	
	$i = 0;
	foreach($exclude_page_ids as $excludepage) {
		$excludepages .= $excludepage;
		if ($i != count($exclude_page_ids)-1) {
		$excludepages .= ',';	
		}
		$i++;
	}
	
	$i = 0;
	foreach($exclude_category_ids as $excludepage) {
		$excludecategories .= $excludepage;
		if ($i != count($exclude_category_ids)-1) {
		$excludecategories .= ',';	
		}
		$i++;
	}

	$content .= '<br/><br/><div style="padding: 10px;">';
	$content .= '<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Remove sections from main menu</div><br/>';
	$content .= '<form name=colorselements method=POST action="admin.php?page=UM">';
	$content .= '<input type=hidden name=excludepost value=1>';
	$content .= 'For removing sections from main menu just add the IDs of the pages and categories you want to remove. <br/>
							 The IDs must be entered comma separated. Ex. 1, 7, 8<br/>
							 For removing NO pages or categories just leave 0 in each field.
							 <br/><br/>';
	$content .= 'Pages IDs<br/>';
	$content .= '<input type=text name=expages value="'.$excludepages.'" size=100>';
	$content .= '<br/><br/>Categories IDs<br/>';
	$content .= '<input type=text name=excategories value="'.$excludecategories.'" size=100>';
	
	
	$content .= '<br/><br/><input type=submit value="Save">';
	
	$content .= '</form><br/><br/>';
	

	$content .= '<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Edit main menu custom links</div><br/>';
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/mainmenu_customlinks.php'));
	
	if (count($links_name) > 0) {
	$content .= '<form name=updatecustomlinkform method=POST action="admin.php?page=UM">';
	$content .= '<input type=hidden name=updatecustomlink value="">';
	$content .= '<input type=hidden name=customlinkid value="">';
	
	
	
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';
	$content .= '<td style="padding: 5px 0px 5px 10px;">Link name</td>';
	$content .= '<td style="padding: 5px 0px 5px 10px;">Link</td>';
	$content .= '<td style="padding: 5px 0px 5px 10px;">Link target</td>';
	$content .= '</tr>';
	
	
	foreach($links_name as $key=>$value) {
	
	$content .= '<tr>';
	$content .= '<td style="padding: 5px;"><input name="links_name_'.$key.'" type="text" value="'.$value.'"></td>';	
	$content .= '<td style="padding: 5px;"><input size=50 name="links_link_'.$key.'" type="text" value="'.$links_link[$key].'"></td>';	
	$content .= '<td style="padding: 5px;">';	
	$content .= '<select name="links_target_'.$key.'">';			
	$content .= '<option value="self"'; 
	if ($links_target[$key] == 'self') { $content .= ' selected="selected"'; }
	$content.='>Same window</option>';			
	$content .= '<option value="_blank"'; 
	if ($links_target[$key] == '_blank') { $content .= ' selected="selected"'; }
	$content.='>New window</option>';			
	$content .= '</select>';
	$content .= '</td>';	
	$content .= '<td style="padding: 5px;"><input 
	onclick="document.updatecustomlinkform.updatecustomlink.value=\'delete\'; 
	document.updatecustomlinkform.customlinkid.value='.$key.';" type="submit" value="delete"></td>';		
	$content .= '</tr>';	
		
		
	}
	$content .= '</table>';
	$content .= '<hr size=1 width=100%>';
	$content .= '<input onclick="document.updatecustomlinkform.updatecustomlink.value=\'update\'" type="submit" value="update all links">';		
	$content .= '<br/><br/>';
	$content .= '</form>';
	
	}	
	$content .= '<br/><div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Add a custom link</div><br/>';
	$content .= '<form name=colorselements method=POST action="admin.php?page=UM">';
	$content .= '<input type=hidden name=addcustomlink value=1>';	
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';
	$content .= '<td>';
	$content .= 'Link name';
	$content .= '</td>';
	$content .= '<td>';
	$content .= '<input type=text name=linkname value="" size=100>';	
	$content .= '</td>';
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td>';
	$content .= 'Link address&nbsp;';
	$content .= '</td>';
	$content .= '<td>';
	$content .= '<input type=text name=link value="" size=100>';		
	$content .= '</td>';
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td>';	
	$content .= 'Target';
	$content .= '</td>';
	$content .= '<td>';	
	$content .= '<select name=linktarget>';			
	$content .= '<option value="self">Same window</option>';			
	$content .= '<option value="_blank">New window</option>';			
	$content .= '</select>';		
	$content .= '</td>';
	$content .= '</tr>';		
	$content .= '</table>';		
	$content .= '<br/><input type=submit value="Add">';
	$content .= '</form><br/><br/>';
	$content .= '</div>';
	
	echo $content;
	
	
	
}

function update_article($articleid=-1) {
	global $_POST;
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/homepage_articles.php'));
	
	$update_articles = $_POST;
	
	//print_r($update_articles);
	
	$new_articles_name = '$articles_name = array(';
	$new_articles_link = '$articles_link = array(';
	$new_articles_target = '$articles_target = array(';			
	$new_articles_text = '$articles_text = array(';			
	$new_articles_picture = '$articles_picture = array(';			
	
	$abs_uploads_dir = get_absolute_url(get_bloginfo('stylesheet_directory').'/images/homepagearticles/');
	
	$i = 0;
	foreach ($_FILES as $lkey => $error) {
		
  if ($_FILES[$lkey]['error'] == 0) {
  	$tmp_name = $_FILES[$lkey]["tmp_name"];
    $name = $_FILES[$lkey]["name"];
    //echo $name;
    //echo $uploads_dir;
    //echo $abs_uploads_dir;
    move_uploaded_file($tmp_name, $abs_uploads_dir.$name);
 
 		$new_articles_picture .= "'".get_bloginfo('stylesheet_directory')."/images/homepagearticles/".$name."', ";
 
   }
   else {
    $new_articles_picture .= "'".$articles_picture[$i]."', ";
    
   // echo $new_articles_picture;
   }
   $i++;
   
	}		
	
	foreach($update_articles as $key=>$value) {
		
	$varname = explode('_', $key);
	
		if ($varname[2] != $articleid) {
		
			if ($varname[1] == 'name') {
				$new_articles_name .= "'".$value."', ";
			}	
			if ($varname[1] == 'link') {
				$new_articles_link .= "'".$value."', ";
			}	
			if ($varname[1] == 'target') {
				$new_articles_target .= "'".$value."', ";
			}		
			
			if ($varname[1] == 'text') {
				$new_articles_text .= "'".$value."', ";
			}					
		
		}
	
	}
	
	if ($new_articles_name != '$articles_name = array(') {
	
	$new_articles_name = substr($new_articles_name, 0, -2);
	$new_articles_link = substr($new_articles_link, 0, -2);
	$new_articles_target = substr($new_articles_target, 0, -2);
	$new_articles_text = substr($new_articles_text, 0, -2);
	$new_articles_picture = substr($new_articles_picture, 0, -2);
	}
	
	$new_articles_name .= ");";
	$new_articles_link .= ");";
	$new_articles_target .= ");";	
	$new_articles_text .= ");";	
	$new_articles_picture .= ");";	

	$new_contents = '<?php
'.$new_articles_name.'
'.$new_articles_link.'
'. $new_articles_target.'
'. $new_articles_text.'
'. $new_articles_picture.'
?>
';	

echo $new_contents;

	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/homepage_articles.php');
	
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);		

	//print_r($_POST);
	
}


function add_article() {
	global $_POST;
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/homepage_articles.php'));
	
	$new_articles_name = '$articles_name = array(';
	$new_articles_link = '$articles_link = array(';
	$new_articles_target = '$articles_target = array(';		
	$new_articles_text = '$articles_text = array(';
	$new_articles_picture_tmp = '$articles_picture = array(';

	$abs_uploads_dir = get_absolute_url(get_bloginfo('stylesheet_directory').'/images/homepagearticles/');
	
	foreach ($_FILES as $lkey => $error) {
		
  if ($_FILES[$lkey]['error'] == 0) {
  	$tmp_name = $_FILES[$lkey]["tmp_name"];
    $name = $_FILES[$lkey]["name"];
    //echo $name;
    //echo $uploads_dir;
    //echo $abs_uploads_dir;
    move_uploaded_file($tmp_name, $abs_uploads_dir.$name);
 
 		$new_articles_picture .= "'".get_bloginfo('stylesheet_directory')."/images/homepagearticles/".$name;
 
   }
   
	}	

	foreach($articles_name as $key=>$value) {
		
		$new_articles_name .= "'".$value."',";
		$new_articles_link .= "'".$articles_link[$key]."',";
		$new_articles_target .= "'".$articles_target[$key]."',";
		$new_articles_text .= "'".$articles_text[$key]."',";
		$new_articles_picture_tmp .= "'".$articles_picture[$key]."',";

	}
	
	$new_articles_name .= "'".$_POST['articlename']."');";
	$new_articles_link .= "'".$_POST['articlelink']."');";
	$new_articles_target .= "'".$_POST['articletarget']."');";
	$new_articles_text .= "'".$_POST['articletext']."');";
	
	$new_articles_picture = $new_articles_picture_tmp.$new_articles_picture."');";

	$new_contents = '<?php
'.$new_articles_name.'
'.$new_articles_link.'
'. $new_articles_target.'
'. $new_articles_text.'
'. $new_articles_picture.'
?>
';

	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/homepage_articles.php');
	
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);		
	
	
}

function update_check() {
	global $_POST;
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/homepage_config.php'));
	
	if ($_POST['autoarticles'] == 'on') {
		
		$new_contents = '$homepage_articles_auto = "true"';		
		
	}
	else {
		$new_contents = '$homepage_articles_auto = "false"';		
	}
	
	$new_contents = '<?php
'.$new_contents.'
?>';
	
	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/homepage_config.php');
	
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);		
	
}



function Unique_homepage_config() {
	
	if ($_POST['addarticle'] == 1) {
		add_article();
	}
	
	if ($_POST['autocheck'] == 1) {
		update_check();
	}
	
	if ($_POST['updatearticle'] == 'update') {
		update_article();		
	}
	
	if ($_POST['updatearticle'] == 'delete') {
		update_article($_POST['articleid']);		
	}	
		
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/homepage_articles.php'));
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/homepage_config.php'));
	
	$content .= '<br/><br/><div style="padding: 10px;">';
	$content .= '<form name=updateautocheck method=POST action="admin.php?page=UHO"">';
	$content .= '<input type=hidden name=autocheck value="1">';
	$content .= '<input';
	if ($homepage_articles_auto == 'true') {
	$content .= ' checked';
	}
	$content .= ' type=checkbox name=autoarticles> check this to get automatic the articles for homepage - please read the documentation to understand how the articles will apear on homepage.<br/><br/>
	If you want to use the below functionality just uncheck this checkbox.';
	$content .= '<br/><br/><input type=submit value="update">';
	$content .= '</form>';
	$content .= '</div>';
		
	if (count($articles_name) > 0) {
	$content .= '<br/><br/><div style="padding: 10px;">';
	$content .= '<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Edit homepage articles</div><br/>';		
	$content .= '<form name=updatearticles method=POST action="admin.php?page=UHO" enctype="multipart/form-data">';
	$content .= '<input type=hidden name=updatearticle value="">';
	$content .= '<input type=hidden name=articleid value="">';
	
	
	
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';
	
	foreach($articles_name as $key=>$value) {
	
	$content .= '<td valign=top>';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';
	$content .= '<td style="padding: 5px;"><input name="articles_name_'.$key.'" type="text" value="'.$value.'"></td>';	
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td style="padding: 5px;"><input size=25 name="articles_link_'.$key.'" type="text" value="'.$articles_link[$key].'"></td>';	
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td style="padding: 5px;">';	
	$content .= '<select name="articles_target_'.$key.'">';			
	$content .= '<option value="self"'; 
	if ($articles_target[$key] == 'self') { $content .= ' selected="selected"'; }
	$content.='>Same window</option>';			
	$content .= '<option value="_blank"'; 
	if ($articles_target[$key] == '_blank') { $content .= ' selected="selected"'; }
	$content.='>New window</option>';			
	$content .= '</select>';
	$content .= '</td>';	
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td style="padding: 5px;">';	
	$content .= '<textarea name="articles_text_'.$key.'" cols=25 rows=5 style="font-size:10px;">'.$articles_text[$key].'</textarea>';		
	$content .= '</td>';
	$content .= '</tr>';		

	$content .= '<tr>';
	$content .= '<td style="padding: 5px;">';	
	$content .= '<img src="'.$articles_picture[$key].'" border=0 width= 192px;>';		
	$content .= '</td>';
	$content .= '</tr>';		

	$content .= '<tr>';
	$content .= '<td style="padding: 5px;">';	
	$content .= '<input type=file name="articles_picture_'.$key.'">';		
	$content .= '</td>';
	$content .= '</tr>';
	
	$content .= '<tr>';	
	$content .= '<td style="padding: 5px;"><input 
	onclick="document.updatearticles.updatearticle.value=\'delete\'; 
	document.updatearticles.articleid.value='.$key.';" type="submit" value="delete"></td>';		
	$content .= '</tr>';			
	$content .= '</table>';			
	$content .= '</td>';			

	
	}
	$content .= '</tr>';		
	$content .= '</table>';
	$content .= '<hr size=1 widh=100%>';
	$content .= '<input onclick="document.updatearticles.updatearticle.value=\'update\'" type="submit" value="update all articles">';		
	$content .= '<br/><br/>';
	$content .= '</form>';
	
	}	
	$content .= '<div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Add new article</div><br/>';		
	$content .= '<form name=addarticle method=POST action="admin.php?page=UHO" enctype="multipart/form-data">';
	$content .= '<input type=hidden name=addarticle value=1>';	
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';
	$content .= '<td>';
	$content .= 'Article name&nbsp;';
	$content .= '</td>';
	$content .= '<td>';
	$content .= '<input type=text name=articlename value="" size=30>';	
	$content .= '</td>';
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td>';
	$content .= 'Article link&nbsp;';
	$content .= '</td>';
	$content .= '<td>';
	$content .= '<input type=text name=articlelink value="" size=50>';		
	$content .= '</td>';
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td>';	
	$content .= 'Link target';
	$content .= '</td>';
	$content .= '<td>';	
	$content .= '<select name=articletarget>';			
	$content .= '<option value="self">Same window</option>';			
	$content .= '<option value="_blank">New window</option>';			
	$content .= '</select>';		
	$content .= '</td>';
	$content .= '</tr>';			
	$content .= '<tr>';
	$content .= '<td>';	
	$content .= 'Article text';
	$content .= '</td>';
	$content .= '<td>';	
	$content .= '<textarea name="articletext" style="font-size: 10px;" cols=45 rows=5></textarea>';		
	$content .= '</td>';
	$content .= '</tr>';		
	$content .= '<tr>';
	$content .= '<td>';	
	$content .= 'Article image';
	$content .= '</td>';
	$content .= '<td>';	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/styles/config_sizes.php'));
	$content .= '<input type=file name=articlepicture> size: '.$homepage_picture_width.'x'.$homepage_picture_height.'px - the files will be uploaded at the original size';		
	$content .= '</td>';
	$content .= '</tr>';
	$content .= '</table>';		
	$content .= '<br/><input type=submit value="Add">';
	$content .= '</form><br/><br/>';
	$content .= '</div>';
	
	echo $content;	
	
}



function add_footerlink() {
	global $_POST;
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/footer_links.php'));
	
	$new_links_name = '$links_name = array(';
	$new_links_link = '$links_link = array(';
	$new_links_target = '$links_target = array(';		

	foreach($links_name as $key=>$value) {
		
		$new_links_name .= "'".$value."',";
		$new_links_link .= "'".$links_link[$key]."',";
		$new_links_target .= "'".$links_target[$key]."',";

	}
	
	$new_links_name .= "'".$_POST['linkname']."');";
	$new_links_link .= "'".$_POST['link']."');";
	$new_links_target .= "'".$_POST['linktarget']."');";

	$new_contents = '<?php
'.$new_links_name.'
'.$new_links_link.'
'. $new_links_target.'
?>
';

	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/footer_links.php');
	
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);		
	
	
}

function update_footerlink($customlinkid=-1) {
	global $_POST;
	
	$update_links = $_POST;
	
	$new_links_name = '$links_name = array(';
	$new_links_link = '$links_link = array(';
	$new_links_target = '$links_target = array(';			
	
	foreach($update_links as $key=>$value) {
		
	$varname = explode('_', $key);
	
		if ($varname[2] != $customlinkid) {
		
			if ($varname[1] == 'name') {
				$new_links_name .= "'".$value."', ";
			}	
			if ($varname[1] == 'link') {
				$new_links_link .= "'".$value."', ";
			}	
			if ($varname[1] == 'target') {
				$new_links_target .= "'".$value."', ";
			}			
		
		}
	
	}
	
	if ($new_links_name != '$links_name = array(') {
	
	$new_links_name = substr($new_links_name, 0, -2);
	$new_links_link = substr($new_links_link, 0, -2);
	$new_links_target = substr($new_links_target, 0, -2);
	}
	
	$new_links_name .= ");";
	$new_links_link .= ");";
	$new_links_target .= ");";	

	$new_contents = '<?php
'.$new_links_name.'
'.$new_links_link.'
'. $new_links_target.'
?>
';	

	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/footer_links.php');
	
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);		

	//print_r($_POST);
	
}

function update_footertext() {
	global $_POST;
	
	$new_contents = '<?php
$footer_text = "'.$_POST['footertext'].'";
?>';
	
	
	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/footer_text.php');
	
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);		
	
}

function Unique_footer_config() {

	if ($_POST['updatefootertext'] == 1) {
		update_footertext();		
	}

	if ($_POST['updatecustomlink'] == 'update') {
		update_footerlink();		
	}
	
	if ($_POST['updatecustomlink'] == 'delete') {
		update_footerlink($_POST['customlinkid']);		
	}	
	
	if ($_POST['addcustomlink'] == 1 ) {
		add_footerlink();
	}
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/footer_text.php'));
	$content .= '<br/><br/><div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Edit footer text</div><br/>';
	$content .= '<form name=addfootertext method=POST action="admin.php?page=UF">';
	$content .= '<input type=hidden name=updatefootertext value="">';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';
	$content .= '<td><textarea name="footertext" cols=70 rows=7 style="font-size: 10px;">'.$footer_text.'</textarea></td>';
	$content .= '</tr>';
	$content .= '</table>';	
	$content .= '<input onclick="document.addfootertext.updatefootertext.value=1" type="submit" value="update">';		
	$content .= '<br/><br/>';
	$content .= '</form>';	
	
	$content .= '<br/><br/><div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Edit footer links</div><br/>';
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/footer_links.php'));
	
	if (count($links_name) > 0) {
	$content .= '<form name=updatecustomlinkform method=POST action="admin.php?page=UF">';
	$content .= '<input type=hidden name=updatecustomlink value="">';
	$content .= '<input type=hidden name=customlinkid value="">';

	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';
	$content .= '<td style="padding: 5px 0px 5px 10px;">Link name</td>';
	$content .= '<td style="padding: 5px 0px 5px 10px;">Link</td>';
	$content .= '<td style="padding: 5px 0px 5px 10px;">Link target</td>';
	$content .= '</tr>';
	
	
	foreach($links_name as $key=>$value) {
	
	$content .= '<tr>';
	$content .= '<td style="padding: 5px;"><input name="links_name_'.$key.'" type="text" value="'.$value.'"></td>';	
	$content .= '<td style="padding: 5px;"><input size=50 name="links_link_'.$key.'" type="text" value="'.$links_link[$key].'"></td>';	
	$content .= '<td style="padding: 5px;">';	
	$content .= '<select name="links_target_'.$key.'">';			
	$content .= '<option value="self"'; 
	if ($links_target[$key] == 'self') { $content .= ' selected="selected"'; }
	$content.='>Same window</option>';			
	$content .= '<option value="_blank"'; 
	if ($links_target[$key] == '_blank') { $content .= ' selected="selected"'; }
	$content.='>New window</option>';			
	$content .= '</select>';
	$content .= '</td>';	
	$content .= '<td style="padding: 5px;"><input 
	onclick="document.updatecustomlinkform.updatecustomlink.value=\'delete\'; 
	document.updatecustomlinkform.customlinkid.value='.$key.';" type="submit" value="delete"></td>';		
	$content .= '</tr>';	
		
		
	}
	$content .= '</table>';
	$content .= '<hr size=1 width=100%>';
	$content .= '<input onclick="document.updatecustomlinkform.updatecustomlink.value=\'update\'" type="submit" value="update all links">';		
	$content .= '<br/><br/>';
	$content .= '</form>';
	
	}	
	$content .= '<br/><div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Add a footer link</div><br/>';
	$content .= '<form name=colorselements method=POST action="admin.php?page=UF">';
	$content .= '<input type=hidden name=addcustomlink value=1>';	
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';
	$content .= '<td>';
	$content .= 'Link name';
	$content .= '</td>';
	$content .= '<td>';
	$content .= '<input type=text name=linkname value="" size=100>';	
	$content .= '</td>';
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td>';
	$content .= 'Link address&nbsp;';
	$content .= '</td>';
	$content .= '<td>';
	$content .= '<input type=text name=link value="" size=100>';		
	$content .= '</td>';
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td>';	
	$content .= 'Target';
	$content .= '</td>';
	$content .= '<td>';	
	$content .= '<select name=linktarget>';			
	$content .= '<option value="self">Same window</option>';			
	$content .= '<option value="_blank">New window</option>';			
	$content .= '</select>';		
	$content .= '</td>';
	$content .= '</tr>';		
	$content .= '</table>';		
	$content .= '<br/><input type=submit value="Add">';
	$content .= '</form><br/><br/>';
	$content .= '</div>';
	
	echo $content;
	
	
}

function update_promos_config() {
	global $_POST;
	
	$new_contents = '<?php
$promo_type = '.$_POST['promotype'].';
?>';
	
	
	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/promo_config.php');
	
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);			
	
}

function add_promos() {
	global $_POST;
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/promos.php'));
	
	$promos_title_new = '$promos_title = array(';
	$promos_text_new = '$promos_text = array(';
	$promos_link_new = '$promos_link = array(';
	$promos_picture1_new_tmp = '$promos_picture1 = array(';
	$promos_picture2_new_tmp = '$promos_picture2 = array(';
	$promos_order_new = '$promos_order = array(';
	
	$abs_uploads_dir = get_absolute_url(get_bloginfo('stylesheet_directory').'/images/promos/');
	
	foreach ($_FILES as $lkey => $error) {
		
  if ($_FILES[$lkey]['error'] == 0) {
  	$tmp_name = $_FILES[$lkey]["tmp_name"];
    $name = $_FILES[$lkey]["name"];
    //echo $name;
    //echo $uploads_dir;
    //echo $abs_uploads_dir;
    move_uploaded_file($tmp_name, $abs_uploads_dir.$name);
 
   }
   
	}
	
	 if ($_FILES['promopicture1']['error'] == 0) {
	 	$name1 = $_FILES['promopicture1']["name"];
		}
	 if ($_FILES['promopicture2']['error'] == 0) {
	 	$name2 = $_FILES['promopicture2']["name"];
		}		
	
	$promos_picture1_new .= "'".get_bloginfo('stylesheet_directory')."/images/promos/".$name1;	
	$promos_picture2_new .= "'".get_bloginfo('stylesheet_directory')."/images/promos/".$name2;	

	foreach($promos_link as $key=>$value) {
		
		$promos_title_new .= "'".$promos_title[$key]."',";
		$promos_text_new .= "'".$promos_text[$key]."',";
		$promos_link_new .= "'".$promos_link[$key]."',";
		$promos_picture1_new_tmp .= "'".$promos_picture1[$key]."',";
		$promos_picture2_new_tmp .= "'".$promos_picture2[$key]."',";
		$promos_order_new .= "'".$promos_order[$key]."',";

	}
	
	$promos_title_new .= "'".$_POST['promotitle']."');";
	$promos_text_new .= "'".$_POST['promotext']."');";
	$promos_link_new .= "'".$_POST['promolink']."');";
	$promos_order_new .= "'".$_POST['promoorder']."');";
	
	$promos_picture1_new = $promos_picture1_new_tmp.$promos_picture1_new."');";
	$promos_picture2_new = $promos_picture2_new_tmp.$promos_picture2_new."');";
	

	$new_contents = '<?php
'.$promos_title_new.'
'.$promos_text_new.'
'. $promos_link_new.'
'. $promos_picture1_new.'
'. $promos_picture2_new.'
'.$promos_order_new.'
?>
';

	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/promos.php');
	
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);		
	
		
}

function update_promos($deleteid=-1) {
	global $_POST;
	
	include (get_absolute_url(get_bloginfo('stylesheet_directory').'/promos.php'));
	
	$new_promo_title = '$promos_title = array(';
	$new_promo_text = '$promos_text = array(';
	$new_promo_link = '$promos_link = array(';
	$new_promo_picture1 = '$promos_picture1 = array(';
	$new_promo_picture2 = '$promos_picture2 = array(';
	$new_promo_order = '$promos_order = array(';	
	
	$abs_uploads_dir = get_absolute_url(get_bloginfo('stylesheet_directory').'/images/promos/');
	
	$i = 0;
	foreach ($_FILES as $lkey => $error) {
	$fieldname = explode('_', $lkey);
	
  if ($_FILES[$lkey]['error'] == 0) {
  	$tmp_name = $_FILES[$lkey]["tmp_name"];
    $name = $_FILES[$lkey]["name"];
    //echo $name;
    //echo $uploads_dir;
    //echo $abs_uploads_dir;
    move_uploaded_file($tmp_name, $abs_uploads_dir.$name);
 
 		if ($fieldname[0] == 'promopicture1') {
 		if ($fieldname[1] != $deleteid) {
 		$new_promo_picture1 .= "'".get_bloginfo('stylesheet_directory')."/images/promos/".$name."', ";
 		}
 		}
 		
 		if ($fieldname[0] == 'promopicture2') {
 		if ($fieldname[1] != $deleteid) {
 		$new_promo_picture2 .= "'".get_bloginfo('stylesheet_directory')."/images/promos/".$name."', ";
 		}
 		}
 
   }
   else {
   	if ($fieldname[0] == 'promopicture1') {
    if ($fieldname[1] != $deleteid) {
    
    $new_promo_picture1 .= "'".$promos_picture1[$i]."', ";
  	}
  	}
   	if ($fieldname[0] == 'promopicture2') {
   	$i--;
   	if ($fieldname[1] != $deleteid) {
   	
    $new_promo_picture2 .= "'".$promos_picture2[$i]."', ";
  	}
  	}    
   // echo $new_articles_picture;
   }
  	
  
  
   $i++;
 	 
   
	}			
	
	foreach($_POST as $key=>$value) {
		
		$updatepromoskey = explode('_', $key);
		
		if ($updatepromoskey[1] != $deleteid) {
		
			if ($updatepromoskey[0] == 'promotitle') {
				$new_promo_title .= "'".$value."', ";	
			}
			if ($updatepromoskey[0] == 'promotext') {
				$new_promo_text .= "'".$value."', ";	
			}
			if ($updatepromoskey[0] == 'promolink') {
				$new_promo_link .= "'".$value."', ";	
			}
			if ($updatepromoskey[0] == 'promoorder') {
				$new_promo_order .= "'".$value."', ";	
			}
		}
		
	}
	
	if ($new_promo_title != '$promos_title = array(') {
		$new_promo_title = substr($new_promo_title, 0, -2);
	}
	if ($new_promo_text != '$promos_text = array(') {
		$new_promo_text = substr($new_promo_text, 0, -2);
	}
	if ($new_promo_link != '$promos_link = array(') {
		$new_promo_link = substr($new_promo_link, 0, -2);
	}
	if ($new_promo_order != '$promos_order = array(') {
		$new_promo_order = substr($new_promo_order, 0, -2);
	}		
	if ($new_promo_picture1 != '$promos_picture1 = array(') {
		$new_promo_picture1 = substr($new_promo_picture1, 0, -2);
	}	
	if ($new_promo_picture2 != '$promos_picture2 = array(') {
		$new_promo_picture2 = substr($new_promo_picture2, 0, -2);
	}			
	
	$new_promo_title .= ");";
	$new_promo_text .= ");";
	$new_promo_link .= ");";
	$new_promo_order .= ");";	
	$new_promo_picture1 .= ");";
	$new_promo_picture2 .= ");";	
	
	
	$new_contents = '<?php
'.$new_promo_title.'
'.$new_promo_text.'
'. $new_promo_link.'
'. $new_promo_picture1.'
'. $new_promo_picture2.'
'.$new_promo_order.'
?>
';

	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/promos.php');
	
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);		
	
}

function Unique_promos_config() {
	
	if ($_POST['updatepromotype'] == 1) {
		update_promos_config();
	}
	
	if ($_POST['addpromo'] == 1) {
		add_promos();
	}	
	
	if ($_POST['updatepromos'] == 1) {
		update_promos();
	}		
	
	if ($_POST['updatepromos'] == 2) {
		update_promos($_POST['deleteid']);
	}			
	
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/promo_config.php'));
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/promos.php'));
	
	$content .= '
	<style>
		input:disabled { background-color: #EFEFEF; } 
		textarea:disabled { background-color: #EFEFEF; } 
	</style>
	<script language=javascript>
	function enableInputs() {
		var inputs = document.getElementsByTagName("input");   
		for (i = 0 ; i < inputs.length ; i++) {
			inputs[i].disabled = false;
		}
		var textareas = document.getElementsByTagName("textarea");   
		for (i = 0 ; i < textareas.length ; i++) {
			textareas[i].disabled = false;
		}		
	}
	</script>
	';
	
	$content .= '<br/><br/><div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Promo type</div><br/>';
	$content .= '<form name=promotypeform method=POST action="admin.php?page=UP">';
	$content .= '<input type=hidden name=updatepromotype value=1>';
	$content .= 'Select promo type&nbsp;<select name=promotype>';
	$content .= '<option value=1'; if ($promo_type == 1) $content .= ' selected'; $content.='>Two thumbnails promo</option>';
	$content .= '<option value=2'; if ($promo_type == 2) $content .= ' selected'; $content.='>One thumbnail promo</option>';
	$content .= '<option value=3'; if ($promo_type == 3) $content .= ' selected'; $content.='>Full picture promo</option>';
	$content .= '<option value=4'; if ($promo_type == 4) $content .= ' selected'; $content.='>Full page promo</option>';
	//$content .= '<option value=5'; if ($promo_type == 5) $content .= ' selected'; $content.='>Qu3er</option>';
	$content .= '</select>';
	$content .= '&nbsp;<input type=submit value="update">';
	$content .= '</form>';

	$content .= '<br/><br/><div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Update promo items</div><br/>';
	$content .= '<form name=promoupdateform method=POST action="admin.php?page=UP" enctype="multipart/form-data">';
	$content .= '<input type=hidden name=updatepromos value=1>';
	$content .= '<input type=hidden name=deleteid value=0>';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';

	foreach($promos_link as $key=>$value) {

	$content .= '<tr>';
	$content .= '<td><input';
	if ($promo_type == 3 || $promo_type ==  4) {
	$content .= ' disabled';
	}
	$content .= ' type=text name=promotitle_'.$key.' value="'.$promos_title[$key].'"></td>';
	$content .= '<td><textarea';
	if ($promo_type == 3 || $promo_type ==  4) {
	$content .= ' disabled';
	}
	$content .= ' name=promotext_'.$key.'>'.$promos_text[$key].'</textarea></td>';
	$content .= '<td><input type=text name=promolink_'.$key.' value="'.$promos_link[$key].'"></td>';
	$content .= '<td><img src="'.$promos_picture1[$key].'" border=0 width=100><br/><input type=file name=promopicture1_'.$key.'></td>';
	$content .= '<td><img src="'.$promos_picture2[$key].'" border=0 width=100><br/><input';
	if ($promo_type == 2 || $promo_type == 3 || $promo_type ==  4) {
	$content .= ' disabled';
	}
	$content .= ' type=file name=promopicture2_'.$key.'></td>';
	$content .= '<td><input type=text name=promoorder_'.$key.' size=3 value="'.$promos_order[$key].'"></td>';
	$content .= '<td><input onclick="enableInputs(); document.promoupdateform.updatepromos.value=2; document.promoupdateform.deleteid.value='.$key.';" type=submit value="delete"></td>';
	$content .= '</tr>';
	
	}
	
	$content .= '</table>';
	$content .= '&nbsp;<input onclick="enableInputs();" type=submit value="update">';
	$content .= '</form>';	

	$content .= '<br/><br/><div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Add promo item</div><br/>';
	$content .= '<form name=addpromoform method=POST action="admin.php?page=UP" enctype="multipart/form-data">';
	$content .= '<input type=hidden name=addpromo value=1>';	
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';
	$content .= '<td>Title</td>';
	$content .= '<td><input';
	if ($promo_type == 3 || $promo_type ==  4) {
	$content .= ' disabled';
	}
	$content .= ' type=text name=promotitle size=50></td>';
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td>Text</td>';
	$content .= '<td><textarea';
	if ($promo_type == 3 || $promo_type ==  4) {
	$content .= ' disabled';
	}
	$content .= ' name=promotext cols=50 rows=5 style="font-size: 10px;"></textarea></td>';	
	$content .= '</tr>';
	$content .= '<tr>';
	$content .= '<td>Link (required)</td>';
	$content .= '<td><input type=text name=promolink size=50></td>';
	$content .= '</tr>';	
	$content .= '<tr>';
	$content .= '<td>Picture 1</td>';
	$content .= '<td><input type=file name=promopicture1></td>';
	if ($promo_type == 1) {
	$content .= '<td>168 x 112px</td>';
	}
	if ($promo_type == 2) {
	$content .= '<td>369 x 246px</td>';
	}	
	if ($promo_type == 3) {
	$content .= '<td>940 x 319px</td>';
	}		
	if ($promo_type == 4) {
	$content .= '<td>longer as you can x 430px</td>';
	}			
	$content .= '</tr>';
	$content .= '<tr>';	
	$content .= '<td>Picture 2</td>';
	$content .= '<td><input';
	if ($promo_type == 2 || $promo_type == 3 || $promo_type ==  4) {
	$content .= ' disabled';
	}
	$content .= ' type=file name=promopicture2></td>';
	if ($promo_type == 1) {
	$content .= '<td>229 x 153px</td>';
	}
	$content .= '</tr>';
	$content .= '<tr>';	
	$content .= '<td>Order</td>';
	$content .= '<td><input type=text name=promoorder size=2></td>';
	$content .= '</tr>';	
	$content .= '</table>';
	$content .= '<input type=submit value="add promo">';
	$content .= '</form>';
	echo $content;
}

function update_pictures_sizes() {
	global $_POST;

$new_contents = '<?php
$gallery_picture_width = '.$_POST['gallery_picture_width'].';
$gallery_picture_height = '.$_POST['gallery_picture_height'].';
$gallery_thumbnail_width = '.$_POST['gallery_thumbnail_width'].';
$gallery_thumbnail_height = '.$_POST['gallery_thumbnail_height'].';
$gallery_picture_width_out = $gallery_picture_width+60;
$gallery_picture_width_bottom = $gallery_picture_width+27;
$gallery_thumbnail_height_ie7 = $gallery_thumbnail_height+19;

$homepage_picture_width = '.$_POST['homepage_picture_width'].';
$homepage_picture_height = '.$_POST['homepage_picture_height'].';
$homepage_box_width = $homepage_picture_width+20;

?>';
	
	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/styles/config_sizes.php');
		
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);	
	
}

function Unique_pictures_config() {
	
	if ($_POST['updatesizes'] == 1) {
		update_pictures_sizes();
	} 
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/styles/config_sizes.php'));
	
	$content .= '<br/><br/><div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Post gallery size</div><br/>';
	$content .= '<form name=promotypeform method=POST action="admin.php?page=UPI">';
	$content .= '<input type=hidden name=updatesizes value=1>';	
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';	
	$content .= '<td colspan=4>This applies just to post galleries not to listing thumbnails</td>';	
	$content .= '</tr>';		
	$content .= '<tr>';	
	$content .= '<td height=10></td>';	
	$content .= '</tr>';		
	$content .= '<tr>';	
	$content .= '<td width=250>Gallery big picture width</td>';	
	$content .= '<td width=70><input size=5 type="text" name="gallery_picture_width" value="'.$gallery_picture_width.'"></td>';	
	$content .= '<td>px</td>';	
	$content .= '<td rowspan=2 style="padding-left: 10px;">! after width and height will be modified, please go <a href="http://localhost/wp/wordpress/wp-admin/options-media.php">here</a> and change the setting of large size images with same values.</td>';
	$content .= '</tr>';
	$content .= '<tr>';		
	$content .= '<td>Gallery big picture height</td>';	
	$content .= '<td><input size=5 type="text" name="gallery_picture_height" value="'.$gallery_picture_height.'"></td>';	
	$content .= '<td>px</td>';	
	$content .= '</tr>';	
	$content .= '<tr>';	
	$content .= '<td height=10></td>';	
	$content .= '</tr>';		
	$content .= '<tr>';		
	$content .= '<td>Gallery thumbnail width</td>';	
	$content .= '<td><input size=5 type="text" name="gallery_thumbnail_width" value="'.$gallery_thumbnail_width.'"></td>';	
	$content .= '<td>px</td>';	
	$content .= '</tr>';
	$content .= '<tr>';		
	$content .= '<td>Gallery thumbnail height</td>';	
	$content .= '<td><input size=5 type="text" name="gallery_thumbnail_height" value="'.$gallery_thumbnail_height.'"></td>';	
	$content .= '<td>px</td>';	
	$content .= '</tr>';			
	$content .= '</table>';
	
	$content .= '<br/><br/><div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Homepage thumbnails size</div><br/>';
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';	
	$content .= '<td colspan=3>This applies to homepage articles thumbnails</td>';	
	$content .= '</tr>';		
	$content .= '<tr>';	
	$content .= '<td height=10></td>';	
	$content .= '</tr>';		
	$content .= '<tr>';	
	$content .= '<td width=250>Homepage picture width</td>';	
	$content .= '<td width=70><input size=5 type="text" name="homepage_picture_width" value="'.$homepage_picture_width.'"></td>';	
	$content .= '<td>px - ! for showing 2 articles on homepage set it up to <b>440px</b> | for 3 <b>282px</b> | for 4 <b>200px</b></td>';	
	$content .= '</tr>';
	$content .= '<tr>';		
	$content .= '<td>Homepage picture height</td>';	
	$content .= '<td><input size=5 type="text" name="homepage_picture_height" value="'.$homepage_picture_height.'"></td>';	
	$content .= '<td>px</td>';	
	$content .= '</tr>';	
	$content .= '</table>';	
	$content .= '<br/><input type=submit value="update">';	
	$content .= '</form>';	
	echo $content;
	
}

function update_header_background() {
	global $_POST;
	
	$new_contents = '<?php
$headerbar_color = \''.$_POST['headerbarcolor'].'\';
?>
';

	$abs_xml_url = get_absolute_url(get_bloginfo('stylesheet_directory').'/styles/config_headercolors.php');
		
	$handle = fopen($abs_xml_url, "w");
	//ftruncate($handle, rand(1, filesize($abs_xml_url)));
	fwrite($handle, $new_contents);
	fclose($handle);	

}

function Unique_settings_config() {
	
	if ($_POST['updatebackground'] == 1) {
		update_header_background();
	}
	
	include(get_absolute_url(get_bloginfo('stylesheet_directory').'/styles/config_headercolors.php'));
	
	$content .= '<br/><br/><div style="font-size: 13px; font-weight: bold; padding: 5px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: #CCCCCC; background-color: #FFFFFF;">Header and footer background</div><br/>';
	$content .= '<form name=backgroundform method=POST action="admin.php?page=USE">';
	$content .= '<input type=hidden name=updatebackground value=1>';	
	$content .= '<table border=0 cellspacing=0 cellpadding=0>';
	$content .= '<tr>';	
	$content .= '<td colspan=4>Here you can change header and footer bakground</td>';	
	$content .= '</tr>';		
	$content .= '<tr>';	
	$content .= '<td height=10></td>';	
	$content .= '</tr>';			
	$content .= '<tr>';	
	$content .= '<td>Select background color</td>';	
	$content .= '<td>';
	$content .= '<select name="headerbarcolor">';
	$content .= '<option value="darkgrey" '; if ($headerbar_color == 'darkgrey') { $content .= 'selected'; } $content .= '>Dark grey</option>';
	$content .= '<option value="grey" '; if ($headerbar_color == 'grey') { $content .= 'selected'; } $content .= '>Light grey</option>';
	$content .= '<option value="black" '; if ($headerbar_color == 'black') { $content .= 'selected'; } $content .= '>Black</option>';
	$content .= '<option value="white" '; if ($headerbar_color == 'white') { $content .= 'selected'; } $content .= '>White</option>';
	$content .= '<option value="red" '; if ($headerbar_color == 'red') { $content .= 'selected'; } $content .= '>Red</option>';
	$content .= '<option value="blue" '; if ($headerbar_color == 'blue') { $content .= 'selected'; } $content .= '>Blue</option>';
	$content .= '<option value="green" '; if ($headerbar_color == 'green') { $content .= 'selected'; } $content .= '>Green</option>';
	$content .= '<option value="yellow" '; if ($headerbar_color == 'yellow') { $content .= 'selected'; } $content .= '>Yellow</option>';
	$content .= '</select>';
	$content .= '</td>';
	$content .= '<td><input type=submit value="update"></td>';
	$content .= '</tr>';			
	
	$content .= '</table>';		
	$content .= '</form>';	
	
	
	
	
	$content .= '</table>';		
	$content .= '</form>';			
	
	echo $content;
	
}



?>