<?php
/*-----------------------------------------------------------------------------------*/
/*	Create a set of arrays for each option
/*-----------------------------------------------------------------------------------*/

global $shortname, $max_galleries;

$max_meta_boxes = array(

	"itemtype" => array(
		"name" => $shortname."_photo_item_type",
		"type" => "select",
		"options" => array('Lightbox', 'Project Page', 'External Link'),
		"std" => "Lightbox",
		"title" => "Open in Lightbox or on a Project Page?"),

	"lightbox_type" => array(
		"name" => $shortname."_photo_lightbox_type",
		"type" => "select",
		"options" => array('Photo', 'YouTube-Video', 'Vimeo-Video'),
		"std" => "Lightbox",
		"title" => "Type of Media you want to display in Lightbox:",
		"display" => 'none'),
	
	"cropping" => array(
	"name" => $shortname."_photo_cropping_direction",
	"type" => "select",
	"options" => array( 'c' => 'Position in the Center (default)',
						't' => 'Align top',
						'tr' => 'Align top right',
						'tl' => 'Align top left',
						'b' => 'Align bottom',
						'br' => 'Align bottom right',
						'bl' => 'Align bottom left',
						'l' => 'Align left',
						'r' => 'Align right'
					   ),	
	"std" => "c",
	"title" => __('Photo Preview Cropping Direction'),
	"display" => 'none'),	
	
	//** Youtube Url MetaBox
	"external_link" => array(
		"name" => $shortname."_photo_external_link",
		"type" => "input",
		"std" => "",
		"title" => __('Link to an external URL (remember http://)'),
		"display" => 'none',
		"size" => '100'),
		
	
	//** Youtube Url MetaBox
	"youtubeurl" => array(
		"name" => $shortname."_photo_video_youtube",
		"type" => "input",
		"std" => "",
		"title" => __('YouTube URL to show in Lightbox'),
		"display" => 'none',
		"size" => '100'),
	
	//** Vimeo Url MetaBox
	"vimeourl" => array(
		"name" => $shortname."_photo_video_vimeo",
		"type" => "input",
		"std" => "",
		"title" => __('Vimeo URL to show in Lightbox'),
		"display" => 'none',
		"size" => '100'),
	
	//** Fullsize Background URL for Photo posts
	"fullsizerandom" => array(
		"name" => $shortname."_show_random_fullsize",
		"type" => "checkbox",
		"std" => "",
		"title" => __('Random Fullsize Background Image from the current gallery.')),
	
	//** Fullsize Background URL for Photo posts
	"fullsizeurl" => array(
		"name" => $shortname."_show_page_fullsize_url",
		"type" => "input",
		"std" => "",
		"title" => __('URL for Fullsize Background Image'),
		"size" => '150'),	

	//** Copyright MetaBox
	"copyright" => array(
		"name" => $shortname."_photo_copyright_information",
		"type" => "input",
		"std" => "",
		"title" => __('Copyright information'),
		"size" => "50"),

	//** Copyright MetaBox
	"copyright_link" => array(
		"name" => $shortname."_photo_copyright_link",
		"type" => "input",
		"std" => "",
		"title" => __('Copyright Link (remember http://)'),
		"size" => "50"),


	//** Location MetaBox
	"location" => array(
		"name" => $shortname."_photo_location",
		"type" => "input",
		"std" => "",
		"title" => __('Location'),
		"size" => "50"),
	
	//** Date MetaBox
	"image_date" => array(
		"name" => $shortname."_photo_date",
		"type" => "input",
		"std" => "",
		"title" => __('Date of shot (e.g. 01/2011)'),
		"size" => "50")
	
);

/*-----------------------------------------------------------------------------------*/
/*	Function creates a meta box for each type (input, select, textarea etc)
/*-----------------------------------------------------------------------------------*/

function max_add_meta_boxes() {
global $post, $max_meta_boxes;
	
	$output = "<div style=\"padding: 0 15px\"><h2>Main Settings</h2>";
	
	foreach($max_meta_boxes as $index => $meta_box) {
		
		if( isset( $meta_box['display'] ) && $meta_box['display'] == "none" ){
			$display = 'style="display: none"';
		}else{
			$display = '';
		}
		
		if( $index == "copyright" ){
			$output .= "<hr /><h2>Additional Informations</h2>";
		}
		
		if( $index == "fullsizerandom" ){
			$output .= "<hr /><h2>Fullsize Background</h2>";
		}		
		
		$output .= '<div id="form_' . $meta_box['name'] .'" '.$display.'>';
		$output .= '<input type="hidden" name="'.$meta_box['name'].'_noncename" id="'.$meta_box['name'].'_noncename" value="'.wp_create_nonce( plugin_basename(__FILE__) ).'" />';
		$output .= '<h4>'.$meta_box['title'].'</h4>';
				
		switch($meta_box['type']){

			case "checkbox":
		
				$meta_box_value = get_post_meta($post->ID, $meta_box['name'].'_value', true);
		
				if($meta_box_value == "")
					$meta_box_value = $meta_box['std'];

				$checked  = $meta_box_value == "true" ? 'checked="checked"' : "";

				$output .= '<input type="checkbox" name="'.$meta_box['name'].'_value" value="true" '.$checked.' /><br />';

			break;

			case "input":
		
				$meta_box_value = get_post_meta($post->ID, $meta_box['name'].'_value', true);
		
				if($meta_box_value == "")
					$meta_box_value = $meta_box['std'];

				if($meta_box['size'] != ""){
					$size = 'size="'.$meta_box['size'].'" ';
				}else{
					$size = "";
				}				

				$output .= '<input type="text" name="'.$meta_box['name'].'_value" value="'.$meta_box_value.'" '.$size.' /><br />';

			break;
			
			case "select":
			
				$output .= '<select name="'.$meta_box['name'].'_value">';
			
				foreach ($meta_box['options'] as $option) {

					$output .= '<option';
					if ( get_post_meta($post->ID, $meta_box['name'].'_value', true) == $option ) { 
						$output .= ' selected="selected"'; 
					} elseif ( !$option ) { 
						$output .= ' selected="selected"'; 
					} 
					$output .= '>'. $option .'</option>';
				} 
			
				$output .= '</select>';
			
			break;			
		}
		if( !isset( $meta_box['description'] ) ) {
			$meta_box['description'] = '';
		}
		
		$output .= '<p><label for="'.$meta_box['name'].'_value">'.$meta_box['description'].'</label></p>';
		$output .= '</div>';
	}
	
	$output .= "</div>";
	
	echo $output;
}

/*-----------------------------------------------------------------------------------*/
/*	Add the Meta Fields on Gallery Page
/*-----------------------------------------------------------------------------------*/

function max_create_meta_box() {
	global $theme_name, $max_meta_boxes;
	if (function_exists('add_meta_box') ) {
		add_meta_box( 'new-meta-boxes', __('Image Detail Settings'), 'max_add_meta_boxes', 'gallery', 'normal', 'high' );
	}
}

/*-----------------------------------------------------------------------------------*/
/*	Save the custom fields on post update
/*-----------------------------------------------------------------------------------*/

function max_save_postdata( $post_id ) {
	global $post, $max_meta_boxes;  
	
	foreach($max_meta_boxes as $meta_box) {  

		if ( !wp_verify_nonce( $_POST[$meta_box['name'].'_noncename'], plugin_basename(__FILE__) )) {  
			return $post_id;  
		}  
		
		if ( 'page' == $_POST['post_type'] ) {  
			if ( !current_user_can( 'edit_page', $post_id ))
				return $post_id;
		} else {  
			if ( !current_user_can( 'edit_post', $post_id ))
				return $post_id;
		}  
		
		$data = $_POST[$meta_box['name'].'_value'];
		
		if(get_post_meta($post_id, $meta_box['name'].'_value') == "")
			add_post_meta($post_id, $meta_box['name'].'_value', $data, true);
			
		elseif($data != get_post_meta($post_id, $meta_box['name'].'_value', true))
			update_post_meta($post_id, $meta_box['name'].'_value', $data);
			
		elseif($data == "")  
			delete_post_meta($post_id, $meta_box['name'].'_value', get_post_meta($post_id, $meta_box['name'].'_value', true));  
			
	}
	
}
add_action('save_post', 'max_save_postdata');
add_action('admin_menu', 'max_create_meta_box');

/*-----------------------------------------------------------------------------------*/
/*	Add the Gallery Select Option on Page edit
/*-----------------------------------------------------------------------------------*/

add_action('save_post', 'max_save_pagedata');
add_action('add_meta_boxes', 'max_add_select_gallery_box');

function max_add_select_gallery_box () {
	add_meta_box('max_select_gallery', __('Gallery Options'), 'max_select_gallery_meta_box', 'page', 'normal', 'high');
}

function max_select_gallery_meta_box () {

	global $order_array;

	wp_nonce_field( plugin_basename(__FILE__), 'myplugin_noncename' );
	
	$custom_fields = get_post_custom_values('_wp_page_template', $_GET['post']);
	$p_tpl = $custom_fields[0];

	if (
		$p_tpl == "template-one-column.php" || 
		$p_tpl == "template-two-column.php" || 
		$p_tpl == "template-three-column.php" || 
		$p_tpl == "template-four-column.php" || 
		$p_tpl == "template-scroller.php" ||
		$p_tpl == "template-fullsize-gallery.php" ||
		$p_tpl == "template-grid-fullsize.php") {

	echo '<h2>'.__('Choose the Gallery, you want to display on your created Page:').'</h2>';

	$check_gal = get_post_meta($_GET['post'], 'max_select_gallery', true);
	$check_info = get_post_meta($_GET['post'], 'max_show_gallery_info', true);
		
	?>
	<p>
		<label for="max_select_gallery"><?php _e('Available Galleries') ?>:</label>
		<select name="max_select_gallery"> 
			<option value=""><?php _e('Select a gallery...') ?></option> 
			<?php 
			$taxonomies =  get_categories('taxonomy='.GALLERY_TAXONOMY); 
			
			foreach ($taxonomies as $tax) {
				$option = '<option value="' . $tax->category_nicename . '"';
				
				if ($tax->category_nicename == $check_gal) $option .= "selected"; // check selected
				
				$option .= ">". $tax->cat_name . "</option>";
				echo $option;
			}
			?>
		</select>
	</p>
		
	<?php 
	// Only show if template ist not a scroller template 
	if( $p_tpl != "template-grid-fullsize.php" && $p_tpl != "template-scroller.php" && $p_tpl != "template-fullsize-gallery.php" ) { 
	?>
	
	<p>
		<?php $checked = ($check_info == 'true') ? 'checked="checked"' : ""; ?>
		<input type="checkbox" name="max_show_gallery_info" value="true" <?php echo $checked ?> />
		<label for="max_show_gallery_info"><?php _e('Show additional informations like copyright and location for this gallery') ?>:</label>		
	</p>
	
	<?php }else{ ?>
	<p><strong>Info:</strong> Additional information fields (e.g. copyright etc) are disabled for this page template.</p>		
	<?php } ?>

	<?php

	} else if ( $p_tpl == "template-flickr.php") { 
	
	?>
	<div style="padding: 0 15px">
		<p>
			<h4><?php _e('Enter the Username for your Flickr Stream') ?> <small>(<a href="http://idgettr.com/" target="_blank">idgettr</a></small>):</h4>
			<input type="text" name="max_portfolio_flickr_user" value="<?php echo get_post_meta($_GET['post'], 'max_portfolio_flickr_user', true); ?>" size="50" />
			<h4><?php _e('Enter the number of Images you want to show') ?>:</h4>
			<input type="text" name="max_portfolio_flickr_count" value="<?php echo get_post_meta($_GET['post'], 'max_portfolio_flickr_count', true); ?>" size="10" />
		</p>
	</div>
	<?php

	//Check if template is a sortable template
	} else if ( $p_tpl == "template-sortable.php") { 
	?>
	<div style="padding: 0 8px">
		<h2><?php echo __('Choose the the Galleries, you want to display on your sortable Gallery:') ?></h2>
		<h4><?php _e('Available Galleries') ?>:</h4>
	</div>
	<p>			
	<?php
	$check_gal_array = get_post_meta($_GET['post'], 'max_sortable_galleries', true);
	$taxonomies =  get_categories('taxonomy='.GALLERY_TAXONOMY); 			
	foreach ($taxonomies as $tax) {
		$option = '<input type="checkbox" name="max_sortable_galleries['.$tax->category_nicename.']" value="' . $tax->term_id . '"';

		if( @in_array($tax->term_id, $check_gal_array ) ){
			$option .= ' checked="checked"';
		}

		$option .= " /> ". $tax->cat_name. "<br />";
		echo $option;
	}
	?>
	</p>
	<?php	

	} else {
		echo '<p><em>' . __('You have to choose one of the Portfolio Templates (except Sortable Portfolio Template) on the right Panel and Publish your Page to select a Gallery.') . '</em></p>';

	}	
	
	$check_fullsize = get_post_meta($_GET['post'], 'max_show_page_fullsize', true);
	
	if( $p_tpl != "template-fullsize-gallery.php" ) {
	?>
	<p>
		<?php $checked = ($check_fullsize == 'true') ? 'checked="checked"' : ""; ?>
		<input type="checkbox" name="max_show_page_fullsize" value="true" <?php echo $checked ?> />
		<label for="max_show_page_fullsize"><?php _e('Show a Fullsize Background Image for this gallery page') ?>:</label>
	</p>
	<p>
		<label for="max_show_page_fullsize_url"><?php _e('URL for Fullsize Background Image') ?>:</label><br />
		<input type="text" name="max_show_page_fullsize_url" value="<?php echo get_post_meta($_GET['post'], 'max_show_page_fullsize_url', true); ?>" size="120" /><br />
		<small>(leave blank to show a random image from homepage fullsize featured galleries)</small>
	</p>	
	<?php
	};
	
	// Gallery Photo order
	if( $p_tpl != "template-flickr.php" && $p_tpl != "template-sortable.php") { 
		
		// get value
		$check_order = get_post_meta($_GET['post'], 'max_gallery_order', true);
	?>	
	<p>
		<label for="max_gallery_order"><?php _e('Select photo order') ?>:</label>
		<select name="max_gallery_order"> 
			<?php 
			
			foreach ($order_array as $index => $value) {
				$option = '<option value="' . $index . '"';
				
				if ($index == $check_order) $option .= "selected"; // check selected
				
				$option .= ">". $value . "</option>";
				echo $option;
			}
			?>
		</select>
		<select name="max_gallery_sort"> 
			<?php
			
			$check_sort = get_post_meta($_GET['post'], 'max_gallery_sort', true); 
			?>
			<option value="DESC" <? if ($check_sort == "DESC") echo "selected"; // check selected ?>>Descending</option>
			<option value="ASC" <? if ($check_sort == "ASC") echo "selected"; // check selected ?>>Ascending</option>
		</select>		
	</p>	
	<?php 
	}
}

/*-----------------------------------------------------------------------------------*/
/*	Save the Gallery Select on Page update
/*-----------------------------------------------------------------------------------*/

function max_save_pagedata($post_id) {

 if ( !wp_verify_nonce( $_POST['myplugin_noncename'], plugin_basename(__FILE__) )) {
    return $post_id;
  }

  if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
    return $post_id;

  if ( 'page' == $_POST['post_type'] ) {
    if ( !current_user_can( 'edit_page', $post_id ) )
      return $post_id;
  } else {
    if ( !current_user_can( 'edit_post', $post_id ) )
      return $post_id;
  }
    
  update_post_meta($post_id, 'max_select_gallery', $_POST['max_select_gallery']);
  update_post_meta($post_id, 'max_scroller_count', $_POST['max_scroller_count']);	
  update_post_meta($post_id, 'max_show_gallery_info', $_POST['max_show_gallery_info']);	
  update_post_meta($post_id, 'max_portfolio_flickr_count', $_POST['max_portfolio_flickr_count']);	
  update_post_meta($post_id, 'max_portfolio_flickr_user', $_POST['max_portfolio_flickr_user']);
  update_post_meta($post_id, 'max_show_page_fullsize_url', $_POST['max_show_page_fullsize_url']);
  update_post_meta($post_id, 'max_show_page_fullsize', $_POST['max_show_page_fullsize']);  
  update_post_meta($post_id, 'max_sortable_galleries', $_POST['max_sortable_galleries']);  
  update_post_meta($post_id, 'max_gallery_order', $_POST['max_gallery_order']);
  update_post_meta($post_id, 'max_gallery_sort', $_POST['max_gallery_sort']);  
}

/*-----------------------------------------------------------------------------------*/
/*	Add the Gallery Select Option on Page edit
/*-----------------------------------------------------------------------------------*/

add_action('save_post', 'max_save_blogdata');
add_action('add_meta_boxes', 'max_add_blog_post_background');

function max_add_blog_post_background() {
	add_meta_box('max_blog_post_background', __('Background Options'), 'max_blog_post_background', 'post', 'normal', 'high');
}

function max_blog_post_background() {

	wp_nonce_field( plugin_basename(__FILE__), 'myplugin_noncename' );
	
	$check_fullsize = get_post_meta($_GET['post'], 'max_show_page_fullsize', true);
	
	?>
	<p>
		<?php $checked = ($check_fullsize == 'true') ? 'checked="checked"' : ""; ?>
		<input type="checkbox" name="max_show_page_fullsize" value="true" <?php echo $checked ?> />
		<label for="max_show_page_fullsize"><?php _e('Show a Fullsize Background Image for this gallery page') ?>:</label>
	</p>
	<p>
		<label for="max_show_page_fullsize_url"><?php _e('URL for Fullsize Background Image') ?>:</label><br />
		<input type="text" name="max_show_page_fullsize_url" value="<?php echo get_post_meta($_GET['post'], 'max_show_page_fullsize_url', true); ?>" size="120" /><br />
		<small>(leave blank to show a random image from homepage fullsize featured galleries)</small>
	</p>	
	<?php
}

/*-----------------------------------------------------------------------------------*/
/*	Save the Gallery Select on Page update
/*-----------------------------------------------------------------------------------*/

function max_save_blogdata($post_id) {

 if ( !wp_verify_nonce( $_POST['myplugin_noncename'], plugin_basename(__FILE__) )) {
    return $post_id;
  }

  if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
    return $post_id;

  if ( 'page' == $_POST['post_type'] ) {
    if ( !current_user_can( 'edit_page', $post_id ) )
      return $post_id;
  } else {
    if ( !current_user_can( 'edit_post', $post_id ) )
      return $post_id;
  }
    
  update_post_meta($post_id, 'max_show_page_fullsize_url', $_POST['max_show_page_fullsize_url']);
  update_post_meta($post_id, 'max_show_page_fullsize', $_POST['max_show_page_fullsize']);  

}


?>