<?php
/* Option related functions

/*-----------------------------------------------------------------------------------*/
/*	Get your custom logo
/*-----------------------------------------------------------------------------------*/

function max_get_custom_logo() {
	
	
	if( get_option_max('custom_logo_value') != '' || get_option_max('custom_footer_logo_value') != '' ) {
		$output = "	<style type=\"text/css\">\n";

		if(get_option_max('custom_logo_value') != '') {
			$output .= "#site-title a { background-image: url(". get_option_max('custom_logo_value') .") !important; }\n";
		}
	
		/* Disabled for this theme
		if(get_option_max('custom_footer_logo_value') != '') {
			$output .= "#colophon a.logo { background-image: url(". get_option_max('custom_footer_logo_value') .") !important; }\n";
		}
		*/
		
		$output .= "</style>\n";
	
		echo $output;
		
	}
	
}
add_action('wp_head', 'max_get_custom_logo');

/*-----------------------------------------------------------------------------------*/
/* Add the FavIcon to the Page
/*-----------------------------------------------------------------------------------*/

function max_get_favicon() {
	
	global $shortname;

	if ( get_option_max('custom_favicon_value') != '') {
		$output = '<link rel="shortcut icon" href="'. get_option_max('custom_favicon_value') .'"/>';
	}else { 
		$output = '<link rel="shortcut icon" href="'. get_template_directory_uri() .'/favicon.png" />';
	}
	
	echo $output;
}

add_action('wp_head', 'max_get_favicon');


/*-----------------------------------------------------------------------------------*/
/* Get JS for the Homepage
/*-----------------------------------------------------------------------------------*/

function max_get_prettyPhoto_js() {
	
	?>
		
	<script type="text/javascript">

		jQuery(document).ready(function($) {
					
			if($().prettyPhoto) { // only load prettyPhoto if script file is included
			
				$("a[rel^='prettyPhoto'], .gallery-icon a[href$='.jpg'], .gallery-icon a[href$='.png'], .gallery-icon a[href$='.gif']").livequery(function(){
					$("a[rel^='prettyPhoto'], .gallery-icon a[href$='.jpg'], .gallery-icon a[href$='.png'], .gallery-icon a[href$='.gif']").prettyPhoto({
						animationSpeed: '<?php get_option_max('pretty_speed',true) ?>',
						slideshow: <?php get_option_max('pretty_interval',true) ?>,
						theme: '<?php get_option_max('pretty_theme',true) ?>',
						show_title: <?php if( get_option_max('pretty_title_show') == "true" ) { echo "true"; } else { echo "false"; } ?>,
						overlay_gallery: <?php if(get_option_max('pretty_gallery_show') == 'true') { echo 'true'; }else{ echo 'false'; }?>						
					})
				});					
				
			}	
			
		});
	
	</script>
		
	<?php
	
}

add_action('wp_head', 'max_get_prettyPhoto_js');


/*-----------------------------------------------------------------------------------*/
/* Output Custom CSS from theme options
/*-----------------------------------------------------------------------------------*/

function max_custom_css() {

		global $shortname;

		$output = '';
		
		$css = get_option_max('custom_css');
		
		if ($css <> '') {
			$output .= $css . "\n";
		}
		
		// Output styles
		if ($output <> '') {
			$output = "<!-- Custom Styling -->\n<style type=\"text/css\">\n" . $output . "</style>\n";
			echo $output;
		}
	
}

add_action('wp_head', 'max_custom_css');


?>