<?php

/**
 * Register widgetized area
 */
 if ( ! function_exists( 'max_widgets_init' ) ):
function max_widgets_init() {
	
	register_sidebar( array (
		'name' => __( 'Blog Sidebar'),
		'id' => 'sidebar-blog',
		'description' => __( 'Blog Sidebar Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );
	
	register_sidebar( array (
		'name' => __( 'Homepage Sidebar'),
		'id' => 'sidebar-homepage',
		'description' => __( 'Homepage Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );	
	
	register_sidebar( array (
		'name' => __( 'Blog Post Sidebar'),
		'id' => 'sidebar-blog-post',
		'description' => __( 'Blog Post Sidebar Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );	

	register_sidebar( array (
		'name' => __( 'Gallery Project Page Sidebar'),
		'id' => 'sidebar-gallery-project',
		'description' => __( 'Gallery Project Page Template Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );

	register_sidebar( array (
		'name' => __( 'Gallery Sortable Sidebar'),
		'id' => 'sidebar-gallery-sortable',
		'description' => __( 'Gallery Sortable Template Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );
	
	register_sidebar( array (
		'name' => __( 'Gallery 4 Column Sidebar'),
		'id' => 'sidebar-gallery-four',
		'description' => __( 'Gallery 4 Column Template Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );

	register_sidebar( array (
		'name' => __( 'Gallery 3 Column Sidebar'),
		'id' => 'sidebar-gallery-three',
		'description' => __( 'Gallery 3 Column Template Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );	

	register_sidebar( array (
		'name' => __( 'Gallery 2 Column Sidebar'),
		'id' => 'sidebar-gallery-two',
		'description' => __( 'Gallery 2 Column Template Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );	

	register_sidebar( array (
		'name' => __( 'Gallery 1 Column Sidebar'),
		'id' => 'sidebar-gallery-one',
		'description' => __( 'Gallery 1 Column Template Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );

	register_sidebar( array (
		'name' => __( 'Tag Sidebar'),
		'id' => 'sidebar-tag',
		'description' => __( 'Tag Template Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );

	register_sidebar( array (
		'name' => __( 'Gallery Flickr Sidebar'),
		'id' => 'sidebar-gallery-flickr',
		'description' => __( 'Gallery Flickr Template Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );

	register_sidebar( array (
		'name' => __( 'Gallery Taxonomy Sidebar'),
		'id' => 'sidebar-gallery-taxonomy',
		'description' => __( 'Gallery Taxonomy Template Widget Area'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );

	register_sidebar( array (
		'name' => __( 'Sidebar left Template Sidebar'),
		'id' => 'sidebar-main',
		'description' => __( 'Sidebar for Custom Template with left sidebar'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );

	register_sidebar( array (
		'name' => __( 'Sidebar Search Result'),
		'id' => 'sidebar-search-result',
		'description' => __( 'Sidebar for Search results with left sidebar'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );


	register_sidebar( array (
		'name' => __( 'Sidebar Archive'),
		'id' => 'sidebar-archive-result',
		'description' => __( 'Sidebar for Archive with left sidebar'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );

	register_sidebar( array (
		'name' => __( 'Sidebar Contact'),
		'id' => 'sidebar-contact',
		'description' => __( 'Sidebar for Contact page with left sidebar'),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => "</aside>",
		'before_title' => '<h1 class="widget-title">',
		'after_title' => '</h1>',
	) );

}
/** Register sidebars by running max_widgets_init() on the widgets_init hook. */
add_action( 'widgets_init', 'max_widgets_init' );
endif;


/*-----------------------------------------------------------------------------------*/
/*	Load Widgets 
/*-----------------------------------------------------------------------------------*/

// Add the Terms Custom Widget
include($fw_path."/widgets/widget-terms.php");
// Add the Recent Photos Widget
include($fw_path."/widgets/widget-recent-photos.php");
// Add the Recent Tweets Widget
include($fw_path."/widgets/widget-twitter.php");
// Add the Flickr Stream Widget
include($fw_path."/widgets/widget-flickr.php");
// Add the Custom Video Widget
include($fw_path."/widgets/widget-video.php");
// Add the Custom Welcome Teaser Widget
include($fw_path."/widgets/widget-teaser.php");

?>