<?php 

/*-----------------------------------------------------------------------------------*/
/*	Custom get_option function with echo function
/*-----------------------------------------------------------------------------------*/

function get_option_max($id, $echo = false){
	global $shortname;
	$option = get_option($shortname."_$id");
  
  	// if echo is set true
	if ($echo)
    	echo $option;
  
	return $option;	
}

/*-----------------------------------------------------------------------------------*/
/*	Get Admin Options Scripts and CSS
/*-----------------------------------------------------------------------------------*/

function max_admin_add_init() {
	
	if( is_admin() && ( $_REQUEST['page'] == 'functions.php' || $_REQUEST['action'] == 'edit' || isset($_REQUEST['post']) ) ){	
		global $fw_dir;
		wp_enqueue_style('functions', $fw_dir."admin/css/admin.css", false, "1.0", "all");
		wp_enqueue_style('checkbox', $fw_dir."admin/css/checkbox.css", false, "1.0", "all");
		
		wp_enqueue_script('jquery', "http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js");
		wp_enqueue_script('jquery-ui',"http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.2/jquery-ui.min.js");
		
		wp_enqueue_script('jquery-color-picker', $fw_dir.'admin/js/colorpicker.js', array('jquery'), '1.0' );
		wp_enqueue_script('jquery-checkbox', $fw_dir.'admin/js/jquery.iphone.checkbox.js', array('jquery'), '1.0' );
		wp_enqueue_script('max_script', $fw_dir.'admin/js/scripts.js', array('media-upload'), '1.0' );
	}
	
}

/*-----------------------------------------------------------------------------------*/
/* Add default options after activation */
/*-----------------------------------------------------------------------------------*/
if ( is_admin() && isset($_GET['activated'] ) ) {
	//Call action that sets
	add_action('admin_init','max_option_setup');
}

function max_option_setup(){

	global $shortname, $fw_dir;

	//Update EMPTY options
	$max_array = array();
	add_option('max_options',$max_array);

	$template = get_option('max_template');
	$saved_options = get_option('max_options');
	
	foreach($template as $option) {
		if($option['type'] != 'section'){
			$id = $option['id'];
			$std = $option['std'];
			$db_option = get_option($id);
			if(empty($db_option)){
				if(is_array($option['type'])) {
					foreach($option['type'] as $child){
						$c_id = $child['id'];
						$c_std = $child['std'];
						update_option($c_id,$c_std);
						$max_array[$c_id] = $c_std; 
					}
				} else {
					update_option($id,$std);
					$max_array[$id] = $std;
				}
			}
			else { //So just store the old values over again.
				$max_array[$id] = $db_option;
			}
		}
	}
	update_option('max_options',$max_array);
}


/*-----------------------------------------------------------------------------------*/
/*	Create the Admin options
/*-----------------------------------------------------------------------------------*/

function max_theme_admin() {

	global $shortname, $fw_dir;

    $options =  get_option('max_template');      
    $themename =  get_option('max_themename');
	
	$i=0;
	?>

	<div id="maxFrame-admin" class="wrap">
	
		<div id="header">
			<div class="padding">
				<h2>
					<img src="<?php echo $fw_dir ?>admin/images/icons/theme_settings.png" /> Theme Options<br />
					<span>This is the Options Panel for your Theme. You can customise your Theme-Settings here.</span>
				</h2>
			</div>
		</div>

		<div id="content_wrap" class="clearfix">
			<form method="post" enctype="multipart/form-data" >			
				<?php
				// Form results
				if ( isset( $_REQUEST['saved'] ) ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
				if ( isset( $_REQUEST['reset'] ) ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
				?>		
			
				<div class="info top-info">      	
			        <input type="submit" name="save" class="button-primary  save-options" value="Save All Changes">        
	  			</div>	
				<div id="content" class="clearfix">
					<div id="options_tabs" class="ui-tabs">
						<ul class="options_tabs ui-tabs-nav">
							<?php foreach ($options as $value) {
								switch ( $value['type'] ) {
									case "section":					
										$i++;					
									?>		
									<li class="ui-state-default ui-corner-top">
										<a href="#option_<?php echo $value['id']; ?>">
											<?php if ($value['icon']){ ?>
											<img src="<?php echo $fw_dir ?>admin/images/icons/<?php echo $value['icon'] ?>" />											
											<?php } ?>
											<?php echo $value['name']; ?><span></span>
										</a>
									</li>
									<?php break;
								}
							}?>
						</ul>
		
						<?php foreach ($options as $value) {
							switch ( $value['type'] ) {
								
								// --> open the option section
								case "open":
								?>
								
								<?php break;
								
								// --> create a subheadline
								case "subhead":
								?>
									
								<div class="max-sub-header">
									<h2>
										<img src="<?php echo $fw_dir ?>admin/images/icons/cog.png" />													
										<?php echo $value['name']; ?>
									</h2>
								</div>
								
								<?php break;								
								
			
								// --> close the option section
								case "close":
								?>
	
									</div>
							
								<?php break;

								case 'slider':
								
								?>
								
								<div class="max-option max-input">
									<h3><?php echo $value['name']; ?></h3>
									<div class="section">
										<div class="element">
										<?php 								
	
											$std =  $value['std'];
											$option_key = $value['id'];
											$saved = get_option( $option_key );
											if(!$saved){
												$saved = $std;
											}
											
											$show = $saved;
											
											if(is_array($show)) $show = implode('-',$show);
											?>
											<div class="clearfix slide-holder">
												<div id="<?php echo $value['id'] ?>_slider" class="ui-slider"></div>
												<input type="text" id="<?php echo $value['id'] ?>_handle" class="slide-value" value="<?php echo $show ?>">
											</div>
											<input type="hidden" name="<?php echo $value['id'] ?>" id="<?php echo $value['id'] ?>" value="<?php echo $show ?>" />
											<script type="text/javascript">jQuery("#<?php echo $value['id'] ?>_slider").slider({
											<?php 
											if(!is_array($saved)) {
												echo 'value: '.$saved.',';
												echo 'range: "min",';
											} else {
												echo 'range: true,';
												echo 'values: ['.implode(',',$saved).'],';
											}
											echo 'step:' .$value['step'].',';
											echo 'max: '.$value['max'].',';
											echo 'min: '.$value['min'].',';
											if(!is_array($saved)) {
												echo 'slide: function(e,ui) { jQuery("#'.$value['id'].'_handle").val(ui.value); jQuery("#'.$value['id'].'").val(ui.value); },';
											} else {
												echo 'slide: function(e,ui) { jQuery("#'.$value['id'].'_handle").val(ui.values[0]+"-"+ui.values[1]); jQuery("#'.$value['id'].'").val(ui.values[0]+"-"+ui.values[1]); },';
											}
											
										?>
										});
										
										jQuery( "#<?php echo $value['id'] ?>_handle" ).change(function() {																								   
											if( jQuery(this).val() > <?php echo $value['max'] ?> ){
												var val = <?php echo $value['max'] ?>;
												jQuery(this).val( val )
											}else{
												var val = jQuery(this).val();
											}																								   
											jQuery("#<?php echo $value['id'] ?>_slider").slider( "value", val );
										});
										
										</script>
										</div>
										<a href="#" class="info-icon">Description</a>
										<div class="description"><div class="inner"><?php echo htmlspecialchars_decode( $value['desc'] ); ?></div></div>
									</div>
								</div>
								
								<?php
								break;

								// --> Create a text input
								case 'text':
								?>
							
								<div class="max-option max-input">
									<h3><?php echo $value['name']; ?></h3>
									<div class="section">
										<div class="element"><input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_option( $value['id'] ) != "") { echo stripslashes(get_option( $value['id'])  ); } else { echo $value['std']; } ?>" size="<?php echo $value['size']; ?>" /></div>
										<a href="#" class="info-icon">Description</a>
										<div class="description"><div class="inner"><?php echo $value['desc']; ?></div></div>
									</div>
								 </div>
								 
								<?php
								break;
								
								// --> Create a textarea input
								case 'textarea':
								?>
								
								<div class="max-option max_textarea">
									<h3><?php echo $value['name']; ?></h3>
									<div class="section">
										<div class="element"><textarea name="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" cols="" rows="<?php echo $value['rows']; ?>"><?php if ( get_option( $value['id'] ) != "") { echo stripslashes(get_option( $value['id']) ); } else { echo $value['std']; } ?></textarea></div>
										<a href="#" class="info-icon">Description</a>
										<div class="description"><div class="inner"><?php echo htmlspecialchars_decode( $value['desc'] ); ?></div></div>
									</div>
								 </div>
								
								<?php
								break;
								
								// --> Create a select input
								case 'select':
								?>
							
								<div class="max-option max_select">
									<h3><?php echo $value['name']; ?></h3>
									<div class="section">
										<div class="element">
											<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
											<?php foreach ($value['options'] as $index => $option ) { ?>
													<option value="<?php echo $index ?>" <?php if (get_option( $value['id'] ) == $index) { echo 'selected="selected"'; } ?>><?php echo $option; ?></option><?php } ?>
											</select>
										</div>
										<a href="#" class="info-icon">Description</a>
										<div class="description"><div class="inner"><?php echo htmlspecialchars_decode( $value['desc'] ); ?></div></div>
									</div>
								</div>
								
								<?php
								break;
								
								// --> Create the font Select 
								case 'font':
								?>
							
								<div class="max-option max_font">
									<h3><?php echo $value['name']; ?></h3>
									<div class="section">
										<div class="element">
											<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
												<option value="<?php echo get_option( $value['id'] ) ?>" selected="selected"><?php echo get_option( $value['id'] ) ?></option>
												<option value="off">None (Turn off the Font)</option>
												<?php max_google_font_select() ?>
											</select>
										</div>
										<a href="#" class="info-icon">Description</a>
										<div class="description"><div class="inner"><?php echo htmlspecialchars_decode( $value['desc'] ); ?></div></div>
									</div>
								</div>								
								
								<?php 
								break;
								
								// --> Create the Colorpicker
								case "colorpicker" :								
								?>
								<div class="max-option option-colorpicker">
									<h3><?php echo htmlspecialchars_decode( $value['name'] ); ?></h3>
									<div class="section">
										<div class="clearfix element">
											<script type="text/javascript">
												jQuery(document).ready(function($) {  
													$('#colorpicker_<?php echo $value['id']; ?>').ColorPicker({
														onSubmit: function(hsb, hex, rgb) {
															$('#colorpicker_<?php echo $value['id']; ?>').val('#'+hex);
														},
														onBeforeShow: function () {
															$(this).ColorPickerSetColor(this.value);
															return false;
														},
														onChange: function (hsb, hex, rgb) {
															$('#cp_<?php echo $value['id']; ?> div').css({'backgroundColor':'#'+hex, 'backgroundImage': 'none', 'borderColor':'#'+hex});
															$('#cp_<?php echo $value['id']; ?>').next('input').attr('value', '#'+hex);
														}
									 				})	
													.bind('keyup', function(){
														$(this).ColorPickerSetColor(this.value);
													});
													
													$('#cp_<?php echo $value['id']; ?>').next('input').change(function(){
													   $('#cp_<?php echo $value['id']; ?> div').css({'backgroundColor': $(this).val(), 'backgroundImage': 'none', 'borderColor': $(this).val()});
													})
													
												});
											</script>
											<div id="cp_<?php echo $value['id']; ?>" class="cp_box">
												<div class="color_display" style="background-color:<?php echo ( get_option($value['id']) != "" ? stripslashes(get_option( $value['id'])) : $value['std'] ) ?>;<?php if ( isset( $value['id'] ) ) { echo 'background-image:none;'; } ?>"></div> 
											</div>											
											<input maxlength="7" type="text" name="<?php echo $value['id']; ?>" id="colorpicker_<?php echo $value['id']; ?>" value=<?php if ( get_option( $value['id'] ) != "") { echo stripslashes(get_option( $value['id']) ); } else { echo $value['std']; } ?> class="cp_input" />
										</div>
										<a href="#" class="info-icon">Description</a>
										<div class="description"><div class="inner"><?php echo htmlspecialchars_decode( $value['desc'] ); ?></div></div>
									</div>
								</div>
								<?php
								break;
							
								// --> Create a checkbox								
								case "checkbox": 
		
								$std =  $value['std'];
								$option_key = $value['id'];
								$saved = get_option($option_key);	
								
								if(isset($saved)){
									if($saved == 'true'){
										$checked = 'checked="checked"';  
									} 
									else{
										$checked = '';     
									}    									
								}
								elseif( $std == 'true' ) {
									$checked = 'checked="checked"';
								}
								else {
									$checked = '';                                                                                    
								}								
						
								?>
								
								<div class="max-option max_checkbox max_singlecheck">
									<h3><?php echo $value['name']; ?></h3>
									<div class="section">
										<div class="element">								
										 <?php if(get_option($value['id'])){ $checked = "checked=\"checked\""; }else{ $checked = "";} ?>  
										 <input type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> />
										</div>
										<a href="#" class="info-icon">Description</a>
										<div class="description"><div class="inner"><?php echo htmlspecialchars_decode( $value['desc'] ); ?></div></div>
									</div>
								 </div>						

								<?php
								break;
								
								case "multicheck":
						
									$std =  $value['std'];         
									?>
									<div class="max-option max_checkbox max_multicheck">
										<h3><?php echo $value['name']; ?></h3>
										<div class="section">
											<div class="element">
									<?php
									
									$option_key = $value['id'];
									$saved_std = get_option($option_key);									
									
									foreach($value['options'] as $index => $option) {
										
										if(is_array($saved_std)) 
										{ 	
											  if(in_array($index, $saved_std)){
												 $checked = 'checked="checked"';  
											  } 
											  else{
												  $checked = '';     
											  }    
										} 
										elseif( $std[$i] == "true" ) {
										   $checked = 'checked="checked"';
										}
										else {
											$checked = '';                                                                                    
										}
										?>
										<input type="checkbox" class="checkbox" name="<?php echo $option_key ?>[]" id="<?php echo $option_key ?>" value="<?php echo $index ?>" <?php echo $checked ?> />&nbsp;<label><?php echo $option ?></label><br />
										<?php
										$i++;
									}
									?>
											</div>
											<a href="#" class="info-icon">Description</a>
											<div class="description"><div class="inner"><?php echo htmlspecialchars_decode( $value['desc'] ); ?></div></div>
										</div>
									 </div>
								
								<?php									
								break;
								
								case "radio":
						
									$std =  $value['std'];         
									?>
									<div class="max-option max_checkbox max_multiradio">
										<h3><?php echo $value['name']; ?></h3>
										<div class="section">
											<div class="element">
									<?php
									
									$option_key = $value['id'];
									$saved_std = get_option($option_key);									
									
									?>
									<ul>
									<?php
									foreach($value['options'] as $index => $option) {
										
										$checked = '';
											if($saved_std != '') {
												if ( $saved_std == $index ) { $checked = ' checked'; }
											} else {
												if ($value['std'] == $index) { $checked = ' checked'; }
										}
										
										?>
										<li>
										<input type="radio" class="radio overlay_pattern" name="<?php echo $option_key ?>" id="<?php echo $option_key."_".$index ?>" value="<?php echo $index ?>" <?php echo $checked ?> />
										<?php if ( $value['addtype'] != "" ){
										?>
										<img src="<?php echo $fw_dir ?>admin/images/overlay-<?php echo $index ?>.png" class="radio-overlay" width="20" height="20" />
										<?php
										}?>
										<label><?php echo $option ?></label>
										</li>
										<?php
										$i++;
									}
									?>
									</ul>
											</div>
											<a href="#" class="info-icon">Description</a>
											<div class="description"><div class="inner"><?php echo htmlspecialchars_decode( $value['desc'] ); ?></div></div>
										</div>
									 </div>
								
								<?php									
								break;								
								
								case "upload":								
								?>
																
								<div class="max-option max_upload">
									<h3><?php echo $value['name']; ?></h3>
									<div class="section">
									<div class="element">
										<?php if( $img = get_option($value['id'].'_value') ){ ?>
										
										<img id="<?php echo $value['id'] ?>_image" src='<?php echo($img) ?>' />										
										<input type="hidden" value="<?php echo($img) ?>" name="<?php echo $value['id'] ?>_value" />
											
										<?php 
										} 
										?>  
											<input type="file" id="<?php echo $value['id'] ?>_input" name="<?php echo $value['id'] ?>" size="40" />
											<?php if( $img ) { ?> <div><input type="checkbox" value="true" name="<?php echo $value['id'] ?>_delete" onclick="jQuery('#<?php echo $value['id'] ?>_image, #<?php echo $value['id'] ?>_input').toggle()" /> <span style="font-size: 10px; color: #888; ">Delete this Image</span></div> <?php } ?>
										</div>
										<a href="#" class="info-icon">Description</a>
										<div class="description"><div class="inner"><?php echo htmlspecialchars_decode( $value['desc'] ); ?></div></div>
									</div>
								</div>
								
								<?php								
								break;
								
								// --> Create a checkbox								
								case "socialinput": 
		
									$std =  $value['std'];         
									?>
									<div class="max-option max_checkbox max_multicheck max_socialinput">
										<h3><?php echo $value['name']; ?></h3>
										<div class="section">
											<div class="element">
											<ul>
									<?php
									
									$option_key = $value['id'];
									$saved_std = get_option($option_key);									
									
									foreach($value['options'] as $index => $option) {
										
										if(is_array($saved_std)) 
										{ 	
											  if(in_array($index, $saved_std)){
												 $checked = 'checked="checked"';  
											  } 
											  else{
												  $checked = '';     
											  }    
										} 
										elseif( $std[$i] == "true" ) {
										   $checked = 'checked="checked"';
										}
										else {
											$checked = '';                                                                                    
										}
										?>
										<li class="clearfix">
										<input type="checkbox" class="checkbox" name="<?php echo $option_key ?>[]" id="<?php echo $option_key ?>" value="<?php echo $index ?>" <?php echo $checked ?> />
										<img src="<?php echo $fw_dir ?>/admin/images/social/<?php echo $index ?>.png" />
										<label><?php echo $option ?></label>
										<input class="socialurl" name="<?php echo $shortname ?>_social_<?php echo $index  ?>" id="invictus_social_<?php echo $index ?>" type="text" value="<?php echo stripslashes( get_option( $shortname.'_social_'.$index  )  ); ?>" />
										</li>
										<?php
										$i++;
									}
									?>
											</ul>
											</div>
											<a href="#" class="info-icon">Description</a>
											<div class="description"><div class="inner"><?php echo htmlspecialchars_decode( $value['desc'] ); ?></div></div>
										</div>
									 </div>
									 
								<?php
								break;								
	
								// --> Create the option section
								case "section":					
									$i++;					
								?>
								
								<div id="option_<?php echo $value['id']; ?>" class="block ui-tabs-panel ui-widget-content ui-corner-bottom ui-tabs-hide">
									<input type="hidden" value="<?php echo $value['name']; ?>" name="<?php echo $value['id']; ?>_default">														
								<?php break;
								
							// End switch
							} 
						// End foreach					
						}?>

					</div>
				</div>
				<div class="info bottom">
					<input name="reset" type="submit" value="Reset" class="button-secondary reset" />
					<input type="submit" name="save" class="button-primary  save-options" value="Save All Changes">   					
					<input type="hidden" name="action" value="save" />
				</div>
			</form>
		</div>
	</div>
	<?php
}

/*-----------------------------------------------------------------------------------*/
/*	Adds an Admin menu separator
/*-----------------------------------------------------------------------------------*/

function add_admin_menu_separator($position) {
  global $menu;
  $index = 0;
  foreach($menu as $offset => $section) {
    if (substr($section[2],0,9)=='separator')
      $index++;
    if ($offset>=$position) {
      $menu[$position] = array('','read',"separator{$index}",'','wp-menu-separator');
      break;
    }
  }
}

/*-----------------------------------------------------------------------------------*/
/*	Define new table columns
/*-----------------------------------------------------------------------------------*/

function gallery_edit_columns($columns){
	$columns = array(
		"cb" => "<input type=\"checkbox\" />",
		"img_preview" => "Preview",
		"title" => "Image Title",
		"description" => "Description",
		"posted" => "Date added",
		"gallery-cat" => "Galleries",
	);
	return $columns;
}

/*-----------------------------------------------------------------------------------*/
/*	Create the new table columns
/*-----------------------------------------------------------------------------------*/

function gallery_custom_columns($column){
	global $post;
	switch ($column) {
		case "img_preview":
			$imgUrl = max_get_post_image_url($post->ID, "full");
			echo '<img src="'.get_template_directory_uri().'/timthumb.php?src='. $imgUrl[0] .'&amp;h=40"  alt="'.get_the_title().'" />';
		break;		
		case "description":
			the_excerpt();
		break;	
		case "posted":
			echo get_the_date();
		break;
		case "gallery-cat":
			echo get_the_term_list($post->ID, GALLERY_TAXONOMY, '', ', ','');
		break;		
	}
}

add_action("manage_posts_custom_column",  "gallery_custom_columns");
add_filter("manage_edit-gallery_columns", "gallery_edit_columns");

?>