<?php
/**
 * @package WordPress
 * @subpackage Invictus
 */
 
global $showSuperbgimage, $fromGallery, $taxonomy_name, $the_term, $post_terms, $isFullsizeGallery, $isPost, $shortname, $page_obj;
 
// Check if social icons should be used
if(get_option_max('social_use')=='true'){

	global $social_array;

	// Prepare Social network icons 
	$iconArray = array();
	$iconUrl = array();
	$iconPath = get_template_directory_uri()."/images/social/";
	if( is_array( get_option_max('social_show') ) ){
		foreach(get_option_max('social_show') as $index => $value) {
			$iconArray[$index] = $value;
			$iconUrl[$index] = get_option_max('social_'.$value);
		}
	}
} 
 
?>

	</div><!-- #main -->

	<footer id="colophon" role="contentinfo">
		
		<?php echo stripslashes( get_option_max('copyright') ) ?>
		
		<?php
		// Check if social array is enabled
		if(get_option_max('social_use')=='true' && is_array(get_option_max('social_show'))){ 
		?>
		<div id="sociallinks"  class="clearfix<?php if(get_option_max('twitter_show')){ ?> left-space<?php } ?>">
			<ul>
				<?php  
					//Start the generated social network loop
					
					$blank = get_option_max('social_show_blank') == 'true' ? 'target="_blank"' : '';
					
					for ($iconCount = 0; $iconCount < count($iconArray); $iconCount++) {
						if ($iconArray[$iconCount] != "")
						if ($iconUrl[$iconCount] !="") // check if url is set
						echo '<li><a href="'.$iconUrl[$iconCount].'" title="'.$iconArray[$iconCount].'" '.$blank.' class="tooltip"><img alt="'.$iconArray[$iconCount].'" src="' . $iconPath . '' . $iconArray[$iconCount] . '.png" /></a></li>';
					}
				?>
			</ul>	
		</div>
		<?php } ?>		
		
	</footer><!-- #colophon -->
</div><!-- #page -->

<?php 

	// check if it is not the homepage and get the random background image post	

	if(isset($page_obj)){
		$pageID = $page_obj->ID;
	}else{
		$pageID= $post->ID;
	}	
	
	wp_reset_query();		
		
	if(!$isPost){
		$imageURL = get_post_meta($pageID, 'max_show_page_fullsize_url', true);
	}else{
		$imageURL = get_post_meta($pageID, $shortname.'_show_page_fullsize_url_value', true);
	}
	

if( !$isFullsizeGallery ) {

	if ( ( !is_home() && get_post_meta($pageID, 'max_show_page_fullsize', true) == 'true' ) || $showSuperbgimage === true ){ 
	
		// Check if a url for a background image is set
		if( $fromGallery !==true ){
		
			if( $imageURL == "" ){
				
				if( !$taxonomy_name ) 
				{				
					$random_post = max_query_term_posts( 1, get_option_max('fullsize_featured_cat'), 'gallery', 'rand' );				
				}
				else
				{
					$random_post = max_query_term_posts( 1, $the_term->term_id, 'gallery', 'rand' );					
				}
			}
			
		}
		
?>
        <script type="text/javascript">

			jQuery(function($){
				// Options for SuperBGImage
				$.fn.superbgimage.options = {
					slideshow: 0, // 0-none, 1-autostart slideshow
					randomimage: 0,
					preload: 1
				};

				// initialize SuperBGImage
				$('#superbgimage').superbgimage().hide();	
				
			});
			
		</script>

		<div id="superbgimage">		
			
			
			
			<div id="scanlines" class="overlay-<?php get_option_max( 'fullsize_overlay_pattern' , true ) ?>"></div>
			
			<?php // Image URL set and no random image from gallery			
				
				if( $imageURL != "" ) {		

			?>		
				<a class="item" href="<?php  echo $imageURL ?>"><img src="<?php  echo $imageURL ?>" /></a>	
			<?php
				}
			?>
			
			<?php // Image URL set and random image from gallery
			if( get_post_meta($post->ID, $shortname.'_show_random_fullsize_value', true) == 'true' && $isPost === true ) {			
				
				$term_id_array = array();
				foreach($post_terms as $index => $value){
					$term_id_array[$index] = $index;
				}

				$random_post = max_query_term_posts( 1 , $term_id_array, 'gallery', 'rand' );
				$imgID = get_post_thumbnail_id($random_post[0]->ID);
				$imgUrl = wp_get_attachment_image_src($imgID,'full');
				
			?>		
				<a class="item" href="<?php  echo $imgUrl[0] ?>"><img src="<?php  echo $imgUrl[0] ?>" /></a>
			<?php
				}
			?>			
			
			<?php
				if( $imageURL == "" && get_post_meta($post->ID, $shortname.'_show_random_fullsize_value', true) != 'true' ){ 
			?>
			<?php if (have_posts()) : while (have_posts()) : the_post(); ?>
			<?php 				
				$imgID = get_post_thumbnail_id();  
				$imgUrl = wp_get_attachment_image_src($imgID,'full');			
			?>		
														
			<?php if ( has_post_thumbnail() ) { ?>						
				<a class="item" href="<?php  echo $imgUrl[0]; ?>"><img src="<?php  echo $imgUrl[0]; ?>" /></a>
			<?php }	?>				
										
			<?php endwhile; ?>
			<?php endif; ?>	
			<?php wp_reset_query(); ?>
			<?php } ?>
					
		</div>
	
<?php }
}
?>

<?php

	// Get Google Analyric Code if set in options menu
	$google_id = get_option_max('google_analytics_id');
	if(!empty($google_id)){
			
		// Get the template part
		get_template_part( 'google_analytic' );
			
	}
?>

<?php wp_footer(); ?>

</body>
</html>