<?php
/*-----------------------------------------------------------------------------------*/
/*	Main Configuration Settings
/*-----------------------------------------------------------------------------------*/

// Some Global Variables
$themename     = "Invictus";
$shortname 	   = "invictus";
$fw_path  	   = TEMPLATEPATH."/doitmax_fw/"; // root to framework directory 
$fw_dir  	   = get_template_directory_uri()."/doitmax_fw/";

require($fw_path.'/update-notifier.php');

// Name the Taxonomies
define('GALLERY_TAXONOMY', 'gallery-categories');

/*-----------------------------------------------------------------------------------*/
/*	Including framework files
/*-----------------------------------------------------------------------------------*/

// get some framework files
$include_files = array(	
						'max_custom_post_type',
						'max_custom_post_meta',					   
						'max_header',
					   	'max_shortcodes',
					   	'max_posts',
					   	'max_lib',
						'max_attachments',
					   	'max_wp_menu',						
					   	'max_widgets',
						'max_theme_functions',
					   	'max_wp_admin'
					);

// Include the files
$count_files   = count($include_files);

for ($x = 0; $x < $count_files; $x++) {
	include($fw_path.$include_files[$x].".php");
}


/*-----------------------------------------------------------------------------------*/
/*  Add default posts and comments RSS feed links to head
/*-----------------------------------------------------------------------------------*/
 
add_theme_support( 'automatic-feed-links' );

/*-----------------------------------------------------------------------------------*/
/*  Add support for Gallery Post Formats
/*-----------------------------------------------------------------------------------*/

// add_theme_support( 'post-formats', array( 'gallery' ) );

/*-----------------------------------------------------------------------------------*/
/*  Allow to execute Shortcodes in the excerpt
/*-----------------------------------------------------------------------------------*/
add_filter( 'the_excerpt', 'shortcode_unautop');
add_filter( 'the_excerpt', 'do_shortcode');
remove_filter('the_excerpt', 'wpautop');

/*-----------------------------------------------------------------------------------*/
/*  Add Excerpt Support to pages
/*-----------------------------------------------------------------------------------*/
add_post_type_support('page', array('excerpt'));

/*-----------------------------------------------------------------------------------*/
/*	WP2.9+ Thumbnails Settings
/*-----------------------------------------------------------------------------------*/

if ( function_exists( 'add_theme_support' ) ) {
	add_theme_support( 'post-thumbnails' );
	set_post_thumbnail_size( 56, 56, true ); // Normal thumbnails
	add_image_size( 'full', 2000, '', true ); // Full thumbnails
	add_image_size( 'large', 600, '', true ); // Large thumbnails
	add_image_size( 'medium', 200, '', true ); // Medium thumbnails
	add_image_size( 'small', 125, '', true ); // Small thumbnails
}


add_action('init','max_options');

if (!function_exists('max_options')) {
function max_options(){

global $themename, $shortname, $wp_gal_cats, $wp_cats, $max_options, $social_array, $order_array;

// Populate option in array for use in theme
$max_options = get_option('max_options');


/*-----------------------------------------------------------------------------------*/
/*	Catch the Wordpress Categories
/*-----------------------------------------------------------------------------------*/

$wp_cats = array();
$max_categories = get_categories('hide_empty=0');
foreach ($max_categories as $category_list ) {
	 $wp_cats[$category_list->cat_ID] = $category_list->cat_name;
}


/*-----------------------------------------------------------------------------------*/
/*	Catch the Wordpress Pages
/*-----------------------------------------------------------------------------------*/

$max_pages = get_pages('sort_column=post_parent,menu_order');    
$wp_pages = array();
foreach ($max_pages as $page_list) {
    $wp_pages[$page_list->ID] = $page_list->post_name; 
}
$max_pages_temp = array_unshift($wp_pages, "Select a page:"); 


/*-----------------------------------------------------------------------------------*/
/*	Catch the Taxonomy Cats for Galleries
/*-----------------------------------------------------------------------------------*/

$gallery_cats = get_terms(GALLERY_TAXONOMY, 'orderby=name&hide_empty=0&hierarchical=1');
$wp_gal_cats = array();
foreach ($gallery_cats as $term_list ) {
	 $wp_gal_cats[$term_list->term_id] = $term_list->name;
}


/*-----------------------------------------------------------------------------------*/
/*	Make theme available for translation
/*-----------------------------------------------------------------------------------*/

load_theme_textdomain( 'invictus', TEMPLATEPATH . '/languages' );

$locale = get_locale();
$locale_file = TEMPLATEPATH . "/languages/$locale.php";
if ( is_readable( $locale_file ) )
	require_once( $locale_file );


/*-----------------------------------------------------------------------------------*/
/*	 Creates the admin menu
/*-----------------------------------------------------------------------------------*/

$social_array 		  = array('etsy'=>"Etsy", 'blogger'=>"Blogger", 'delicious'=>"Delicious" ,'deviantart'=>"Deviantart",'digg'=>"Digg",'facebook'=>"Facebook",'flickr'=>"Flickr",'friendfeed'=>"FriendFeed",'icq'=>"ICQ", 'lastfm'=>"Lastfm",'linkedin'=>"LinkedIn","msn"=>"MSN",'myspace'=>"MySpace",'reddit'=>"Reddit",'rss'=>"RSS",'skype'=>"Skype",'stumbleupon'=>"Stumbleupon",'technorati'=>"Technorati",'tumblr'=>"Tumblr", 'twitter'=>"Twitter",'vimeo'=>"Vimeo",'xing'=>"Xing",'yahoo'=>"Yahoo",'youtube'=>"YouTube");
$theme_array  		  = array("black"=>"Black Theme","white"=>"White Theme");
$font_array  		  = array("DroidItalic"=>"DroidItalic","KnockOut"=>"KnockOut","M2p"=>"M2p","Mido"=>"Mido","MrsEvans"=>"MrsEvans","Palatino"=>"Palatino","PTSans"=>"PTSans","QuickSand"=>"QuickSand","Titillium"=>"Titillium","Vegur"=>"Vegur");
$order_array  		  = array("rand"=>"Random","id"=>"Post-ID","date"=>"Post Date","title"=>"Post Title","modified"=>"Last modified");
$pretty_speed_array	  = array('fast'=>'Fast',"normal"=>'Normal',"slow"=>'Slow');
$pretty_theme_array   = array('dark_square'=>"Dark Square",'light_square'=>"Light Square",'dark_rounded'=>"Dark Rounded",'light_rounded'=>"Light Rounded",'facebook'=>"Facebook");
$fullsize_speed_array = array('slow'=>'Slow','normal'=>'Normal','fast'=>'Fast');
$fullsize_transition_array = array(0=>"None",1=>"Fade",2=>"Slide Down",3=>"Slide Left",4=>"Slide Top",5=>"Slide Right",6=>"Blind horizontal",7=>"Blind Vertiacl",90=>"Slide Right/Left",91=>"Slide Top/Down");
$fullsize_overlay_array = array("dotted"=> "Dots", "squared" => "Squares", "scanlines" => "Scanlines", "carbon" => "Carbon", "triangles" => "Triangles" );

// The Options
$options = array();


// Create the General Tab
$options[] = array( "name" => __('General','invictus'),
					"id"=>"general",
					"type" => "section",
					"icon" => "hammer_screwdriver.png");
$options[] = array( "type" => "open");

	$options[] = array( "name" => __('Logo Options','invictus'),
						"id"=>"subhead_general_logo",
						"type" => "subhead");
	
		$options[] = array( "name" => __('Custom Logo','invictus'),
							"desc" => __('Upload your own Logo to use as Site Logo. (Should not be larger than 235x100px)','invictus'),
							"id" => $shortname."_custom_logo",
							"std" => "",
							"type" => "upload");
		
		$options[] = array( "name" => __('Custom Favicon','invictus'),
							"desc" => __('Upload a 16px x 16px Png/Gif image that will represent your website\'s favicon.','invictus'),
							"id" => $shortname."_custom_favicon",
							"std" => "",
							"type" => "upload");

	$options[] = array( "name" => __('Post Options','invictus'),
						"id"=>"subhead_general_post",
						"type" => "subhead");

		$options[] = array( "name" => __('Posts per page','invictus'),
							"desc" => __('Enter the number of post, that will be displayed on one page of your portfolio or blog.','invictus'),
							"id" => $shortname."_general_posts_per_page",
							"type" => "slider",
							"step" => "1",
							"max" => "54",
							"min" => "1",
							"std" => "24");
		
		$options[] = array( "name" => __('Blog Category','invictus'),
							"desc" => __('Choose the Cagetory of your Blog to display the Blog Posts in the correct Template file.','invictus'),
							"id" => $shortname."_general_blog_id",
							"type" => "select",
							"options" => $wp_cats,
							"std" => "2");

		$options[] = array( "name" => __('Show Full Blogpost','invictus'),
							"desc" => __('Check, if you want to show the full blog post instead of a short excerpt.','invictus'),
							"id" => $shortname."_general_show_fullblog",
							"type" => "checkbox",
							"std" => "false");
		
		$options[] = array( "name" => __('Show Post Author','invictus'),
							"desc" => __('Check, if you want to show the post author of a post on the blog post page.','invictus'),
							"id" => $shortname."_general_show_author",
							"type" => "checkbox",
							"std" => "true");
				
	$options[] = array( "name" => __('Others','invictus'),
						"id"=>"subhead_general_others",
						"type" => "subhead");	
		
		$options[] = array( "name" => __('Google Analytics ID','invictus'),
							"desc" => __('Enter your Google Analytic ID to track your page visitors.','invictus'),
							"id" => $shortname."_google_analytics_id",
							"type" => "text",
							"std" => "");

		$options[] = array( "name" => __('Custom CSS','framework'),
							"desc" => __('Enter some CSS to your theme by adding it to this block.','invictus'),
							"id" => $shortname."_custom_css",
							"std" => "",
							"type" => "textarea",
							"rows" => 10);

$options[] = array( "type" => "close");


// Create the Homepage Tab
$options[] = array( "name" => __('Homepage','invictus'),
					"id"=> $shortname."_header_homepage",
					"type" => "section",
					"icon" => "house.png");
$options[] = array( "type" => "open");


	$options[] = array( "name" => __('Welcome Teaser','invictus'),
						"id"=>"subhead_general_welcome",
						"type" => "subhead");
	
		$options[] = array( "name" => __('Show Welcome Teaser','invictus'),
							"desc" => __('Check, if you want to show your Welcome Teaser on the Homepage','invictus'),
							"id" => $shortname."_homepage_show_welcome_teaser",
							"type" => "checkbox",
							"std" => "true");
		
		$options[] = array( "name" => __('Welcome Teaser','invictus'),
							"desc" => __('Change your "Welcome Teaser on the Homepage.','invictus'),
							"id" => $shortname."_homepage_welcome_teaser",
							"type" => "textarea",
							"std" => "Hi, my name is <strong>John Doe</strong>. I AM a Professional Photographer located in the beautiful city of <strong>Berlin, Germany</strong>. Checkyout my great work in my awesome online Portfolio.",
							"rows"=> 8 );
		
		$options[] = array( "name" => __('Welcome Teaser Font Size','invictus'),
							"desc" => __('Select the fontsize for your Welcome Teaser in px','invictus'),
							"id" => $shortname."_homepage_teaser_font_size",
							"type" => "slider",
							"step" => "1",
							"max" => "60",
							"min" => "1",
							"std" => "26");

	$options[] = array( "name" => __('Welcome Teaser Bold Font Size','invictus'),
						"desc" => __('Select the fontsize for the bold text of your Welcome Teaser in px','invictus'),
						"id" => $shortname."_homepage_teaser_font_size_bold",
						"type" => "slider",
						"step" => "1",
						"max" => "60",
						"min" => "1",
						"std" => "34");	
	
	$options[] = array( "name" => __('Other','invictus'),
						"id"=>"subhead_general_welcome",
						"type" => "subhead");	

		$options[] = array( "name" => __('Show Sidebar','invictus'),
							"desc" => __('Check, if you want to show a sidebar on your Homepage','invictus'),
							"id" => $shortname."_homepage_show_homepage_sidebar",
							"type" => "checkbox",
							"std" => "false");
		
		$options[] = array( "name" => __('Show Thumbnail Scroller on Homepage','invictus'),
							"desc" => __('Check, if you want to show the thumbnails on the homepage or not. By default the thumbnails are displayed.','invictus'),
							"id" => $shortname."_homepage_show_thumbnails",
							"type" => "checkbox",
							"std" => "true");

$options[] = array( "type" => "close");


// Create the Colors & Layout Tab
$options[] = array( "name" => __('Colors','invictus'),
					"id"=> $shortname."_header_colors",
					"type" => "section",
					"icon" => "control_wheel.png");
$options[] = array( "type" => "open");

	$options[] = array( "name" => __('Main Colors','invictus'),
						"id"=>"subhead_colors_main",
						"type" => "subhead");

		$options[] = array( "name" => __('Colour Scheme','invictus'),
							"desc" => __('Select the colour scheme for the theme.','invictus'),
							"id" => $shortname."_color_main",
							"type" => "select",
							"options" => $theme_array,
							"std" => "white");
		
		$options[] = array( "name"  => __('Set Main Color','invictus'),
							"desc" =>  __('This is the main color for your theme (borders, current nav marker, nav pulldown background...)','invictus'),
							"id" => $shortname."_color_main_typo",
							"type" => "colorpicker",
							"std" => "#c73a3a");
		
		$options[] = array( "name"  => __('Set Link Color','invictus'),
							"desc" => __('This is the link color for your theme.','invictus'),
							"id" => $shortname."_color_main_link",
							"type" => "colorpicker",
							"std" => "#c73a3a");

		$options[] = array( "name"  => __('Navigation Link','invictus'),
							"desc" => __('This is the color for your navigation links (normal and visited).','invictus'),
							"id" => $shortname."_color_nav_link",
							"type" => "colorpicker",
							"std" => "#AAAAAA");

		$options[] = array( "name"  => __('Navigation Link Hover','invictus'),
							"desc" => __('This is the hover color for your navigation links (hover and active).','invictus'),
							"id" => $shortname."_color_nav_link_hover",
							"type" => "colorpicker",
							"std" => "#FFFFFF");

		$options[] = array( "name"  => __('Pulldown Link','invictus'),
							"desc" => __('This is the color for your pulldown links (normal and visited).','invictus'),
							"id" => $shortname."_color_pulldown_link",
							"type" => "colorpicker",
							"std" => "#FFFFFF");

		$options[] = array( "name"  => __('Pulldown Link Hover','invictus'),
							"desc" => __('This is the hover color for your pulldown links (hover and active).','invictus'),
							"id" => $shortname."_color_pulldown_link_hover",
							"type" => "colorpicker",
							"std" => "#212121");							

	$options[] = array( "name" => __('Headline Colors','invictus'),
						"id"=>"subhead_colors_headline",
						"type" => "subhead");

		$options[] = array( "name"  => __('H1 Headline Color','invictus'),
							"desc" => __('This is the color for your H1 Headlines.','invictus'),
							"id" => $shortname."_color_main_h1",
							"type" => "colorpicker",
							"std" => "#c73a3a");
		
		$options[] = array( "name"  => __('H2 Headline Color','invictus'),
							"desc" => __('This is the color for your H2 Headlines.','invictus'),
							"id" => $shortname."_color_main_h2",
							"type" => "colorpicker",
							"std" => "#EEEEEE");
		
		$options[] = array( "name"  => __('H3 Headline Color','invictus'),
							"desc" => __('This is the color for your H3 Headlines.','invictus'),
							"id" => $shortname."_color_main_h3",
							"type" => "colorpicker",
							"std" => "#CCCCCC");
		
		$options[] = array( "name"  =>  __('H4 Headline Color','invictus'),
							"desc" =>  __('This is the color for your H4 Headlines.','invictus'),
							"id" => $shortname."_color_main_h4",
							"type" => "colorpicker",
							"std" => "#CCCCCC");
		
		$options[] = array( "name"  => __('H5 Headline Color','invictus'),
							"desc" => __('This is the color for your H5 Headlines.','invictus'),
							"id" => $shortname."_color_main_h5",
							"type" => "colorpicker",
							"std" => "#CCCCCC");
		
		$options[] = array( "name"  => __('H6 Headline Color','invictus'),
							"desc" => __('This is the color for your H6 Headlines.','invictus'),
							"id" => $shortname."_color_main_h6",
							"type" => "colorpicker",
							"std" => "#CCCCCC");

$options[] = array( "type" => "close");


// Create the Font Tab
$options[] = array( "name" => __('Fonts','invictus'),
					"id"=> $shortname."_header_font",
					"type" => "section",
					"icon" => "font.png");
$options[] = array( "type" => "open");


	$options[] = array( "name" => __('Main Font','invictus'),
						"id"=>"subhead_font_main",
						"type" => "subhead");

		$options[] = array( "name" => __('Main Body Font Style','invictus'),
							"desc" => __('Select your main body font from Google Font API. <a href="http://www.google.com/webfonts" target="_blank">See all Google Fonts</a>','invictus'),
							"id" => $shortname."_color_main_font",
							"std" => "PT Sans",
							"type" => "font");
		
		$options[] = array( "name" => __('Headline Font Style','invictus'),
							"desc" => __('Select your headline font from Google Font API. <a href="http://www.google.com/webfonts" target="_blank">See all Google Fonts</a>','invictus'),
							"id" => $shortname."_color_main_headlines",
							"std" => "Yanone Kaffeesatz",
							"type" => "font");
		
		$options[] = array( "name" => __('Body Font Size','invictus'),
							"desc" => __('Select the fontsize for your body text in px','invictus'),
							"id" => $shortname."_color_font_size",
							"type" => "slider",
							"step" => "1",
							"max" => "20",
							"min" => "1",
							"std" => "12");	

	$options[] = array( "name" => __('Headline Font','invictus'),
						"id"=>"subhead_font_headline",
						"type" => "subhead");

		$options[] = array( "name"  => __('H1 Font-Size','invictus'),
							"desc" => __('This is the font-size for your H1 Headlines in pixel.','invictus'),
							"id" => $shortname."_font_size_h1",
							"type" => "slider",
							"step" => "1",
							"max" => "80",
							"min" => "1",
							"std" => "42");	
		
		$options[] = array( "name"  => __('H2 Font-Size','invictus'),
							"desc" => __('This is the font-size for your H2 Headlines in pixel.','invictus'),
							"id" => $shortname."_font_size_h2",
							"type" => "slider",
							"step" => "1",
							"max" => "80",
							"min" => "1",
							"std" => "36");	
				
		$options[] = array( "name"  => __('H3 Font-Size','invictus'),
							"desc" => __('This is the font-size for your H3 Headlines in pixel.','invictus'),
							"id" => $shortname."_font_size_h3",
							"type" => "slider",
							"step" => "1",
							"max" => "80",
							"min" => "1",
							"std" => "30");		
		
		$options[] = array( "name"  => __('H4 Font-Size','invictus'),
							"desc" => __('This is the font-size for your H4 Headlines in pixel.','invictus'),
							"id" => $shortname."_font_size_h4",
							"type" => "slider",
							"step" => "1",
							"max" => "80",
							"min" => "1",
							"std" => "24");	
		
		
		$options[] = array( "name"  => __('H5 Font-Size','invictus'),
							"desc" => __('This is the font-size for your H5 Headlines in pixel.','invictus'),
							"id" => $shortname."_font_size_h5",
							"type" => "slider",
							"step" => "1",
							"max" => "80",
							"min" => "1",
							"std" => "18");		
		
		$options[] = array( "name"  => __('H6 Font-Size','invictus'),
							"desc" => __('This is the font-size for your H6 Headlines in pixel.','invictus'),
							"id" => $shortname."_font_size_h6",
							"type" => "slider",
							"step" => "1",
							"max" => "80",
							"min" => "1",
							"std" => "16");	

$options[] = array( "type" => "close");


// Create the Images Tab
$options[] = array( "name" => __('Images','invictus'),
					"id"=> $shortname."_header_images",
					"type" => "section",
					"icon" => "images.png");
$options[] = array( "type" => "open");


$options[] = array( "name" => __('Photo Project Page Settings','invictus'),
					"id"=>"subhead_image_project",
					"type" => "subhead");

	$options[] = array( "name" => __('Do not crop Photos on Project Page','invictus'),
						"desc" => __('Check, if you want to use the original Ratio without cropping for your Photos on a Photos Project Page.','invictus'),
						"id" => $shortname."_image_project_original_ratio",
						"type" => "checkbox",
						"std" => "false");
	
	$options[] = array( "name" => __('Show Gallery Images on Photo Project Page','invictus'),
						"desc" => __('Check, if you want to show Images from the current Gallery where the Photo is drawn from.','invictus'),
						"id" => $shortname."_image_show_gallery_images",
						"type" => "checkbox",
						"std" => "false");	
	
	$options[] = array( "name" => __('Number of Photo Page Gallery Images','invictus'),
					"desc" => __('Set the number of Gallery Images to show on a Photos Project Page. These Images are drawn from the Gallery the current Photo is bind to.','invictus'),
					"id" => $shortname."_image_count_gallery_images",
					"type" => "slider",
					"step" => "1",
					"max" => "100",
					"min" => "1",
					"std" => "20");
	
	$options[] = array( "name" => __('Show Photo Author','invictus'),
						"desc" => __('Check, if you want to show the author of a photo post on the photos project page.','invictus'),
						"id" => $shortname."_general_show_photo_author",
						"type" => "checkbox",
						"std" => "true");		

$options[] = array( "name" => __('Other Settings','invictus'),
					"id"=>"subhead_image_others",
					"type" => "subhead");

$options[] = array( "name" => __('Show Image Caption','invictus'),
					"desc" => __('Show the Image Caption and a small Excerpt on mouseover.','invictus'),
					"id" => $shortname."_image_show_caption",
					"type" => "checkbox",
					"std" => "true");

$options[] = array( "name" => __('Fullsize Grid Image Heigth','invictus'),
					"desc" => __('Set the height of a single image in the fullsize grid template','invictus'),
					"id" => $shortname."_image_fullsize_grid_height",
					"type" => "slider",
					"step" => "1",
					"max" => "600",
					"min" => "1",
					"std" => "200");

$options[] = array( "name" => __('Fullsize Scroller Image Heigth','invictus'),
					"desc" => __('Set the height of a single image in the fullsize scroller template','invictus'),
					"id" => $shortname."_image_fullsize_scroller_height",
					"type" => "slider",
					"step" => "1",
					"max" => "1000",
					"min" => "1",
					"std" => "400");

$options[] = array( "name" => __('Show Image Fade','invictus'),
					"desc" => __('Show the image fade and background on mouseover.','invictus'),
					"id" => $shortname."_image_show_fade",
					"type" => "checkbox",
					"std" => "true");					

$options[] = array( "type" => "close");


// Create the Fullsize Gallery Tab
$options[] = array( "name" => "Fullsize Gallery",
					"id"=>"header_fullsize",
					"type" => "section",
					"icon" => "fullsize_gallery.png");
$options[] = array( "type" => "open");
	
	$options[] = array( "name" => __('Main Settings','invictus'),
						"id"=>"subhead_fullsize_main",
						"type" => "subhead");	
	
		$options[] = array( "name" => __('Number of images','invictus'),
							"desc" => __('Enter the number of images you want to show in the fullsize gallery.','invictus'),
							"id" => $shortname."_fullsize_featured_count",
							"type" => "slider",
							"step" => "1",
							"max" => "100",
							"min" => "1",
							"std" => "18");	
		
		$options[] = array( "name" => __('Featured Galleries','invictus'),
							"desc" => __('Choose the Galleries from which featured Images for the Fullsize Gallery are drawn.','invictus'),
							"id" => $shortname."_fullsize_featured_cat",
							"type" => "multicheck",
							"options" => $wp_gal_cats,
							"std" => "false");
							
		$options[] = array( "name" => __('Image order','invictus'),
							"desc" => __('Choose the order of images displayed in the Fullsize Gallery on homepage.','invictus'),
							"id" => $shortname."_fullsize_featured_order",
							"type" => "select",
							"options" => $order_array,
							"std" => "normal");							
							
		$options[] = array( "name" => __('Show Fullsize Overlay','invictus'),
					"desc" => __('Check, if you want to show the Overlay Pattern on Pages with a Fullsize Background Gallery.','invictus'),
					"id" => $shortname."_homepage_show_fullsize_overlay",
					"type" => "checkbox",
					"std" => "true");

		$options[] = array( "name" => __('Overlay Pattern','invictus'),
							"desc" => __('Select the type of Overlay Pattern for your Fullsize Gallery.','invictus'),
							"id" => $shortname."_fullsize_overlay_pattern",
							"type" => "radio",
							"options" => $fullsize_overlay_array,
							"std" => "dotted",
							"addtype" => "overlay");

	$options[] = array( "name" => __('Slider Settings','invictus'),
						"id"=>"subhead_fullsize_slider",
						"type" => "subhead");

		$options[] = array( "name" => __('Thumbnail height','invictus'),
							"desc" => __('Set the height of the thumbnails in the scroller. The width is set proportional.','invictus'),
							"id" => $shortname."_fullsize_thumb_height",
							"type" => "slider",
							"step" => "1",
							"max" => "200",
							"min" => "1",
							"std" => "100");	

		$options[] = array( "name" => __('Thumbnail Quality','invictus'),
							"desc" => __('Set quality value of the Thumbnails in percent.','invictus'),
							"id" => $shortname."_fullsize_thumb_quality",
							"type" => "slider",
							"step" => "1",
							"max" => "100",
							"min" => "1",
							"std" => "90");	
		
		$options[] = array( "name" => __('Slide Interval','invictus'),
							"desc" => __('The interval betweeen background slides in ms.','invictus'),
							"id" => $shortname."_fullsize_interval",
							"type" => "slider",
							"step" => "100",
							"max" => "50000",
							"min" => "1000",
							"std" => "8000");
		
		$options[] = array( "name" => __('Animation Speed','invictus'),
							"desc" => __('The speed of the slides animation.','invictus'),
							"id" => $shortname."_fullsize_speed",
							"type" => "select",
							"options" => $fullsize_speed_array,
							"std" => "normal");
		
		$options[] = array( "name" => __('Transition','invictus'),
							"desc" => __('Type of slide transition.','invictus'),
							"id" => $shortname."_fullsize_transition",
							"type" => "select",
							"options" => $fullsize_transition_array,
							"std" => 1);

$options[] = array( "type" => "close");


// Create the PrettyPhoto Tab
$options[] = array( "name" => __('PrettyPhoto','invictus'),
					"id"=> $shortname."_header_prettyPhoto",
					"type" => "section",
					"icon" => "prettyphoto.png");
$options[] = array( "type" => "open");

$options[] = array( "name" => __('Slideshow Interval','invictus'),
					"desc" => __('Interval time of images in ms. Value "false" will disable the slideshow."','invictus'),
					"id" => $shortname."_pretty_interval",
					"type" => "slider",
					"step" => "100",
					"max" => "50000",
					"min" => "1000",
					"std" => "8000");

$options[] = array( "name" => __('Animation Speed','invictus'),
					"desc" => __('The Speed of the popup animation to open an image.','invictus'),
					"id" => $shortname."_pretty_speed",
					"type" => "select",
					"options" => $pretty_speed_array,
					"std" => 'normal');

$options[] = array( "name" => __('Theme','invictus'),
					"desc" => __('Choose from one of the five supplied themes.','invictus'),
					"id" => $shortname."_pretty_theme",
					"type" => "select",
					"options" => $pretty_theme_array,
					"std" => "dark_square");

$options[] = array( "name" => __('Show Lightbox Gallery','invictus'),
					"desc" => __('Check, if you want to show the lightbox gallery of prettyPhoto.','invictus'),
					"id" => $shortname."_pretty_gallery_show",
					"type" => "checkbox",
					"std" => "true");

$options[] = array( "name" => __('Show Lightbox Title &amp; Description','invictus'),
					"desc" => __('Check, if you want to show the title and description of a image open in prettyPhoto.','invictus'),
					"id" => $shortname."_pretty_title_show",
					"type" => "checkbox",
					"std" => "true");

$options[] = array( "type" => "close");


// Create the Contact Tab
$options[] = array( "name" => __('Contact','invictus'),
					"id"=> $shortname."_header_contact",
					"type" => "section",
					"icon" => "vcard.png");
$options[] = array( "type" => "open");

$options[] = array( "name" => __('Contact Form eMail','invictus'),
					"desc" => __('Enter the eMail thats used to send a you a contact request via contact formular.','invictus'),
					"id" => $shortname."_contact_email",
					"type" => "text",
					"std" => "");

$options[] = array( "name" => __('Show Sidebar Text','invictus'),
					"desc" => __('Show the Info Sidebar Text on Contact Page on the right Sidebar','invictus'),
					"id" => $shortname."_contact_show_text",
					"type" => "checkbox",
					"std" => "true");

$options[] = array( "name" => __('Contact Sidebar Text','invictus'),
					"desc" => __('Enter the text "Contact Info" in the right Sidebar on Contact Us page.','invictus'),
					"id" => $shortname."_contact_info",
					"type" => "textarea",
					"std" => "Aenean nisl orci, condimentum ultrices consequat eu, vehicula ac mauris. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean nisl orci, condimentum ultrices consequat eu, vehicula ac mauris. Ut adipiscing, leo nec. Lorem ipsum dolor sit amet, consectetur adipiscing elit.",
					"rows"=> 6 );

$options[] = array( "name" => __('Show Contact Info','invictus'),
					"desc" => __('Show Info Box on Contact Page on the right Sidebar','invictus'),
					"id" => $shortname."_contact_show_info",
					"type" => "checkbox",
					"std" => "true");

$options[] = array( "name" => __('Contact Info Header','invictus'),
					"desc" => __('Enter the headline of your Contact Infos.','invictus'),
					"id" => $shortname."_contact_info_header",
					"type" => "text",
					"std" => "");

$options[] = array( "name" => __('Adress Line 1','invictus'),
					"desc" => __('Enter the first Adress Line.','invictus'),
					"id" => $shortname."_contact_adress_1",
					"type" => "text",
					"std" => "");

$options[] = array( "name" => __('Adress Line 2','invictus'),
					"desc" => __('Enter the second Adress Line.','invictus'),
					"id" => $shortname."_contact_adress_2",
					"type" => "text",
					"std" => "");

$options[] = array( "name" => __('Phone','invictus'),
					"desc" => __('Enter your Phone Number. Leave blank to hide.','invictus'),
					"id" => $shortname."_contact_phone",
					"type" => "text",
					"std" => "");

$options[] = array( "name" => __('Fax','invictus'),
					"desc" => __('Enter your Fax Number. Leave blank to hide.','invictus'),
					"id" => $shortname."_contact_fax",
					"type" => "text",
					"std" => "");

$options[] = array( "name" => __('Contact eMail','invictus'),
					"desc" => __('Enter your Company E-Mail. Leave blank to hide.','invictus'),
					"id" => $shortname."_contact_info_email",
					"type" => "text",
					"std" => "");

$options[] = array( "type" => "close");


// Create the Footer Tab
$options[] = array( "name" => __('Footer','invictus'),
					"id"=> $shortname."_header_footer",
					"type" => "section",
					"icon" => "layout_footer.png");
$options[] = array( "type" => "open");

$options[] = array( "name" => __('Copyright','invictus'),
					"desc" => __('Enter your Copyright Text here.','invictus'),
					"id" => $shortname."_copyright",
					"type" => "select",
					"type" => "textarea",
					"std" => "copyright 2011 doitmax - Invictus. // Fullsize Background Wordpress Theme",
					"rows"=> 6 );

$options[] = array( "name" => __("Show Social links",'invictus'),
					"desc" => __('Do you want to show social links in your site footer?','invictus'),
					"id" => $shortname."_social_use",
					"type" => "checkbox",
					"std" => "true");

$options[] = array( "type" => "close");


// Create the Social Management Tab
$options[] = array( "name" => __('Socials','invictus'),
					"id"=>"header_social",
					"type" => "section",
					"icon" => "social.png");
$options[] = array( "type" => "open");

$options[] = array( "name" => __('Social Icons','invictus'),
					"desc" => __('Choose the social icons that will be displayed in your footer.','invictus'),
					"id" => $shortname."_social_show",
					"type" => "socialinput",
					"options" => $social_array,
					"std" => array('true'));

$options[] = array( "name" => __("Open Blank",'invictus'),
					"desc" => __('Do you want to show social links in a blank Browser window?','invictus'),
					"id" => $shortname."_social_show_blank",
					"type" => "checkbox",
					"std" => "true");


$options[] = array( "type" => "close");

// update Some Options
update_option('max_template',$options); 					  
update_option('max_themename',$themename);   
update_option('max_shortname',$shortname);

// Generate the admin menu
function max_admin_add_admin() {

	global $fw_dir, $shortname, $social_array;

    $themename =  get_option('max_themename');      
    $shortname =  get_option('max_shortname'); 
	$options   =  get_option('max_template'); 

	if ( isset($_GET['page']) && $_GET['page'] == basename(__FILE__) ) {
		
		if ( 'save' == $_REQUEST['action'] ) {
			
				foreach ($options as $value) {  
			
				if( $value['type'] == 'upload' ){			
					
					$overrides = array( 'test_form' => false);
						
					$upload = wp_handle_upload( $_FILES[ $value['id'] ], $overrides );
					
					if( isset( $upload['url'] ) ){
						update_option( $value['id']."_value", $upload['url'] );
					}		
							
					if( $_POST[ $value['id']."_delete" ] == 'true' ) {						
						
						delete_option( $value['id']."_value" );
						
					}
										
				
				} else {	
					
					if( $value['type'] == 'socialinput' ){
						foreach($social_array as $s_index => $s_value){
							update_option( $shortname . '_social_' . $s_index, $_REQUEST[ $shortname . '_social_' . $s_index ]  );
						}
					}
				
					update_option( $value['id'], $_REQUEST[ $value['id'] ]  );
					
				}
				
			}
			header("Location: admin.php?page=functions.php&saved=true");
			die;			
		}else if( 'reset' == $_REQUEST['action'] ) {	
			foreach ($options as $value) {
				delete_option( $value['id'] );
			}		
			header("Location: admin.php?page=functions.php&reset=true");
			die;
		}
	}
	
	// Adds the menu page
	add_menu_page($themename, $themename, 'administrator', basename(__FILE__), 'max_theme_admin', $fw_dir."images/menu_icon.png");
	add_submenu_page( basename(__FILE__), 'Invictus', 'Settings', 'manage_options', basename(__FILE__), 'max_theme_admin');
}
	
// Add the Admin menu
add_action('admin_init', 'max_admin_add_init');  
add_action('admin_menu', 'max_admin_add_admin');  


}
/*-----------------------------------------------------------------------------------*/
/*	Add some Filters to allow shortcodes in a Text Widget
/*-----------------------------------------------------------------------------------*/

add_filter('widget_text', 'shortcode_unautop');
add_filter('widget_text', 'do_shortcode');

}
?>