<?php
/**
 * @package WordPress
 * @subpackage Invictus
 */
?><!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php
	/*
	 * Print the <title> tag based on what is being viewed.
	 */
	global $page, $paged, $showSuperbgimage;

	wp_title( '|', true, 'right' );

	// Add the blog name.
	bloginfo( 'name' );

	// Add the blog description for the home/front page.
	$site_description = get_bloginfo( 'description', 'display' );
	if ( $site_description && ( is_home() || is_front_page() ) )
		echo " | $site_description";

	// Add a page number if necessary:
	if ( $paged >= 2 || $page >= 2 )
		echo ' | ' . sprintf( __( 'Page %s', 'invictus' ), max( $paged, $page ) );


	?></title>

<link rel="profile" href="http://gmpg.org/xfn/11" />

<!-- Get the Main Style CSS -->
<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo( 'stylesheet_url' ); ?>" />
<!-- Get the Theme Style CSS -->
<link rel="stylesheet" type="text/css" media="all" href="<?php echo get_template_directory_uri(); ?>/css/<?php get_option_max('color_main',true) ?>.css" />

<!-- Google Font API include -->
<?php max_get_google_font( get_option_max( 'color_main_font' ) ) ?>
<?php max_get_google_font( get_option_max( 'color_main_headlines' ) ) ?>


<!--[if lt IE 9]>
<link rel="stylesheet" type="text/css" media="all" href="<?php echo get_template_directory_uri(); ?>/css/ie.css" />
<link rel="stylesheet" type="text/css" media="all" href="<?php echo get_template_directory_uri(); ?>/css/ie_<?php get_option_max('color_main',true) ?>.css" />
<![endif]-->

<?php // Main Color styles ?>
<style type="text/css">

	<?php $rgba_1 = max_HexToRGB( get_option_max( 'color_main_typo' ) ) ?>
	
	a:link, a:visited { color: <?php get_option_max( 'color_main_link' , true) ?> }
	
	nav#navigation ul a:link, nav#navigation ul a:visited { color: <?php get_option_max( 'color_nav_link' , true) ?> }
	nav#navigation ul a:hover, nav#navigation ul a:active,
	nav#navigation ul .sfHover a:hover, nav#navigation ul .sfHover a:active { color: <?php get_option_max( 'color_nav_link_hover' , true) ?> }
	nav#navigation ul ul li a:link, nav#navigation ul ul li a:visited { color: <?php get_option_max( 'color_pulldown_link' , true) ?> }
	nav#navigation ul ul li a:hover, nav#navigation ul ul li a:active { color: <?php get_option_max( 'color_pulldown_link_hover' , true) ?> }	
	
	#site-title,
	nav#navigation ul a:hover,
	nav#navigation ul li.sfHover a,
	nav#navigation ul li.current-cat a,
	nav#navigation ul li.current_page_item a,
	nav#navigation ul li.current-menu-item a,
	nav#navigation ul li.current-page-ancestor a,
	#colophon,
	#thumbnails .pulldown-items a.activeslide { 
		border-color: <?php get_option_max( 'color_main_typo' , true) ?>;
	}
	
	#thumbnails .scroll-link,
	#fullsizeTimer,
	.blog .date-badge,
	.pagination a:hover,
	.pagination span.current { 
		background-color: <?php get_option_max( 'color_main_typo' , true) ?>;
	}	
	
	#expander,
	#toggleThumbs { 
		background-color: rgba(<?php echo $rgba_1['r'] ?>,<?php echo $rgba_1['g'] ?>,<?php echo $rgba_1['b'] ?>, 0.75); 
	}
	nav#navigation ul ul { 
		background-color: rgba(<?php echo $rgba_1['r'] ?>,<?php echo $rgba_1['g'] ?>,<?php echo $rgba_1['b'] ?>, 0.9); 
	}

	nav#navigation ul ul li {
		border-color: rgb(<?php echo $rgba_1['r'] + 50 ?>,<?php echo $rgba_1['g'] + 50 ?>,<?php echo $rgba_1['b'] + 50 ?>); 		
	}
	
	h1, h1 a:link, h1 a:visited { color: <?php get_option_max( 'color_main_h1', true) ?>; }
	h2 { color: <?php get_option_max( 'color_main_h2', true) ?>; }
	h3 { color: <?php get_option_max( 'color_main_h3', true) ?>; }
	h4 { color: <?php get_option_max( 'color_main_h4', true) ?>; }
	h5 { color: <?php get_option_max( 'color_main_h5', true) ?>; }
	h6 { color: <?php get_option_max( 'color_main_h6', true) ?>; }

	h1, h2, h3, h4, h5, h6, h7, #welcomeTeaser, .max_widget_teaser {
		<?php $head_font = get_option_max( 'color_main_headlines') != "off" ? '"'.get_option_max( 'color_main_headlines' ).'","Helvetica Neue", Helvetica, Arial, sans-serif ' : '"Helvetica Neue", Helvetica, Arial, sans-serif' ?>
		font-family: <?php echo $head_font ?>;
		font-weight: 300	
	}

	body, #sidebar .widget { 
		<?php $body_font_size = get_option_max( 'color_font_size') != "" ? get_option_max( 'color_font_size') : 12 ?>
		font-size:  <?php echo $body_font_size ?>px !important;
		<?php $body_font = get_option_max( 'color_main_font' ) != "off" ? '"'.get_option_max( 'color_main_font' ).'","Helvetica Neue", Helvetica, Arial, sans-serif ' : '"Helvetica Neue", Helvetica, Arial, sans-serif' ?>
		font-family: <?php echo $body_font ?>; 
	}

	h1 { font-size: <?php get_option_max( 'font_size_h1',true) ?>px; }
	h2 { font-size: <?php get_option_max( 'font_size_h2',true) ?>px; }
	h3 { font-size: <?php get_option_max( 'font_size_h3',true) ?>px; }
	h4 { font-size: <?php get_option_max( 'font_size_h4',true) ?>px; }
	h5 { font-size: <?php get_option_max( 'font_size_h5',true) ?>px; }
	h6 { font-size: <?php get_option_max( 'font_size_h6',true) ?>px; }

	<?php if ( get_option_max( 'homepage_teaser_font_size' ) != ""){?>
#welcomeTeaser { font-size: <?php get_option_max( 'homepage_teaser_font_size', true ) ?>px; }
	<?php } ?><?php if ( get_option_max( 'homepage_teaser_font_size_bold' ) !="" ){?>
#welcomeTeaser .inner strong { font-size: <?php get_option_max( 'homepage_teaser_font_size_bold', true ) ?>px; }
	<?php } ?>


</style>

<!--[if lt IE 9]>
<style type="text/css">
	#expander,
	#toggleThumbs,
	nav#navigation ul ul { background-color: <?php get_option_max( 'color_main_typo' , true) ?>; }
</style>
<![endif]-->

<?php if ( is_singular() && get_option( 'thread_comments' ) ) wp_enqueue_script( 'comment-reply' ); ?>
<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />

<!--[if lt IE 9]>
<script src="<?php bloginfo( 'template_directory' ); ?>/html5.js" type="text/javascript"></script>
<![endif]-->

<?php wp_head(); ?>

<link rel="stylesheet" href="magiczoom.css" type="text/css" />
<script src="magiczoom.js" type="text/javascript"></script>

</head>



<body <?php body_class(); ?>>

<div id="page" class="hfeed">

	<header id="branding" role="banner">	
		
		<hgroup class="navbar">
			<h1 id="site-title">
				<a href="<?php echo home_url( '/' ); ?>" title="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>" rel="home">
					<?php bloginfo( 'name' ); ?>
					<span id="site-description"><?php bloginfo( 'description' ); ?></span>						
				</a>
			</h1>			
		</hgroup>

		<?php if( is_home() ){ ?>
			<?php 
			// Check if Welcome teaser should be shown
			if ( get_option_max('homepage_show_welcome_teaser') == 'true' ) { 
			
			$welcome = stripslashes( get_option_max('homepage_welcome_teaser') );
			
			?>			
			<div id="welcomeTeaser"><span class="inner"><?php echo $welcome ?></span></div>
		<?php 	} ?>
		<?php 
			// Check if Homepage Sidebar is activated 
			if ( get_option_max('homepage_show_homepage_sidebar') == 'true' ) { 
		?>
			<div id="sidebar">
				 <?php	/* Widgetised Area */	if ( !function_exists( 'dynamic_sidebar' ) || !dynamic_sidebar('sidebar-homepage') ) ?>		
			</div>			
		<?php 	} ?>				
		<?php } ?>		

		<nav id="navigation" role="navigation">
			
			<div id="navHolder">
				<h1 class="section-heading"><a href="<?php echo home_url( '/' ); ?>" title="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>" rel="home"><?php _e( 'Main menu', 'invictus' ); ?></a></h1>
				<div class="skip-link screen-reader-text"><a href="#content" title="<?php esc_attr_e( 'Skip to content', 'invictus' ); ?>"><?php _e( 'Skip to content', 'invictus' ); ?></a></div>
				<?php if ( has_nav_menu( 'primary' ) ) { /* if menu location 'primary-menu' exists then use custom menu */ ?>                        
					<?php wp_nav_menu( array( 'theme_location' => 'primary', 'menu_class' => 'sf-menu', 'container' => '', 'walker' => new menu_walker() ) ); ?>
				<?php } else { /* else use wp_list_pages */?>
				<ul class="sf-menu">
					<?php wp_list_pages(); ?>
				</ul>
				<?php } ?>
			</div>						

			<?php 
				// check if we must show superbgimage expander
				if ( ( is_home() || get_post_meta($post->ID, 'max_show_page_fullsize', true) == 'true' ) || $showSuperbgimage === true ){ 
			?>
			<a href="#" id="expander" class="slide-up">
				<span>Hide Content</span>
			</a>
			<?php } ?>
								
		</nav><!-- #navigation -->
			
	</header><!-- #branding -->

	<div id="main" class="clearfix">