<?php
/**
 * @package WordPress
 * @subpackage Invictus
 */

// Generated values !! DO NOT CHANGE !! 
// get the featured posts for the supersized background

$posts = max_query_term_posts( get_option_max('fullsize_featured_count') , get_option_max('fullsize_featured_cat'), 'gallery', get_option_max('fullsize_featured_order') );
$cntPosts = count($posts);
$images = $cntPosts <= get_option_max('fullsize_featured_count') ? $cntPosts : get_option_max('fullsize_featured_count'); // number of images to show

// check if a slide show is available => more than 1 image for the gallery
$show_slideshow = false;
if( get_option_max('fullsize_featured_count') > 1 ) {
	$show_slideshow = true;
}

get_header(); ?>

<?php
	// Check if to show fullsize Background overlay on homepage
	if ( get_option_max( 'homepage_show_fullsize_overlay' ) == 'true' ) { 
?>
	<div id="scanlines" class="overlay-<?php get_option_max( 'fullsize_overlay_pattern' , true ) ?>"></div>	
<?php } ?>

		<?php /* Start the Loop */ ?>
		<?php if (have_posts()) : ?>	
		
		<div id="thumbnails">

			<?php 
			// check if more than one image is set as fullsize image
			if( $show_slideshow ) { 
			?>
			
			<!-- Thumbnail toggle arrow -->
			<a href="#toggleThumbs" id="toggleThumbs" class="slide-up">Toggle Thumbnails</a>			
					
			<div class="controls">
				<a href="#prev" id="fullsizePrev" class="fullsize-link fullsize-prev" title="Prev Image">Prev</a>
				<a href="#start" id="fullsizeStart" class="fullsize-control fullsize-start" title="Start Slideshow" style="display: none;">Start Slideshow</a>
				<a href="#stop" id="fullsizeStop" class="fullsize-control fullsize-stop" title="Stop Slideshow">Stop Slideshow</a>				
				<a href="#next" id="fullsizeNext" class="fullsize-link fullsize-next" title="Next Image">Next</a>
			</div>
			
			<a id="scroll_left" href="#scroll-left" class="scroll-link scroll-left">Scroll left</a>
			<a id="scroll_right" href="#scroll-right" class="scroll-link scroll-right">Scroll right</a>
			
			<div id="fullsizeTimer"></div>			

			<?php }	?>

			<div id="thumbnailContainer" <?php if ( !$show_slideshow ) echo ('style="display: none"') ?> >
			
				<div id="fullsize" class="clearfix pulldown-items">			
					
					<?php if (have_posts()) : while (have_posts()) : the_post(); ?>
					<?php 
						
						// get attached image
						$imgID = get_post_thumbnail_id();  
						$imgUrl = wp_get_attachment_image_src($imgID, 'full');
												
						// get thumbnail quality
						$quality = get_option_max('fullsize_thumb_quality') == "" ? 90 : get_option_max('fullsize_thumb_quality');

					?>													
					<?php if ( has_post_thumbnail() ) { ?>						
						<a class="item" href="<?php  echo $imgUrl[0]; ?>" title="<span><?php the_title() ?></span><?php if($post->post_excerpt){ the_excerpt(); }?>">
							<img src="<?php echo get_template_directory_uri(); ?>/timthumb.php?src=<?php  echo $imgUrl[0]; ?>&amp;h=<?php get_option_max('fullsize_thumb_height',true) ?>&amp;zc=1&amp;q=<?php echo $quality ?>" height="<?php get_option_max('fullsize_thumb_height',true) ?>" class="is-thumb" title="<?php the_title() ?>" />
						</a>
					<?php }	?>								
										
					<?php endwhile; ?>
					<?php endif; ?>	
					<?php wp_reset_query(); ?>
					
					<div class="scroll-bar-wrap ui-widget-content ui-corner-bottom">
						<div class="scroll-bar"></div>
					</div>			
				
				</div>
				
			</div><!--// #thumbnailContainer -->

		</div><!--// #thumbnails -->

		<?php endif; ?>

		<script type="text/javascript">
		
			jQuery(function($){
											
				// Options for SuperBGImage
				$.fn.superbgimage.options = {
					transition: <?php get_option_max('fullsize_transition',true) ?>, 
					slideshow: <?php $slideshow = $show_slideshow ? 1 : 0; echo $slideshow; ?>,
					speed: '<?php get_option_max('fullsize_speed',true) ?>', // animation speed
					randomimage: 0,
					preload: 1,
					slide_interval: <?php get_option_max('fullsize_interval',true) ?>, // invervall of animation
					<?php					
					// check if more than one image is set as fullsize image
					if( $show_slideshow ) { ?>					
					onClick: superbgimage_click, // function-callback click image 
					onHide: superbgimage_hide, // function-callback hide image
					onShow: superbgimage_show // function-callback show image					
					<?php } ?>
				};
				
				<?php
				// check if more than one image is set as fullsize image
				if( $show_slideshow ) {
				
					// Show thumnails if option is activated
					if( get_option_max('homepage_show_thumbnails') == 'true' ){ ?>
					
					$('#thumbnails').delay(1500, function(){ $('#thumbnails').stop().animate({ bottom: $('#colophon').outerHeight() }) });
					$('#toggleThumbs').removeClass('slide-up').addClass('slide-down');
					
					<?php } ?>
			
					// function callback on clicking image, show next slide
					function superbgimage_click(img) {
						$('#fullsize').nextSlide();
						$('#fullsizeTimer').startTimer( <?php get_option_max('fullsize_interval',true) ?> );
					}
					
					function superbgimage_hide(img) {
						$('#fullsizeTimer').stop().css({ width: 0 });
						$('#fullsize a.activeslide').animate({ opacity: 0.5, top: 0 });				
					}
							
					// function callback on showing image
					// get title and display it
					function superbgimage_show(img) {
						
						$('#fullsizeTimer').startTimer( <?php get_option_max('fullsize_interval',true) ?> );
						
						$('#fullsize a.activeslide').animate({ opacity: 1, top: -5 });

					}
				
					// start slideshow
					$('#thumbnails a.fullsize-start').click(function() {
						
						// show/hide controls
						$('#thumbnails a.fullsize-stop').show();
						$(this).hide();
						
						$('#fullsizeTimer').startTimer( <?php get_option_max('fullsize_interval',true) ?> );
						return $('#fullsize').startSlideShow();
					});
				
				<?php } ?>
				
				
				$('body').addClass('fullsize-gallery');
				
			});
		</script>		

<?php get_footer(); ?>

