<?php
/**
 * @package WordPress
 * @subpackage invictus
 */
 
$showSuperbgimage = true ;
$fromGallery = true;
$isPost = true;

get_header();

?>

<div id="single-page" class="clearfix left-sidebar">

		<div id="primary">

			<nav id="nav-above">
				<div class="nav-previous"><?php previous_post_link( '%link', '<span class="meta-nav">' . _x( '&larr;', 'Previous post link', 'invictus' ) . '</span> %title' ); ?></div>
				<div class="nav-next"><?php next_post_link( '%link', '%title <span class="meta-nav">' . _x( '&rarr;', 'Next post link', 'invictus' ) . '</span>' ); ?></div>
			</nav><!-- #nav-above -->

			<header class="entry-header">
					
				<h1 class="entry-title"><?php the_title(); ?></h1>
				<?php 
				// check if there is a excerpt
				if( max_get_the_excerpt() ){ 
				?>
				<h2 class="entry-description"><?php max_get_the_excerpt(true) ?></h2>
				<?php } ?>
			
			</header><!-- .entry-header -->

			<div id="content" role="main">
			
				<?php the_post(); ?>


				<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>

					<?php 
					if ( (function_exists('has_post_thumbnail')) && (has_post_thumbnail()) ) { 
					
						// Get the thumbnail
						$imgID = get_post_thumbnail_id();  
						$imgUrl = wp_get_attachment_image_src($imgID, 'full');
						
						// Check if images should be cropped
						$timb_height ='';
						$timb_img_height = '';
						
						if(get_option_max( 'image_project_original_ratio' ) != 'true' ) {
							$timb_height = '&amp;h=350';
							$timb_img_height = 'height="350"';
						}
						
					?>
					
					<div class="entry-image">
						<?php 
							// Check if it is an image or video
							if( get_post_meta($post->ID, $shortname.'_photo_lightbox_type_value', true) == "YouTube-Video"){
								$showUrl = get_post_meta($post->ID, $shortname.'_photo_video_youtube_value', true);
							}
						?>

						<?php 
							// Check if it is an image or video
							if( get_post_meta($post->ID, $shortname.'_photo_lightbox_type_value', true) == "Photo"){
								$showUrl = $imgUrl[0];
							}
						?>

						<?php 
							// Check if it is an image or video
							if( get_post_meta($post->ID, $shortname.'_photo_lightbox_type_value', true) == "Vimeo-Video"){
								$showUrl = get_post_meta($post->ID, $shortname.'_photo_video_vimeo_value', true);
							}
						?>

						<a href="<?php echo $showUrl ?>" class="scroll-link" style="display: block;" rel="prettyPhoto" title="<?php echo get_the_excerpt() ?>">
							<img src="<?php echo get_template_directory_uri(); ?>/timthumb.php?src=<?php  echo $imgUrl[0]; ?><?php echo $timb_height ?>&amp;w=600&amp;a=<?php echo get_cropping_direction( get_post_meta($post->ID, $shortname.'_photo_cropping_direction_value', 2313) ) ?>&amp;q=100" <?php echo $timb_img_height ?> width="600" class="fade-image" alt="<?php the_title() ?>" title="<?php the_title() ?>" />
						</a>				
					</div>
						
					<?php }  ?>
	
					<div class="clearfix">
					
						<div class="entry-meta">
							<ul class="clearfix ">
								<?php
									$terms = wp_get_post_terms($post->ID, GALLERY_TAXONOMY);
									$term_list = "";
									$post_terms = array();
									foreach ($terms as $term) {
										$term_list .= "$term->name, ";
										$post_terms[$term->term_id] =  $term->slug;
									}																		
									printf( __( '<li>By <span>%1$s</span></li>', 'invictus'), get_the_author() );	
									printf( __( '<li>Posted on <span>%1$s</span></li>', 'invictus'), get_the_date() );
									printf( __( '<li>In <span>%1$s</span></li>', 'invictus'), substr($term_list, 0, -2) );				

								?>
								<?php 
								if( get_post_meta($post->ID, $shortname.'_photo_copyright_information_value', true) != "" ) {
								
									if( get_post_meta($post->ID, $shortname.'_photo_copyright_link_value', true) != "" ){ ?>
								
									<li><?php _e('Copyright','invictus') ?>: <a href="<?php echo get_post_meta($post->ID, $shortname.'_photo_copyright_link_value', true) ?>" title="<?php echo get_post_meta($post->ID, $shortname.'_photo_copyright_information_value', true) ?>" target="_blank"><?php echo get_post_meta($post->ID, $shortname.'_photo_copyright_information_value', true) ?></a></li>
									
									<?php } else { ?>
									
									<li><?php _e('Copyright','invictus') ?>: <?php echo get_post_meta($post->ID, $shortname.'_photo_copyright_information_value', true) ?></li>
							
								<?php
									} 
								} 
								?>
																			
								<?php if( get_post_meta($post->ID, $shortname.'_photo_location_value', true) != "" ) { ?> <li><?php _e('Location','invictus') ?>: <span><?php echo get_post_meta($post->ID, $shortname.'_photo_location_value', true) ?></span></li> <?php } ?>
								<?php if( get_post_meta($post->ID, $shortname.'_photo_date_value', true) != "" ) { ?> <li><?php _e('Date','invictus') ?>: <span><?php echo get_post_meta($post->ID, $shortname.'_photo_date_value', true) ?></span></li> <?php } ?>

							</ul>
							
						</div><!-- .entry-meta -->


						<ul class="clearfix entry-tags">
							<?php echo get_the_tag_list('<li class="title">Tags:<li>','<li>','</li>'); ?>
						</ul>													
				
						<div class="entry-content">	
							<?php the_content(); ?>
						</div><!-- .entry-content -->				
								
						
					</div>
								
				</article><!-- #post-<?php the_ID(); ?> -->
						
				<?php 		
				// Check if other images of a gallery should be shown
				if ( get_option_max('image_show_gallery_images') == "true" ){
						
					// Get all Images from the Gallery				
					$term_ids = array();
					foreach($post_terms as $index => $value){
						$term_ids[$index] = $index;
					}
			
					$gallery_images = max_query_term_posts( get_option_max('image_count_gallery_images'), $term_ids, 'gallery', 'rand' );				
					$imgDimensions = array( 'width' => 144, 'height' => 108 );
				?>
						
				<div id="relatedGalleryImages" class="entry-related-images portfolio-four-columns">
					<h3 class="related-title"><?php _e('More Images from this Gallery') ?></h3>
					<ul id="portfolioList" class="clearfix portfolio-list">
				<?php
				if ( have_posts() ) while ( have_posts() ) : the_post(); 

					// get the post thumbnail
					$img_id = get_post_thumbnail_id();
					$img_url = wp_get_attachment_image_src($img_id, 'full');
							
				?>						
				<li data-id="id-<?php echo $post->ID ?>" class="item <?php echo max_get_post_lightbox_class(); ?> <?php echo $_term_classes ?>">
					<div class="shadow">
					<?php							
						// get the gallery item 
						max_get_post_custom_image();							
					?>
					</div>
					<a title="<?php echo wptexturize($post->post_title) ?>" href="<?php echo get_permalink($post->ID) ?>"><?php echo wptexturize($post->post_title) ?></a>					
				</li>
					<?php endwhile; // end of the loop. 
					// reset the gallery image query
					wp_reset_query();							
					?>
					</ul>
				</div>
				
				<?php } ?>							
						
				<?php 
					// Check if author should be shown and get the Author Infos
					if ( get_option_max('general_show_photo_author') == "true" ) 				
						echo do_shortcode("[authorbox]") 
				?>						
						
				<?php 
					// Get Related Posts
					echo do_shortcode("[related_posts]") 
				?>

				<div id="comments-holder" class="clearfix">
					<?php comments_template( '', true ); ?>
				</div>
			
			</div><!-- #content -->
		</div><!-- #primary -->

		<div id="sidebar">
			 <?php	/* Widgetised Area */	if ( !function_exists( 'dynamic_sidebar' ) || !dynamic_sidebar('sidebar-gallery-project') ) ?>		
		</div>

</div>

<?php get_footer(); ?>


