<?php
/**
 * Template for displaying the Blog Detail Page 
 *
 * @package WordPress
 * @subpackage Invictus
 * @since Invictus 1.0
 */

get_header(); ?>


<div id="single-page" class="clearfix blog left-sidebar">

		<div id="primary">

			<nav id="nav-above">
				<div class="nav-previous"><?php previous_post_link( '%link', '<span class="meta-nav">' . _x( '&larr;', 'Previous post link', 'invictus' ) . '</span> %title' ); ?></div>
				<div class="nav-next"><?php next_post_link( '%link', '%title <span class="meta-nav">' . _x( '&rarr;', 'Next post link', 'invictus' ) . '</span>' ); ?></div>
			</nav><!-- #nav-above -->

			<header class="entry-header">
					
				<h1 class="entry-title"><?php the_title(); ?></h1>
			
			</header><!-- .entry-header -->

			<div id="content" role="main">

			<?php if ( have_posts() ) while ( have_posts() ) : the_post(); ?>


				<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>

					<?php 
					if ( (function_exists('has_post_thumbnail')) && (has_post_thumbnail()) ) { 
					
						// Get the thumbnail
						$imgID = get_post_thumbnail_id();  
						$imgUrl = wp_get_attachment_image_src($imgID, 'full');
					
					?>
					
					<div class="entry-image">
						<a href="<?php echo $imgUrl[0]; ?>" class="scroll-link" style="display: block;" rel="prettyPhoto" title="<?php the_title() ?>">
							<img src="<?php echo get_template_directory_uri(); ?>/timthumb.php?src=<?php  echo $imgUrl[0]; ?>&amp;h=350&amp;w=600&amp;a=<?php echo get_cropping_direction( get_post_meta($post->ID, $shortname.'_photo_cropping_direction_value', 2313) ) ?>&amp;q=100" height="350" width="600" class="fade-image" alt="<?php the_title() ?>" title="<?php the_title() ?>" />
						</a>				
					</div>
						
					<?php } ?>
	
					<div class="clearfix">
					
						<div class="entry-meta">
							<ul class="clearfix">
								<?php								
									// get entry categories
									$post_categories = wp_get_post_categories( $post->ID );
									$cat_list = array();
									foreach ( $post_categories as $c ) {
										$cat = get_category( $c );
										$cat_list[] .= $cat->name;
									}						
									
									$cat_list = implode(', ', $cat_list);
									
									// get comment count
									$comments_count = get_comments_number();
									$comment_string = $comments_count == 1 ? "Comment" : "Comments";
									
									printf( __( '<li>By <span>%1$s</span></li>', 'invictus'), get_the_author() );	
									printf( __( '<li>Posted on <span>%1$s</span></li>', 'invictus'), get_the_date() );									
									printf( __( '<li>In <span>%1$s</span></li>', 'invictus'), $cat_list );
									printf( __( '<li>With <span>%1$s ' . $comment_string . '</span> </li>', 'invictus'), $comments_count );									
								?>
							</ul>
						</div><!-- .entry-meta -->
				
						<div class="entry-content">	
							<?php the_content(); ?>
						</div><!-- .entry-content -->
						
					</div>
				
				</article>

				<?php
					// Check if author should be shown
					if ( get_option_max('general_show_author') == "true" ) 
						echo do_shortcode("[authorbox]")
				?>

				<?php 
					echo do_shortcode("[related_posts]") 
				?>

				<?php endwhile; // end of the loop. ?>
				
				<div id="comments-holder" class="clearfix">
					<?php comments_template( '', true ); ?>
				</div>
				
				<div class="pagination hidden"><p><?php posts_nav_link(' '); ?></p></div>
			
			</div><!-- #content -->
		</div><!-- #primary -->

		<div id="sidebar">
			 <?php	/* Widgetised Area */	if ( !function_exists( 'dynamic_sidebar' ) || !dynamic_sidebar('sidebar-blog-post') ) ?>		
		</div>

</div>

<?php get_footer(); ?>

