<?php
/**
 * The loop that displays posts.
 *
 *
 * @package WordPress
 * @subpackage invictus
 * @since invictus 1.0
 */
global $imgDimensions, $substrExcerpt;

?>

			<?php if (have_posts()) : ?>
				
				<ul id="portfolioList" class="clearfix portfolio-list">
					
					<?php if (have_posts()) : while (have_posts()) : the_post(); ?>
							
						<li class="item">
							<div class="shadow">
							<?php
								
							global $shortname;
									
							// check if its a lightbox or a project page link
							$photo_item_type = get_post_meta($post->ID, $shortname.'_photo_item_type_value', 34434);
								
							// Get the post image via timthumb
							$imgUrl = max_get_post_image_url($post->ID, "full");
									
							if ( has_post_thumbnail() ) {
										
								// Photo Type is a Lightbox
								if($photo_item_type == "Lightbox" ){

								?>
									
								<a href="<?php echo $imgUrl[0]; ?>" rel="prettyPhoto[gal]" title="<?php echo get_the_excerpt() ?>"><img src="<?php echo get_template_directory_uri(); ?>/timthumb.php?src=<?php  echo $imgUrl[0] ?>&amp;w=<?php echo $imgDimensions['width'] ?> &amp;h=<?php echo $imgDimensions['height'] ?>&amp;a=<?php echo get_cropping_direction( get_post_meta($post->ID, $shortname.'_photo_cropping_direction_value', true) ) ?>&amp;q=100" alt="<?php the_title() ?>" width="<?php echo $imgDimensions['width'] ?>" height="<?php echo $imgDimensions['height'] ?>" /></a>
									
								<?php											
								}
										
								// Photo Type is a Project Page
								if($photo_item_type == "Project Page" ){	
										
								?>
											
								<a href="<?php the_permalink() ?>" title="<?php the_title() ?>"><img src="<?php echo get_template_directory_uri(); ?>/timthumb.php?src=<?php  echo $imgUrl[0] ?>&amp;w=<?php echo $imgDimensions['width'] ?>&amp;h=<?php echo $imgDimensions['height'] ?>&amp;a=<?php echo get_cropping_direction( get_post_meta($post->ID, $shortname.'_photo_cropping_direction_value', true) ) ?>&amp;q=100" width="<?php echo $imgDimensions['width'] ?>" height="<?php echo $imgDimensions['height'] ?>"  alt="<?php the_title() ?>" class="fade-image"/></a>
										
								<?php											
								}
										
							}
													
							?>
							</div>
							
							<?php 

							// check if catption option is selected 
							if ( get_option_max( 'image_show_caption' ) == 'true' ) {
							
							?>
							
							<div class="item-caption">
								<?php the_title() ?>
								<span>
								<?php 
								// check the excerpt length and cut it off, if necessary
								$_excerpt = get_the_excerpt();
								echo ( strlen( $_excerpt )  > $substrExcerpt ? substr( $_excerpt , 0, $substrExcerpt - 3 ) . "..." : $_excerpt );
								
								?>
								</span>
							</div>
							
							<?php } ?>
							
						</li>
								
						<?php endwhile; ?>
					
						<?php else : ?>
					
						<h2><?php _e('No Entries found','invictus') ?></h2>
					
						<?php endif; ?>
						
					</ul>
					
					<?php 
						
					/* Display navigation to next/previous pages when applicable */ 
					if (function_exists("max_pagination")) {
					
						max_pagination();
					
					}
						
					?>
					
<?php endif; ?>
