<?php
/**
 * Template Name: Blog Template
 *
 * @package WordPress
 * @subpackage Invictus
 * @since Invictus 1.0
 */

get_header(); 

wp_reset_query();

query_posts(array('posts_per_page' => get_option_max('general_posts_per_page'), 'paged' => $paged));

$page = get_post($pageID);

?>

<div id="single-page" class="clearfix blog left-sidebar">

		<div id="primary">

			<header <?php post_class('entry-header'); ?> id="post-<?php the_ID(); ?>" >
			
				<h1 class="page-title"><?php the_title(); ?> </h1>
				<?php 
				// check if there is a excerpt
				if( max_get_the_excerpt() ){ 
				?>
				<h2 class="page-description"><?php max_get_the_excerpt(true) ?></h2>
				<?php } ?>
					
			</header>

			<div id="content" role="main">		
			
			<?php 
				// including the content template blog-loop.php
				get_template_part( 'blog-loop' );
			?>				
							
			</div><!-- #content -->	
			
		</div><!-- #primary -->

		<div id="sidebar">
			 <?php	/* Widgetised Area */	if ( !function_exists( 'dynamic_sidebar' ) || !dynamic_sidebar('sidebar-blog') ) ?>		
		</div>
		
</div>
<?php get_footer(); ?>
