<?php
/**
 * Template Name: Portfolio Fullsize Background Gallery
 * 
 * @package WordPress
 * @subpackage Invictus
 */

wp_enqueue_script('jquery-mousewheel');
wp_enqueue_script('custom-superbgimage');

$isFullsizeGallery = true;

// Generated values !! DO NOT CHANGE !! 
// get the posts for the supersized background
$taxonomy_name = get_post_meta($post->ID, 'max_select_gallery', true);

// get post order
$order_string = get_post_meta($post->ID, 'max_gallery_order', true);
$order_by = "&orderby=".$order_string;

$posts = query_posts("posts_per_page=9999".$order_by."&post_type=gallery&".GALLERY_TAXONOMY."=".$taxonomy_name);
$cntPosts = count($posts);

get_header(); ?>

<?php
	// Check if to show fullsize Background overlay on homepage
	if ( get_option_max( 'homepage_show_fullsize_overlay' ) == 'true' ) { 
?>
	<div id="scanlines" class="overlay-<?php get_option_max( 'fullsize_overlay_pattern' , true ) ?>"></div>	
<?php } ?>

		<?php /* Start the Loop */ ?>
		<?php if (have_posts()) : ?>
		
		<div id="thumbnails">
		
			<!-- Thumbnail toggle arrow -->
			<a href="#toggleThumbs" id="toggleThumbs" class="slide-up">Toggle Thumbnails</a>
		
			<div class="controls">
				<a href="#prev" id="fullsizePrev" class="fullsize-link fullsize-prev" title="Prev Image">Prev</a>
				<a href="#start" id="fullsizeStart" class="fullsize-control fullsize-start" title="Start Slideshow" style="display: none;">Start Slideshow</a>
				<a href="#stop" id="fullsizeStop" class="fullsize-control fullsize-stop" title="Stop Slideshow">Stop Slideshow</a>				
				<a href="#next" id="fullsizeNext" class="fullsize-link fullsize-next" title="Next Image">Next</a>
			</div>
			
			<a id="scroll_left" href="#scroll-left" class="scroll-link scroll-left">Scroll left</a>
			<a id="scroll_right" href="#scroll-right" class="scroll-link scroll-right">Scroll right</a>
			
			<div id="fullsizeTimer"></div>			

			<div id="thumbnailContainer">
			
				<div id="fullsize" class="clearfix pulldown-items">			
					
					<?php if (have_posts()) : while (have_posts()) : the_post(); ?>
					<?php 				
						$imgID = get_post_thumbnail_id();  
						$imgUrl = wp_get_attachment_image_src($imgID,'full');
						
						// get thumbnail quality
						$quality = get_option_max('fullsize_thumb_quality') == "" ? 90 : get_option_max('fullsize_thumb_quality');

					?>
													
						<?php if ( has_post_thumbnail() ) { ?>
						
						<a class="item" href="<?php  echo $imgUrl[0]; ?>" title="<span><?php the_title() ?></span><?php if($post->post_excerpt){ the_excerpt(); }?>"  rev="<?php the_permalink()?>">
							<img src="<?php echo get_template_directory_uri(); ?>/timthumb.php?src=<?php  echo $imgUrl[0]; ?>&amp;h=<?php get_option_max('fullsize_thumb_height',true) ?>&amp;zc=1&amp;q=<?php echo $quality ?>" height="<?php get_option_max('fullsize_thumb_height',true) ?>" class="is-thumb" title="<?php the_title() ?>" />
						</a>
						<?php }	?>								
										
					<?php endwhile; ?>
					<?php endif; ?>	
					<?php wp_reset_query(); ?>
					
					<div class="scroll-bar-wrap ui-widget-content ui-corner-bottom">
						<div class="scroll-bar"></div>
					</div>			
				
				</div>
				
			</div><!--// #thumbnailContainer -->
			
		</div><!--// #thumbnails -->

		<?php endif; ?>

		<script type="text/javascript">
		
			jQuery(function($){
											
				// Options for SuperBGImage
				$.fn.superbgimage.options = {
					transition: <?php get_option_max('fullsize_transition',true) ?>, 
					slideshow: 1,
					speed: '<?php get_option_max('fullsize_speed',true) ?>', // animation speed
					randomimage: 0,
					preload: 1,
					slide_interval: <?php get_option_max('fullsize_interval',true) ?>, // invervall of animation
					onClick: superbgimage_click, // function-callback click image
					onHide: superbgimage_hide, // function-callback hide image
					onShow: superbgimage_show // function-callback show image
				};
				
				<?php 
				// Show thumnails if option is activated
				if( get_option_max('homepage_show_thumbnails') == 'true' ){ ?>
				
				$('#thumbnails').delay(1500, function(){ $('#thumbnails').stop().animate({ bottom: $('#colophon').outerHeight() }) });
				$('#toggleThumbs').removeClass('slide-up').addClass('slide-down');
				
				<?php } ?>
		
				// function callback on clicking image, show next slide
				function superbgimage_click(img) {
					$('#fullsize').nextSlide();
					$('#fullsizeTimer').startTimer( <?php get_option_max('fullsize_interval',true) ?> );
				}
				
				function superbgimage_hide(img) {
					$('#fullsizeTimer').stop().css({ width: 0 });
					$('#fullsize a.activeslide').animate({ opacity: 0.5, top: 0 });				
				}
						
				// function callback on showing image
				// get title and display it
				function superbgimage_show(img) {
					
					$('#fullsizeTimer').startTimer( <?php get_option_max('fullsize_interval',true) ?> );
					
					$('#fullsize a.activeslide').animate({ opacity: 1, top: -5 });
					
					if($('body').hasClass('.home')){
						//$super.css('background', 'none');
					}
				}
			
				// start slideshow
				$('#thumbnails a.fullsize-start').click(function() {
					
					// show/hide controls
					$('#thumbnails a.fullsize-stop').show();
					$(this).hide();
					
					$('#fullsizeTimer').startTimer( <?php get_option_max('fullsize_interval',true) ?> );
					return $('#fullsize').startSlideShow();
				});
				
				$('body').addClass('fullsize-gallery');
				
			
			});
		</script>		

<?php get_footer(); ?>

