<?php
/**
 * Template Name: Portfolio Fullsize Gridview
 *
 * @package WordPress
 * @subpackage Invictus
 * @since Invictus 1.0
 */

wp_enqueue_script('vgrid');

get_header(); 

wp_reset_query();

// set the image dimensions for this portfolio template
$imgDimensions = array( 'height' => get_option_max( 'image_fullsize_grid_height' ) );

$itemCaption = false;

?>

		<div id="primary" class="portfolio-fullsize-grid">
			<div id="content" role="main">
				
				<header class="entry-header">
						
				<h1 class="page-title"><?php the_title(); ?></h1>
				<?php 
				// check if there is a excerpt
				if( max_get_the_excerpt() ){ 
				?>
				<h2 class="page-description"><?php max_get_the_excerpt(true) ?></h2>
				<?php } ?>
				
				</header><!-- .entry-header -->

				
				<?php 
					// including the loop template gallery-loop.php
					get_template_part( 'gallery-loop' );
				?>

			</div><!-- #content -->
		</div><!-- #container -->
		
		<script type="text/javascript"> 
		//<![CDATA[
		$(function(){
				   
			$(window).load( function(){
			
				$("#portfolioList").vgrid({
					easeing: "easeOutQuint",
					useLoadImageEvent: true,
					time: 400,
					fadeIn: {
						time: 500,
						delay: 50
					}
				});
				
			})
		});
		//]]>
		</script> 

<?php get_footer(); ?>
