<?php
/**
 * Template Name: Portfolio Sortable Grid
 *
 * @package WordPress
 * @subpackage Invictus
 * @since Invictus 1.0
 */

wp_enqueue_script('quicksand');
wp_enqueue_script('custom-quicksand');

get_header(); 

wp_reset_query();

// set the image dimensions for this portfolio template
$imgDimensions = array( 'width' => 118, 'height' => 89 );
$itemCaption = false;

?>

<div id="single-page" class="clearfix left-sidebar">

		<div id="primary" class="portfolio-sortable-grid" >
			<div id="content" role="main">
				
				<header class="entry-header">
						
				<h1 class="page-title"><?php the_title(); ?></h1>
				<?php 
				// check if there is a excerpt
				if( max_get_the_excerpt() ){ 
				?>
				<h2 class="page-description"><?php max_get_the_excerpt(true) ?></h2>
				<?php } ?>
				
				</header><!-- .entry-header -->
							
				<ul class="splitter">
					<li>
						<ul id="portfolioSort" class="clearfix content-sort">
						<li class="segment-0 current"><a href="#" data-value="all"><?php _e('All','invictus') ?></a></li>
						<?php 
							// Get the taxonomies for galleries
							$output = "";
							$parent = "";
							$i = 1;
							asort($wp_gal_cats);
							foreach( $wp_gal_cats as $index => $value ) {
								$_the_term = get_term( $index, GALLERY_TAXONOMY );
								if( @in_array($_the_term->term_id, get_post_meta($post->ID, 'max_sortable_galleries', true) ) ){
									$output .= '<li class="segment-'.$i.'"><a href="#" data-value="' . $_the_term->slug . '">'.$value.'</a></li>';
									$i++;
								}
							};
							echo $output;
						?>
						</ul>
					</li>
				</ul>
											
				<?php 
					// including the loop template gallery-loop.php
					get_template_part( 'gallery-loop' );
				?>

			</div><!-- #content -->
		</div><!-- #container -->

		<div id="sidebar">
			 <?php	/* Widgetised Area */	if ( !function_exists( 'dynamic_sidebar' ) || !dynamic_sidebar('sidebar-gallery-sortable') ) ?>		
		</div>

</div>

<?php get_footer(); ?>
